(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
SetOptions[InputNotebook[],AutoGeneratedPackage->Automatic]


(* ::Input::Initialization:: *)
(*
   Frost Concepts, 2021.
 Use at your own risk.
Most rights reserved.
Permission for resale not granted.
http://www.frostconcepts.org
 Requires Mathematica\[RegisteredTrademark] v12.1 or later
*)


(* ::Input::Initialization:: *)
(* Analyzes edistances for metric criteria and other attributes *)

(* Input: [edistances_,verbose_] *)(* edistances = {{v1\[UndirectedEdge]v2,8},{v1\[DirectedEdge]v3,Sqrt[2]},...} (#1 = directed and/or undirected edges, no rules; #2 = non-complex distance)*)
(* verbose = (True | False) progress messages. default is False) *)

(* Output: resultsTable *)

EdgeDistanceGraphAnalysis[edistances_,verbose_]:=Block[
(* local variables *)
{
showprogress,
passedStr,failedStr,naStr,
undirectedEdgeStr,directedEdgeStr,
startTime,endTime,elapsedTime,

edistancesDimensions,edgeList,edgeListCount,distanceList,
edistancesDimensionTests,edistancesDimensionFailures,

realStr,invalidDistancesTests,invalidDistances,invalidDistancesTestFailures,invalidDistancesTestValue,hasInvalidDistances,
distancesMinMaxTests,distancesMinMaxTestFailures,distancesMinMax,
minAbsDistance,\[Epsilon],

directedEdgeTests,directedEdgeCount,directedEdgeFailures,hasDirectedEdges,
undirectedEdgeTests,undirectedEdgeCount,undirectedEdgeFailures,hasUndirectedEdges,
invalidEdgeTests,invalidEdgeTestFailures,invalidEdgeTestValue,hasInvalidEdges,

vertexEdgeData1,gatheredInputPairData,
vertexEdgeData2,vertexEdgeData,gatheredVertexPairData,
gatheredVertexEdgesData,gatheredVertexEdgesHash,

duplicateEdgeTests,duplicateEdgeCount,noDuplicateEdgesQ,duplicateEdgeTestValue,
nonZeroSelfLoopTests,nonZeroSelfLoopCount,noNonZeroSelfLoopsQ,nonZeroSelfLoopTestValue,
singleEdgePathTests,singleEdgePathTestsFailures,singleEdgePathCount,

vertices,
verticesTests,verticesTestsFailures,verticesCount,

vertexEdgeDistancesTallies,
verticesMultiplicitiesTests,verticesMultiplicitiesTestFailures,verticesMultiplicitiesCount,
verticesMultiplicityRangeTests,verticesMultiplicityRangeTestFailures,verticesMultiplicityRange,

sortedVertexEdgeDistancesTallies,
nnMultiplicitiesTests,nnMultiplicitiesTestFailures,nnMultiplicitiesCount,
nnMultiplicitiesRangeTests,nnMultiplicitiesRangeTestFailures,nnMultiplicitiesRange,

fvalsdata,fmaxdata,
componentMaximalTests,componentMaximalTestFailures,componentMaximalTestValue,

plainEdgeGraph,
connectedTests,componentsCount,connectedFailures,connectedQ,connectedTestValue,
edgeHashSet,
completeTests,completeCount,completeFailures,completeQ,v1,v2,e1,e2,e3,e4,completeTestValue,

LBGedgeList,LBGedgeListCount,
LBGedgesLaplacianTests,LBGedgesLaplacianEigenvalues,LBGedgesLaplacianFailures,LBGedgesLaplacianTestValue,

positiveDefiniteTests,positiveDefiniteFailures,positiveDefiniteQ,positiveDefiniteTestValue,
identityTests,identityFailures,identityQ,identityTestValue,

vertexPairEdgeDataHash,
commutativeTests,commutativeFailures,commutativeQ,commutativeTestValue,
epair,edist,rpair,rpdata,rdist,

triangleTests,triangleFailures,triangleQ,triangleTestValue,
a,agoes,b,abdist,bgoes,c,bcdist,acdistlist,error,abserror,minTerror,maxTerror,

triangleTestsMinMaxTests,triangleTestsMinMaxFailures,triangleTestsMinMaxErrors,

metricTests,metricFailures,metricQ,metricTestValue,

EDGAstartTime,EDGAendTime,EDGAelapsedTime,
resultsHeader,timingResults,resultsBody,resultsTable
},
EDGAstartTime=AbsoluteTime[];
(* process input *)
edistancesDimensions=Dimensions[edistances];
edgeList=edistances[[;;,1]];
edgeListCount=Length[edgeList];
distanceList=edistances[[;;,2]];
showprogress=False;
If[BooleanQ[verbose],showprogress=verbose];

If[showprogress,
Print["EdgeDistanceGraphAnalysis:"];
Print["\t","edistancesDimensions = ",edistancesDimensions];
Print["\t","showprogress = ",showprogress];
];

(* initialization *)
passedStr="Passed";
failedStr="Failed";
naStr="n/a";
undirectedEdgeStr=ToString[Head[0\[UndirectedEdge]0]];
directedEdgeStr=ToString[Head[0\[DirectedEdge]0]];
realStr=ToString[Head[N[Sqrt[2]]]];

(* analysis *)
edistancesDimensionTests=naStr;
edistancesDimensionFailures=naStr;

invalidDistancesTests=edgeListCount;
invalidDistances=If[#==realStr,Nothing,#]&/@(ToString[Head[N[#]]]&/@distanceList);
invalidDistancesTestFailures=Length[invalidDistances];
hasInvalidDistances=(invalidDistancesTestFailures>0);
invalidDistancesTestValue=If[hasInvalidDistances,
failedStr<>": "<>StringRiffle[invalidDistances,", "],
passedStr
];

distancesMinMaxTests=edgeListCount;
distancesMinMaxTestFailures=naStr;
distancesMinMax=MinMax[distanceList];

minAbsDistance=Min[Abs[distanceList]];
\[Epsilon]=If[minAbsDistance==0,
1.0*10^-9,
N[minAbsDistance/2]*10^-9
];

directedEdgeCount=Total[If[ToString[Head[#]]==directedEdgeStr,1,0]&/@edgeList];
hasDirectedEdges=(directedEdgeCount>0);
directedEdgeTests=edgeListCount;
directedEdgeFailures=naStr;

undirectedEdgeCount=Total[If[ToString[Head[#]]==undirectedEdgeStr,1,0]&/@edgeList];
hasUndirectedEdges=(undirectedEdgeCount>0);
undirectedEdgeTests=edgeListCount;
undirectedEdgeFailures=naStr;

invalidEdgeTests=edgeListCount;
invalidEdgeTestFailures=edgeListCount-(directedEdgeCount+undirectedEdgeCount);
hasInvalidEdges=(invalidEdgeTestFailures>0);
invalidEdgeTestValue=If[hasInvalidEdges,
failedStr<>": "<>StringRiffle[Sort[DeleteDuplicates[If[MemberQ[{undirectedEdgeStr,directedEdgeStr},#],Nothing,#]&/@(ToString[Head[#]]&/@edgeList)]],", "],
passedStr
];

nonZeroSelfLoopTests=edgeListCount;
nonZeroSelfLoopCount=Total[If[(#[[1,1]]==#[[1,2]])\[And](#[[2]]!=0),1,0]&/@({(List@@#[[1]]),#[[2]]}&/@edistances)];
noNonZeroSelfLoopsQ=(nonZeroSelfLoopCount==0);
nonZeroSelfLoopTestValue=If[noNonZeroSelfLoopsQ,passedStr,failedStr];

vertexEdgeData1=({#[[1,1]],#[[1,2]],#[[2]],ToString[Head[#[[1]]]]}&/@edistances);
gatheredInputPairData={#[[1,1]],({#[[2]],#[[3]]}&/@#)}&/@GatherBy[{{#[[1]],#[[2]]},#[[3]],#[[4]]}&/@vertexEdgeData1,First];
vertexEdgeData2=If[#[[4]]==undirectedEdgeStr,{#[[2]],#[[1]],#[[3]],#[[4]]},Nothing]&/@vertexEdgeData1;
vertexEdgeData=Sort[DeleteDuplicates[Join[vertexEdgeData1,vertexEdgeData2]]];
Clear[vertexEdgeData1,vertexEdgeData2];
gatheredVertexPairData={#[[1,1]],({#[[2]],#[[3]]}&/@#)}&/@GatherBy[{{#[[1]],#[[2]]},#[[3]],#[[4]]}&/@vertexEdgeData,First];
gatheredVertexEdgesData={#[[1,1]],#}&/@GatherBy[vertexEdgeData,First];

duplicateEdgeTests=Length[gatheredInputPairData];
duplicateEdgeCount=Total[If[Length[#[[2]]]>1,1,0]&/@gatheredInputPairData];
noDuplicateEdgesQ=(duplicateEdgeCount==0);
duplicateEdgeTestValue=If[noDuplicateEdgesQ,passedStr,failedStr];
Clear[gatheredInputPairData];

singleEdgePathTests=naStr;
singleEdgePathTestsFailures=naStr;
singleEdgePathCount=Length[vertexEdgeData];

vertices=Sort[DeleteDuplicates[vertexEdgeData[[;;,1]]]];
verticesCount=Length[vertices];
verticesTests=naStr;
verticesTestsFailures=naStr;
Clear[vertexEdgeData];

vertexEdgeDistancesTallies=(Tally[(#[[3]]&/@#)]&/@gatheredVertexEdgesData[[;;,2]]);
verticesMultiplicitiesTests=verticesCount;
verticesMultiplicitiesTestFailures=naStr;
verticesMultiplicitiesCount=Total[Total[(If[#[[2]]==1,0,1]&/@#)]&/@vertexEdgeDistancesTallies];

verticesMultiplicityRangeTests=verticesCount;
verticesMultiplicityRangeTestFailures=naStr;
verticesMultiplicityRange=If[verticesMultiplicitiesCount==0,
naStr,
MinMax[(If[#[[2]]==1,Nothing,#[[1]]]&/@Flatten[GatherBy[#,Last],1])&/@vertexEdgeDistancesTallies]
];

sortedVertexEdgeDistancesTallies=Sort[Flatten[GatherBy[#,First],1]][[1]]&/@vertexEdgeDistancesTallies;
nnMultiplicitiesCount=If[verticesMultiplicitiesCount==0,
0,
Total[If[#[[2]]==1,0,1]&/@sortedVertexEdgeDistancesTallies]
];
nnMultiplicitiesTests=verticesCount;
nnMultiplicitiesTestFailures=naStr;
Clear[vertexEdgeDistancesTallies];

nnMultiplicitiesRange=If[nnMultiplicitiesCount==0,
naStr,
MinMax[If[#[[2]]==1,Nothing,#[[1]]]&/@sortedVertexEdgeDistancesTallies]
];
nnMultiplicitiesRangeTests=verticesCount;
nnMultiplicitiesRangeTestFailures=naStr;
Clear[sortedVertexEdgeDistancesTallies];

If[showprogress,
Print["\t","invalidDistancesTestValue = ",invalidDistancesTestValue];
Print["\t","distancesMinMax = ",distancesMinMax];
Print["\t","\[Epsilon] = ",\[Epsilon]];
Print["\t","directedEdgeCount = ",directedEdgeCount];
Print["\t","undirectedEdgeCount = ",undirectedEdgeCount];
Print["\t","invalidEdgeTestValue = ",invalidEdgeTestValue];
Print["\t","nonZeroSelfLoopCount = ",nonZeroSelfLoopCount];
Print["\t","duplicateEdgeCount = ",duplicateEdgeCount];
Print["\t","singleEdgePathCount = ",singleEdgePathCount];
Print["\t","verticesCount = ",verticesCount];
Print["\t","verticesMultiplicitiesCount = ",verticesMultiplicitiesCount];
Print["\t","verticesMultiplicityRange = ",verticesMultiplicityRange];
Print["\t","nnMultiplicitiesCount = ",nnMultiplicitiesCount];
Print["\t","nnMultiplicitiesRange = ",nnMultiplicitiesRange];
];

If[hasInvalidDistances\[Or]hasInvalidEdges,
Do[
componentMaximalTestFailures=If[hasInvalidDistances,1,0]+If[hasInvalidEdges,1,0];
componentMaximalTests=componentMaximalTestFailures;
componentMaximalTestValue="invalid distances or edges",
1],
Do[
(* HERE *)
If[showprogress,Print["\t","beginning maximal component distance test ..."]];
startTime=AbsoluteTime[];
{fmaxdata,fvalsdata,componentMaximalTests}=ComponentMaximal[edistances];
componentMaximalTestFailures=naStr;
componentMaximalTestValue={fmaxdata[[1]],fmaxdata[[2]],fmaxdata[[3]],N[fmaxdata[[4]]]};
endTime=AbsoluteTime[];
If[showprogress,
Print["\t\t","elapsed time = ",Quantity[endTime-startTime,"Seconds"]];
Print["\t\t","maximal component distance \[Delta] = ",fmaxdata[[1]]];
];
{},
1]
];
If[showprogress,Print["\t","componentMaximalTestValue = ",componentMaximalTestValue]];

plainEdgeGraph=Graph[edgeList];
connectedTests=naStr;
componentsCount=Length[ConnectedComponents[UndirectedGraph[plainEdgeGraph]]];
connectedFailures=If[componentsCount==1,naStr,componentsCount];
connectedQ=(componentsCount==1);
connectedTestValue=If[connectedQ,"connected","not connected"];
Clear[plainEdgeGraph];
If[showprogress,Print["\t","componentsCount = ",componentsCount]];

edgeHashSet=CreateDataStructure["HashSet"];
edgeHashSet["Union",edgeList];
completeTests=0;
completeCount=naStr;
completeFailures=naStr;
completeQ=True;
v1=0;
While[(completeQ)\[And](v1<verticesCount),
v1++;
Pause[0];
v2=v1;
While[(completeQ)\[And](v2<verticesCount),
completeTests++;
v2++;
e1=vertices[[v1]]\[UndirectedEdge]vertices[[v2]];
e2=vertices[[v1]]\[DirectedEdge]vertices[[v2]];
e3=vertices[[v2]]\[UndirectedEdge]vertices[[v1]];
e4=vertices[[v2]]\[DirectedEdge]vertices[[v1]];
completeQ=(edgeHashSet["MemberQ",e1]\[Or]edgeHashSet["MemberQ",e2]\[Or]edgeHashSet["MemberQ",e3]\[Or]edgeHashSet["MemberQ",e4]);
];
];
completeTestValue=If[completeQ,"complete","not complete"];
Clear[edgeHashSet];
If[showprogress,Print["\t","completeTestValue = ",completeTestValue]];

If[showprogress,Print["\t","beginning computation of largest Laplacian of least bridges edges ..."]];
LBGedgeList=(LeastBridgesEdgeDistances[edistances,\[Infinity],False])[[;;,1]];
LBGedgeListCount=Length[LBGedgeList];
LBGedgesLaplacianTests=Max[LBGedgeListCount,1];
startTime=AbsoluteTime[];
LBGedgesLaplacianEigenvalues=LaplacianMatrixEigenvalues[LBGedgeList];
endTime=AbsoluteTime[];
LBGedgesLaplacianTestValue=LBGedgesLaplacianEigenvalues[[1]];
LBGedgesLaplacianFailures=If[NumberQ[LBGedgesLaplacianTestValue],0,1];
If[showprogress,
elapsedTime=endTime-startTime;
Print["\t\t","elapsed time = ",If[elapsedTime<60,Quantity[elapsedTime,"Seconds"],Quantity[elapsedTime/60.,"Minutes"]]];
Print["\t\t","LBGedgesLaplacianTestValue = ",LBGedgesLaplacianTestValue]
];

positiveDefiniteTests=edgeListCount;
positiveDefiniteFailures=Total[If[#[[2]]==0,1,0]&/@edistances];
positiveDefiniteQ=(positiveDefiniteFailures==0);
positiveDefiniteTestValue=If[positiveDefiniteQ,passedStr,failedStr];

identityTests=nonZeroSelfLoopTests;
identityFailures=nonZeroSelfLoopCount;
identityQ=noNonZeroSelfLoopsQ;
identityTestValue=If[identityQ,passedStr,failedStr];

vertexPairEdgeDataHash=CreateDataStructure["HashTable"];
vertexPairEdgeDataHash["Insert",#[[1]]->#[[2]]]&/@gatheredVertexPairData;
commutativeTests=0;
commutativeFailures=0;
Do[
epair=epdata[[1]];
rpair=Reverse[epair];
If[vertexPairEdgeDataHash["KeyExistsQ",rpair],
rpdata=vertexPairEdgeDataHash["Lookup",rpair];
Do[
edist=eedge[[1]];
Do[
commutativeTests++;
rdist=redge[[1]];
If[rdist!=edist,commutativeFailures++];
{},
{redge,rpdata}
],
{eedge,epdata[[2]]}
];
],
{epdata,gatheredVertexPairData}
];
Clear[vertexPairEdgeDataHash];
commutativeTests+=duplicateEdgeCount;
commutativeFailures+=duplicateEdgeCount;
commutativeQ=(commutativeFailures==0);
commutativeTestValue=If[commutativeQ,passedStr,failedStr];

If[showprogress,
Print["\t","positiveDefiniteTests = ",positiveDefiniteTests];
Print["\t\t","positiveDefiniteFailures = ",positiveDefiniteFailures];
Print["\t","identityTests = ",positiveDefiniteTests];
Print["\t\t","identityFailures = ",positiveDefiniteFailures];
Print["\t","commutativeTests = ",commutativeTests];
Print["\t\t","commutativeFailures = ",commutativeFailures];
];

If[showprogress,Print["\t","beginning triangle inequality tests for all paths {a\[RightArrow]b, b\[RightArrow]c, a\[RightArrow]c} ..."]];
startTime=AbsoluteTime[];
triangleTests=0;
triangleFailures=0;
minTerror=+\[Infinity];
maxTerror=-\[Infinity];
gatheredVertexEdgesHash=CreateDataStructure["HashTable"];
gatheredVertexEdgesHash["Insert",#[[1]]->#[[2]]]&/@gatheredVertexEdgesData;
Do[
a=vedata[[1]];
(* Print["a = ",a]; *)
agoes=If[#[[2]]==a,Nothing,#[[2;;3]]]&/@vedata[[2]];
(* Print["agoes = ",agoes]; *)
Do[
b=abdata[[1]];
abdist=abdata[[2]];
(* Print["\t","b = ",b,", abdist = ",abdist]; *)
bgoes=If[MemberQ[{a,b},#[[2]]],Nothing,#[[2;;3]]]&/@gatheredVertexEdgesHash["Lookup",b];
(* Print["\t","bgoes = ",bgoes]; *)
Do[
c=bcdata[[1]];
bcdist=bcdata[[2]];
(* Print["\t\t","c = ",c,", bcdist = ",bcdist]; *)
acdistlist=If[#[[1]]==c,#[[2]],Nothing]&/@agoes;
(* Print["\t\t\t","acdistlist = ",acdistlist]; *)
Do[
triangleTests++;
error=acdist-(abdist+bcdist);
If[error>\[Epsilon],
triangleFailures++;
abserror=Abs[error];
minTerror=Min[minTerror,abserror];
maxTerror=Max[maxTerror,abserror];
];
{},
{acdist,acdistlist}
];
{},
{bcdata,bgoes}
];
{},
{abdata,agoes}
];
{},
{vedata,gatheredVertexEdgesData}
];
endTime=AbsoluteTime[];
(* Print["end of triangle tests."]; *)
triangleFailures+=positiveDefiniteFailures;
triangleQ=(triangleFailures==0);
triangleTestValue=If[triangleQ,
passedStr,
If[triangleFailures==positiveDefiniteFailures,
failedStr<>", not positive definite",
failedStr
]
];
Clear[gatheredVertexEdgesData];
Clear[gatheredVertexEdgesHash];

triangleTestsMinMaxTests=If[triangleQ\[Or](triangleFailures==positiveDefiniteFailures),naStr,triangleTests];
triangleTestsMinMaxFailures=If[triangleQ\[Or](triangleFailures==positiveDefiniteFailures),naStr,triangleFailures-positiveDefiniteFailures];
triangleTestsMinMaxErrors=If[triangleQ\[Or](triangleFailures==positiveDefiniteFailures),naStr,{minTerror,maxTerror}];

If[showprogress,
elapsedTime=endTime-startTime;
Print["\t\t","elapsed time = ",If[elapsedTime<60,Quantity[elapsedTime,"Seconds"],Quantity[elapsedTime/60.,"Minutes"]]];
Print["\t\t","triangleTests = ",triangleTests];
Print["\t\t","triangleFailures = ",triangleFailures];
Print["\t\t","triangleTestsMinMaxErrors = ",triangleTestsMinMaxErrors];
];

metricTests=positiveDefiniteTests+identityTests+commutativeTests+triangleTests;
metricFailures=identityFailures+commutativeFailures+triangleFailures; (* note positiveDefiniteFailures are added to triangleFailures *)
metricQ=(metricFailures==0);
metricTestValue=Which[
metricQ,passedStr,
(positiveDefiniteQ\[And]identityQ\[And](!commutativeQ)\[And]triangleQ),"non-hermitian metric",
True,failedStr
];

If[showprogress,
Print["\t","metricTestValue = ",metricTestValue];
];

EDGAendTime=AbsoluteTime[];
elapsedTime=EDGAendTime-EDGAstartTime;
EDGAelapsedTime=Which[
elapsedTime<60,Quantity[elapsedTime,"Seconds"],
elapsedTime<3600,Quantity[elapsedTime/60.,"Minutes"],
True,Quantity[elapsedTime/3600.,"Hours"]
];

resultsHeader={{"Test Name","Test Count","Failure Count","Test Value"}};
resultsBody={
{"edistances dimensions",edistancesDimensionTests,edistancesDimensionFailures,edistancesDimensions},
{If[hasInvalidDistances,Style["invalid distances",{Bold,Red}],"invalid distances"],invalidDistancesTests,invalidDistancesTestFailures,invalidDistancesTestValue},
{"distances min,max",distancesMinMaxTests,distancesMinMaxTestFailures,distancesMinMax},
{"numerical error tolerance \[Epsilon]",distancesMinMaxTests,distancesMinMaxTestFailures,\[Epsilon]},
{"directed edges",directedEdgeTests,directedEdgeFailures,directedEdgeCount},
{"undirected edges",undirectedEdgeTests,undirectedEdgeFailures,undirectedEdgeCount},
{If[hasInvalidEdges,Style["invalid edges",{Bold,Red}],"invalid edges"],invalidEdgeTests,invalidEdgeTestFailures,invalidEdgeTestValue},
{If[nonZeroSelfLoopTestValue!=passedStr,Style["non-zero self loops",{Bold,Red}],"non-zero self loops"],nonZeroSelfLoopTests,nonZeroSelfLoopCount,nonZeroSelfLoopTestValue},
{If[duplicateEdgeTestValue!=passedStr,Style["duplicate edges",{Bold,Red}],"duplicate edges"],duplicateEdgeTests,duplicateEdgeCount,duplicateEdgeTestValue},
{"all single edge paths",singleEdgePathTests,singleEdgePathTestsFailures,singleEdgePathCount},
{"vertices",verticesTests,verticesTestsFailures,verticesCount},
{"instances of multiplicity",verticesMultiplicitiesTests,verticesMultiplicitiesTestFailures,verticesMultiplicitiesCount},
{"multiplicities min,max",verticesMultiplicityRangeTests,verticesMultiplicityRangeTestFailures,verticesMultiplicityRange},
{"nearest neighbor multiplicities",nnMultiplicitiesTests,nnMultiplicitiesTestFailures,nnMultiplicitiesCount},
{"n.n. multiplicities min,max",nnMultiplicitiesRangeTests,nnMultiplicitiesRangeTestFailures,nnMultiplicitiesRange},
{"component maximal {\!\(\*SubscriptBox[\(\[Delta]\), \(opt\)]\),c,v,f[\!\(\*SubscriptBox[\(\[Delta]\), \(opt\)]\)]}",componentMaximalTests,componentMaximalTestFailures,componentMaximalTestValue},
{"connected graph",connectedTests,connectedFailures,connectedTestValue},
{"complete graph",completeTests,completeFailures,completeTestValue},
{"largest Laplacian of least bridges edges",LBGedgesLaplacianTests,LBGedgesLaplacianFailures,LBGedgesLaplacianTestValue},
{If[positiveDefiniteTestValue!=passedStr,Style["positive definite",{Bold,Red}],"positive definite"],positiveDefiniteTests,positiveDefiniteFailures,positiveDefiniteTestValue},
{If[identityTestValue!=passedStr,Style["identity distance",{Bold,Red}],"identity distance"],identityTests,identityFailures,identityTestValue},
{"commutative edge distances",commutativeTests,commutativeFailures,commutativeTestValue},
{If[triangleTestValue!=passedStr,Style["triangle inequality",{Bold,Red}],"triangle inequality"],triangleTests,triangleFailures,triangleTestValue},
{"triangle ineq. min,max |errors|",triangleTestsMinMaxTests,triangleTestsMinMaxFailures,triangleTestsMinMaxErrors},
{If[metricTestValue==failedStr,Style["metric",{Bold,Red}],"metric"],metricTests,metricFailures,metricTestValue}
};
timingResults={{"elapsed analysis time",Total[If[IntegerQ[#],#,1]&/@resultsBody[[;;,2]]],naStr,EDGAelapsedTime}};
resultsTable=Join[resultsHeader,timingResults,resultsBody]
];



(* ::Input::Initialization:: *)
(* Outputs EdgeDistances of Least Bridges Graph, possibly distance limited *)

(* Input: [edistances_,distancelimit_,verbose_] *)(* edistances = {{v1\[UndirectedEdge]v2,8},{v1\[DirectedEdge]v3,Sqrt[2]},...} (#1 = directed and/or undirected edges, no rules; #2 = non-complex distance)*)
(* distancelimit = L (L \[LessEqual] 0 \[RightArrow] no graph computed, L < \[Infinity] \[RightArrow] LBG computation halts at L if reached, \[Infinity] \[RightArrow] no distance limit, NumberQ[L]\[Equal]False \[RightArrow] ignored) *)
(* verbose = (True | False) progress messages. default is False) *)

(* Output: acceptedEdgeDistances *)

LeastBridgesEdgeDistances[edistances_,distancelimit_,verbose_]:=Block[
(* local variables *)
{
edgeCount,
absoluteMinMax,
distancePairsGathered,
uniqueEdgeDistances,uniqueEdgeDistancesCount,
pairToEdgeHash,pairToDistanceHash,
vertices,verticesCount,
distancelimitNaN,distancelimitStr,requestedlimit,assignedlimit,t,triallimit,
showprogress,
trial,
acceptedEdgeDistances,acceptedEdgesCount,priorAcceptedEdgesCount,
graphEdgesVertices,graphEdgesVerticesCount,
graphComponents,graphComponentsCount,vertexComponentHash,threadedComponents,
graphPairsDegenerateSet,
trialSelections,trialPairs,trialPairsCount,trialPairsDistance,
thisPair,notDegenerate,v1component,v2component,notSelfLoop,
thisEdge,thisEdgeHeadStr,undirectedEdgeStr,directedEdgeStr,
trialEdgesCount,verticesComplements,verticesComplementsCount,
pseudoComponents,pseudoComponentsCount
},
(* process input *)
edgeCount=Length[edistances];
absoluteMinMax=MinMax[edistances[[;;,2]]];
distancePairsGathered=(GatherBy[Sort[{#[[2]],{#[[1,1]],#[[1,2]]}}&/@edistances],First]);
uniqueEdgeDistances=distancePairsGathered[[;;,1,1]];
uniqueEdgeDistancesCount=Length[distancePairsGathered];
pairToEdgeHash=CreateDataStructure["HashTable"];
pairToEdgeHash["Insert",{#[[1,1]],#[[1,2]]}->#[[1]]]&/@edistances;
pairToDistanceHash=CreateDataStructure["HashTable"];
pairToDistanceHash["Insert",{#[[1,1]],#[[1,2]]}->#[[2]]]&/@edistances;
vertices=Sort[DeleteDuplicates[Flatten[(List@@#)&/@edistances[[;;,1]]]]];
verticesCount=Length[vertices];

distancelimitNaN=!NumberQ[distancelimit];
If[((distancelimitNaN)&&(distancelimit!=\[Infinity])),
Do[
distancelimitStr=ToString[distancelimit];
{assignedlimit,requestedlimit}={0,distancelimitStr};
{},
1],
Which[
distancelimit==\[Infinity],{assignedlimit,requestedlimit}={absoluteMinMax[[2]],distancelimit},
distancelimit<0,{assignedlimit,requestedlimit}={0,distancelimit},
distancelimit>absoluteMinMax[[2]],{assignedlimit,requestedlimit}={absoluteMinMax[[2]],distancelimit},
True,{assignedlimit,requestedlimit}={distancelimit,distancelimit}]
];
t=1;
While[((assignedlimit>=uniqueEdgeDistances[[t]])&&(t<uniqueEdgeDistancesCount)),t++];
If[assignedlimit==uniqueEdgeDistances[[t]],triallimit=t,triallimit=t-1];

showprogress=False;
If[BooleanQ[verbose],showprogress=verbose];
If[showprogress,
Print["LeastBridgesEdgeDistances:"];

Print["\t","INITIALIZATION"];
Print["\t\t","Dimensions[edistances] = ",Dimensions[edistances]];
Print["\t\t","edgeCount = ",edgeCount];
Print["\t\t","absoluteMinMax = ",absoluteMinMax];
Print["\t\t","uniqueEdgeDistancesCount = ",uniqueEdgeDistancesCount];
Print["\t\t","verticesCount = ",verticesCount];

Print["\t","distancelimit = ",distancelimit];
Print["\t\t","distancelimitNaN = ",distancelimitNaN];
Print["\t\t","requestedlimit = ",requestedlimit];
Print["\t\t","assignedlimit = ",assignedlimit];
Print["\t\t","triallimit = ",triallimit," of ",uniqueEdgeDistancesCount," possible"];

Print["\t","verbose = ",verbose];
Print["\t\t","showprogress = ",showprogress];
];

undirectedEdgeStr=ToString[Head[0\[UndirectedEdge]0]];
directedEdgeStr=ToString[Head[0\[DirectedEdge]0]];

(* least bridges graph edges *)
If[showprogress,
Print["\t","COMPUTATION"];
Print["\t","computing least bridge graph edges"]
];
trial=0;
acceptedEdgeDistances={};
acceptedEdgesCount=0;
graphEdgesVertices={};
graphEdgesVerticesCount=0;
graphComponents={};
graphComponentsCount=Length[graphComponents];
(* vertexComponentHash maps vertex to component index. reset every trial. *)
pseudoComponents=({#}&/@vertices);
pseudoComponentsCount=Length[pseudoComponents];
vertexComponentHash=CreateDataStructure["HashTable"];
threadedComponents=Flatten[Table[Table[{pseudoComponents[[i,j]],i},{j,1,Length[pseudoComponents[[i]]]}],{i,1,pseudoComponentsCount}],1];
vertexComponentHash["Insert",#[[1]]->#[[2]]]&/@threadedComponents;
(* a set of every edge in the graph, including vertex pairs of directed edges and both vertex pairs (forward and reverse) of undirected edges *)
graphPairsDegenerateSet=CreateDataStructure["HashSet"];
If[showprogress,
Print["\t\t","\[Bullet] trial: ",trial];
Print["\t\t\t","pseudoComponentsCount = ",pseudoComponentsCount];
Print["\t\t\t","graphComponentsCount = ",graphComponentsCount];
];
While[((graphComponentsCount>1)||(graphEdgesVerticesCount<verticesCount))&&(trial<triallimit),
Do[
trial++;
If[showprogress,Print["\t\t","\[Bullet] trial: ",trial]];

priorAcceptedEdgesCount=acceptedEdgesCount;
trialSelections=distancePairsGathered[[trial]];
trialPairs=trialSelections[[;;,2]];
trialPairsCount=Length[trialPairs];
trialPairsDistance=pairToDistanceHash["Lookup",trialPairs[[1]]];
If[showprogress,
Print["\t\t\t","trialPairsCount = ",trialPairsCount];
Print["\t\t\t","trialPairsDistance = ",trialPairsDistance];
Print["\t\t\t","trialPairs = ",trialPairs];
];

Do[
thisPair=trialPairs[[p]];
notDegenerate=!graphPairsDegenerateSet["MemberQ",thisPair];
v1component=vertexComponentHash["Lookup",thisPair[[1]]];
v2component=vertexComponentHash["Lookup",thisPair[[2]]];
notSelfLoop=v1component!=v2component;
If[showprogress,
Print["\t\t\t\t","thisPair = ",thisPair];
Print["\t\t\t\t\t","notDegenerate = ",notDegenerate];
Print["\t\t\t\t\t","notSelfLoop = ",notSelfLoop];
];

If[(notDegenerate)&&(notSelfLoop),
Do[
thisEdge=pairToEdgeHash["Lookup",thisPair];
thisEdgeHeadStr=ToString[Head[thisEdge]];
If[thisEdgeHeadStr==undirectedEdgeStr,
Do[ (* unordered edge *)
AppendTo[acceptedEdgeDistances,{thisEdge,trialPairsDistance}];
graphPairsDegenerateSet["Insert",thisPair];
graphPairsDegenerateSet["Insert",Reverse[thisPair]];
{},
1]
];
If[thisEdgeHeadStr==directedEdgeStr,
Do[ (* directed edge *)
AppendTo[acceptedEdgeDistances,{thisEdge,trialPairsDistance}];
graphPairsDegenerateSet["Insert",thisPair];
{},
1]
];
{},
1] (* end add thisPair to graph *)
];
{},
{p,1,trialPairsCount}
];

graphComponents=ConnectedComponents[UndirectedGraph[acceptedEdgeDistances[[;;,1]]]];
graphComponentsCount=Length[graphComponents];
acceptedEdgesCount=Length[acceptedEdgeDistances];
trialEdgesCount=acceptedEdgesCount-priorAcceptedEdgesCount;
graphEdgesVertices=Sort[DeleteDuplicates[Flatten[(List@@#)&/@acceptedEdgeDistances[[;;,1]]]]];
graphEdgesVerticesCount=Length[graphEdgesVertices];
verticesComplements=Complement[vertices,graphEdgesVertices];
verticesComplementsCount=Length[verticesComplements];

pseudoComponents=Join[graphComponents,{#}&/@verticesComplements];
pseudoComponentsCount=Length[pseudoComponents];
vertexComponentHash=CreateDataStructure["HashTable"];
threadedComponents=Flatten[Table[Table[{pseudoComponents[[i,j]],i},{j,1,Length[pseudoComponents[[i]]]}],{i,1,pseudoComponentsCount}],1];
vertexComponentHash["Insert",#[[1]]->#[[2]]]&/@threadedComponents;

{},
1]
];

If[showprogress,Print["\t\t","completed ",trial," trials."]];
If[showprogress,Print["\t\t","acceptedEdgesCount = ",acceptedEdgesCount]];
If[showprogress,Print["\t\t","graphEdgesVerticesCount = ",graphEdgesVerticesCount]];

Sort[acceptedEdgeDistances]
];



(* ::Input::Initialization:: *)
(* Outputs EdgeDistances of Least Bridges Graph Clusters *)

(* Input: [edistances_] *)
(* edistances = {{v1\[UndirectedEdge]v2,8},{v1\[DirectedEdge]v3,Sqrt[2]},...} (#1 = directed and/or undirected edges, no rules; #2 = non-complex distance)*)

(* Output: selectedEdgeDistances *)

LeastBridgesClusters[edistances_]:=Block[
{
fmaxdata,fvalsdata,testCount,\[Delta]opt
},
{fmaxdata,fvalsdata,testCount}=ComponentMaximal[edistances];
\[Delta]opt=fmaxdata[[1]];
LeastBridgesEdgeDistances[edistances,\[Delta]opt,False]
];



(* ::Input::Initialization:: *)
(* Outputs classified edge distances of Least Bridges Graph, possibly distance limited *)

(* Input: [edistances_,distancelimit_,verbose_] *)(* edistances = {{v1\[UndirectedEdge]v2,8},{v1\[DirectedEdge]v3,Sqrt[2]},...} (#1 = directed and/or undirected edges, no rules; #2 = non-complex distance)*)
(* distancelimit = L (L \[LessEqual] 0 \[RightArrow] no graph computed, L < \[Infinity] \[RightArrow] LBG computation halts at L if reached, \[Infinity] \[RightArrow] no distance limit, NumberQ[L]\[Equal]False \[RightArrow] ignored) *)
(* verbose = (True | False) progress messages. default is False) *)

(* Output: {componentCoreEdges,nnBridges,leastBridges} *)

LeastBridgesClassifiedEdges[edistances_,distancelimit_,verbose_]:=Block[
(* local variables *)
{
edgeCount,
absoluteMinMax,
distancePairsGathered,
uniqueEdgeDistances,uniqueEdgeDistancesCount,
nnUniqueEdgeDistances,nnEdges,nnUniqueEdges,nnUniqueDirectedEdgeCount,nnUniqueUndirectedEdgeCount,nnEdgeQ,
pairToEdgeHash,pairToDistanceHash,
vertices,verticesCount,
distancelimitNaN,distancelimitStr,requestedlimit,assignedlimit,t,triallimit,
showprogress,
trial,

componentCoreEdges,nnBridges,leastBridges,
componentCoreEdgesCount,nnBridgesCount,leastBridgesCount,
acceptedEdgeDistances,
newComponentQ,

acceptedEdgesCount,priorAcceptedEdgesCount,
graphEdgesVertices,graphEdgesVerticesCount,
graphComponents,graphComponentsCount,graphComponentsVertices,
vertexComponentHash,threadedComponents,
graphPairsDegenerateSet,
trialSelections,trialPairs,trialPairsCount,trialPairsDistance,
thisPair,notDegenerate,v1component,v2component,notSelfLoop,
thisEdge,thisEdgeHeadStr,undirectedEdgeStr,directedEdgeStr,
trialEdgesCount,verticesComplements,verticesComplementsCount,
pseudoComponents,pseudoComponentsCount
},
(* process input *)
edgeCount=Length[edistances];
absoluteMinMax=MinMax[edistances[[;;,2]]];
distancePairsGathered=(GatherBy[Sort[{#[[2]],{#[[1,1]],#[[1,2]]}}&/@edistances],First]);
uniqueEdgeDistances=distancePairsGathered[[;;,1,1]];
uniqueEdgeDistancesCount=Length[distancePairsGathered];
pairToEdgeHash=CreateDataStructure["HashTable"];
pairToEdgeHash["Insert",{#[[1,1]],#[[1,2]]}->#[[1]]]&/@edistances;
pairToDistanceHash=CreateDataStructure["HashTable"];
pairToDistanceHash["Insert",{#[[1,1]],#[[1,2]]}->#[[2]]]&/@edistances;
vertices=Sort[DeleteDuplicates[Flatten[(List@@#)&/@edistances[[;;,1]]]]];
verticesCount=Length[vertices];

distancelimitNaN=!NumberQ[distancelimit];
If[((distancelimitNaN)&&(distancelimit!=\[Infinity])),
Do[
distancelimitStr=ToString[distancelimit];
{assignedlimit,requestedlimit}={0,distancelimitStr};
{},
1],
Which[
distancelimit==\[Infinity],{assignedlimit,requestedlimit}={absoluteMinMax[[2]],distancelimit},
distancelimit<0,{assignedlimit,requestedlimit}={0,distancelimit},
distancelimit>absoluteMinMax[[2]],{assignedlimit,requestedlimit}={absoluteMinMax[[2]],distancelimit},
True,{assignedlimit,requestedlimit}={distancelimit,distancelimit}]
];
t=1;
While[((assignedlimit>=uniqueEdgeDistances[[t]])&&(t<uniqueEdgeDistancesCount)),t++];
If[assignedlimit==uniqueEdgeDistances[[t]],triallimit=t,triallimit=t-1];

showprogress=False;
If[BooleanQ[verbose],showprogress=verbose];

(* more initialization *)
undirectedEdgeStr=ToString[Head[0\[UndirectedEdge]0]];
directedEdgeStr=ToString[Head[0\[DirectedEdge]0]];
nnUniqueEdgeDistances=NearestUniqueEdgeDistances[edistances];
nnUniqueEdges=nnUniqueEdgeDistances[[;;,1]];
nnUniqueDirectedEdgeCount=Total[If[ToString[Head[#]]==directedEdgeStr,1,0]&/@nnUniqueEdges];
nnUniqueUndirectedEdgeCount=Total[If[ToString[Head[#]]==undirectedEdgeStr,1,0]&/@nnUniqueEdges];
nnEdges=DeleteDuplicates[Join[nnUniqueEdges,(If[ToString[Head[#]]==undirectedEdgeStr,#[[2]]\[UndirectedEdge]#[[1]],Nothing]&/@nnUniqueEdges)]];

(* progress report *)
If[showprogress,
Print["LeastBridgesEdgeDistances:"];

Print["\t","INITIALIZATION"];
Print["\t","Dimensions[edistances] = ",Dimensions[edistances]];
Print["\t\t","edgeCount = ",edgeCount];
Print["\t\t","absoluteMinMax = ",absoluteMinMax];
Print["\t\t","uniqueEdgeDistancesCount = ",uniqueEdgeDistancesCount];
Print["\t\t","verticesCount = ",verticesCount];
Print["\t\t","nnUniqueDirectedEdgeCount = ",nnUniqueDirectedEdgeCount];
Print["\t\t","nnUniqueUndirectedEdgeCount = ",nnUniqueUndirectedEdgeCount];

Print["\t","distancelimit = ",distancelimit];
Print["\t\t","distancelimitNaN = ",distancelimitNaN];
Print["\t\t","requestedlimit = ",requestedlimit];
Print["\t\t","assignedlimit = ",assignedlimit];
Print["\t\t","triallimit = ",triallimit," of ",uniqueEdgeDistancesCount," possible"];

Print["\t","verbose = ",verbose];
Print["\t\t","showprogress = ",showprogress];
];

(* least bridges graph edges *)
If[showprogress,
Print["\t","COMPUTATION"];
Print["\t","computing least bridge graph edges"]
];
trial=0;
acceptedEdgeDistances={};
componentCoreEdges={};
nnBridges={};
leastBridges={};
componentCoreEdgesCount=Length[componentCoreEdges];
nnBridgesCount=Length[nnBridges];
leastBridgesCount=Length[leastBridges];
acceptedEdgesCount=0;
graphEdgesVertices={};
graphEdgesVerticesCount=0;
graphComponents={};
graphComponentsCount=Length[graphComponents];
graphComponentsVertices=Sort[Flatten[graphComponents]];
(* vertexComponentHash maps vertex to component index. reset every trial. *)
pseudoComponents=({#}&/@vertices);
pseudoComponentsCount=Length[pseudoComponents];
vertexComponentHash=CreateDataStructure["HashTable"];
threadedComponents=Flatten[Table[Table[{pseudoComponents[[i,j]],i},{j,1,Length[pseudoComponents[[i]]]}],{i,1,pseudoComponentsCount}],1];
vertexComponentHash["Insert",#[[1]]->#[[2]]]&/@threadedComponents;
(* a set of every edge in the graph, including vertex pairs of directed edges and both vertex pairs (forward and reverse) of undirected edges *)
graphPairsDegenerateSet=CreateDataStructure["HashSet"];
If[showprogress,
Print["\t\t","\[Bullet] trial: ",trial];
Print["\t\t\t","pseudoComponentsCount = ",pseudoComponentsCount];
Print["\t\t\t","graphComponentsCount = ",graphComponentsCount];
];
While[((graphComponentsCount>1)||(graphEdgesVerticesCount<verticesCount))&&(trial<triallimit),
Do[
trial++;
If[showprogress,Print["\t\t","\[Bullet] trial: ",trial]];

priorAcceptedEdgesCount=acceptedEdgesCount;
trialSelections=distancePairsGathered[[trial]];
trialPairs=trialSelections[[;;,2]];
trialPairsCount=Length[trialPairs];
trialPairsDistance=pairToDistanceHash["Lookup",trialPairs[[1]]];
If[showprogress,
Print["\t\t\t","trialPairsCount = ",trialPairsCount];
Print["\t\t\t","trialPairsDistance = ",trialPairsDistance];
Print["\t\t\t","trialPairs = ",trialPairs];
];

Do[
thisPair=trialPairs[[p]];
notDegenerate=!graphPairsDegenerateSet["MemberQ",thisPair];
v1component=vertexComponentHash["Lookup",thisPair[[1]]];
v2component=vertexComponentHash["Lookup",thisPair[[2]]];
notSelfLoop=v1component!=v2component;
If[showprogress,
Print["\t\t\t\t","thisPair = ",thisPair];
Print["\t\t\t\t\t","notDegenerate = ",notDegenerate];
Print["\t\t\t\t\t","notSelfLoop = ",notSelfLoop];
];

If[(notDegenerate)&&(notSelfLoop),
Do[
thisEdge=pairToEdgeHash["Lookup",thisPair];
nnEdgeQ=MemberQ[nnEdges,thisEdge];
newComponentQ=!(MemberQ[graphComponentsVertices,thisPair[[1]]]\[Or]MemberQ[graphComponentsVertices,thisPair[[2]]]);
If[showprogress,
Print["\t\t\t\t\t","nnEdgeQ = ",nnEdgeQ];
Print["\t\t\t\t\t","newComponentQ = ",newComponentQ];
];

If[newComponentQ,AppendTo[componentCoreEdges,{thisEdge,trialPairsDistance}]];
If[nnEdgeQ\[And](!newComponentQ),AppendTo[nnBridges,{thisEdge,trialPairsDistance}]];
If[!(nnEdgeQ\[Or]newComponentQ),AppendTo[leastBridges,{thisEdge,trialPairsDistance}]];

thisEdgeHeadStr=ToString[Head[thisEdge]];
If[thisEdgeHeadStr==undirectedEdgeStr,
Do[ (* unordered edge *)
AppendTo[acceptedEdgeDistances,{thisEdge,trialPairsDistance}];
graphPairsDegenerateSet["Insert",thisPair];
graphPairsDegenerateSet["Insert",Reverse[thisPair]];
{},
1]
];
If[thisEdgeHeadStr==directedEdgeStr,
Do[ (* directed edge *)
AppendTo[acceptedEdgeDistances,{thisEdge,trialPairsDistance}];
graphPairsDegenerateSet["Insert",thisPair];
{},
1]
];
{},
1] (* end add thisPair to graph *)
];
{},
{p,1,trialPairsCount}
];

componentCoreEdgesCount=Length[componentCoreEdges];
nnBridgesCount=Length[nnBridges];
leastBridgesCount=Length[leastBridges];

graphComponents=ConnectedComponents[UndirectedGraph[acceptedEdgeDistances[[;;,1]]]];
graphComponentsCount=Length[graphComponents];
graphComponentsVertices=Sort[Flatten[graphComponents]];
acceptedEdgesCount=Length[acceptedEdgeDistances];
trialEdgesCount=acceptedEdgesCount-priorAcceptedEdgesCount;

If[showprogress,
Print["\t\t\t","componentCoreEdgesCount = ",componentCoreEdgesCount];
Print["\t\t\t","nnBridgesCount = ",nnBridgesCount];
Print["\t\t\t","leastBridgesCount = ",leastBridgesCount];
];

graphEdgesVertices=Sort[DeleteDuplicates[Flatten[(List@@#)&/@acceptedEdgeDistances[[;;,1]]]]];
graphEdgesVerticesCount=Length[graphEdgesVertices];
verticesComplements=Complement[vertices,graphEdgesVertices];
verticesComplementsCount=Length[verticesComplements];

pseudoComponents=Join[graphComponents,{#}&/@verticesComplements];
pseudoComponentsCount=Length[pseudoComponents];
vertexComponentHash=CreateDataStructure["HashTable"];
threadedComponents=Flatten[Table[Table[{pseudoComponents[[i,j]],i},{j,1,Length[pseudoComponents[[i]]]}],{i,1,pseudoComponentsCount}],1];
vertexComponentHash["Insert",#[[1]]->#[[2]]]&/@threadedComponents;

{},
1]
];

If[showprogress,Print["\t\t","completed ",trial," trials."]];
If[showprogress,Print["\t\t","acceptedEdgesCount = ",acceptedEdgesCount]];
If[showprogress,Print["\t\t","graphEdgesVerticesCount = ",graphEdgesVerticesCount]];

{componentCoreEdges,nnBridges,leastBridges}
];



(* ::Input::Initialization:: *)
(* Creates Distance Annotated Least Bridges Graph Edges *)

(* Input: [edistances_,estyle_,labeled_,distancelimit_,verbose_] *)
(* edistances = {{v1\[UndirectedEdge]v2,8},{v1\[DirectedEdge]v3,Sqrt[2]},...} (#1 = directed and/or undirected edges, no rules; #2 = non-complex distance)*)
(* estyle = "plain edges" | "hued edges" *)
(* labeled = False | True | fpp (False \[RightArrow] no label, True \[RightArrow] labeled with default fpp, fpp \[RightArrow] use precision fpp \[GreaterEqual] 1) *)
(* distancelimit = L (L \[LessEqual] 0 \[RightArrow] no graph computed, L < \[Infinity] \[RightArrow] LBG computation halts at L if reached, \[Infinity] \[RightArrow] max distance, NumberQ[L]\[Equal]False \[RightArrow] ignored) *)
(* verbose = (True | False) | {True|False, True|False, True|False} (#1 = class messages, #2 = LBG messages, #3 = progress) *)

(* Output: {hues,partitions,annotatedEdges} *)

LeastBridgesPartitionedEdges[edistances_,estyle_,labeled_,distancelimit_,verbose_]:=Block[
(* local variables *)
{
edgeCount,
absoluteMinMax,distancePairsGathered,distancePairsGatheredCount,uniqueEdgeDistances,uniqueEdgeDistancesCount,
pairToEdgeHash,pairToDistanceHash,pairToClassIndexHash,distanceToClassIndexHash,
vertices,verticesCount,binCount,
plainEdges="plain edges",plainEdgesQ, huedEdges="hued edges",huedEdgesQ,edgeStyle,
labelQ,defaultFpp=3,fppQ,fpp,
distancelimitNaN,distancelimitStr,requestedlimit,assignedlimit,t,triallimit,
showclasses,showLBG,showprogress,

partitions={},partitionsCount,np,
b,c,
overallMin,overallMax,binWidth,
processedVertices,processedVerticesCount,remainingVerticesCount,
remainingEdgeData,remainingEdgeDataCount,
theseDistances,theseDistancesCount,theseDistancesMinMax,theseDistancesMean,
distanceClass,distanceClassCount,distanceClasses={},
classVertices,classVerticesCount,distanceClassVertices={},
binPartitionsCount,binPartitions,binsCenters,binsCentersCount,binTallies,binTalliesCount,binsXY,binTallyMax,binsYupperB,
distancesHash,distancesHashCount,
vertexOrderedDistances,distancesGatheredByVertices,firstOrderNeighborDistancesData,
walking,priorTrend,beenDown,beenUp,bFinal,upperBound,trend,plotdistances,
hmin=1/7,hmax=5/6,hsup=1,hinc,hValues,hues={},

trial,
maxEdgeClass,annotatedEdges,graphEdgesCount,priorGraphEdgesCount,
graphEdgesVertices,graphEdgesVerticesCount,
graphComponents,graphComponentsCount,vertexComponentHash,threadedComponents,
graphPairsDegenerateSet,
trialSelections,trialPairs,trialPairsCount,trialPairsDistance,
thisPair,notDegenerate,v1component,v2component,
thisEdge,thisDistance,thisClassIndex,
trialEdgesCount,verticesComplements,verticesComplementsCount,
pseudoComponents,pseudoComponentsCount
},
(* process input *)
edgeCount=Length[edistances];
absoluteMinMax=MinMax[edistances[[;;,2]]];
distancePairsGathered=(GatherBy[Sort[{#[[2]],{#[[1,1]],#[[1,2]]}}&/@edistances],First]);
distancePairsGatheredCount=Length[distancePairsGathered];
uniqueEdgeDistances=distancePairsGathered[[;;,1,1]];
uniqueEdgeDistancesCount=distancePairsGatheredCount;
pairToEdgeHash=CreateDataStructure["HashTable"];
pairToEdgeHash["Insert",{#[[1,1]],#[[1,2]]}->#[[1]]]&/@edistances;
pairToDistanceHash=CreateDataStructure["HashTable"];
pairToDistanceHash["Insert",{#[[1,1]],#[[1,2]]}->#[[2]]]&/@edistances;
pairToClassIndexHash=CreateDataStructure["HashTable"];
distanceToClassIndexHash=CreateDataStructure["HashTable"];
vertices=Sort[DeleteDuplicates[Flatten[(List@@#)&/@edistances[[;;,1]]]]];
verticesCount=Length[vertices];
binCount=Max[1,Round[verticesCount/3]];
plainEdgesQ=(estyle==plainEdges);
huedEdgesQ=(estyle==huedEdges);
edgeStyle="unknown, defaulting to \""<>plainEdges<>"\"";
If[plainEdgesQ||huedEdgesQ,edgeStyle=estyle,plainEdgesQ=True];
fppQ=NumberQ[labeled];
fpp=If[fppQ,Round[labeled],0];
If[fpp>0,
labelQ=True,
If[TrueQ[labeled],
Do[
labelQ=True;
fpp=defaultFpp;
{},
1],
labelQ=False
]
];

distancelimitNaN=!NumberQ[distancelimit];
If[((!NumberQ[distancelimit])&&(distancelimit!=\[Infinity])),
Do[
distancelimitStr=ToString[distancelimit];
{assignedlimit,requestedlimit}={0,distancelimitStr};
{},
1],
Which[
distancelimit==\[Infinity],{assignedlimit,requestedlimit}={absoluteMinMax[[2]],distancelimit},
distancelimit<0,{assignedlimit,requestedlimit}={0,distancelimit},
distancelimit>absoluteMinMax[[2]],{assignedlimit,requestedlimit}={absoluteMinMax[[2]],distancelimit},
True,{assignedlimit,requestedlimit}={distancelimit,distancelimit}]
];
t=1;
While[((assignedlimit>=uniqueEdgeDistances[[t]])&&(t<uniqueEdgeDistancesCount)),t++];
If[assignedlimit==uniqueEdgeDistances[[t]],triallimit=t,triallimit=t-1];
Which[
Length[verbose]==0,Which[!BooleanQ[verbose],{showclasses,showLBG,showprogress}={False,False,True},
verbose,{showclasses,showLBG,showprogress}={True,True,True},
!verbose,{showclasses,showLBG,showprogress}={False,False,False}],
Length[verbose]==3,{showclasses,showLBG,showprogress}=verbose,
True,{showclasses,showLBG,showprogress}={False,False,True}
];
If[showprogress,
Print["LeastBridgesPartitionedEdges:"];
Print["\t","verbose = ",verbose];
Print["\t\t","showclasses = ",showclasses];
Print["\t\t","showLBG = ",showLBG];
Print["\t\t","showprogress = ",showprogress];
Print["\t","edge count = ",edgeCount];
Print["\t","edge distances min/max = ",absoluteMinMax];
Print["\t","unique distances = ",distancePairsGatheredCount];
Print["\t","vertex count = ",verticesCount];
Print["\t\t","computed bin count = ",binCount];
Print["\t","edge style = ",edgeStyle];
Print["\t","label edges = ",labeled];
Print["\t\t","label requested = ",labelQ];
Print["\t\t","fpp supplied = ",fppQ];
Print["\t\t","fpp value = ",fpp];
Print["\t","distance limit = ",assignedlimit];
If[assignedlimit!=requestedlimit,Print["\t\t","requested distance limit (",requestedlimit,") modified"]];
Print["\t\t","trial limit = ",triallimit," of ",uniqueEdgeDistancesCount," possible"];
];

(* distance classes *)
If[showprogress,Print["\t","processing distance classes"]];
absoluteMinMax=MinMax[edistances[[;;,2]]];
If[plainEdgesQ,
Do[
hues={Black};
partitions=absoluteMinMax;
pairToClassIndexHash["Insert",{#[[1,1]],#[[1,2]]}->1]&/@edistances;
{},
1],
    (* else *)
Do[
(* initialization *)
partitions={absoluteMinMax[[1]]};  (* initialization *)
processedVertices={};
processedVerticesCount=0;
remainingEdgeData=edistances;
remainingEdgeDataCount=Length[remainingEdgeData];
theseDistances=remainingEdgeData[[;;,2]];
theseDistancesCount=Length[theseDistances];
theseDistancesMinMax=absoluteMinMax;
overallMin=absoluteMinMax[[1]];
overallMax=absoluteMinMax[[2]];
theseDistancesMean=Mean[theseDistances];
binWidth=N[(overallMax-overallMin)/binCount];
binPartitionsCount=Round[IntegerPart[(overallMax-overallMin)/binWidth]+1]+1;
binPartitions=Table[overallMin+((b-1)*binWidth),{b,1,binPartitionsCount}];
binsCenters=Table[Mean[{binPartitions[[b-1]],binPartitions[[b]]}],{b,2,binPartitionsCount}];
binsCentersCount=Length[binsCenters];
binTallies=BinCounts[theseDistances,{binPartitions}];
binTalliesCount=Length[binTallies];
binsXY=Thread[List[binsCenters,binTallies]];
If[showclasses,
Print[
"\t\t","\[Bullet] initialization\n",
"\t\t\t",
ListPlot[
(If[#[[2]]==0,Nothing,#]&/@binsXY),
PlotRange->{{0,overallMax},All},
PlotStyle->{Black,PointSize[0.025]},
AxesStyle->{{Black,11},{Black,11}},
Ticks->Automatic,
AxesLabel->{Style["bin \[Mu]",{Black,11}],Style["count",{Black,11}]},
PlotLabel->Column[
{
Style["Distance distribution of complete graph",{Black,12}],
Style["binWidth \[TildeTilde] "<>ToString[SetPrecision[binWidth,3]]<>",  mean \[TildeTilde] "<>ToString[SetPrecision[theseDistancesMean,3]],{Black,11}]
},
Center,0.5],
ImageSize->{256,Automatic}
]
]
];
r=4;
c=0;  (* class iteration count *)
While[((processedVerticesCount<verticesCount)&&(remainingEdgeDataCount>0)),
Do[
c++;
If[showclasses,Print["\t\t","\[Bullet] class iteration: ",c]];
(* 1. Get the nearest neighbors *)
remainingVerticesCount=verticesCount-processedVerticesCount;
distancesHash=CreateDataStructure["HashTable"]; (* unique edges are retained in remainingEdgeData *)
distancesHash["Insert",#[[1]]->#[[2]]]&/@remainingEdgeData;
If[distancesHash["KeyExistsQ",#[[1]]],Nothing,distancesHash["Insert",#[[1]]->distancesHash["Lookup",#[[2]]]]]&/@(If[DirectedGraphQ[Graph[#]],Nothing,{Head[#]@@Reverse[List@@#],#}]&/@distancesHash["Keys"]);
distancesHashCount=distancesHash["Length"];
vertexOrderedDistances=Sort[{#[[1]],#[[2]],distancesHash["Lookup",#]}&/@distancesHash["Keys"]];
distancesGatheredByVertices=GatherBy[vertexOrderedDistances,First];
firstOrderNeighborDistancesData=Sort[Flatten[First[GatherBy[Sort[#,(#1[[3]]<#2[[3]])&],Last]]&/@distancesGatheredByVertices,1],(#1[[3]]<#2[[3]])&];
(* 2. Compute the bin data *)
theseDistances=firstOrderNeighborDistancesData[[;;,3]];
theseDistancesCount=Length[theseDistances];
theseDistancesMinMax=MinMax[theseDistances];
theseDistancesMean=Mean[theseDistances];
binPartitionsCount=Round[IntegerPart[(theseDistancesMinMax[[2]]-theseDistances[[1]])/binWidth]+1]+1;
binPartitions=Table[theseDistances[[1]]+((b-1)*binWidth),{b,1,binPartitionsCount}];
binsCenters=Table[Mean[{binPartitions[[b-1]],binPartitions[[b]]}],{b,2,binPartitionsCount}];
binsCentersCount=Length[binsCenters];
binTallies=BinCounts[theseDistances,{binPartitions}];
binTalliesCount=Length[binTallies];
binsXY=Thread[List[binsCenters,binTallies]];
binTallyMax=Max[binTallies];
binsYupperB=If[Mod[binTallyMax,5]==0,binTallyMax+2,Round[binTallyMax+2.5,5]+2];
If[showclasses,
Print[
"\t\t\t",
ListPlot[
binsXY,
PlotRange->{{0,overallMax},{0,binsYupperB}},
PlotStyle->{Black,PointSize[0.025]},
AxesStyle->{{Black,11},{Black,11}},
Ticks->Automatic,
AxesLabel->{Style["bin \[Mu]",{Black,11}],Style["count",{Black,11}]},
PlotLabel->Column[
{
Style["1st order nearest neighbor distances",{Black,12}],
Style["of "<>Which[c==1,"all ",True,"remaining "]<>ToString[remainingVerticesCount]<>" vertices",{Black,12}]
},
Center,0.5],
ImageSize->{256,Automatic}
]
]
];
(* capture leading subdistribution *)
b=1;
trend=0;
If[binTalliesCount>1,  (* We are walking through binTallies. *)
Do[
walking=True;
priorTrend=0;
beenDown=False;
beenUp=False;
While[walking && (b<binTalliesCount),
Do[
b++;
trend=Which[
binTallies[[b]]>binTallies[[b-1]],1,
binTallies[[b]]==binTallies[[b-1]],0,
binTallies[[b]]<binTallies[[b-1]],-1
];
If[(trend==1)&&(trend>priorTrend)&&(beenUp||beenDown),walking=False];
If[(trend==-1)&&(!beenDown),beenDown=True];
If[(trend==1)&&(!beenUp),beenUp=True];
priorTrend=trend;
{},
1]
];
{},
1]
];
bFinal=Max[1,If[((b==binTalliesCount)&&(trend==-1)),b,b-1]];
upperBound=binPartitions[[bFinal+1]];
AppendTo[partitions,upperBound];
(* find the vertices with an edge length < upperBound *)
distanceClass=If[((#[[3]]<upperBound)&&(!MemberQ[processedVertices,#[[1]]])),#,Nothing]&/@firstOrderNeighborDistancesData;
distanceClassCount=Length[distanceClass];
classVertices=Sort[DeleteDuplicates[distanceClass[[;;,1]]]];
classVerticesCount=Length[classVertices];
AppendTo[distanceClassVertices,classVertices];
plotdistances=distanceClass[[;;,3]];
binTallies=BinCounts[plotdistances,{binPartitions}];
binsXY=Thread[List[binsCenters,binTallies]];
If[showclasses,
Print[
"\t\t\t",
ListPlot[
(If[#[[2]]==0,Nothing,#]&/@binsXY),
PlotRange->{{0,overallMax},{0,binsYupperB}},
PlotStyle->{Black,PointSize[0.025]},
AxesStyle->{{Black,11},{Black,11}},
Ticks->Automatic,
AxesLabel->{Style["bin \[Mu]",{Black,11}],Style["count",{Black,11}]},
PlotLabel->Column[
{
Style["Leading "<>ToString[bFinal]<>" bins, upper bound \[TildeTilde] "<>ToString[SetPrecision[upperBound,3]],{Black,12}],
Style["with "<>ToString[classVerticesCount]<>" vertices and "<>ToString[Length[DeleteDuplicates[plotdistances]]]<>" unique distances",{Black,12}]
},
Center,0.5],
ImageSize->{256,Automatic}
]
]
];
(* update the recursive files *)
processedVertices=Sort[Join[processedVertices,classVertices]];
remainingEdgeData=If[MemberQ[classVertices,#[[1,1]]]||MemberQ[classVertices,#[[1,2]]],Nothing,#]&/@remainingEdgeData;
distanceClasses=AppendTo[distanceClasses,distanceClass];
processedVerticesCount=Length[processedVertices];
remainingEdgeDataCount=Length[remainingEdgeData];
{},
1]
]; (* end While *)
If[c==1,partitions=binPartitions];
If[Last[partitions]!=overallMax,AppendTo[partitions,overallMax]];
partitionsCount=Length[partitions];
(* assign the class indices *)
If[showclasses,Print["\t\t","\[Bullet] assigning class indices"]];
Do[
thisDistance=pairToDistanceHash["Lookup",pair];
c=1;
While[((c<partitionsCount)&&(partitions[[c+1]]<=thisDistance)),c++];
pairToClassIndexHash["Insert",pair->c];
distanceToClassIndexHash["Insert",thisDistance->c]; (* cross-check of assignment *)
{},
{pair,pairToDistanceHash["Keys"]}
];
(* Print["\t\t","distanceToClassIndexHash = ",{#,distanceToClassIndexHash["Lookup",#]}&/@Sort[distanceToClassIndexHash["Keys"]]]; *)
(* assign the hues *)
np=Max[1,partitionsCount-3];
hinc=(hmax-hmin)/np;
hValues=Table[h,{h,hmin,hmax,hinc}];
(* AppendTo[hValues,hsup]; *)
hues=Hue[#]&/@hValues;
If[showprogress,Print["\t\t","hue values = ",hValues]];
{},
1]
];
If[showprogress,Print["\t\t","hues = ",hues]];
If[showprogress,Print["\t\t","partitions = ",partitions]];

(* least bridge graph edges *)
If[showprogress,Print["\t","computing least bridge graph edges"]];
trial=0;
maxEdgeClass=0;
annotatedEdges={};
graphEdgesCount=0;
graphEdgesVertices={};
graphEdgesVerticesCount=0;
graphComponents={#}&/@vertices;
graphComponentsCount=Length[graphComponents];
(* maps vertex to component index. reset every trial. *)
vertexComponentHash=CreateDataStructure["HashTable"];
threadedComponents=Flatten[Table[Table[{graphComponents[[i,j]],i},{j,1,Length[graphComponents[[i]]]}],{i,1,graphComponentsCount}],1];
vertexComponentHash["Insert",#[[1]]->#[[2]]]&/@threadedComponents;
(* a set of every edge in the graph, including vertex pairs of directed edges and both vertex pairs (forward and reverse) of undirected edges *)
graphPairsDegenerateSet=CreateDataStructure["HashSet"];
If[showLBG,Print[
"\t\t","\[Bullet] trial iteration: ",trial,"\n",
"\t\t\t","components = ",graphComponentsCount,"\n",
"\t\t\t","distance pair sets = ",distancePairsGatheredCount
]];
While[((graphComponentsCount>1)||(graphEdgesVerticesCount<verticesCount))&&(trial<triallimit),
Do[
trial++;
If[showLBG,Print["\t\t","\[Bullet] trial iteration: ",trial]];

priorGraphEdgesCount=graphEdgesCount;
trialSelections=distancePairsGathered[[trial]];
trialPairs=trialSelections[[;;,2]];
trialPairsCount=Length[trialPairs];
trialPairsDistance=pairToDistanceHash["Lookup",trialPairs[[1]]];
If[showprogress,
Print["\t\t\t","trial pairs count = ",trialPairsCount];
Print["\t\t\t","trial pairs distance = ",trialPairsDistance];
Print["\t\t\t","trialPairs = ",trialPairs];
];

Do[
thisPair=trialPairs[[p]];
notDegenerate=!graphPairsDegenerateSet["MemberQ",thisPair];
v1component=vertexComponentHash["Lookup",thisPair[[1]]];
v2component=vertexComponentHash["Lookup",thisPair[[2]]];

If[(notDegenerate)&&(v1component!=v2component),
Do[
thisEdge=pairToEdgeHash["Lookup",thisPair];
thisClassIndex=pairToClassIndexHash["Lookup",thisPair];
maxEdgeClass=Max[maxEdgeClass,thisClassIndex];
If[Head[thisEdge]==Head[0\[UndirectedEdge]0],
Do[ (* unordered edge *)
If[labelQ,
AppendTo[annotatedEdges,Annotation[thisEdge,{EdgeLabels->Placed[Style[SetPrecision[trialPairsDistance,fpp],{Black,11}],Automatic],EdgeStyle->{Thickness[Medium],Dashing[{}],hues[[thisClassIndex]]}}]],
AppendTo[annotatedEdges,Annotation[thisEdge,{EdgeStyle->{Thickness[Medium],Dashing[{}],hues[[thisClassIndex]]}}]]
];
graphPairsDegenerateSet["Insert",thisPair];
graphPairsDegenerateSet["Insert",Reverse[thisPair]];
{},
1]
];
If[Head[thisEdge]==Head[0\[DirectedEdge]0],
Do[ (* directed edge *)
If[labelQ,
AppendTo[annotatedEdges,Annotation[thisEdge,{EdgeLabels->Placed[Style[SetPrecision[trialPairsDistance,fpp],{Black,11}],Automatic],EdgeStyle->{Thickness[Medium],Dashing[{}],hues[[thisClassIndex]]}}]],
AppendTo[annotatedEdges,Annotation[thisEdge,{EdgeStyle->{Thickness[Medium],Dashing[{}],hues[[thisClassIndex]]}}]]
];
graphPairsDegenerateSet["Insert",thisPair];
{},
1]
];
{},
1] (* end add thisPair to graph *)
];
{},
{p,1,trialPairsCount}
];

graphComponents=ConnectedComponents[UndirectedGraph[annotatedEdges]];
graphComponentsCount=Length[graphComponents];
graphEdgesCount=Length[annotatedEdges];
trialEdgesCount=graphEdgesCount-priorGraphEdgesCount;
graphEdgesVertices=Sort[DeleteDuplicates[Flatten[List@@#[[1]]&/@annotatedEdges]]];
graphEdgesVerticesCount=Length[graphEdgesVertices];
verticesComplements=Complement[vertices,graphEdgesVertices];
verticesComplementsCount=Length[verticesComplements];

pseudoComponents=Join[graphComponents,{#}&/@verticesComplements];
pseudoComponentsCount=Length[pseudoComponents];
vertexComponentHash=CreateDataStructure["HashTable"];
threadedComponents=Flatten[Table[Table[{pseudoComponents[[i,j]],i},{j,1,Length[pseudoComponents[[i]]]}],{i,1,pseudoComponentsCount}],1];
vertexComponentHash["Insert",#[[1]]->#[[2]]]&/@threadedComponents;

{},
1]
];

If[showprogress,Print["\t\t","completed ",trial," trials."]];
If[showprogress,Print["\t\t","graph edges count = ",graphEdgesCount]];
If[showprogress,Print["\t\t","graph vertices count = ",graphEdgesVerticesCount]];
If[showprogress,Print["\t\t","maxEdgeClass = ",maxEdgeClass]];

{hues,partitions,Sort[annotatedEdges]}
];



(* ::Input::Initialization:: *)
HuePartitionLegend[hues_,partitions_,fpp_]:=Row[
{
Column[Style[#,{Black,12}]&/@{"Distance","Legend:"},Left,0.5],
Grid[
{
hues,
Table[Style[ToString[Row[SetPrecision[#,fpp]&/@{partitions[[p]],partitions[[p+1]]},", "]],{Black,12}],{p,1,Length[hues]}]
},
Alignment->Center,Spacings->{1, 1},Frame->All]
},Spacer[16]];



(* ::Input::Initialization:: *)
(* Outputs unique nearest-neighbor EdgeDistances, where {Edge[a,b], c} means b is a nearest-neighbor of a at distance c *)
(* Input: [edistances_] *)(* edistances = {{v1\[UndirectedEdge]v2,8},{v1\[DirectedEdge]v3,Sqrt[2]},...} (#1 = directed and/or undirected edges, no rules; #2 = non-complex distance)*)

NearestUniqueEdgeDistances[edistances_]:=Block[
(* local variables *)
{
undirectedEdgeStr,directedEdgeStr,
vertexEdges,
nnEdgeDistances
},
undirectedEdgeStr=ToString[Head[0\[UndirectedEdge]0]];
directedEdgeStr=ToString[Head[0\[DirectedEdge]0]];
vertexEdges=DeleteDuplicates[Join[
({#[[1,1]],#[[1]],#[[2]]}&/@edistances),
(If[ToString[Head[#[[1]]]]==directedEdgeStr,Nothing,{#[[1,2]],#[[1,2]]\[UndirectedEdge]#[[1,1]],#[[2]]}]&/@edistances)
]];
nnEdgeDistances=DeleteDuplicates[
(
{If[ToString[Head[#[[2]]]]==undirectedEdgeStr,Sort[#[[2]]],#[[2]]],#[[3]]}&/@Flatten[(GatherBy[#,Last][[1]]&/@(SortBy[#,Last]&/@GatherBy[vertexEdges,First])),1]
)];

nnEdgeDistances
];




(* ::Input::Initialization:: *)
(* Outputs {fmaxdata,fvalsdata,testCount} *)

(* Input: edistances_ *)
(* edistances = {{v1\[UndirectedEdge]v2,8},{v1\[DirectedEdge]v3,Sqrt[2]},...} (#1 = directed and/or undirected edges, no rules; #2 = non-complex distance)*)

(* Output: {fmaxdata,fvalsdata,testCount} *)
(* fmaxdata = {Subscript[\[Delta], opt],c,v,f[Subscript[\[Delta], opt]]} *)
(* fvalsdata = {{Subscript[\[Delta], 1],c,v,f[Subscript[\[Delta], 1]]},...,{Subscript[\[Delta], n],c,v,f[Subscript[\[Delta], n]]}} where n is determined by a telescoping algorithm *)
(* testCount = # of telescoping trials to determine Subscript[\[Delta], opt] *)

ComponentMaximal[edistances_]:=Block[
{
uniqueEdgeDistances,uniqueEdgeDistancesCount,uniqueEdgeDistancesIndexHash,
verticesHalfCount,
imin,imax,iinc,iopt,iradius,
new\[Delta]vals,new\[Delta]valscount,\[Delta]vals,\[Delta]opt,
myf,fscale,newfvals,fmax,fmaxdata,fvalsdata,
testCount
},
(* initialize *)
uniqueEdgeDistances=Sort[DeleteDuplicates[edistances[[;;,2]]]];
uniqueEdgeDistancesCount=Length[uniqueEdgeDistances];
uniqueEdgeDistancesIndexHash=CreateDataStructure["HashTable"];
uniqueEdgeDistancesIndexHash["Insert",uniqueEdgeDistances[[#]]->#]&/@Range[uniqueEdgeDistancesCount];
verticesQuarterCount=Length[DeleteDuplicates[Flatten[List@@@edistances[[;;,1]]]]]/4;
fscale=1;
While[fscale<verticesQuarterCount,fscale*=2];
myf[x_]:=Block[
{edists,edgeG,compcount,vertcount,f},
edists=LeastBridgesEdgeDistances[edistances,x,False];
edgeG=Graph[edists[[;;,1]]];
compcount=Length[ConnectedComponents[edgeG]];
vertcount=Length[VertexList[edgeG]];
f=compcount*vertcount/fscale;
{x,compcount,vertcount,f}
];
(* compute *)
\[Delta]vals={};
fvalsdata={};
imin=1;
imax=uniqueEdgeDistancesCount;
new\[Delta]valscount=uniqueEdgeDistancesCount;
testCount=0;

While[new\[Delta]valscount>0,
testCount++;
iinc=(imax-imin)/8;

new\[Delta]vals=If[MemberQ[\[Delta]vals,#],Nothing,#]&/@DeleteDuplicates[Table[uniqueEdgeDistances[[Round[i]]],{i,imin,imax,iinc}]];
newfvals=(myf[#]&/@new\[Delta]vals);
fvalsdata=Join[fvalsdata,newfvals];

fmax=Max[fvalsdata[[;;,4]]];
fmaxdata=Last[If[#[[4]]==fmax,#,Nothing]&/@fvalsdata];
\[Delta]opt=fmaxdata[[1]];
iopt=uniqueEdgeDistancesIndexHash["Lookup",\[Delta]opt];

iradius=Round[3*iinc];
imin=Max[iopt-iradius,1];
imax=Min[iopt+iradius,uniqueEdgeDistancesCount];

\[Delta]vals=Join[\[Delta]vals,new\[Delta]vals];
new\[Delta]valscount=Length[new\[Delta]vals];
];

{fmaxdata,fvalsdata,testCount}
];



(* ::Input::Initialization:: *)
(* Outputs List of Laplacian matrix eigenvalues or List of error code(s) *)

(* Input: [edgelist_] *)
(* edgelist = {v1\[UndirectedEdge]v2,{v1\[DirectedEdge]v3},...} directed and/or undirected edges, no rules or other Head *)

(* Output: laplacianMatrixEigenvalues *)

LaplacianMatrixEigenvalues[edgelist_]:=Block[
{
directedEdgeStr,undirectedEdgeStr,acceptedEdgeHeadStrs,
vertexPairs,
vertices,verticesCount,vertexCoordHash,
vertexDegrees,
labeledLaplacianMatrix,j,
laplacianMatrixEigenvalues
},
directedEdgeStr=ToString[Head[0\[DirectedEdge]0]];
undirectedEdgeStr=ToString[Head[0\[UndirectedEdge]0]];
acceptedEdgeHeadStrs={directedEdgeStr,undirectedEdgeStr};
laplacianMatrixEigenvalues=Join[{Indeterminate},(If[MemberQ[acceptedEdgeHeadStrs,#],Nothing,#]&/@(ToString[Head[#]]&/@edgelist))];

If[Length[laplacianMatrixEigenvalues]==1,
vertexPairs=Join[List@@@edgelist,If[ToString[Head[#]]==undirectedEdgeStr,Reverse[List@@#],Nothing]&/@edgelist];
(* Print[vertexPairs]; *)

vertices=Sort[DeleteDuplicates[Flatten[vertexPairs]]];
verticesCount=Length[vertices];
vertexCoordHash=CreateDataStructure["HashTable"];
vertexCoordHash["Insert",vertices[[#]]->(#+1)]&/@Range[verticesCount];
(* Print[{#,vertexCoordHash["Lookup",#]}&/@vertices]; *)

vertexDegrees=Table[
{v,Total[If[#[[1]]==v,1,0]&/@vertexPairs]},
{v,vertices}
];
(* Print[vertexDegrees]; *)

labeledLaplacianMatrix=Table[Table[0,verticesCount+1],verticesCount+1];
labeledLaplacianMatrix[[2;;,1]]=vertices;
labeledLaplacianMatrix[[1,2;;]]=vertices;
Do[
labeledLaplacianMatrix[[vertexCoordHash["Lookup",edata[[1]]],vertexCoordHash["Lookup",edata[[2]]]]]=-1,
{edata,vertexPairs}
];
j=1;
Do[
j++;
labeledLaplacianMatrix[[j,j]]+=vertexDegrees[[i,2]],
{i,verticesCount}
];
(* Print["labeledLaplacianMatrix:\n",Grid[labeledLaplacianMatrix,Frame\[Rule]All]]; *)

laplacianMatrixEigenvalues=N[Eigenvalues[labeledLaplacianMatrix[[2;;,2;;]]]];
(* Print[laplacianMatrixEigenvalues]; *)
];

laplacianMatrixEigenvalues
];



(* ::Input::Initialization:: *)
LeastBridgesGraphsKey:=3306206825;

