(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    427075,       8178]
NotebookOptionsPosition[    425226,       8138]
NotebookOutlinePosition[    425698,       8157]
CellTagsIndexPosition[    425655,       8154]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"SetOptions", "[", 
  RowBox[{
   RowBox[{"InputNotebook", "[", "]"}], ",", 
   RowBox[{"AutoGeneratedPackage", "\[Rule]", "Automatic"}]}], "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.802192433608954*^9, 3.802192433608954*^9}},
 CellLabel->"In[13]:=",ExpressionUUID->"8c5d4967-02f1-4da1-84c8-76a8548377d4"],

Cell[BoxData[
 RowBox[{"(*", "\[IndentingNewLine]", "   ", 
  RowBox[{
   RowBox[{"Frost", " ", "Concepts"}], ",", " ", 
   RowBox[{
    RowBox[{
    "2021.", "\[IndentingNewLine]", " ", "Use", " ", "at", " ", "your", " ", 
     "own", " ", 
     RowBox[{"risk", ".", "\[IndentingNewLine]", "Most"}], " ", "rights", " ", 
     RowBox[{"reserved", ".", "\[IndentingNewLine]", "Permission"}], " ", 
     "for", " ", "resale", " ", "not", " ", 
     RowBox[{"granted", ".", "\[IndentingNewLine]", 
      RowBox[{"http", ":"}]}]}], "//", 
    RowBox[{
     RowBox[{"www", ".", "frostconcepts", ".", "org"}], "\[IndentingNewLine]",
      " ", "Requires", " ", "Mathematica", 
     TooltipBox[
      StyleBox["\[RegisteredTrademark]", "StandFormChar"],
      "StandardForm"], " ", "v12", ".1", " ", "or", " ", "later"}]}]}], 
  "\[IndentingNewLine]", "*)"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.802192433608954*^9, 3.802192433608954*^9}, {
  3.8248608627209926`*^9, 3.8248609251279907`*^9}, {3.8479230012648163`*^9, 
  3.84792300781653*^9}, {3.848192776914865*^9, 3.8481928035074625`*^9}, {
  3.848192858748963*^9, 3.8481928663468385`*^9}, {3.8482618726360407`*^9, 
  3.84826188137094*^9}, {3.8482619142360487`*^9, 3.8482619202188225`*^9}, {
  3.8482619589686484`*^9, 3.8482621067777004`*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"9480d78b-feb2-41d0-b29e-a0a9a01ad1da"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Analyzes", " ", "edistances", " ", "for", " ", "metric", " ", "criteria", 
    " ", "and", " ", "other", " ", "attributes"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Input", ":", " ", 
    RowBox[{"[", 
     RowBox[{"edistances_", ",", "verbose_"}], "]"}]}], " ", "*)"}], 
  RowBox[{"(*", " ", 
   RowBox[{"edistances", " ", "=", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"v1", "\[UndirectedEdge]", "v2"}], ",", "8"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"v1", "\[DirectedEdge]", "v3"}], ",", 
         SqrtBox["2"]}], "}"}], ",", "..."}], "}"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"#1", " ", "=", " ", 
        RowBox[{"directed", " ", 
         RowBox[{"and", "/", "or"}], " ", "undirected", " ", "edges"}]}], ",",
        " ", 
       RowBox[{
        RowBox[{"no", " ", "rules"}], ";", " ", 
        RowBox[{"#2", " ", "=", " ", 
         RowBox[{"non", "-", 
          RowBox[{"complex", " ", "distance"}]}]}]}]}], ")"}]}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{" ", 
    RowBox[{"verbose", " ", "=", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"True", " ", "|", " ", "False"}], ")"}], " ", "progress", " ", 
      RowBox[{"messages", ".", " ", "default"}], " ", "is", " ", "False"}]}], 
    ")"}], " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Output", ":", " ", "resultsTable"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"EdgeDistanceGraphAnalysis", "[", 
      RowBox[{"edistances_", ",", "verbose_"}], "]"}], ":=", 
     RowBox[{"Block", "[", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"local", " ", "variables"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
        "showprogress", ",", "\[IndentingNewLine]", "passedStr", ",", 
         "failedStr", ",", "naStr", ",", "\[IndentingNewLine]", 
         "undirectedEdgeStr", ",", "directedEdgeStr", ",", 
         "\[IndentingNewLine]", "startTime", ",", "endTime", ",", 
         "elapsedTime", ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         "edistancesDimensions", ",", "edgeList", ",", "edgeListCount", ",", 
         "distanceList", ",", "\[IndentingNewLine]", 
         "edistancesDimensionTests", ",", "edistancesDimensionFailures", ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "realStr", ",", 
         "invalidDistancesTests", ",", "invalidDistances", ",", 
         "invalidDistancesTestFailures", ",", "invalidDistancesTestValue", 
         ",", "hasInvalidDistances", ",", "\[IndentingNewLine]", 
         "distancesMinMaxTests", ",", "distancesMinMaxTestFailures", ",", 
         "distancesMinMax", ",", "\[IndentingNewLine]", "minAbsDistance", ",",
          "\[Epsilon]", ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         "directedEdgeTests", ",", "directedEdgeCount", ",", 
         "directedEdgeFailures", ",", "hasDirectedEdges", ",", 
         "\[IndentingNewLine]", "undirectedEdgeTests", ",", 
         "undirectedEdgeCount", ",", "undirectedEdgeFailures", ",", 
         "hasUndirectedEdges", ",", "\[IndentingNewLine]", "invalidEdgeTests",
          ",", "invalidEdgeTestFailures", ",", "invalidEdgeTestValue", ",", 
         "hasInvalidEdges", ",", "\[IndentingNewLine]", "\[IndentingNewLine]",
          "vertexEdgeData1", ",", "gatheredInputPairData", ",", 
         "\[IndentingNewLine]", "vertexEdgeData2", ",", "vertexEdgeData", ",",
          "gatheredVertexPairData", ",", "\[IndentingNewLine]", 
         "gatheredVertexEdgesData", ",", "gatheredVertexEdgesHash", ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "duplicateEdgeTests", 
         ",", "duplicateEdgeCount", ",", "noDuplicateEdgesQ", ",", 
         "duplicateEdgeTestValue", ",", "\[IndentingNewLine]", 
         "nonZeroSelfLoopTests", ",", "nonZeroSelfLoopCount", ",", 
         "noNonZeroSelfLoopsQ", ",", "nonZeroSelfLoopTestValue", ",", 
         "\[IndentingNewLine]", "singleEdgePathTests", ",", 
         "singleEdgePathTestsFailures", ",", "singleEdgePathCount", ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "vertices", ",", 
         "\[IndentingNewLine]", "verticesTests", ",", "verticesTestsFailures",
          ",", "verticesCount", ",", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "vertexEdgeDistancesTallies", ",", 
         "\[IndentingNewLine]", "verticesMultiplicitiesTests", ",", 
         "verticesMultiplicitiesTestFailures", ",", 
         "verticesMultiplicitiesCount", ",", "\[IndentingNewLine]", 
         "verticesMultiplicityRangeTests", ",", 
         "verticesMultiplicityRangeTestFailures", ",", 
         "verticesMultiplicityRange", ",", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "sortedVertexEdgeDistancesTallies", ",", 
         "\[IndentingNewLine]", "nnMultiplicitiesTests", ",", 
         "nnMultiplicitiesTestFailures", ",", "nnMultiplicitiesCount", ",", 
         "\[IndentingNewLine]", "nnMultiplicitiesRangeTests", ",", 
         "nnMultiplicitiesRangeTestFailures", ",", "nnMultiplicitiesRange", 
         ",", "\[IndentingNewLine]", "\[IndentingNewLine]", "fvalsdata", ",", 
         "fmaxdata", ",", "\[IndentingNewLine]", "componentMaximalTests", ",",
          "componentMaximalTestFailures", ",", "componentMaximalTestValue", 
         ",", "\[IndentingNewLine]", "\[IndentingNewLine]", "plainEdgeGraph", 
         ",", "\[IndentingNewLine]", "connectedTests", ",", "componentsCount",
          ",", "connectedFailures", ",", "connectedQ", ",", 
         "connectedTestValue", ",", "\[IndentingNewLine]", "edgeHashSet", ",",
          "\[IndentingNewLine]", "completeTests", ",", "completeCount", ",", 
         "completeFailures", ",", "completeQ", ",", "v1", ",", "v2", ",", 
         "e1", ",", "e2", ",", "e3", ",", "e4", ",", "completeTestValue", ",",
          "\[IndentingNewLine]", "\[IndentingNewLine]", "LBGedgeList", ",", 
         "LBGedgeListCount", ",", "\[IndentingNewLine]", 
         "LBGedgesLaplacianTests", ",", "LBGedgesLaplacianEigenvalues", ",", 
         "LBGedgesLaplacianFailures", ",", "LBGedgesLaplacianTestValue", ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         "positiveDefiniteTests", ",", "positiveDefiniteFailures", ",", 
         "positiveDefiniteQ", ",", "positiveDefiniteTestValue", ",", 
         "\[IndentingNewLine]", "identityTests", ",", "identityFailures", ",",
          "identityQ", ",", "identityTestValue", ",", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "vertexPairEdgeDataHash", ",", 
         "\[IndentingNewLine]", "commutativeTests", ",", 
         "commutativeFailures", ",", "commutativeQ", ",", 
         "commutativeTestValue", ",", "\[IndentingNewLine]", "epair", ",", 
         "edist", ",", "rpair", ",", "rpdata", ",", "rdist", ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "triangleTests", ",", 
         "triangleFailures", ",", "triangleQ", ",", "triangleTestValue", ",", 
         "\[IndentingNewLine]", "a", ",", "agoes", ",", "b", ",", "abdist", 
         ",", "bgoes", ",", "c", ",", "bcdist", ",", "acdistlist", ",", 
         "error", ",", "abserror", ",", "minTerror", ",", "maxTerror", ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         "triangleTestsMinMaxTests", ",", "triangleTestsMinMaxFailures", ",", 
         "triangleTestsMinMaxErrors", ",", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "metricTests", ",", "metricFailures", ",", 
         "metricQ", ",", "metricTestValue", ",", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "EDGAstartTime", ",", "EDGAendTime", ",", 
         "EDGAelapsedTime", ",", "\[IndentingNewLine]", "resultsHeader", ",", 
         "timingResults", ",", "resultsBody", ",", "resultsTable"}], 
        "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"EDGAstartTime", "=", 
         RowBox[{"AbsoluteTime", "[", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"process", " ", "input"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"edistancesDimensions", "=", 
         RowBox[{"Dimensions", "[", "edistances", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"edgeList", "=", 
         RowBox[{"edistances", "[", 
          RowBox[{"[", 
           RowBox[{";;", ",", "1"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"edgeListCount", "=", 
         RowBox[{"Length", "[", "edgeList", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"distanceList", "=", 
         RowBox[{"edistances", "[", 
          RowBox[{"[", 
           RowBox[{";;", ",", "2"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"showprogress", "=", "False"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"BooleanQ", "[", "verbose", "]"}], ",", 
          RowBox[{"showprogress", "=", "verbose"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Print", "[", "\"\<EdgeDistanceGraphAnalysis:\>\"", "]"}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<edistancesDimensions = \>\"", ",", 
             "edistancesDimensions"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<showprogress = \>\"", ",", 
             "showprogress"}], "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], 
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", "initialization", " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"passedStr", "=", "\"\<Passed\>\""}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"failedStr", "=", "\"\<Failed\>\""}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"naStr", "=", "\"\<n/a\>\""}], ";", "\[IndentingNewLine]", 
        RowBox[{"undirectedEdgeStr", "=", 
         RowBox[{"ToString", "[", 
          RowBox[{"Head", "[", 
           RowBox[{"0", "\[UndirectedEdge]", "0"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"directedEdgeStr", "=", 
         RowBox[{"ToString", "[", 
          RowBox[{"Head", "[", 
           RowBox[{"0", "\[DirectedEdge]", "0"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"realStr", "=", 
         RowBox[{"ToString", "[", 
          RowBox[{"Head", "[", 
           RowBox[{"N", "[", 
            RowBox[{"Sqrt", "[", "2", "]"}], "]"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", "analysis", " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"edistancesDimensionTests", "=", "naStr"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"edistancesDimensionFailures", "=", "naStr"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"invalidDistancesTests", "=", "edgeListCount"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"invalidDistances", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"#", "\[Equal]", "realStr"}], ",", "Nothing", ",", "#"}],
             "]"}], "&"}], "/@", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"ToString", "[", 
              RowBox[{"Head", "[", 
               RowBox[{"N", "[", "#", "]"}], "]"}], "]"}], "&"}], "/@", 
            "distanceList"}], ")"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"invalidDistancesTestFailures", "=", 
         RowBox[{"Length", "[", "invalidDistances", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"hasInvalidDistances", "=", 
         RowBox[{"(", 
          RowBox[{"invalidDistancesTestFailures", ">", "0"}], ")"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"invalidDistancesTestValue", "=", 
         RowBox[{"If", "[", 
          RowBox[{"hasInvalidDistances", ",", "\[IndentingNewLine]", 
           RowBox[{"failedStr", "<>", "\"\<: \>\"", "<>", 
            RowBox[{"StringRiffle", "[", 
             RowBox[{"invalidDistances", ",", "\"\<, \>\""}], "]"}]}], ",", 
           "\[IndentingNewLine]", "passedStr"}], "\[IndentingNewLine]", 
          "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"distancesMinMaxTests", "=", "edgeListCount"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"distancesMinMaxTestFailures", "=", "naStr"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"distancesMinMax", "=", 
         RowBox[{"MinMax", "[", "distanceList", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"minAbsDistance", "=", 
         RowBox[{"Min", "[", 
          RowBox[{"Abs", "[", "distanceList", "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Epsilon]", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"minAbsDistance", "\[Equal]", "0"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"1.0", "*", 
            SuperscriptBox["10", 
             RowBox[{"-", "9"}]]}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"N", "[", 
             RowBox[{"minAbsDistance", "/", "2"}], "]"}], "*", 
            SuperscriptBox["10", 
             RowBox[{"-", "9"}]]}]}], "\[IndentingNewLine]", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"directedEdgeCount", "=", 
         RowBox[{"Total", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"ToString", "[", 
                RowBox[{"Head", "[", "#", "]"}], "]"}], "\[Equal]", 
               "directedEdgeStr"}], ",", "1", ",", "0"}], "]"}], "&"}], "/@", 
           "edgeList"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"hasDirectedEdges", "=", 
         RowBox[{"(", 
          RowBox[{"directedEdgeCount", ">", "0"}], ")"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"directedEdgeTests", "=", "edgeListCount"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"directedEdgeFailures", "=", "naStr"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"undirectedEdgeCount", "=", 
         RowBox[{"Total", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"ToString", "[", 
                RowBox[{"Head", "[", "#", "]"}], "]"}], "\[Equal]", 
               "undirectedEdgeStr"}], ",", "1", ",", "0"}], "]"}], "&"}], "/@",
            "edgeList"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"hasUndirectedEdges", "=", 
         RowBox[{"(", 
          RowBox[{"undirectedEdgeCount", ">", "0"}], ")"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"undirectedEdgeTests", "=", "edgeListCount"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"undirectedEdgeFailures", "=", "naStr"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"invalidEdgeTests", "=", "edgeListCount"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"invalidEdgeTestFailures", "=", 
         RowBox[{"edgeListCount", "-", 
          RowBox[{"(", 
           RowBox[{"directedEdgeCount", "+", "undirectedEdgeCount"}], 
           ")"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"hasInvalidEdges", "=", 
         RowBox[{"(", 
          RowBox[{"invalidEdgeTestFailures", ">", "0"}], ")"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"invalidEdgeTestValue", "=", 
         RowBox[{"If", "[", 
          RowBox[{"hasInvalidEdges", ",", "\[IndentingNewLine]", 
           RowBox[{"failedStr", "<>", "\"\<: \>\"", "<>", 
            RowBox[{"StringRiffle", "[", 
             RowBox[{
              RowBox[{"Sort", "[", 
               RowBox[{"DeleteDuplicates", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"undirectedEdgeStr", ",", "directedEdgeStr"}], 
                    "}"}], ",", "#"}], "]"}], ",", "Nothing", ",", "#"}], 
                   "]"}], "&"}], "/@", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"ToString", "[", 
                    RowBox[{"Head", "[", "#", "]"}], "]"}], "&"}], "/@", 
                   "edgeList"}], ")"}]}], "]"}], "]"}], ",", "\"\<, \>\""}], 
             "]"}]}], ",", "\[IndentingNewLine]", "passedStr"}], 
          "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"nonZeroSelfLoopTests", "=", "edgeListCount"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"nonZeroSelfLoopCount", "=", 
         RowBox[{"Total", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", 
                   RowBox[{"1", ",", "1"}], "]"}], "]"}], "\[Equal]", 
                 RowBox[{"#", "[", 
                  RowBox[{"[", 
                   RowBox[{"1", ",", "2"}], "]"}], "]"}]}], ")"}], "\[And]", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "\[NotEqual]", "0"}], 
                ")"}]}], ",", "1", ",", "0"}], "]"}], "&"}], "/@", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"List", "@@", 
                  RowBox[{"#", "[", 
                   RowBox[{"[", "1", "]"}], "]"}]}], ")"}], ",", 
                RowBox[{"#", "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "&"}], "/@", 
             "edistances"}], ")"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"noNonZeroSelfLoopsQ", "=", 
         RowBox[{"(", 
          RowBox[{"nonZeroSelfLoopCount", "\[Equal]", "0"}], ")"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"nonZeroSelfLoopTestValue", "=", 
         RowBox[{"If", "[", 
          RowBox[{"noNonZeroSelfLoopsQ", ",", "passedStr", ",", "failedStr"}],
           "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"vertexEdgeData1", "=", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"#", "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
              RowBox[{"#", "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "2"}], "]"}], "]"}], ",", 
              RowBox[{"#", "[", 
               RowBox[{"[", "2", "]"}], "]"}], ",", 
              RowBox[{"ToString", "[", 
               RowBox[{"Head", "[", 
                RowBox[{"#", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}], "]"}]}], "}"}], "&"}],
            "/@", "edistances"}], ")"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"gatheredInputPairData", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"#", "[", 
              RowBox[{"[", 
               RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"#", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], ",", 
                  RowBox[{"#", "[", 
                   RowBox[{"[", "3", "]"}], "]"}]}], "}"}], "&"}], "/@", 
               "#"}], ")"}]}], "}"}], "&"}], "/@", 
          RowBox[{"GatherBy", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"#", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], ",", 
                  RowBox[{"#", "[", 
                   RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ",", 
                RowBox[{"#", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], ",", 
                RowBox[{"#", "[", 
                 RowBox[{"[", "4", "]"}], "]"}]}], "}"}], "&"}], "/@", 
             "vertexEdgeData1"}], ",", "First"}], "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"vertexEdgeData2", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"#", "[", 
               RowBox[{"[", "4", "]"}], "]"}], "\[Equal]", 
              "undirectedEdgeStr"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"#", "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{"#", "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{"#", "[", 
                RowBox[{"[", "3", "]"}], "]"}], ",", 
               RowBox[{"#", "[", 
                RowBox[{"[", "4", "]"}], "]"}]}], "}"}], ",", "Nothing"}], 
            "]"}], "&"}], "/@", "vertexEdgeData1"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"vertexEdgeData", "=", 
         RowBox[{"Sort", "[", 
          RowBox[{"DeleteDuplicates", "[", 
           RowBox[{"Join", "[", 
            RowBox[{"vertexEdgeData1", ",", "vertexEdgeData2"}], "]"}], "]"}],
           "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Clear", "[", 
         RowBox[{"vertexEdgeData1", ",", "vertexEdgeData2"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"gatheredVertexPairData", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"#", "[", 
              RowBox[{"[", 
               RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"#", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], ",", 
                  RowBox[{"#", "[", 
                   RowBox[{"[", "3", "]"}], "]"}]}], "}"}], "&"}], "/@", 
               "#"}], ")"}]}], "}"}], "&"}], "/@", 
          RowBox[{"GatherBy", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"#", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], ",", 
                  RowBox[{"#", "[", 
                   RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ",", 
                RowBox[{"#", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], ",", 
                RowBox[{"#", "[", 
                 RowBox[{"[", "4", "]"}], "]"}]}], "}"}], "&"}], "/@", 
             "vertexEdgeData"}], ",", "First"}], "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"gatheredVertexEdgesData", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"#", "[", 
              RowBox[{"[", 
               RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "#"}], "}"}], 
           "&"}], "/@", 
          RowBox[{"GatherBy", "[", 
           RowBox[{"vertexEdgeData", ",", "First"}], "]"}]}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"duplicateEdgeTests", "=", 
         RowBox[{"Length", "[", "gatheredInputPairData", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"duplicateEdgeCount", "=", 
         RowBox[{"Total", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Length", "[", 
                RowBox[{"#", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "]"}], ">", "1"}], ",", "1", 
              ",", "0"}], "]"}], "&"}], "/@", "gatheredInputPairData"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"noDuplicateEdgesQ", "=", 
         RowBox[{"(", 
          RowBox[{"duplicateEdgeCount", "\[Equal]", "0"}], ")"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"duplicateEdgeTestValue", "=", 
         RowBox[{"If", "[", 
          RowBox[{"noDuplicateEdgesQ", ",", "passedStr", ",", "failedStr"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Clear", "[", "gatheredInputPairData", "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"singleEdgePathTests", "=", "naStr"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"singleEdgePathTestsFailures", "=", "naStr"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"singleEdgePathCount", "=", 
         RowBox[{"Length", "[", "vertexEdgeData", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"vertices", "=", 
         RowBox[{"Sort", "[", 
          RowBox[{"DeleteDuplicates", "[", 
           RowBox[{"vertexEdgeData", "[", 
            RowBox[{"[", 
             RowBox[{";;", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"verticesCount", "=", 
         RowBox[{"Length", "[", "vertices", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"verticesTests", "=", "naStr"}], ";", "\[IndentingNewLine]", 
        RowBox[{"verticesTestsFailures", "=", "naStr"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Clear", "[", "vertexEdgeData", "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"vertexEdgeDistancesTallies", "=", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"Tally", "[", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "&"}], "/@", "#"}], ")"}], 
             "]"}], "&"}], "/@", 
           RowBox[{"gatheredVertexEdgesData", "[", 
            RowBox[{"[", 
             RowBox[{";;", ",", "2"}], "]"}], "]"}]}], ")"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"verticesMultiplicitiesTests", "=", "verticesCount"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"verticesMultiplicitiesTestFailures", "=", "naStr"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"verticesMultiplicitiesCount", "=", 
         RowBox[{"Total", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Total", "[", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "1"}], ",", 
                  "0", ",", "1"}], "]"}], "&"}], "/@", "#"}], ")"}], "]"}], 
            "&"}], "/@", "vertexEdgeDistancesTallies"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"verticesMultiplicityRangeTests", "=", "verticesCount"}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"verticesMultiplicityRangeTestFailures", "=", "naStr"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"verticesMultiplicityRange", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"verticesMultiplicitiesCount", "\[Equal]", "0"}], ",", 
           "\[IndentingNewLine]", "naStr", ",", "\[IndentingNewLine]", 
           RowBox[{"MinMax", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "1"}], ",", 
                   "Nothing", ",", 
                   RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "&"}], "/@", 
                RowBox[{"Flatten", "[", 
                 RowBox[{
                  RowBox[{"GatherBy", "[", 
                   RowBox[{"#", ",", "Last"}], "]"}], ",", "1"}], "]"}]}], 
               ")"}], "&"}], "/@", "vertexEdgeDistancesTallies"}], "]"}]}], 
          "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"sortedVertexEdgeDistancesTallies", "=", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Sort", "[", 
             RowBox[{"Flatten", "[", 
              RowBox[{
               RowBox[{"GatherBy", "[", 
                RowBox[{"#", ",", "First"}], "]"}], ",", "1"}], "]"}], "]"}], 
            "[", 
            RowBox[{"[", "1", "]"}], "]"}], "&"}], "/@", 
          "vertexEdgeDistancesTallies"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"nnMultiplicitiesCount", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"verticesMultiplicitiesCount", "\[Equal]", "0"}], ",", 
           "\[IndentingNewLine]", "0", ",", "\[IndentingNewLine]", 
           RowBox[{"Total", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "1"}], ",", "0",
                 ",", "1"}], "]"}], "&"}], "/@", 
             "sortedVertexEdgeDistancesTallies"}], "]"}]}], 
          "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"nnMultiplicitiesTests", "=", "verticesCount"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"nnMultiplicitiesTestFailures", "=", "naStr"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Clear", "[", "vertexEdgeDistancesTallies", "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"nnMultiplicitiesRange", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"nnMultiplicitiesCount", "\[Equal]", "0"}], ",", 
           "\[IndentingNewLine]", "naStr", ",", "\[IndentingNewLine]", 
           RowBox[{"MinMax", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "1"}], ",", 
                "Nothing", ",", 
                RowBox[{"#", "[", 
                 RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "&"}], "/@", 
             "sortedVertexEdgeDistancesTallies"}], "]"}]}], 
          "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"nnMultiplicitiesRangeTests", "=", "verticesCount"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"nnMultiplicitiesRangeTestFailures", "=", "naStr"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Clear", "[", "sortedVertexEdgeDistancesTallies", "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<invalidDistancesTestValue = \>\"", ",", 
             "invalidDistancesTestValue"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<distancesMinMax = \>\"", ",", 
             "distancesMinMax"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<\[Epsilon] = \>\"", ",", "\[Epsilon]"}], 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<directedEdgeCount = \>\"", ",", 
             "directedEdgeCount"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<undirectedEdgeCount = \>\"", ",", 
             "undirectedEdgeCount"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<invalidEdgeTestValue = \>\"", ",", 
             "invalidEdgeTestValue"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<nonZeroSelfLoopCount = \>\"", ",", 
             "nonZeroSelfLoopCount"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<duplicateEdgeCount = \>\"", ",", 
             "duplicateEdgeCount"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<singleEdgePathCount = \>\"", ",", 
             "singleEdgePathCount"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<verticesCount = \>\"", ",", 
             "verticesCount"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<verticesMultiplicitiesCount = \>\"", ",",
              "verticesMultiplicitiesCount"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<verticesMultiplicityRange = \>\"", ",", 
             "verticesMultiplicityRange"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<nnMultiplicitiesCount = \>\"", ",", 
             "nnMultiplicitiesCount"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<nnMultiplicitiesRange = \>\"", ",", 
             "nnMultiplicitiesRange"}], "]"}], ";"}]}], "\[IndentingNewLine]",
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"hasInvalidDistances", "\[Or]", "hasInvalidEdges"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Do", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"componentMaximalTestFailures", "=", 
              RowBox[{
               RowBox[{"If", "[", 
                RowBox[{"hasInvalidDistances", ",", "1", ",", "0"}], "]"}], 
               "+", 
               RowBox[{"If", "[", 
                RowBox[{"hasInvalidEdges", ",", "1", ",", "0"}], "]"}]}]}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{
             "componentMaximalTests", "=", "componentMaximalTestFailures"}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{
             "componentMaximalTestValue", "=", 
              "\"\<invalid distances or edges\>\""}]}], ",", 
            "\[IndentingNewLine]", "1"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Do", "[", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", "HERE", " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{"showprogress", ",", 
               RowBox[{"Print", "[", 
                RowBox[{
                "\"\<\\t\>\"", ",", 
                 "\"\<beginning maximal component distance test ...\>\""}], 
                "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"startTime", "=", 
              RowBox[{"AbsoluteTime", "[", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
               "fmaxdata", ",", "fvalsdata", ",", "componentMaximalTests"}], 
               "}"}], "=", 
              RowBox[{"ComponentMaximal", "[", "edistances", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"componentMaximalTestFailures", "=", "naStr"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"componentMaximalTestValue", "=", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"fmaxdata", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{"fmaxdata", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], ",", 
                RowBox[{"fmaxdata", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], ",", 
                RowBox[{"N", "[", 
                 RowBox[{"fmaxdata", "[", 
                  RowBox[{"[", "4", "]"}], "]"}], "]"}]}], "}"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"endTime", "=", 
              RowBox[{"AbsoluteTime", "[", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{"showprogress", ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"Print", "[", 
                 RowBox[{
                 "\"\<\\t\\t\>\"", ",", "\"\<elapsed time = \>\"", ",", 
                  RowBox[{"Quantity", "[", 
                   RowBox[{
                    RowBox[{"endTime", "-", "startTime"}], ",", 
                    "\"\<Seconds\>\""}], "]"}]}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"Print", "[", 
                 RowBox[{
                 "\"\<\\t\\t\>\"", ",", 
                  "\"\<maximal component distance \[Delta] = \>\"", ",", 
                  RowBox[{"fmaxdata", "[", 
                   RowBox[{"[", "1", "]"}], "]"}]}], "]"}], ";"}]}], 
              "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "1"}], "]"}]}],
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<\\t\>\"", ",", "\"\<componentMaximalTestValue = \>\"", ",", 
            "componentMaximalTestValue"}], "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"plainEdgeGraph", "=", 
         RowBox[{"Graph", "[", "edgeList", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"connectedTests", "=", "naStr"}], ";", "\[IndentingNewLine]", 
        RowBox[{"componentsCount", "=", 
         RowBox[{"Length", "[", 
          RowBox[{"ConnectedComponents", "[", 
           RowBox[{"UndirectedGraph", "[", "plainEdgeGraph", "]"}], "]"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"connectedFailures", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"componentsCount", "\[Equal]", "1"}], ",", "naStr", ",", 
           "componentsCount"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"connectedQ", "=", 
         RowBox[{"(", 
          RowBox[{"componentsCount", "\[Equal]", "1"}], ")"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"connectedTestValue", "=", 
         RowBox[{"If", "[", 
          RowBox[{
          "connectedQ", ",", "\"\<connected\>\"", ",", 
           "\"\<not connected\>\""}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Clear", "[", "plainEdgeGraph", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<\\t\>\"", ",", "\"\<componentsCount = \>\"", ",", 
            "componentsCount"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"edgeHashSet", "=", 
         RowBox[{"CreateDataStructure", "[", "\"\<HashSet\>\"", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"edgeHashSet", "[", 
         RowBox[{"\"\<Union\>\"", ",", "edgeList"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"completeTests", "=", "0"}], ";", "\[IndentingNewLine]", 
        RowBox[{"completeCount", "=", "naStr"}], ";", "\[IndentingNewLine]", 
        RowBox[{"completeFailures", "=", "naStr"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"completeQ", "=", "True"}], ";", "\[IndentingNewLine]", 
        RowBox[{"v1", "=", "0"}], ";", "\[IndentingNewLine]", 
        RowBox[{"While", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", "completeQ", ")"}], "\[And]", 
           RowBox[{"(", 
            RowBox[{"v1", "<", "verticesCount"}], ")"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"v1", "++"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Pause", "[", "0", "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"v2", "=", "v1"}], ";", "\[IndentingNewLine]", 
           RowBox[{"While", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", "completeQ", ")"}], "\[And]", 
              RowBox[{"(", 
               RowBox[{"v2", "<", "verticesCount"}], ")"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"completeTests", "++"}], ";", "\[IndentingNewLine]", 
              RowBox[{"v2", "++"}], ";", "\[IndentingNewLine]", 
              RowBox[{"e1", "=", 
               RowBox[{
                RowBox[{"vertices", "[", 
                 RowBox[{"[", "v1", "]"}], "]"}], "\[UndirectedEdge]", 
                RowBox[{"vertices", "[", 
                 RowBox[{"[", "v2", "]"}], "]"}]}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"e2", "=", 
               RowBox[{
                RowBox[{"vertices", "[", 
                 RowBox[{"[", "v1", "]"}], "]"}], "\[DirectedEdge]", 
                RowBox[{"vertices", "[", 
                 RowBox[{"[", "v2", "]"}], "]"}]}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"e3", "=", 
               RowBox[{
                RowBox[{"vertices", "[", 
                 RowBox[{"[", "v2", "]"}], "]"}], "\[UndirectedEdge]", 
                RowBox[{"vertices", "[", 
                 RowBox[{"[", "v1", "]"}], "]"}]}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"e4", "=", 
               RowBox[{
                RowBox[{"vertices", "[", 
                 RowBox[{"[", "v2", "]"}], "]"}], "\[DirectedEdge]", 
                RowBox[{"vertices", "[", 
                 RowBox[{"[", "v1", "]"}], "]"}]}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"completeQ", "=", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"edgeHashSet", "[", 
                  RowBox[{"\"\<MemberQ\>\"", ",", "e1"}], "]"}], "\[Or]", 
                 RowBox[{"edgeHashSet", "[", 
                  RowBox[{"\"\<MemberQ\>\"", ",", "e2"}], "]"}], "\[Or]", 
                 RowBox[{"edgeHashSet", "[", 
                  RowBox[{"\"\<MemberQ\>\"", ",", "e3"}], "]"}], "\[Or]", 
                 RowBox[{"edgeHashSet", "[", 
                  RowBox[{"\"\<MemberQ\>\"", ",", "e4"}], "]"}]}], ")"}]}], 
              ";"}]}], "\[IndentingNewLine]", "]"}], ";"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"completeTestValue", "=", 
         RowBox[{"If", "[", 
          RowBox[{
          "completeQ", ",", "\"\<complete\>\"", ",", "\"\<not complete\>\""}],
           "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Clear", "[", "edgeHashSet", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<\\t\>\"", ",", "\"\<completeTestValue = \>\"", ",", 
            "completeTestValue"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]",
         "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<\\t\>\"", ",", 
            "\"\<beginning computation of largest Laplacian of least bridges \
edges ...\>\""}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"LBGedgeList", "=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"LeastBridgesEdgeDistances", "[", 
            RowBox[{"edistances", ",", "\[Infinity]", ",", "False"}], "]"}], 
           ")"}], "[", 
          RowBox[{"[", 
           RowBox[{";;", ",", "1"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"LBGedgeListCount", "=", 
         RowBox[{"Length", "[", "LBGedgeList", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"LBGedgesLaplacianTests", "=", 
         RowBox[{"Max", "[", 
          RowBox[{"LBGedgeListCount", ",", "1"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"startTime", "=", 
         RowBox[{"AbsoluteTime", "[", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"LBGedgesLaplacianEigenvalues", "=", 
         RowBox[{"LaplacianMatrixEigenvalues", "[", "LBGedgeList", "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"endTime", "=", 
         RowBox[{"AbsoluteTime", "[", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"LBGedgesLaplacianTestValue", "=", 
         RowBox[{"LBGedgesLaplacianEigenvalues", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"LBGedgesLaplacianFailures", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"NumberQ", "[", "LBGedgesLaplacianTestValue", "]"}], ",", 
           "0", ",", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"elapsedTime", "=", 
            RowBox[{"endTime", "-", "startTime"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{"\"\<\\t\\t\>\"", ",", "\"\<elapsed time = \>\"", ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"elapsedTime", "<", "60"}], ",", 
               RowBox[{"Quantity", "[", 
                RowBox[{"elapsedTime", ",", "\"\<Seconds\>\""}], "]"}], ",", 
               RowBox[{"Quantity", "[", 
                RowBox[{
                 RowBox[{"elapsedTime", "/", "60."}], ",", 
                 "\"\<Minutes\>\""}], "]"}]}], "]"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<LBGedgesLaplacianTestValue = \>\"", 
             ",", "LBGedgesLaplacianTestValue"}], "]"}]}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"positiveDefiniteTests", "=", "edgeListCount"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"positiveDefiniteFailures", "=", 
         RowBox[{"Total", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"#", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], ",", "1", 
              ",", "0"}], "]"}], "&"}], "/@", "edistances"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"positiveDefiniteQ", "=", 
         RowBox[{"(", 
          RowBox[{"positiveDefiniteFailures", "\[Equal]", "0"}], ")"}]}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"positiveDefiniteTestValue", "=", 
         RowBox[{"If", "[", 
          RowBox[{"positiveDefiniteQ", ",", "passedStr", ",", "failedStr"}], 
          "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"identityTests", "=", "nonZeroSelfLoopTests"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"identityFailures", "=", "nonZeroSelfLoopCount"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"identityQ", "=", "noNonZeroSelfLoopsQ"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"identityTestValue", "=", 
         RowBox[{"If", "[", 
          RowBox[{"identityQ", ",", "passedStr", ",", "failedStr"}], "]"}]}], 
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"vertexPairEdgeDataHash", "=", 
         RowBox[{"CreateDataStructure", "[", "\"\<HashTable\>\"", "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"vertexPairEdgeDataHash", "[", 
           RowBox[{"\"\<Insert\>\"", ",", 
            RowBox[{
             RowBox[{"#", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "\[Rule]", 
             RowBox[{"#", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], "&"}], "/@", 
         "gatheredVertexPairData"}], ";", "\[IndentingNewLine]", 
        RowBox[{"commutativeTests", "=", "0"}], ";", "\[IndentingNewLine]", 
        RowBox[{"commutativeFailures", "=", "0"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Do", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"epair", "=", 
            RowBox[{"epdata", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"rpair", "=", 
            RowBox[{"Reverse", "[", "epair", "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"vertexPairEdgeDataHash", "[", 
              RowBox[{"\"\<KeyExistsQ\>\"", ",", "rpair"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"rpdata", "=", 
               RowBox[{"vertexPairEdgeDataHash", "[", 
                RowBox[{"\"\<Lookup\>\"", ",", "rpair"}], "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"Do", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"edist", "=", 
                  RowBox[{"eedge", "[", 
                   RowBox[{"[", "1", "]"}], "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Do", "[", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"commutativeTests", "++"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"rdist", "=", 
                    RowBox[{"redge", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"rdist", "\[NotEqual]", "edist"}], ",", 
                    RowBox[{"commutativeFailures", "++"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{"redge", ",", "rpdata"}], "}"}]}], 
                  "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{"eedge", ",", 
                  RowBox[{"epdata", "[", 
                   RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], 
               "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", 
            "]"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"epdata", ",", "gatheredVertexPairData"}], "}"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Clear", "[", "vertexPairEdgeDataHash", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"commutativeTests", "+=", "duplicateEdgeCount"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"commutativeFailures", "+=", "duplicateEdgeCount"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"commutativeQ", "=", 
         RowBox[{"(", 
          RowBox[{"commutativeFailures", "\[Equal]", "0"}], ")"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"commutativeTestValue", "=", 
         RowBox[{"If", "[", 
          RowBox[{"commutativeQ", ",", "passedStr", ",", "failedStr"}], 
          "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<positiveDefiniteTests = \>\"", ",", 
             "positiveDefiniteTests"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<positiveDefiniteFailures = \>\"", ",",
              "positiveDefiniteFailures"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<identityTests = \>\"", ",", 
             "positiveDefiniteTests"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<identityFailures = \>\"", ",", 
             "positiveDefiniteFailures"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<commutativeTests = \>\"", ",", 
             "commutativeTests"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<commutativeFailures = \>\"", ",", 
             "commutativeFailures"}], "]"}], ";"}]}], "\[IndentingNewLine]", 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<\\t\>\"", ",", 
            "\"\<beginning triangle inequality tests for all paths {a\
\[RightArrow]b, b\[RightArrow]c, a\[RightArrow]c} ...\>\""}], "]"}]}], "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"startTime", "=", 
         RowBox[{"AbsoluteTime", "[", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"triangleTests", "=", "0"}], ";", "\[IndentingNewLine]", 
        RowBox[{"triangleFailures", "=", "0"}], ";", "\[IndentingNewLine]", 
        RowBox[{"minTerror", "=", 
         RowBox[{"+", "\[Infinity]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"maxTerror", "=", 
         RowBox[{"-", "\[Infinity]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"gatheredVertexEdgesHash", "=", 
         RowBox[{"CreateDataStructure", "[", "\"\<HashTable\>\"", "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"gatheredVertexEdgesHash", "[", 
           RowBox[{"\"\<Insert\>\"", ",", 
            RowBox[{
             RowBox[{"#", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "\[Rule]", 
             RowBox[{"#", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], "&"}], "/@", 
         "gatheredVertexEdgesData"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Do", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"a", "=", 
            RowBox[{"vedata", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"Print", "[", 
              RowBox[{"\"\<a = \>\"", ",", "a"}], "]"}], ";"}], " ", "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"agoes", "=", 
            RowBox[{
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "a"}], ",", 
                "Nothing", ",", 
                RowBox[{"#", "[", 
                 RowBox[{"[", 
                  RowBox[{"2", ";;", "3"}], "]"}], "]"}]}], "]"}], "&"}], "/@", 
             RowBox[{"vedata", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"Print", "[", 
              RowBox[{"\"\<agoes = \>\"", ",", "agoes"}], "]"}], ";"}], " ", 
            "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Do", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"b", "=", 
               RowBox[{"abdata", "[", 
                RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"abdist", "=", 
               RowBox[{"abdata", "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"(*", " ", 
               RowBox[{
                RowBox[{"Print", "[", 
                 RowBox[{
                 "\"\<\\t\>\"", ",", "\"\<b = \>\"", ",", "b", ",", 
                  "\"\<, abdist = \>\"", ",", "abdist"}], "]"}], ";"}], " ", 
               "*)"}], "\[IndentingNewLine]", 
              RowBox[{"bgoes", "=", 
               RowBox[{
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"a", ",", "b"}], "}"}], ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", "Nothing", 
                   ",", 
                   RowBox[{"#", "[", 
                    RowBox[{"[", 
                    RowBox[{"2", ";;", "3"}], "]"}], "]"}]}], "]"}], "&"}], "/@", 
                RowBox[{"gatheredVertexEdgesHash", "[", 
                 RowBox[{"\"\<Lookup\>\"", ",", "b"}], "]"}]}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"(*", " ", 
               RowBox[{
                RowBox[{"Print", "[", 
                 RowBox[{
                 "\"\<\\t\>\"", ",", "\"\<bgoes = \>\"", ",", "bgoes"}], 
                 "]"}], ";"}], " ", "*)"}], "\[IndentingNewLine]", 
              RowBox[{"Do", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"c", "=", 
                  RowBox[{"bcdata", "[", 
                   RowBox[{"[", "1", "]"}], "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"bcdist", "=", 
                  RowBox[{"bcdata", "[", 
                   RowBox[{"[", "2", "]"}], "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"(*", " ", 
                  RowBox[{
                   RowBox[{"Print", "[", 
                    RowBox[{
                    "\"\<\\t\\t\>\"", ",", "\"\<c = \>\"", ",", "c", ",", 
                    "\"\<, bcdist = \>\"", ",", "bcdist"}], "]"}], ";"}], " ",
                   "*)"}], "\[IndentingNewLine]", 
                 RowBox[{"acdistlist", "=", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "c"}], ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "Nothing"}], "]"}], 
                    "&"}], "/@", "agoes"}]}], ";", "\[IndentingNewLine]", 
                 RowBox[{"(*", " ", 
                  RowBox[{
                   RowBox[{"Print", "[", 
                    RowBox[{
                    "\"\<\\t\\t\\t\>\"", ",", "\"\<acdistlist = \>\"", ",", 
                    "acdistlist"}], "]"}], ";"}], " ", "*)"}], 
                 "\[IndentingNewLine]", 
                 RowBox[{"Do", "[", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"triangleTests", "++"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"error", "=", 
                    RowBox[{"acdist", "-", 
                    RowBox[{"(", 
                    RowBox[{"abdist", "+", "bcdist"}], ")"}]}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"error", ">", "\[Epsilon]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"triangleFailures", "++"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"abserror", "=", 
                    RowBox[{"Abs", "[", "error", "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"minTerror", "=", 
                    RowBox[{"Min", "[", 
                    RowBox[{"minTerror", ",", "abserror"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"maxTerror", "=", 
                    RowBox[{"Max", "[", 
                    RowBox[{"maxTerror", ",", "abserror"}], "]"}]}], ";"}]}], 
                    "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{"acdist", ",", "acdistlist"}], "}"}]}], 
                  "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
                 RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{"bcdata", ",", "bgoes"}], "}"}]}], 
               "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
              RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"abdata", ",", "agoes"}], "}"}]}], 
            "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"vedata", ",", "gatheredVertexEdgesData"}], "}"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"endTime", "=", 
         RowBox[{"AbsoluteTime", "[", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<end of triangle tests.\>\"", "]"}], 
          ";"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"triangleFailures", "+=", "positiveDefiniteFailures"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"triangleQ", "=", 
         RowBox[{"(", 
          RowBox[{"triangleFailures", "\[Equal]", "0"}], ")"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"triangleTestValue", "=", 
         RowBox[{"If", "[", 
          RowBox[{
          "triangleQ", ",", "\[IndentingNewLine]", "passedStr", ",", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
             "triangleFailures", "\[Equal]", "positiveDefiniteFailures"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"failedStr", "<>", "\"\<, not positive definite\>\""}], 
             ",", "\[IndentingNewLine]", "failedStr"}], "\[IndentingNewLine]",
             "]"}]}], "\[IndentingNewLine]", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Clear", "[", "gatheredVertexEdgesData", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Clear", "[", "gatheredVertexEdgesHash", "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"triangleTestsMinMaxTests", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"triangleQ", "\[Or]", 
            RowBox[{"(", 
             RowBox[{
             "triangleFailures", "\[Equal]", "positiveDefiniteFailures"}], 
             ")"}]}], ",", "naStr", ",", "triangleTests"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"triangleTestsMinMaxFailures", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"triangleQ", "\[Or]", 
            RowBox[{"(", 
             RowBox[{
             "triangleFailures", "\[Equal]", "positiveDefiniteFailures"}], 
             ")"}]}], ",", "naStr", ",", 
           RowBox[{"triangleFailures", "-", "positiveDefiniteFailures"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"triangleTestsMinMaxErrors", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"triangleQ", "\[Or]", 
            RowBox[{"(", 
             RowBox[{
             "triangleFailures", "\[Equal]", "positiveDefiniteFailures"}], 
             ")"}]}], ",", "naStr", ",", 
           RowBox[{"{", 
            RowBox[{"minTerror", ",", "maxTerror"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"elapsedTime", "=", 
            RowBox[{"endTime", "-", "startTime"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{"\"\<\\t\\t\>\"", ",", "\"\<elapsed time = \>\"", ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"elapsedTime", "<", "60"}], ",", 
               RowBox[{"Quantity", "[", 
                RowBox[{"elapsedTime", ",", "\"\<Seconds\>\""}], "]"}], ",", 
               RowBox[{"Quantity", "[", 
                RowBox[{
                 RowBox[{"elapsedTime", "/", "60."}], ",", 
                 "\"\<Minutes\>\""}], "]"}]}], "]"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<triangleTests = \>\"", ",", 
             "triangleTests"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<triangleFailures = \>\"", ",", 
             "triangleFailures"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<triangleTestsMinMaxErrors = \>\"", 
             ",", "triangleTestsMinMaxErrors"}], "]"}], ";"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"metricTests", "=", 
         RowBox[{
         "positiveDefiniteTests", "+", "identityTests", "+", 
          "commutativeTests", "+", "triangleTests"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"metricFailures", "=", 
         RowBox[{
         "identityFailures", "+", "commutativeFailures", "+", 
          "triangleFailures"}]}], ";", " ", 
        RowBox[{"(*", " ", 
         RowBox[{
         "note", " ", "positiveDefiniteFailures", " ", "are", " ", "added", 
          " ", "to", " ", "triangleFailures"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"metricQ", "=", 
         RowBox[{"(", 
          RowBox[{"metricFailures", "\[Equal]", "0"}], ")"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"metricTestValue", "=", 
         RowBox[{"Which", "[", "\[IndentingNewLine]", 
          RowBox[{"metricQ", ",", "passedStr", ",", "\[IndentingNewLine]", 
           RowBox[{"(", 
            RowBox[{"positiveDefiniteQ", "\[And]", "identityQ", "\[And]", 
             RowBox[{"(", 
              RowBox[{"!", "commutativeQ"}], ")"}], "\[And]", "triangleQ"}], 
            ")"}], ",", "\"\<non-hermitian metric\>\"", ",", 
           "\[IndentingNewLine]", "True", ",", "failedStr"}], 
          "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<metricTestValue = \>\"", ",", 
             "metricTestValue"}], "]"}], ";"}]}], "\[IndentingNewLine]", 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"EDGAendTime", "=", 
         RowBox[{"AbsoluteTime", "[", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"elapsedTime", "=", 
         RowBox[{"EDGAendTime", "-", "EDGAstartTime"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"EDGAelapsedTime", "=", 
         RowBox[{"Which", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"elapsedTime", "<", "60"}], ",", 
           RowBox[{"Quantity", "[", 
            RowBox[{"elapsedTime", ",", "\"\<Seconds\>\""}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"elapsedTime", "<", "3600"}], ",", 
           RowBox[{"Quantity", "[", 
            RowBox[{
             RowBox[{"elapsedTime", "/", "60."}], ",", "\"\<Minutes\>\""}], 
            "]"}], ",", "\[IndentingNewLine]", "True", ",", 
           RowBox[{"Quantity", "[", 
            RowBox[{
             RowBox[{"elapsedTime", "/", "3600."}], ",", "\"\<Hours\>\""}], 
            "]"}]}], "\[IndentingNewLine]", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"resultsHeader", "=", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Test Name\>\"", ",", "\"\<Test Count\>\"", ",", 
            "\"\<Failure Count\>\"", ",", "\"\<Test Value\>\""}], "}"}], 
          "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"resultsBody", "=", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "\"\<edistances dimensions\>\"", ",", "edistancesDimensionTests", 
             ",", "edistancesDimensionFailures", ",", 
             "edistancesDimensions"}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{"hasInvalidDistances", ",", 
               RowBox[{"Style", "[", 
                RowBox[{"\"\<invalid distances\>\"", ",", 
                 RowBox[{"{", 
                  RowBox[{"Bold", ",", "Red"}], "}"}]}], "]"}], ",", 
               "\"\<invalid distances\>\""}], "]"}], ",", 
             "invalidDistancesTests", ",", "invalidDistancesTestFailures", 
             ",", "invalidDistancesTestValue"}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<distances min,max\>\"", ",", "distancesMinMaxTests", ",", 
             "distancesMinMaxTestFailures", ",", "distancesMinMax"}], "}"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<numerical error tolerance \[Epsilon]\>\"", ",", 
             "distancesMinMaxTests", ",", "distancesMinMaxTestFailures", ",", 
             "\[Epsilon]"}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<directed edges\>\"", ",", "directedEdgeTests", ",", 
             "directedEdgeFailures", ",", "directedEdgeCount"}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<undirected edges\>\"", ",", "undirectedEdgeTests", ",", 
             "undirectedEdgeFailures", ",", "undirectedEdgeCount"}], "}"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{"hasInvalidEdges", ",", 
               RowBox[{"Style", "[", 
                RowBox[{"\"\<invalid edges\>\"", ",", 
                 RowBox[{"{", 
                  RowBox[{"Bold", ",", "Red"}], "}"}]}], "]"}], ",", 
               "\"\<invalid edges\>\""}], "]"}], ",", "invalidEdgeTests", ",",
              "invalidEdgeTestFailures", ",", "invalidEdgeTestValue"}], "}"}],
            ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
               "nonZeroSelfLoopTestValue", "\[NotEqual]", "passedStr"}], ",", 
               RowBox[{"Style", "[", 
                RowBox[{"\"\<non-zero self loops\>\"", ",", 
                 RowBox[{"{", 
                  RowBox[{"Bold", ",", "Red"}], "}"}]}], "]"}], ",", 
               "\"\<non-zero self loops\>\""}], "]"}], ",", 
             "nonZeroSelfLoopTests", ",", "nonZeroSelfLoopCount", ",", 
             "nonZeroSelfLoopTestValue"}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"duplicateEdgeTestValue", "\[NotEqual]", "passedStr"}],
                ",", 
               RowBox[{"Style", "[", 
                RowBox[{"\"\<duplicate edges\>\"", ",", 
                 RowBox[{"{", 
                  RowBox[{"Bold", ",", "Red"}], "}"}]}], "]"}], ",", 
               "\"\<duplicate edges\>\""}], "]"}], ",", "duplicateEdgeTests", 
             ",", "duplicateEdgeCount", ",", "duplicateEdgeTestValue"}], 
            "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<all single edge paths\>\"", ",", "singleEdgePathTests", ",", 
             "singleEdgePathTestsFailures", ",", "singleEdgePathCount"}], 
            "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<vertices\>\"", ",", "verticesTests", ",", 
             "verticesTestsFailures", ",", "verticesCount"}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<instances of multiplicity\>\"", ",", 
             "verticesMultiplicitiesTests", ",", 
             "verticesMultiplicitiesTestFailures", ",", 
             "verticesMultiplicitiesCount"}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<multiplicities min,max\>\"", ",", 
             "verticesMultiplicityRangeTests", ",", 
             "verticesMultiplicityRangeTestFailures", ",", 
             "verticesMultiplicityRange"}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<nearest neighbor multiplicities\>\"", ",", 
             "nnMultiplicitiesTests", ",", "nnMultiplicitiesTestFailures", 
             ",", "nnMultiplicitiesCount"}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<n.n. multiplicities min,max\>\"", ",", 
             "nnMultiplicitiesRangeTests", ",", 
             "nnMultiplicitiesRangeTestFailures", ",", 
             "nnMultiplicitiesRange"}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<component maximal {\!\(\*SubscriptBox[\(\[Delta]\), \(opt\)]\
\),c,v,f[\!\(\*SubscriptBox[\(\[Delta]\), \(opt\)]\)]}\>\"", ",", 
             "componentMaximalTests", ",", "componentMaximalTestFailures", 
             ",", "componentMaximalTestValue"}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<connected graph\>\"", ",", "connectedTests", ",", 
             "connectedFailures", ",", "connectedTestValue"}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<complete graph\>\"", ",", "completeTests", ",", 
             "completeFailures", ",", "completeTestValue"}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<largest Laplacian of least bridges edges\>\"", ",", 
             "LBGedgesLaplacianTests", ",", "LBGedgesLaplacianFailures", ",", 
             "LBGedgesLaplacianTestValue"}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
               "positiveDefiniteTestValue", "\[NotEqual]", "passedStr"}], ",", 
               RowBox[{"Style", "[", 
                RowBox[{"\"\<positive definite\>\"", ",", 
                 RowBox[{"{", 
                  RowBox[{"Bold", ",", "Red"}], "}"}]}], "]"}], ",", 
               "\"\<positive definite\>\""}], "]"}], ",", 
             "positiveDefiniteTests", ",", "positiveDefiniteFailures", ",", 
             "positiveDefiniteTestValue"}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"identityTestValue", "\[NotEqual]", "passedStr"}], ",", 
               RowBox[{"Style", "[", 
                RowBox[{"\"\<identity distance\>\"", ",", 
                 RowBox[{"{", 
                  RowBox[{"Bold", ",", "Red"}], "}"}]}], "]"}], ",", 
               "\"\<identity distance\>\""}], "]"}], ",", "identityTests", 
             ",", "identityFailures", ",", "identityTestValue"}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<commutative edge distances\>\"", ",", "commutativeTests", 
             ",", "commutativeFailures", ",", "commutativeTestValue"}], "}"}],
            ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"triangleTestValue", "\[NotEqual]", "passedStr"}], ",", 
               RowBox[{"Style", "[", 
                RowBox[{"\"\<triangle inequality\>\"", ",", 
                 RowBox[{"{", 
                  RowBox[{"Bold", ",", "Red"}], "}"}]}], "]"}], ",", 
               "\"\<triangle inequality\>\""}], "]"}], ",", "triangleTests", 
             ",", "triangleFailures", ",", "triangleTestValue"}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<triangle ineq. min,max |errors|\>\"", ",", 
             "triangleTestsMinMaxTests", ",", "triangleTestsMinMaxFailures", 
             ",", "triangleTestsMinMaxErrors"}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"metricTestValue", "\[Equal]", "failedStr"}], ",", 
               RowBox[{"Style", "[", 
                RowBox[{"\"\<metric\>\"", ",", 
                 RowBox[{"{", 
                  RowBox[{"Bold", ",", "Red"}], "}"}]}], "]"}], ",", 
               "\"\<metric\>\""}], "]"}], ",", "metricTests", ",", 
             "metricFailures", ",", "metricTestValue"}], "}"}]}], 
          "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"timingResults", "=", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"\"\<elapsed analysis time\>\"", ",", 
            RowBox[{"Total", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"IntegerQ", "[", "#", "]"}], ",", "#", ",", "1"}], 
                "]"}], "&"}], "/@", 
              RowBox[{"resultsBody", "[", 
               RowBox[{"[", 
                RowBox[{";;", ",", "2"}], "]"}], "]"}]}], "]"}], ",", "naStr",
             ",", "EDGAelapsedTime"}], "}"}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"resultsTable", "=", 
         RowBox[{"Join", "[", 
          RowBox[{"resultsHeader", ",", "timingResults", ",", "resultsBody"}],
           "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.802192433608954*^9, 3.802192433608954*^9}, {
   3.8248608627209926`*^9, 3.8248609251279907`*^9}, {3.8479230012648163`*^9, 
   3.84792300781653*^9}, 3.848177220303105*^9, {3.84817740495807*^9, 
   3.8481774665588512`*^9}, 3.8481774972559514`*^9, {3.848177531603591*^9, 
   3.8481775784133263`*^9}, {3.8481798906678257`*^9, 
   3.8481798931199813`*^9}, {3.8481799290512304`*^9, 3.84817995290837*^9}, {
   3.8481802921997657`*^9, 3.8481803003117876`*^9}, {3.8481803305965567`*^9, 
   3.848180342388281*^9}, {3.8481803875000796`*^9, 3.848180390420767*^9}, {
   3.848180426424759*^9, 3.848180510926563*^9}, {3.848180859792182*^9, 
   3.848180927350684*^9}, {3.848180994756955*^9, 3.8481810318322945`*^9}, 
   3.8481908856286273`*^9, {3.8481910280157237`*^9, 3.848191057367675*^9}, {
   3.8481914030007544`*^9, 3.8481914370756884`*^9}, {3.8481914798122396`*^9, 
   3.8481916496521864`*^9}, 3.848191692451498*^9, {3.848191756193019*^9, 
   3.8481917921325607`*^9}, {3.848191872700619*^9, 3.848192059407806*^9}, {
   3.84819209190511*^9, 3.8481922307460155`*^9}, {3.8481922666908503`*^9, 
   3.8481922753579254`*^9}, 3.848192354476392*^9, {3.8481926741639977`*^9, 
   3.8481927253582163`*^9}, {3.8481928993969817`*^9, 3.848192923148457*^9}, {
   3.8481930512564344`*^9, 3.8481931368685255`*^9}, {3.8481931867488356`*^9, 
   3.8481933275391483`*^9}, {3.8481933818352423`*^9, 3.848193421428608*^9}, {
   3.848193453591011*^9, 3.8481935748793707`*^9}, {3.8481936201334906`*^9, 
   3.848193648416502*^9}, {3.8481937147970037`*^9, 3.8481937222010703`*^9}, {
   3.848193800044612*^9, 3.8481939575049467`*^9}, {3.848193998772775*^9, 
   3.848194031217182*^9}, {3.8481940614731045`*^9, 3.8481940910725613`*^9}, 
   3.8481941443295813`*^9, {3.8481942389720507`*^9, 3.848194243460868*^9}, {
   3.848194306580782*^9, 3.848194412188375*^9}, {3.848194445577024*^9, 
   3.8481945932403584`*^9}, {3.848194626532731*^9, 3.8481946439129357`*^9}, {
   3.8481948068054886`*^9, 3.84819498046461*^9}, 3.8481950172614236`*^9, {
   3.8481951040942755`*^9, 3.848195110508554*^9}, {3.84819514215135*^9, 
   3.8481951745080433`*^9}, {3.8481952257084446`*^9, 
   3.8481952343009977`*^9}, {3.8481952662030935`*^9, 3.848195267341341*^9}, 
   3.8481952977357855`*^9, {3.848195354909464*^9, 3.8481954992179327`*^9}, {
   3.848195556485944*^9, 3.848195604253544*^9}, 3.848195649567114*^9, {
   3.8481956960204144`*^9, 3.8481958203996696`*^9}, {3.8481958510632668`*^9, 
   3.848195854158738*^9}, {3.848195886366126*^9, 3.8481958914813366`*^9}, 
   3.848195921815242*^9, {3.84819613182174*^9, 3.848196142396474*^9}, {
   3.8481961947511024`*^9, 3.8481962064767666`*^9}, 3.848196272805812*^9, {
   3.848196311833023*^9, 3.848196340526254*^9}, {3.848196371017411*^9, 
   3.848196374446251*^9}, {3.8481964445993032`*^9, 3.8481964593894606`*^9}, {
   3.848196540710432*^9, 3.848196553425572*^9}, 3.8481966343255477`*^9, {
   3.8481966669977417`*^9, 3.848196772828122*^9}, {3.8481968218816195`*^9, 
   3.8481968501906624`*^9}, {3.848196981781437*^9, 3.8481969894306097`*^9}, {
   3.8481970349371533`*^9, 3.8481970356975207`*^9}, {3.8481975717581425`*^9, 
   3.848197762145789*^9}, {3.8481981817080994`*^9, 3.8481983727485676`*^9}, {
   3.8481985039664297`*^9, 3.8481985620452056`*^9}, {3.8481986730780516`*^9, 
   3.848198803842391*^9}, {3.848198865858057*^9, 3.8481989231419926`*^9}, {
   3.848199189958067*^9, 3.8481991971664276`*^9}, {3.8481992488735456`*^9, 
   3.848199264151203*^9}, {3.848199491162012*^9, 3.8481995305142794`*^9}, {
   3.8481995713692303`*^9, 3.848199580520645*^9}, {3.8481996816228046`*^9, 
   3.848199723025055*^9}, {3.8481997757423267`*^9, 3.848199838293824*^9}, {
   3.848200111389723*^9, 3.8482001754650693`*^9}, {3.848200216652358*^9, 
   3.8482003996077914`*^9}, {3.8482005016126595`*^9, 
   3.8482005210182962`*^9}, {3.8482006022848234`*^9, 
   3.8482006031536827`*^9}, {3.8482006521945486`*^9, 3.848200739774496*^9}, {
   3.8482007764078207`*^9, 3.8482007822224565`*^9}, {3.848200837175108*^9, 
   3.8482008391103373`*^9}, {3.8482008981582527`*^9, 3.848200916669736*^9}, {
   3.8482009764400086`*^9, 3.848200976976965*^9}, {3.8482010148808823`*^9, 
   3.8482010153572865`*^9}, {3.848201119721984*^9, 3.848201126670142*^9}, {
   3.848201172141215*^9, 3.8482012817063046`*^9}, 3.848201351677797*^9, {
   3.8482014176123023`*^9, 3.8482016037689424`*^9}, {3.8482016366294017`*^9, 
   3.848201643967186*^9}, {3.8482016819417796`*^9, 3.8482017299326463`*^9}, {
   3.848201783409855*^9, 3.848201835254848*^9}, {3.8482018659735775`*^9, 
   3.8482018815463877`*^9}, {3.848202169150345*^9, 3.848202230861676*^9}, {
   3.8482022697618637`*^9, 3.848202300815443*^9}, {3.848202353518119*^9, 
   3.8482023819942894`*^9}, {3.8482025664951477`*^9, 
   3.8482026485094976`*^9}, {3.8482027840006742`*^9, 
   3.8482028385023355`*^9}, {3.848202891061467*^9, 3.8482028925587325`*^9}, {
   3.848203176042655*^9, 3.848203208375761*^9}, 3.848203307439313*^9, {
   3.8482035268211145`*^9, 3.848203538179238*^9}, {3.848203573831188*^9, 
   3.848203634695443*^9}, {3.8482039286580863`*^9, 3.848203943051135*^9}, {
   3.848204137798545*^9, 3.8482042266522923`*^9}, {3.848204338210455*^9, 
   3.8482043811777053`*^9}, 3.848247274440116*^9, 3.8482473617986608`*^9, {
   3.848250640836412*^9, 3.848250641752403*^9}, {3.8482509878522253`*^9, 
   3.848251009577018*^9}, {3.848251055854094*^9, 3.8482514152589254`*^9}, {
   3.8482514982220097`*^9, 3.8482515122736683`*^9}, {3.8482515559736853`*^9, 
   3.8482517067658167`*^9}, {3.848251746912909*^9, 3.84825193064073*^9}, {
   3.8482519623171425`*^9, 3.848252033345748*^9}, {3.848252095989953*^9, 
   3.8482521278095813`*^9}, {3.8482521808438387`*^9, 3.8482522542021303`*^9}, 
   3.8482523364483633`*^9, {3.848252392626638*^9, 3.848252420152688*^9}, {
   3.848252495406787*^9, 3.8482525279581366`*^9}, {3.8482526325398054`*^9, 
   3.8482527275747004`*^9}, {3.848252759642058*^9, 3.8482527841078463`*^9}, {
   3.848252820359161*^9, 3.848252822994911*^9}, {3.8482569659754095`*^9, 
   3.848256993450599*^9}, {3.8482570397765255`*^9, 3.848257078686598*^9}, {
   3.848257115442814*^9, 3.848257161581131*^9}, 3.848257234638193*^9, {
   3.8482572720259323`*^9, 3.8482572767305813`*^9}, 3.848257392462757*^9, {
   3.848257701097482*^9, 3.848257794106445*^9}, {3.848257860069724*^9, 
   3.8482579341495*^9}, {3.84825800264249*^9, 3.8482580870977993`*^9}, 
   3.8482581214904537`*^9, {3.848258156702388*^9, 3.848258234825733*^9}, {
   3.8482585301694527`*^9, 3.848258599766074*^9}, {3.8482596615271797`*^9, 
   3.8482596671349936`*^9}, {3.848259714050818*^9, 3.848259726349107*^9}, {
   3.848259760366376*^9, 3.848259826049658*^9}, {3.848259872457923*^9, 
   3.848259915114622*^9}, {3.8482599461304646`*^9, 3.848259961000329*^9}, {
   3.8482600205937595`*^9, 3.8482601331456566`*^9}, {3.848260163675575*^9, 
   3.848260171298048*^9}, {3.8482602748139477`*^9, 3.848260411744114*^9}, {
   3.8482607266472683`*^9, 3.8482607614736085`*^9}, 3.848260827215256*^9, {
   3.8482609369502954`*^9, 3.848260941025337*^9}, {3.8482609766812034`*^9, 
   3.8482610428714232`*^9}, {3.8482610991280766`*^9, 3.848261126131276*^9}, {
   3.848261157779205*^9, 3.8482612075704527`*^9}, {3.84826126078115*^9, 
   3.8482613487396283`*^9}, {3.848262226034813*^9, 3.848262267327279*^9}, {
   3.848262382669984*^9, 3.848262558716149*^9}, {3.8482625962740183`*^9, 
   3.848262622842738*^9}, {3.8482627370089283`*^9, 3.848262779228136*^9}, {
   3.848262809857043*^9, 3.848262850832279*^9}, {3.848262896106072*^9, 
   3.8482629069821815`*^9}, 3.8482633357266493`*^9, {3.848263545202654*^9, 
   3.848263555281971*^9}, {3.848263593904843*^9, 3.848263602532358*^9}, 
   3.848263677168214*^9, {3.848263715799536*^9, 3.848263723028206*^9}, {
   3.848263822970165*^9, 3.8482639298217115`*^9}, {3.848263965665121*^9, 
   3.848263988270712*^9}, {3.8482641787559824`*^9, 3.848264180962778*^9}, {
   3.848264281630943*^9, 3.848264286909748*^9}, {3.848264328864904*^9, 
   3.8482643711507893`*^9}, {3.8482644063614607`*^9, 3.848264412207223*^9}, {
   3.848264450442799*^9, 3.8482644516588984`*^9}, {3.8482644847675476`*^9, 
   3.848264650183203*^9}, {3.8482646860454054`*^9, 3.8482647025428615`*^9}, {
   3.8482647898233256`*^9, 3.848264811389901*^9}, {3.8482648461347947`*^9, 
   3.8482648641427555`*^9}, {3.84826489600508*^9, 3.848265007155967*^9}, {
   3.8482651766245112`*^9, 3.848265198967819*^9}, {3.8482652790786953`*^9, 
   3.8482653222433395`*^9}, {3.848265357069894*^9, 3.8482653661554003`*^9}, {
   3.8482660016430225`*^9, 3.8482661251834664`*^9}, {3.84826617232075*^9, 
   3.848266287540896*^9}, {3.848269222841963*^9, 3.8482692489714594`*^9}, {
   3.8482693062346916`*^9, 3.84826937207041*^9}, {3.848269451950291*^9, 
   3.848269612058954*^9}, {3.848269752675307*^9, 3.8482697551025476`*^9}, 
   3.8482698033670645`*^9, {3.848269840232341*^9, 3.848269849117051*^9}, {
   3.8482698856682405`*^9, 3.8482699680654883`*^9}, {3.8482702241029415`*^9, 
   3.848270368402669*^9}, {3.848270417006474*^9, 3.848270481575447*^9}, {
   3.84827053251081*^9, 3.848270557481217*^9}, {3.848270611335436*^9, 
   3.8482706496456995`*^9}, {3.8482706988166904`*^9, 3.84827078696625*^9}, {
   3.8482713860802526`*^9, 3.848271409016235*^9}, {3.848271486659524*^9, 
   3.84827153799444*^9}, {3.8482715825185957`*^9, 3.8482715920719304`*^9}, {
   3.848271725761711*^9, 3.848271745967613*^9}, {3.848271787011566*^9, 
   3.848271803198526*^9}, {3.8482719665543303`*^9, 3.848271970382367*^9}, {
   3.848272013334963*^9, 3.848272221950444*^9}, {3.8482723256032953`*^9, 
   3.8482723360299697`*^9}, {3.848272427575534*^9, 3.8482724842559657`*^9}, 
   3.8482725565493345`*^9, 3.8482725895369325`*^9, {3.8482730930479746`*^9, 
   3.848273104342307*^9}, {3.84827314585238*^9, 3.8482732117528877`*^9}, {
   3.848273265461874*^9, 3.848273283157011*^9}, {3.8482735278174477`*^9, 
   3.8482735524815855`*^9}, {3.848273600024704*^9, 3.8482736040966682`*^9}, 
   3.8482736401935515`*^9, 3.848279119961465*^9, {3.848279153003695*^9, 
   3.8482791742416515`*^9}, 3.8482792073667884`*^9, {3.8482793425524235`*^9, 
   3.848279346820683*^9}, {3.8482793783589077`*^9, 3.8482793878447576`*^9}, {
   3.8482795557191525`*^9, 3.848279568962532*^9}, 3.8482796558458185`*^9, {
   3.848279844397636*^9, 3.8482798838353777`*^9}, {3.8482799594886847`*^9, 
   3.848279996273408*^9}, 3.848280092905571*^9, {3.8482812666294017`*^9, 
   3.848281414494707*^9}, {3.8482814502793016`*^9, 3.8482815115513124`*^9}, 
   3.84828186801633*^9, {3.8482819209982867`*^9, 3.84828210678761*^9}, {
   3.848282146551973*^9, 3.8482821574846044`*^9}, 3.8482822863231115`*^9, 
   3.8482824024619064`*^9, {3.8482824780538187`*^9, 3.848282479404724*^9}, {
   3.848282535899047*^9, 3.848282539216997*^9}, {3.84828262367264*^9, 
   3.8482826424609103`*^9}, {3.8482829744908905`*^9, 3.84828297631981*^9}, {
   3.8482830882746534`*^9, 3.84828309841509*^9}, {3.8482831462768865`*^9, 
   3.84828317774539*^9}, {3.8482833164241905`*^9, 3.8482833730164213`*^9}, {
   3.8482834357757463`*^9, 3.848283516352976*^9}, {3.8482835484361677`*^9, 
   3.848283642957316*^9}, {3.8482836776205144`*^9, 3.848283715700715*^9}, {
   3.8482839649174366`*^9, 3.848284045956606*^9}, {3.8482842490325212`*^9, 
   3.848284250989298*^9}, {3.8482842927582455`*^9, 3.8482844320400267`*^9}, {
   3.848284838157981*^9, 3.8482848684302387`*^9}, {3.8482850692690268`*^9, 
   3.8482851139642897`*^9}, {3.84828526130251*^9, 3.848285269817762*^9}, {
   3.84828533293629*^9, 3.848285341928546*^9}, {3.848285383384562*^9, 
   3.8482853999932504`*^9}, 3.8482856416783247`*^9, 3.848285690657166*^9, {
   3.8482858045571513`*^9, 3.848285817369491*^9}, {3.848285854289056*^9, 
   3.848285863549489*^9}, {3.848285949043954*^9, 3.8482859835460978`*^9}, {
   3.8482863741709456`*^9, 3.848286474475436*^9}, {3.848286523596165*^9, 
   3.8482865829218884`*^9}, {3.8482866279766493`*^9, 3.848286711657236*^9}, {
   3.8482867501492167`*^9, 3.8482868117900267`*^9}, {3.848286863451796*^9, 
   3.8482869165993533`*^9}, {3.8482869469656725`*^9, 3.848286959277572*^9}, {
   3.848287012480024*^9, 3.8482870335613623`*^9}, {3.8482871786742477`*^9, 
   3.8482871882091937`*^9}, {3.848287264393866*^9, 3.8482872774563437`*^9}, {
   3.8482873292389836`*^9, 3.848287339354007*^9}, {3.848287461187666*^9, 
   3.848287487172757*^9}, {3.84828755651991*^9, 3.8482876627410736`*^9}, {
   3.848288013336006*^9, 3.8482880197043076`*^9}, {3.848288094122222*^9, 
   3.848288131136963*^9}, {3.8482881772846775`*^9, 3.8482881958573985`*^9}, 
   3.848288381090166*^9, 3.848288430126021*^9, {3.8482885144039087`*^9, 
   3.8482885646510525`*^9}, {3.8482886338207026`*^9, 3.848288639284582*^9}, {
   3.848288707214119*^9, 3.8482887324156914`*^9}, 3.848288921484293*^9, {
   3.84828900460843*^9, 3.848289088901221*^9}, {3.84828912551621*^9, 
   3.8482893063251557`*^9}, {3.848289447384076*^9, 3.8482896681502295`*^9}, {
   3.848289712765192*^9, 3.848289725349298*^9}, {3.848289767225048*^9, 
   3.8482898351415796`*^9}, {3.8482898674840884`*^9, 
   3.8482898690736723`*^9}, {3.848289900414169*^9, 3.8482899327487745`*^9}, {
   3.848289963449417*^9, 3.8482899845611467`*^9}, {3.84829004543735*^9, 
   3.848290094345174*^9}, {3.8482901300012894`*^9, 3.848290173704802*^9}, {
   3.8482902338698864`*^9, 3.84829023515508*^9}, {3.8482903872243376`*^9, 
   3.8482904020024185`*^9}, {3.848290437350148*^9, 3.848290503657175*^9}, {
   3.8482905796389704`*^9, 3.8482906135773273`*^9}, {3.848290768137512*^9, 
   3.8482908945746183`*^9}, {3.84829118608788*^9, 3.848291190028005*^9}, {
   3.8482912914689407`*^9, 3.8482913012850657`*^9}, {3.848291344717307*^9, 
   3.8482913459025793`*^9}, {3.8482913957895308`*^9, 
   3.8482914243371506`*^9}, {3.8482914753525734`*^9, 3.848291480830313*^9}, {
   3.8482915260220184`*^9, 3.848291531288391*^9}, {3.848291579017645*^9, 
   3.848291588845606*^9}, {3.8482916368721485`*^9, 3.848291650817348*^9}, {
   3.848291691285595*^9, 3.848291693301881*^9}, {3.8482918634233565`*^9, 
   3.848291865061203*^9}, {3.848292072140757*^9, 3.848292094844538*^9}, {
   3.8483364769314036`*^9, 3.8483366401465344`*^9}, {3.848336680752939*^9, 
   3.8483367737973204`*^9}, {3.84833682042262*^9, 3.84833684082658*^9}, {
   3.8483369159033847`*^9, 3.848336922846775*^9}, {3.8483369812955837`*^9, 
   3.8483370608768206`*^9}, {3.84833714735583*^9, 3.8483371824984765`*^9}, {
   3.848337245174388*^9, 3.848337268454629*^9}, {3.8483373381995697`*^9, 
   3.8483375003379717`*^9}, {3.8483375327507477`*^9, 
   3.8483375497018957`*^9}, {3.848337752460241*^9, 3.8483378626657476`*^9}, {
   3.848337892824071*^9, 3.8483379311371913`*^9}, {3.8483379690832815`*^9, 
   3.84833798075622*^9}, {3.848338030829955*^9, 3.84833806851377*^9}, {
   3.848338179302413*^9, 3.8483383768176956`*^9}, {3.8483384702301655`*^9, 
   3.848338492983364*^9}, 3.8483385412285023`*^9, 3.8483386347877483`*^9, {
   3.8483386806202803`*^9, 3.8483387750177126`*^9}, {3.848338865102056*^9, 
   3.848338880142147*^9}, {3.848339008334633*^9, 3.8483391071442375`*^9}, {
   3.8483391738109026`*^9, 3.8483392087898693`*^9}, 3.848339257667083*^9, {
   3.8483393103548164`*^9, 3.848339337511179*^9}, {3.8483393734251204`*^9, 
   3.848339375175195*^9}, {3.8483394096546116`*^9, 3.848339453202426*^9}, {
   3.8483394845561943`*^9, 3.848339559373781*^9}, {3.848339619878171*^9, 
   3.8483396296661897`*^9}, {3.8483396915550675`*^9, 
   3.8483397006552577`*^9}, {3.8483440030071363`*^9, 
   3.8483442807451153`*^9}, {3.8483443602646556`*^9, 3.8483443621612253`*^9}, 
   3.848344426678318*^9, {3.8483444792272563`*^9, 3.848344498830733*^9}, 
   3.848344556774584*^9, {3.848344633377605*^9, 3.84834465933434*^9}, {
   3.848344772270306*^9, 3.848344792684717*^9}, {3.8483448240456915`*^9, 
   3.848344830603738*^9}, {3.84834486692741*^9, 3.8483448848622785`*^9}, 
   3.8483449437063484`*^9, {3.8483449784508376`*^9, 3.848344990957656*^9}, {
   3.8483450346502547`*^9, 3.8483450389853563`*^9}, {3.8483450849984922`*^9, 
   3.848345150485292*^9}, {3.8483452149139295`*^9, 3.8483452171785274`*^9}, {
   3.8483454067571726`*^9, 3.848345411760374*^9}, {3.848345463228942*^9, 
   3.848345470865381*^9}, {3.848345527268618*^9, 3.84834555866245*^9}, 
   3.8483456206146727`*^9, 3.8483457220418043`*^9, {3.8483458330708766`*^9, 
   3.848345846366119*^9}, {3.848345884046138*^9, 3.8483459149654894`*^9}, {
   3.848345948005064*^9, 3.8483459829420147`*^9}, {3.8483462395448217`*^9, 
   3.848346456774876*^9}, {3.8483467630478725`*^9, 3.848346773698474*^9}, {
   3.848346856707751*^9, 3.848346940210098*^9}, {3.848346979385297*^9, 
   3.8483470650382957`*^9}, {3.8483471002870007`*^9, 3.8483471017589083`*^9}, 
   3.8483471820631404`*^9, {3.848347223723214*^9, 3.848347276446865*^9}, {
   3.8483473313175015`*^9, 3.8483473646802855`*^9}, {3.8483475799910793`*^9, 
   3.8483475802541676`*^9}, {3.848347660976128*^9, 3.8483476746540937`*^9}, {
   3.8483477493671455`*^9, 3.84834777114612*^9}, {3.848348376182259*^9, 
   3.848348433175254*^9}, {3.8483484728061132`*^9, 3.8483485735156364`*^9}, {
   3.8483486072697067`*^9, 3.848348670466872*^9}, {3.8483487010358047`*^9, 
   3.8483487168097496`*^9}, 3.8483487557941895`*^9, {3.84834880999839*^9, 
   3.8483488132773886`*^9}, {3.848349105563469*^9, 3.8483491109265146`*^9}, {
   3.848349150142315*^9, 3.84834922213455*^9}, {3.8483496180539017`*^9, 
   3.8483496646611013`*^9}, {3.848349707700601*^9, 3.848349759478053*^9}, {
   3.8483499067314625`*^9, 3.848349911321838*^9}, {3.848350164525238*^9, 
   3.84835017141637*^9}, {3.848350208718814*^9, 3.8483502172549095`*^9}, {
   3.848350266683877*^9, 3.848350281881031*^9}, {3.848350348031293*^9, 
   3.848350474334818*^9}, {3.848350524351823*^9, 3.8483505323667793`*^9}, {
   3.848350579795981*^9, 3.848350637588689*^9}, {3.84835073694221*^9, 
   3.8483507570563593`*^9}, 3.848351717780857*^9, 3.848351772050177*^9, {
   3.848351803219577*^9, 3.8483520548777094`*^9}, {3.8483522172201204`*^9, 
   3.8483522814229717`*^9}, {3.848352324710449*^9, 3.848352363010983*^9}, {
   3.8483525094425917`*^9, 3.8483525220869207`*^9}, {3.848352555775325*^9, 
   3.8483525627029862`*^9}, {3.8483526043870087`*^9, 3.848352630022743*^9}, {
   3.848352661093599*^9, 3.8483526796835356`*^9}, {3.8483527116509533`*^9, 
   3.848352721865638*^9}, {3.8483527760629663`*^9, 3.848352820446452*^9}, 
   3.8483530372752533`*^9, {3.8483530833269396`*^9, 3.848353099964023*^9}, {
   3.8483531461427674`*^9, 3.8483532182831736`*^9}, {3.8483532876107674`*^9, 
   3.8483532955817223`*^9}, {3.8483533457823677`*^9, 3.848353356935809*^9}, 
   3.8483534009032087`*^9, {3.848353610701294*^9, 3.848353716421338*^9}, {
   3.848353814685935*^9, 3.8483538737857695`*^9}, {3.8483545626557927`*^9, 
   3.848354597790862*^9}, {3.8483550445087104`*^9, 3.8483550505345716`*^9}, {
   3.848355124609434*^9, 3.848355131983418*^9}, {3.8483584786157217`*^9, 
   3.848358502299198*^9}, {3.8483590066847014`*^9, 3.848359038527171*^9}, {
   3.8483590925330167`*^9, 3.848359186532132*^9}, {3.8483592397032776`*^9, 
   3.8483593763299003`*^9}, {3.848359445997204*^9, 3.848359523283407*^9}, {
   3.8483595575190907`*^9, 3.8483595654834623`*^9}, {3.8483598110194807`*^9, 
   3.848359828973981*^9}, {3.848359939878149*^9, 3.848360092870797*^9}, {
   3.848360187840407*^9, 3.8483601931756363`*^9}, {3.8483602988517056`*^9, 
   3.848360306146896*^9}, {3.8483603793593044`*^9, 3.8483604047718596`*^9}, {
   3.848360443351221*^9, 3.8483605044398584`*^9}, {3.8483605420408077`*^9, 
   3.8483605615139456`*^9}, {3.848360592974386*^9, 3.848360602869938*^9}, {
   3.8483606721636972`*^9, 3.848360783063608*^9}, {3.848360872690394*^9, 
   3.848360878555662*^9}, {3.848360916518671*^9, 3.8483609237907844`*^9}, {
   3.848360959006275*^9, 3.8483609793349986`*^9}, {3.848361054429885*^9, 
   3.848361065979138*^9}, 3.8483611075026684`*^9, {3.8483616172624493`*^9, 
   3.8483616713476267`*^9}, {3.8483619387166214`*^9, 3.848361976863299*^9}, {
   3.8483620213368177`*^9, 3.8483620580488205`*^9}, {3.848362214514855*^9, 
   3.848362240302723*^9}, {3.84836251578904*^9, 3.8483626087866535`*^9}, {
   3.8483626397882986`*^9, 3.8483626399368258`*^9}, {3.8483626869402003`*^9, 
   3.848362691446458*^9}, {3.8483627252463446`*^9, 3.848362747552438*^9}, 
   3.8483628075717607`*^9, {3.8483628871329193`*^9, 3.848362898529907*^9}, {
   3.8483632029273443`*^9, 3.8483632268380136`*^9}, {3.84836331672676*^9, 
   3.848363321069769*^9}, {3.848363378027224*^9, 3.848363381707801*^9}, {
   3.8483636190536823`*^9, 3.848363718779112*^9}, {3.8483637865441875`*^9, 
   3.8483637867073298`*^9}, {3.848363848649479*^9, 3.8483639165122128`*^9}, {
   3.8483639891418705`*^9, 3.8483640282511845`*^9}, {3.848364144628235*^9, 
   3.848364225821197*^9}, {3.8483645753711243`*^9, 3.848364592176062*^9}, {
   3.8483646647397676`*^9, 3.8483646655078983`*^9}, {3.8483647407149982`*^9, 
   3.8483648017004437`*^9}, {3.8483648517952185`*^9, 3.848364860910864*^9}, {
   3.848364914389219*^9, 3.848364926749664*^9}, {3.8483649630632887`*^9, 
   3.848365021044215*^9}, {3.848365063199128*^9, 3.8483651659121447`*^9}, {
   3.8483652676024847`*^9, 3.8483652715190964`*^9}, {3.848365399218636*^9, 
   3.8483654643987417`*^9}, {3.848365559832115*^9, 3.8483657347676225`*^9}, 
   3.8483658070322533`*^9, {3.848365889111273*^9, 3.848365907821917*^9}, {
   3.848365947778962*^9, 3.848366184427328*^9}, {3.848366240079526*^9, 
   3.8483662511696815`*^9}, {3.8483663339552617`*^9, 
   3.8483664724669476`*^9}, {3.848366574572268*^9, 3.848366578413453*^9}, {
   3.8483666960921316`*^9, 3.848366737226462*^9}, {3.848366780181814*^9, 
   3.8483669320338573`*^9}, {3.8483669663169155`*^9, 3.848367032655841*^9}, {
   3.8483670663592896`*^9, 3.84836716238326*^9}, {3.84836751958942*^9, 
   3.8483675249255896`*^9}, {3.8483691296755576`*^9, 
   3.8483691777985477`*^9}, {3.8483692258455553`*^9, 3.848369309015547*^9}, {
   3.8483700156763244`*^9, 3.8483700279595213`*^9}, {3.848370111611492*^9, 
   3.848370177678331*^9}, {3.8483702261102395`*^9, 3.8483702324913144`*^9}, {
   3.8483710838559117`*^9, 3.848371109701863*^9}, {3.8483711957807074`*^9, 
   3.8483712186392283`*^9}, {3.848371397988644*^9, 3.8483714690734787`*^9}, {
   3.8483715166322684`*^9, 3.8483715567579765`*^9}, {3.8483716062543097`*^9, 
   3.84837161996629*^9}, {3.848371651612709*^9, 3.848371684395895*^9}, {
   3.848371724262802*^9, 3.8483717573382664`*^9}, {3.848371869253908*^9, 
   3.848371871813533*^9}, {3.8483725336594405`*^9, 3.848372537110422*^9}, {
   3.8483725751001997`*^9, 3.848372636490902*^9}, {3.848373275758504*^9, 
   3.848373277852435*^9}, {3.848373389780071*^9, 3.8483734036865683`*^9}, {
   3.848373649877514*^9, 3.8483736664773655`*^9}, {3.8483737062349453`*^9, 
   3.8483737659662237`*^9}, {3.848374034905902*^9, 3.8483740389240246`*^9}, {
   3.8483754580362663`*^9, 3.848375491260363*^9}, {3.848375529768081*^9, 
   3.8483755418482885`*^9}, {3.848375682922799*^9, 3.8483757773369646`*^9}, {
   3.8483758811341944`*^9, 3.848375918027989*^9}, {3.848375957631818*^9, 
   3.848375974423965*^9}, {3.8483760636430025`*^9, 3.84837619204005*^9}, 
   3.848376231041928*^9, {3.848376308255019*^9, 3.8483763243762326`*^9}, {
   3.8483763571166983`*^9, 3.848376415559745*^9}, {3.848376478445059*^9, 
   3.848376487347269*^9}, {3.8483766512290373`*^9, 3.8483768955198064`*^9}, {
   3.8483770175381317`*^9, 3.8483770319529133`*^9}, {3.848377072170342*^9, 
   3.8483771217282085`*^9}, 3.8483771707258167`*^9, {3.8483772161592836`*^9, 
   3.8483774145721827`*^9}, {3.8483775357782745`*^9, 3.848377549835913*^9}, {
   3.848377684024289*^9, 3.848377700866249*^9}, 3.848412604695546*^9, {
   3.8484127117596645`*^9, 3.8484127200327816`*^9}, {3.8484128315136323`*^9, 
   3.848412843474374*^9}, {3.8484131057784824`*^9, 3.8484131701605067`*^9}, {
   3.848413258463731*^9, 3.848413305498783*^9}, {3.848413340953235*^9, 
   3.848413346766325*^9}, {3.8484133886205893`*^9, 3.8484133916098785`*^9}, {
   3.8484137998839417`*^9, 3.84841380811817*^9}, {3.848416202274779*^9, 
   3.848416252842051*^9}, {3.848416320346586*^9, 3.8484163485261016`*^9}, 
   3.848416508612613*^9, {3.8484427744597216`*^9, 3.8484428527414103`*^9}, {
   3.8484429595568013`*^9, 3.848443024701493*^9}, {3.848443515491151*^9, 
   3.8484435273707485`*^9}, {3.848443707666621*^9, 3.848443714010373*^9}, {
   3.848443751170911*^9, 3.848443770658983*^9}, {3.848443820197459*^9, 
   3.8484439990495358`*^9}, {3.8484447310016737`*^9, 
   3.8484448630540447`*^9}, {3.8484448957168136`*^9, 3.848444928611659*^9}, {
   3.8484449632270684`*^9, 3.848445008235414*^9}, {3.848445041581004*^9, 
   3.8484451480234456`*^9}, {3.848445183780033*^9, 3.8484452329330015`*^9}, {
   3.8484454271248684`*^9, 3.8484455428577833`*^9}, {3.8484456188895903`*^9, 
   3.8484456476738796`*^9}, {3.8484457009851665`*^9, 3.848445711463374*^9}, {
   3.848445838725376*^9, 3.848445887589511*^9}, {3.848445926952961*^9, 
   3.8484461496299562`*^9}, {3.848446186023802*^9, 3.848446204376179*^9}, {
   3.8484462578323355`*^9, 3.848446275014434*^9}, {3.848446816478196*^9, 
   3.8484469050778217`*^9}, {3.848446990415241*^9, 3.8484470175460787`*^9}, {
   3.8484473280707207`*^9, 3.8484473528872337`*^9}, {3.8484480343409257`*^9, 
   3.848448094604303*^9}, {3.8484481519121494`*^9, 3.848448160401915*^9}, {
   3.8484481963451023`*^9, 3.848448205816742*^9}, {3.848448236687912*^9, 
   3.8484482512121525`*^9}, {3.8484484305600753`*^9, 
   3.8484485929979753`*^9}, {3.8484486322391677`*^9, 
   3.8484486504652405`*^9}, {3.848448884023924*^9, 3.848448944261077*^9}, {
   3.848449148226201*^9, 3.8484491769602175`*^9}, {3.8484492848570786`*^9, 
   3.848449290904359*^9}, {3.8484493965086594`*^9, 3.8484494005067267`*^9}, {
   3.8484495441023874`*^9, 3.848449545215183*^9}, {3.848449577351722*^9, 
   3.848449581110035*^9}, {3.848449615478691*^9, 3.848449616583887*^9}, {
   3.8484496854485273`*^9, 3.8484496871067853`*^9}, {3.8484497222201095`*^9, 
   3.84844972782862*^9}, {3.848449861549575*^9, 3.8484499015752926`*^9}, {
   3.848450102381958*^9, 3.8484501473913064`*^9}, {3.8484502320937915`*^9, 
   3.8484503101879387`*^9}, {3.8484503509453883`*^9, 3.848450564797635*^9}, {
   3.848450596971656*^9, 3.8484506045701056`*^9}, {3.8484507308028426`*^9, 
   3.848450732482225*^9}, {3.848450798916187*^9, 3.848450889154693*^9}, {
   3.848450971251444*^9, 3.8484509883660865`*^9}, {3.8484510885775166`*^9, 
   3.848451091766961*^9}, {3.8484511588158007`*^9, 3.8484511647736845`*^9}, 
   3.8484512753207154`*^9, {3.8484513256031303`*^9, 3.8484513762100983`*^9}, {
   3.8484514690316086`*^9, 3.84845148122019*^9}, {3.848451549329361*^9, 
   3.848451578269309*^9}, {3.84845162941783*^9, 3.8484517104933453`*^9}, {
   3.848451866446471*^9, 3.8484518668424597`*^9}, {3.8484520451020346`*^9, 
   3.8484520692561197`*^9}, {3.848452183003459*^9, 3.848452198067644*^9}, 
   3.848452240027088*^9, {3.848452387259914*^9, 3.8484524128202534`*^9}, {
   3.848452703731885*^9, 3.8484527807236366`*^9}, 3.8484528142565174`*^9, {
   3.8484531446321845`*^9, 3.8484532385502515`*^9}, {3.8484532892877083`*^9, 
   3.848453339311018*^9}, {3.848453376736893*^9, 3.848453378219872*^9}, {
   3.8484534921826353`*^9, 3.8484535593654613`*^9}, {3.8484536188778715`*^9, 
   3.848453699423873*^9}, {3.8484538122398176`*^9, 3.8484538234833636`*^9}, {
   3.8484538660602245`*^9, 3.8484539556092386`*^9}, {3.8484539973227105`*^9, 
   3.8484541183841143`*^9}, 3.8484541591209383`*^9, {3.8484542017075853`*^9, 
   3.848454205175584*^9}, {3.8484542399198008`*^9, 3.84845424761793*^9}, {
   3.848454352451941*^9, 3.84845439433762*^9}, {3.8484544885899787`*^9, 
   3.8484546720081234`*^9}, {3.848454704580432*^9, 3.8484547128811145`*^9}, 
   3.8484548002807336`*^9, {3.8484548613194633`*^9, 3.8484548809054227`*^9}, {
   3.8484549558781567`*^9, 3.848454989858322*^9}, {3.8484550300005646`*^9, 
   3.848455049433855*^9}, {3.848455084801466*^9, 3.848455091491248*^9}, {
   3.8484551593491206`*^9, 3.848455166231738*^9}, {3.8484554750616913`*^9, 
   3.8484554808894477`*^9}, {3.848455643733164*^9, 3.8484556472748666`*^9}, {
   3.848455720449478*^9, 3.848455751062851*^9}, 3.8484560962564416`*^9, 
   3.848456159662327*^9, {3.848456653468239*^9, 3.848456688035038*^9}, {
   3.8484567189385667`*^9, 3.8484568066428337`*^9}, {3.8484569370555024`*^9, 
   3.848456939094677*^9}, {3.8484569780036926`*^9, 3.8484569794044514`*^9}, {
   3.8484570137329645`*^9, 3.8484570145889626`*^9}, {3.8484570574189835`*^9, 
   3.848457080232993*^9}, {3.8484571148192825`*^9, 3.848457129788129*^9}, {
   3.8484571629326086`*^9, 3.8484573812907314`*^9}, {3.848457616151087*^9, 
   3.848457678032942*^9}, {3.848457725890324*^9, 3.8484577624417143`*^9}, {
   3.84845779826117*^9, 3.848457801972187*^9}, {3.8484580621299095`*^9, 
   3.8484582018739367`*^9}, {3.8484582641635847`*^9, 
   3.8484584611252804`*^9}, {3.848458538516741*^9, 3.8484585543012805`*^9}, {
   3.8484585944152713`*^9, 3.8484586211305504`*^9}, {3.8484587613790474`*^9, 
   3.8484589189927864`*^9}, {3.848459003252246*^9, 3.8484590457551365`*^9}, {
   3.848459124851755*^9, 3.848459233992796*^9}, {3.848459296444496*^9, 
   3.8484592981311812`*^9}, {3.8484593297990007`*^9, 3.848459330775179*^9}, {
   3.8484594183156404`*^9, 3.848459484923886*^9}, {3.848459521063222*^9, 
   3.84845953278607*^9}, {3.848459632002076*^9, 3.84845963482281*^9}, {
   3.8484599040519457`*^9, 3.848460120166822*^9}, {3.8484602469623747`*^9, 
   3.8484602639655204`*^9}, {3.848460312684061*^9, 3.848460333111273*^9}, {
   3.848460375939988*^9, 3.8484603824268484`*^9}, {3.848460663451562*^9, 
   3.8484607582878485`*^9}, {3.8484609068602467`*^9, 3.848460906933135*^9}, {
   3.8484611211394033`*^9, 3.8484611373619366`*^9}, {3.8484614126649647`*^9, 
   3.848461418426957*^9}, {3.8484616025336456`*^9, 3.8484616217916503`*^9}, {
   3.8484616751406193`*^9, 3.848461680244706*^9}, {3.8484617541186223`*^9, 
   3.8484618179092836`*^9}, {3.84846224979331*^9, 3.8484623338936114`*^9}, {
   3.8484624186390905`*^9, 3.848462420057222*^9}, {3.848462569530733*^9, 
   3.8484625721798115`*^9}, {3.848462664976065*^9, 3.848462683808465*^9}, 
   3.848462750503959*^9, {3.84846293668659*^9, 3.8484630563012934`*^9}, {
   3.848463137159775*^9, 3.8484631514348283`*^9}, {3.8484633758606834`*^9, 
   3.8484634051749067`*^9}, {3.848463539443099*^9, 3.848463598982876*^9}, {
   3.8484637154492965`*^9, 3.8484637197981033`*^9}, {3.848463805941819*^9, 
   3.848463814899578*^9}, {3.8484640245813913`*^9, 3.8484640638242254`*^9}, {
   3.84846418622758*^9, 3.8484642668948135`*^9}, {3.848464874239996*^9, 
   3.848464881336038*^9}, {3.8484650704169683`*^9, 3.8484650979367056`*^9}, {
   3.8484651552805223`*^9, 3.848465168108698*^9}, {3.848465239037159*^9, 
   3.848465239807599*^9}, {3.8484657437676334`*^9, 3.8484657579883113`*^9}, {
   3.8484658057059903`*^9, 3.84846586184635*^9}, {3.8484659665038395`*^9, 
   3.8484659682743673`*^9}, {3.848466012129636*^9, 3.8484660906593513`*^9}, {
   3.848466180488203*^9, 3.8484662313218975`*^9}, {3.8484662913959613`*^9, 
   3.8484663183118715`*^9}, {3.848466424668065*^9, 3.848466425528158*^9}, 
   3.848466620932423*^9, {3.8484669462017174`*^9, 3.8484670306742344`*^9}, {
   3.8484670669969654`*^9, 3.8484670676261883`*^9}, {3.8484671393756523`*^9, 
   3.8484671631159706`*^9}, {3.8484673208013268`*^9, 
   3.8484673795520873`*^9}, {3.8484674833598595`*^9, 3.848467483990902*^9}, {
   3.8484676633033943`*^9, 3.848467698898075*^9}, {3.8484999347152605`*^9, 
   3.8484999366921177`*^9}, {3.848499975760049*^9, 3.8485000118640947`*^9}, {
   3.848500054331023*^9, 3.848500071139076*^9}, {3.848500250124179*^9, 
   3.8485002937797003`*^9}, {3.848500606049167*^9, 3.848500611029687*^9}, {
   3.848500853335676*^9, 3.848500855730775*^9}, {3.8485009275188437`*^9, 
   3.8485009715062532`*^9}, 3.8485010505328712`*^9, {3.8485012422512703`*^9, 
   3.848501304064698*^9}, 3.848501336947776*^9, {3.848501442099086*^9, 
   3.8485014650879974`*^9}, {3.848501546312682*^9, 3.8485015484960175`*^9}, {
   3.8485027633270597`*^9, 3.8485027721719885`*^9}, 3.84850319435034*^9, {
   3.848505530239025*^9, 3.848505608451652*^9}, {3.848505684578903*^9, 
   3.848505795545825*^9}, {3.848505832908204*^9, 3.8485059336653104`*^9}, {
   3.8485059701538253`*^9, 3.8485060121973944`*^9}, {3.848506076268239*^9, 
   3.8485060863741083`*^9}, {3.848506160280542*^9, 3.8485061991244507`*^9}, {
   3.8485062561565065`*^9, 3.848506389219776*^9}, {3.84850643491693*^9, 
   3.8485064661139607`*^9}, {3.848506499917067*^9, 3.8485065420205746`*^9}, {
   3.8485070634337587`*^9, 3.848507067488042*^9}, {3.8485071183835588`*^9, 
   3.8485071474325476`*^9}, {3.848507451612444*^9, 3.8485075617184772`*^9}, {
   3.848507621891187*^9, 3.8485076266143026`*^9}, {3.8485076677289653`*^9, 
   3.8485076851071744`*^9}, {3.8485077468807755`*^9, 
   3.8485077487233334`*^9}, {3.8485078954991665`*^9, 3.848507966264756*^9}, {
   3.8485079998334064`*^9, 3.848508036781826*^9}, {3.848508197697342*^9, 
   3.848508216505089*^9}, {3.848508277079835*^9, 3.8485082777351007`*^9}, {
   3.8485083631649623`*^9, 3.8485083891599903`*^9}, {3.8485085062547693`*^9, 
   3.8485085337737875`*^9}, {3.848508614294306*^9, 3.8485086211885247`*^9}, {
   3.8485091058725367`*^9, 3.8485091519746456`*^9}, {3.8485125581833954`*^9, 
   3.8485126251196566`*^9}, {3.848512788854014*^9, 3.8485128077310886`*^9}, {
   3.848512839866664*^9, 3.848512874466197*^9}, {3.848512922390378*^9, 
   3.8485129277334394`*^9}, {3.8485129604029226`*^9, 3.848512974358914*^9}, {
   3.8485131814248857`*^9, 3.8485131838457613`*^9}, {3.8485148795450954`*^9, 
   3.8485150108089743`*^9}, {3.848515149376829*^9, 3.848515223608677*^9}, 
   3.8485152602579465`*^9, {3.8485153032562*^9, 3.848515389253177*^9}, {
   3.8485154445683575`*^9, 3.848515454059326*^9}, {3.8485163036497273`*^9, 
   3.8485163095429697`*^9}, {3.8485163897192216`*^9, 
   3.8485164256986637`*^9}, {3.848516485791907*^9, 3.8485165096580076`*^9}, {
   3.84852422944131*^9, 3.8485242598128595`*^9}, {3.848524347756941*^9, 
   3.848524351982359*^9}, {3.8485243905158463`*^9, 3.848524514864953*^9}, {
   3.8485245981556854`*^9, 3.8485246000295935`*^9}, 3.848524635537575*^9, {
   3.848524741051879*^9, 3.8485247558566895`*^9}, {3.8485248535612226`*^9, 
   3.8485248621581345`*^9}, {3.8485249060914474`*^9, 
   3.8485249626577244`*^9}, {3.848526566404692*^9, 3.8485266466666145`*^9}, {
   3.84852671233272*^9, 3.848526741059805*^9}, {3.84852678576516*^9, 
   3.848526820362233*^9}, {3.8485269100397825`*^9, 3.848526911306198*^9}, {
   3.8485269574310102`*^9, 3.8485270299522486`*^9}, {3.84852710300486*^9, 
   3.848527259769876*^9}, {3.8485273089947467`*^9, 3.8485273442944264`*^9}, {
   3.848527379932994*^9, 3.8485274131549263`*^9}, {3.8485274573830986`*^9, 
   3.8485274778484607`*^9}, 3.848527571701195*^9, {3.8485277187463017`*^9, 
   3.8485277196800046`*^9}, {3.8485281044059567`*^9, 
   3.8485281097321644`*^9}, {3.8485282276265717`*^9, 3.848528251647911*^9}, {
   3.8485283416711397`*^9, 3.8485283458299437`*^9}, 3.848528544022827*^9, {
   3.8485289891081715`*^9, 3.848529036316159*^9}, 3.8485291914512825`*^9, {
   3.8485292330115566`*^9, 3.8485293231558323`*^9}, {3.848529609993552*^9, 
   3.8485296620397253`*^9}, {3.848529726961671*^9, 3.848529754345524*^9}, {
   3.8485298529821568`*^9, 3.848529873038305*^9}, {3.848529918028077*^9, 
   3.8485299529623113`*^9}, 3.8485301126978917`*^9, {3.8485302136421595`*^9, 
   3.848530221241845*^9}, {3.848530259091509*^9, 3.848530278881583*^9}, {
   3.8485303188998356`*^9, 3.848530393878315*^9}, {3.848532222361238*^9, 
   3.8485323547961054`*^9}, {3.8485330808955145`*^9, 
   3.8485330867761497`*^9}, {3.8485332986727743`*^9, 3.848533299981944*^9}, 
   3.848534811402095*^9, {3.848535046950244*^9, 3.8485351028967648`*^9}, 
   3.8485355502608356`*^9, {3.8485362685524626`*^9, 3.84853627580103*^9}, 
   3.8485363876599283`*^9, 3.8485365723321323`*^9, {3.848536636664409*^9, 
   3.848536665776307*^9}, {3.848536828260042*^9, 3.848536833852*^9}, {
   3.848537369738737*^9, 3.8485373704425077`*^9}, {3.848538457886979*^9, 
   3.8485384815084333`*^9}, {3.848538555284723*^9, 3.8485386156886325`*^9}, 
   3.84853888782414*^9, 3.848538923083042*^9, {3.8486125172480893`*^9, 
   3.84861251953677*^9}, 3.84868610972608*^9, {3.848686340741361*^9, 
   3.8486863668111844`*^9}, 3.848697418932922*^9, {3.8486974565707254`*^9, 
   3.8486974752682524`*^9}, {3.848701088004823*^9, 3.8487011000276318`*^9}, {
   3.8487072455163727`*^9, 3.848707248365844*^9}, {3.849213839994221*^9, 
   3.849213842921951*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"e1f05980-5fef-4dfc-9dc5-a9e2bfbed61a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Outputs", " ", "EdgeDistances", " ", "of", " ", "Least", " ", "Bridges", 
     " ", "Graph"}], ",", " ", 
    RowBox[{"possibly", " ", "distance", " ", "limited"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Input", ":", " ", 
    RowBox[{"[", 
     RowBox[{"edistances_", ",", "distancelimit_", ",", "verbose_"}], "]"}]}],
    " ", "*)"}], 
  RowBox[{"(*", " ", 
   RowBox[{"edistances", " ", "=", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"v1", "\[UndirectedEdge]", "v2"}], ",", "8"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"v1", "\[DirectedEdge]", "v3"}], ",", 
         SqrtBox["2"]}], "}"}], ",", "..."}], "}"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"#1", " ", "=", " ", 
        RowBox[{"directed", " ", 
         RowBox[{"and", "/", "or"}], " ", "undirected", " ", "edges"}]}], ",",
        " ", 
       RowBox[{
        RowBox[{"no", " ", "rules"}], ";", " ", 
        RowBox[{"#2", " ", "=", " ", 
         RowBox[{"non", "-", 
          RowBox[{"complex", " ", "distance"}]}]}]}]}], ")"}]}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"distancelimit", " ", "=", " ", 
    RowBox[{"L", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"L", " ", "\[LessEqual]", " ", "0"}], " ", "\[RightArrow]", 
        " ", 
        RowBox[{"no", " ", "graph", " ", "computed"}]}], ",", " ", 
       RowBox[{
        RowBox[{"L", " ", "<", " ", "\[Infinity]"}], " ", "\[RightArrow]", 
        " ", 
        RowBox[{
        "LBG", " ", "computation", " ", "halts", " ", "at", " ", "L", " ", 
         "if", " ", "reached"}]}], ",", " ", 
       RowBox[{"\[Infinity]", " ", "\[RightArrow]", " ", 
        RowBox[{"no", " ", "distance", " ", "limit"}]}], ",", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"NumberQ", "[", "L", "]"}], "\[Equal]", "False"}], " ", 
        "\[RightArrow]", " ", "ignored"}]}], ")"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{" ", 
    RowBox[{"verbose", " ", "=", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"True", " ", "|", " ", "False"}], ")"}], " ", "progress", " ", 
      RowBox[{"messages", ".", " ", "default"}], " ", "is", " ", "False"}]}], 
    ")"}], " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Output", ":", " ", "acceptedEdgeDistances"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"LeastBridgesEdgeDistances", "[", 
      RowBox[{"edistances_", ",", "distancelimit_", ",", "verbose_"}], "]"}], 
     ":=", 
     RowBox[{"Block", "[", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"local", " ", "variables"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
        "edgeCount", ",", "\[IndentingNewLine]", "absoluteMinMax", ",", 
         "\[IndentingNewLine]", "distancePairsGathered", ",", 
         "\[IndentingNewLine]", "uniqueEdgeDistances", ",", 
         "uniqueEdgeDistancesCount", ",", "\[IndentingNewLine]", 
         "pairToEdgeHash", ",", "pairToDistanceHash", ",", 
         "\[IndentingNewLine]", "vertices", ",", "verticesCount", ",", 
         "\[IndentingNewLine]", "distancelimitNaN", ",", "distancelimitStr", 
         ",", "requestedlimit", ",", "assignedlimit", ",", "t", ",", 
         "triallimit", ",", "\[IndentingNewLine]", "showprogress", ",", 
         "\[IndentingNewLine]", "trial", ",", "\[IndentingNewLine]", 
         StyleBox["acceptedEdgeDistances",
          FontColor->RGBColor[1, 0.5, 0]], ",", "acceptedEdgesCount", ",", 
         "priorAcceptedEdgesCount", ",", "\[IndentingNewLine]", 
         "graphEdgesVertices", ",", "graphEdgesVerticesCount", ",", 
         "\[IndentingNewLine]", "graphComponents", ",", 
         "graphComponentsCount", ",", "vertexComponentHash", ",", 
         "threadedComponents", ",", "\[IndentingNewLine]", 
         "graphPairsDegenerateSet", ",", "\[IndentingNewLine]", 
         "trialSelections", ",", "trialPairs", ",", "trialPairsCount", ",", 
         "trialPairsDistance", ",", "\[IndentingNewLine]", "thisPair", ",", 
         "notDegenerate", ",", "v1component", ",", "v2component", ",", 
         "notSelfLoop", ",", "\[IndentingNewLine]", "thisEdge", ",", 
         "thisEdgeHeadStr", ",", "undirectedEdgeStr", ",", "directedEdgeStr", 
         ",", "\[IndentingNewLine]", "trialEdgesCount", ",", 
         "verticesComplements", ",", "verticesComplementsCount", ",", 
         "\[IndentingNewLine]", "pseudoComponents", ",", 
         "pseudoComponentsCount"}], "\[IndentingNewLine]", "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"process", " ", "input"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"edgeCount", "=", 
         RowBox[{"Length", "[", "edistances", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"absoluteMinMax", "=", 
         RowBox[{"MinMax", "[", 
          RowBox[{"edistances", "[", 
           RowBox[{"[", 
            RowBox[{";;", ",", "2"}], "]"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"distancePairsGathered", "=", 
         RowBox[{"(", 
          RowBox[{"GatherBy", "[", 
           RowBox[{
            RowBox[{"Sort", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"#", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
                   RowBox[{"#", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "2"}], "]"}], "]"}]}], "}"}]}], "}"}], 
               "&"}], "/@", "edistances"}], "]"}], ",", "First"}], "]"}], 
          ")"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"uniqueEdgeDistances", "=", 
         RowBox[{"distancePairsGathered", "[", 
          RowBox[{"[", 
           RowBox[{";;", ",", "1", ",", "1"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"uniqueEdgeDistancesCount", "=", 
         RowBox[{"Length", "[", "distancePairsGathered", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"pairToEdgeHash", "=", 
         RowBox[{"CreateDataStructure", "[", "\"\<HashTable\>\"", "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"pairToEdgeHash", "[", 
           RowBox[{"\"\<Insert\>\"", ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"#", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"#", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "2"}], "]"}], "]"}]}], "}"}], "\[Rule]", 
             RowBox[{"#", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}]}], "]"}], "&"}], "/@", 
         "edistances"}], ";", "\[IndentingNewLine]", 
        RowBox[{"pairToDistanceHash", "=", 
         RowBox[{"CreateDataStructure", "[", "\"\<HashTable\>\"", "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"pairToDistanceHash", "[", 
           RowBox[{"\"\<Insert\>\"", ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"#", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"#", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "2"}], "]"}], "]"}]}], "}"}], "\[Rule]", 
             RowBox[{"#", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], "&"}], "/@", 
         "edistances"}], ";", "\[IndentingNewLine]", 
        RowBox[{"vertices", "=", 
         RowBox[{"Sort", "[", 
          RowBox[{"DeleteDuplicates", "[", 
           RowBox[{"Flatten", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"List", "@@", "#"}], ")"}], "&"}], "/@", 
             RowBox[{"edistances", "[", 
              RowBox[{"[", 
               RowBox[{";;", ",", "1"}], "]"}], "]"}]}], "]"}], "]"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"verticesCount", "=", 
         RowBox[{"Length", "[", "vertices", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"distancelimitNaN", "=", 
         RowBox[{"!", 
          RowBox[{"NumberQ", "[", "distancelimit", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", "distancelimitNaN", ")"}], "&&", 
            RowBox[{"(", 
             RowBox[{"distancelimit", "\[NotEqual]", "\[Infinity]"}], ")"}]}],
            ")"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Do", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"distancelimitStr", "=", 
              RowBox[{"ToString", "[", "distancelimit", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"assignedlimit", ",", "requestedlimit"}], "}"}], "=", 
              RowBox[{"{", 
               RowBox[{"0", ",", "distancelimitStr"}], "}"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "1"}], "]"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"Which", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"distancelimit", "\[Equal]", "\[Infinity]"}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"assignedlimit", ",", "requestedlimit"}], "}"}], "=", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"absoluteMinMax", "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", "distancelimit"}], 
              "}"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"distancelimit", "<", "0"}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"assignedlimit", ",", "requestedlimit"}], "}"}], "=", 
             RowBox[{"{", 
              RowBox[{"0", ",", "distancelimit"}], "}"}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"distancelimit", ">", 
             RowBox[{"absoluteMinMax", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"assignedlimit", ",", "requestedlimit"}], "}"}], "=", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"absoluteMinMax", "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", "distancelimit"}], 
              "}"}]}], ",", "\[IndentingNewLine]", "True", ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"assignedlimit", ",", "requestedlimit"}], "}"}], "=", 
             RowBox[{"{", 
              RowBox[{"distancelimit", ",", "distancelimit"}], "}"}]}]}], 
           "]"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"t", "=", "1"}], ";", "\[IndentingNewLine]", 
        RowBox[{"While", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"assignedlimit", "\[GreaterEqual]", 
              RowBox[{"uniqueEdgeDistances", "[", 
               RowBox[{"[", "t", "]"}], "]"}]}], ")"}], "&&", 
            RowBox[{"(", 
             RowBox[{"t", "<", "uniqueEdgeDistancesCount"}], ")"}]}], ")"}], 
          ",", 
          RowBox[{"t", "++"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"assignedlimit", "\[Equal]", 
           RowBox[{"uniqueEdgeDistances", "[", 
            RowBox[{"[", "t", "]"}], "]"}]}], ",", 
          RowBox[{"triallimit", "=", "t"}], ",", 
          RowBox[{"triallimit", "=", 
           RowBox[{"t", "-", "1"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"showprogress", "=", "False"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"BooleanQ", "[", "verbose", "]"}], ",", 
          RowBox[{"showprogress", "=", "verbose"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Print", "[", "\"\<LeastBridgesEdgeDistances:\>\"", "]"}], 
           ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{"\"\<\\t\>\"", ",", "\"\<INITIALIZATION\>\""}], "]"}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<Dimensions[edistances] = \>\"", ",", 
             RowBox[{"Dimensions", "[", "edistances", "]"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<edgeCount = \>\"", ",", "edgeCount"}],
             "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<absoluteMinMax = \>\"", ",", 
             "absoluteMinMax"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<uniqueEdgeDistancesCount = \>\"", ",",
              "uniqueEdgeDistancesCount"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<verticesCount = \>\"", ",", 
             "verticesCount"}], "]"}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<distancelimit = \>\"", ",", 
             "distancelimit"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<distancelimitNaN = \>\"", ",", 
             "distancelimitNaN"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<requestedlimit = \>\"", ",", 
             "requestedlimit"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<assignedlimit = \>\"", ",", 
             "assignedlimit"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<triallimit = \>\"", ",", "triallimit",
              ",", "\"\< of \>\"", ",", "uniqueEdgeDistancesCount", ",", 
             "\"\< possible\>\""}], "]"}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<verbose = \>\"", ",", "verbose"}], "]"}],
            ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<showprogress = \>\"", ",", 
             "showprogress"}], "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], 
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"undirectedEdgeStr", "=", 
         RowBox[{"ToString", "[", 
          RowBox[{"Head", "[", 
           RowBox[{"0", "\[UndirectedEdge]", "0"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"directedEdgeStr", "=", 
         RowBox[{"ToString", "[", 
          RowBox[{"Head", "[", 
           RowBox[{"0", "\[DirectedEdge]", "0"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"least", " ", "bridges", " ", "graph", " ", "edges"}], " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Print", "[", 
            RowBox[{"\"\<\\t\>\"", ",", "\"\<COMPUTATION\>\""}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", 
             "\"\<computing least bridge graph edges\>\""}], "]"}]}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"trial", "=", "0"}], ";", "\[IndentingNewLine]", 
        RowBox[{"acceptedEdgeDistances", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"acceptedEdgesCount", "=", "0"}], ";", "\[IndentingNewLine]", 
        RowBox[{"graphEdgesVertices", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"graphEdgesVerticesCount", "=", "0"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"graphComponents", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"graphComponentsCount", "=", 
         RowBox[{"Length", "[", "graphComponents", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "vertexComponentHash", " ", "maps", " ", "vertex", " ", "to", " ", 
          "component", " ", 
          RowBox[{"index", ".", " ", "reset"}], " ", "every", " ", 
          RowBox[{"trial", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"pseudoComponents", "=", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"{", "#", "}"}], "&"}], "/@", "vertices"}], ")"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"pseudoComponentsCount", "=", 
         RowBox[{"Length", "[", "pseudoComponents", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"vertexComponentHash", "=", 
         RowBox[{"CreateDataStructure", "[", "\"\<HashTable\>\"", "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"threadedComponents", "=", 
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"pseudoComponents", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", ",", "j"}], "]"}], "]"}], ",", "i"}], "}"}], 
               ",", 
               RowBox[{"{", 
                RowBox[{"j", ",", "1", ",", 
                 RowBox[{"Length", "[", 
                  RowBox[{"pseudoComponents", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", "pseudoComponentsCount"}], "}"}]}], 
            "]"}], ",", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"vertexComponentHash", "[", 
           RowBox[{"\"\<Insert\>\"", ",", 
            RowBox[{
             RowBox[{"#", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "\[Rule]", 
             RowBox[{"#", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], "&"}], "/@", 
         "threadedComponents"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
          "a", " ", "set", " ", "of", " ", "every", " ", "edge", " ", "in", 
           " ", "the", " ", "graph"}], ",", " ", 
          RowBox[{
          "including", " ", "vertex", " ", "pairs", " ", "of", " ", 
           "directed", " ", "edges", " ", "and", " ", "both", " ", "vertex", 
           " ", "pairs", " ", 
           RowBox[{"(", 
            RowBox[{"forward", " ", "and", " ", "reverse"}], ")"}], " ", "of",
            " ", "undirected", " ", "edges"}]}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"graphPairsDegenerateSet", "=", 
         RowBox[{"CreateDataStructure", "[", "\"\<HashSet\>\"", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<\[Bullet] trial: \>\"", ",", 
             "trial"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\\t\>\"", ",", "\"\<pseudoComponentsCount = \>\"", ",",
              "pseudoComponentsCount"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\\t\>\"", ",", "\"\<graphComponentsCount = \>\"", ",", 
             "graphComponentsCount"}], "]"}], ";"}]}], "\[IndentingNewLine]", 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"While", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"graphComponentsCount", ">", "1"}], ")"}], "||", 
             RowBox[{"(", 
              RowBox[{"graphEdgesVerticesCount", "<", "verticesCount"}], 
              ")"}]}], ")"}], "&&", 
           RowBox[{"(", 
            RowBox[{"trial", "<", "triallimit"}], ")"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Do", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"trial", "++"}], ";", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{"showprogress", ",", 
               RowBox[{"Print", "[", 
                RowBox[{
                "\"\<\\t\\t\>\"", ",", "\"\<\[Bullet] trial: \>\"", ",", 
                 "trial"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"priorAcceptedEdgesCount", "=", "acceptedEdgesCount"}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"trialSelections", "=", 
              RowBox[{"distancePairsGathered", "[", 
               RowBox[{"[", "trial", "]"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"trialPairs", "=", 
              RowBox[{"trialSelections", "[", 
               RowBox[{"[", 
                RowBox[{";;", ",", "2"}], "]"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"trialPairsCount", "=", 
              RowBox[{"Length", "[", "trialPairs", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"trialPairsDistance", "=", 
              RowBox[{"pairToDistanceHash", "[", 
               RowBox[{"\"\<Lookup\>\"", ",", 
                RowBox[{"trialPairs", "[", 
                 RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{"showprogress", ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"Print", "[", 
                 RowBox[{
                 "\"\<\\t\\t\\t\>\"", ",", "\"\<trialPairsCount = \>\"", ",", 
                  "trialPairsCount"}], "]"}], ";", "\[IndentingNewLine]", 
                RowBox[{"Print", "[", 
                 RowBox[{
                 "\"\<\\t\\t\\t\>\"", ",", "\"\<trialPairsDistance = \>\"", 
                  ",", "trialPairsDistance"}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"Print", "[", 
                 RowBox[{
                 "\"\<\\t\\t\\t\>\"", ",", "\"\<trialPairs = \>\"", ",", 
                  "trialPairs"}], "]"}], ";"}]}], "\[IndentingNewLine]", 
              "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"Do", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"thisPair", "=", 
                 RowBox[{"trialPairs", "[", 
                  RowBox[{"[", "p", "]"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"notDegenerate", "=", 
                 RowBox[{"!", 
                  RowBox[{"graphPairsDegenerateSet", "[", 
                   RowBox[{"\"\<MemberQ\>\"", ",", "thisPair"}], "]"}]}]}], 
                ";", "\[IndentingNewLine]", 
                RowBox[{"v1component", "=", 
                 RowBox[{"vertexComponentHash", "[", 
                  RowBox[{"\"\<Lookup\>\"", ",", 
                   RowBox[{"thisPair", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"v2component", "=", 
                 RowBox[{"vertexComponentHash", "[", 
                  RowBox[{"\"\<Lookup\>\"", ",", 
                   RowBox[{"thisPair", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"notSelfLoop", "=", 
                 RowBox[{"v1component", "\[NotEqual]", "v2component"}]}], ";",
                 "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{"showprogress", ",", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"Print", "[", 
                    RowBox[{
                    "\"\<\\t\\t\\t\\t\>\"", ",", "\"\<thisPair = \>\"", ",", 
                    "thisPair"}], "]"}], ";", "\[IndentingNewLine]", 
                   RowBox[{"Print", "[", 
                    RowBox[{
                    "\"\<\\t\\t\\t\\t\\t\>\"", ",", 
                    "\"\<notDegenerate = \>\"", ",", "notDegenerate"}], "]"}],
                    ";", "\[IndentingNewLine]", 
                   RowBox[{"Print", "[", 
                    RowBox[{
                    "\"\<\\t\\t\\t\\t\\t\>\"", ",", "\"\<notSelfLoop = \>\"", 
                    ",", "notSelfLoop"}], "]"}], ";"}]}], 
                 "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", "notDegenerate", ")"}], "&&", 
                   RowBox[{"(", "notSelfLoop", ")"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"Do", "[", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"thisEdge", "=", 
                    RowBox[{"pairToEdgeHash", "[", 
                    RowBox[{"\"\<Lookup\>\"", ",", "thisPair"}], "]"}]}], ";",
                     "\[IndentingNewLine]", 
                    RowBox[{"thisEdgeHeadStr", "=", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"Head", "[", "thisEdge", "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    "thisEdgeHeadStr", "\[Equal]", "undirectedEdgeStr"}], ",",
                     "\[IndentingNewLine]", 
                    RowBox[{"Do", "[", " ", 
                    RowBox[{"(*", " ", 
                    RowBox[{"unordered", " ", "edge"}], " ", "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"acceptedEdgeDistances", ",", 
                    RowBox[{"{", 
                    RowBox[{"thisEdge", ",", "trialPairsDistance"}], "}"}]}], 
                    "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"graphPairsDegenerateSet", "[", 
                    RowBox[{"\"\<Insert\>\"", ",", "thisPair"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"graphPairsDegenerateSet", "[", 
                    RowBox[{"\"\<Insert\>\"", ",", 
                    RowBox[{"Reverse", "[", "thisPair", "]"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "1"}], 
                    "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    "thisEdgeHeadStr", "\[Equal]", "directedEdgeStr"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Do", "[", " ", 
                    RowBox[{"(*", " ", 
                    RowBox[{"directed", " ", "edge"}], " ", "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"acceptedEdgeDistances", ",", 
                    RowBox[{"{", 
                    RowBox[{"thisEdge", ",", "trialPairsDistance"}], "}"}]}], 
                    "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"graphPairsDegenerateSet", "[", 
                    RowBox[{"\"\<Insert\>\"", ",", "thisPair"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "1"}], 
                    "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "1"}], 
                   "]"}]}], " ", 
                 RowBox[{"(*", " ", 
                  RowBox[{
                  "end", " ", "add", " ", "thisPair", " ", "to", " ", 
                   "graph"}], " ", "*)"}], "\[IndentingNewLine]", "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"p", ",", "1", ",", "trialPairsCount"}], "}"}]}], 
              "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"graphComponents", "=", 
              RowBox[{"ConnectedComponents", "[", 
               RowBox[{"UndirectedGraph", "[", 
                RowBox[{"acceptedEdgeDistances", "[", 
                 RowBox[{"[", 
                  RowBox[{";;", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], ";",
              "\[IndentingNewLine]", 
             RowBox[{"graphComponentsCount", "=", 
              RowBox[{"Length", "[", "graphComponents", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"acceptedEdgesCount", "=", 
              RowBox[{"Length", "[", "acceptedEdgeDistances", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"trialEdgesCount", "=", 
              RowBox[{
              "acceptedEdgesCount", "-", "priorAcceptedEdgesCount"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"graphEdgesVertices", "=", 
              RowBox[{"Sort", "[", 
               RowBox[{"DeleteDuplicates", "[", 
                RowBox[{"Flatten", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"List", "@@", "#"}], ")"}], "&"}], "/@", 
                  RowBox[{"acceptedEdgeDistances", "[", 
                   RowBox[{"[", 
                    RowBox[{";;", ",", "1"}], "]"}], "]"}]}], "]"}], "]"}], 
               "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"graphEdgesVerticesCount", "=", 
              RowBox[{"Length", "[", "graphEdgesVertices", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"verticesComplements", "=", 
              RowBox[{"Complement", "[", 
               RowBox[{"vertices", ",", "graphEdgesVertices"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"verticesComplementsCount", "=", 
              RowBox[{"Length", "[", "verticesComplements", "]"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"pseudoComponents", "=", 
              RowBox[{"Join", "[", 
               RowBox[{"graphComponents", ",", 
                RowBox[{
                 RowBox[{
                  RowBox[{"{", "#", "}"}], "&"}], "/@", 
                 "verticesComplements"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"pseudoComponentsCount", "=", 
              RowBox[{"Length", "[", "pseudoComponents", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"vertexComponentHash", "=", 
              RowBox[{
              "CreateDataStructure", "[", "\"\<HashTable\>\"", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"threadedComponents", "=", 
              RowBox[{"Flatten", "[", 
               RowBox[{
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"Table", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"pseudoComponents", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j"}], "]"}], "]"}], ",", "i"}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{"j", ",", "1", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"pseudoComponents", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
                  ",", 
                  RowBox[{"{", 
                   RowBox[{"i", ",", "1", ",", "pseudoComponentsCount"}], 
                   "}"}]}], "]"}], ",", "1"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"vertexComponentHash", "[", 
                RowBox[{"\"\<Insert\>\"", ",", 
                 RowBox[{
                  RowBox[{"#", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "\[Rule]", 
                  RowBox[{"#", "[", 
                   RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], "&"}], "/@", 
              "threadedComponents"}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "1"}], "]"}]}],
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<\\t\\t\>\"", ",", "\"\<completed \>\"", ",", "trial", ",", 
            "\"\< trials.\>\""}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<\\t\\t\>\"", ",", "\"\<acceptedEdgesCount = \>\"", ",", 
            "acceptedEdgesCount"}], "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<\\t\\t\>\"", ",", "\"\<graphEdgesVerticesCount = \>\"", ",", 
            "graphEdgesVerticesCount"}], "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Sort", "[", "acceptedEdgeDistances", "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.8048894328314266`*^9, 3.8048894997893095`*^9}, 
   3.8048932504914227`*^9, 3.8048932855556264`*^9, 3.8048933200387383`*^9, {
   3.8049787200358596`*^9, 3.804978723801437*^9}, {3.804978767722407*^9, 
   3.8049788118152714`*^9}, {3.8053053803429146`*^9, 
   3.8053053877333555`*^9}, {3.8053054803528347`*^9, 
   3.8053055428980227`*^9}, {3.8053093369091387`*^9, 
   3.8053093403934264`*^9}, {3.8100699591179037`*^9, 
   3.8100700165378733`*^9}, {3.810240248551813*^9, 3.8102402662699814`*^9}, {
   3.810240362712524*^9, 3.8102403698530006`*^9}, 3.8102404642945232`*^9, 
   3.8198464252718763`*^9, {3.819846496426095*^9, 3.8198465080664034`*^9}, {
   3.819846647143484*^9, 3.8198466548463907`*^9}, 3.819848553304391*^9, {
   3.819848594121112*^9, 3.8198486448221283`*^9}, {3.819848853713481*^9, 
   3.8198488575436077`*^9}, {3.819849305886876*^9, 3.8198493126366835`*^9}, {
   3.819849783805763*^9, 3.819849795289811*^9}, {3.8198498751370897`*^9, 
   3.8198498796753483`*^9}, 3.819852410975874*^9, {3.819852720438212*^9, 
   3.819852726688031*^9}, {3.81985871609789*^9, 3.819858723004779*^9}, {
   3.8198588690489035`*^9, 3.8198588808657217`*^9}, {3.819859020980142*^9, 
   3.819859077063222*^9}, {3.8198592298239613`*^9, 3.8198592314959803`*^9}, {
   3.8198598378046885`*^9, 3.819859848586525*^9}, {3.819859966904131*^9, 
   3.819859978467265*^9}, {3.8198601024428253`*^9, 3.819860147710929*^9}, {
   3.81986041497547*^9, 3.8198604260385838`*^9}, {3.8198605213875723`*^9, 
   3.819860528950492*^9}, 3.819860656019965*^9, {3.8198622090297728`*^9, 
   3.8198622151392*^9}, 3.819863567856737*^9, 3.8198636082164145`*^9, {
   3.819934109527196*^9, 3.819934115702182*^9}, 3.819939980798693*^9, {
   3.81994004790958*^9, 3.819940055487485*^9}, 3.8199465340708485`*^9, 
   3.819947052234573*^9, {3.819947237064841*^9, 3.819947248002035*^9}, {
   3.8199482827172318`*^9, 3.819948291930473*^9}, {3.819989034310416*^9, 
   3.8199890499118176`*^9}, 3.819995532946477*^9, {3.8199956762079926`*^9, 
   3.8199956892388983`*^9}, {3.8200889339886756`*^9, 3.820088944941464*^9}, {
   3.82008912313525*^9, 3.820089124775836*^9}, 3.8200907862550397`*^9, {
   3.8200912810865135`*^9, 3.820091286789473*^9}, {3.820115148129422*^9, 
   3.82011515286366*^9}, {3.8201152861410875`*^9, 3.8201153572484207`*^9}, {
   3.820206233484451*^9, 3.820206255112809*^9}, {3.8202071518792677`*^9, 
   3.820207169675432*^9}, 3.8202073478112817`*^9, 3.8202079047303452`*^9, {
   3.820460400220234*^9, 3.8204604028023806`*^9}, 3.820460462612266*^9, 
   3.8204606147399035`*^9, 3.82054410414405*^9, {3.820640395379943*^9, 
   3.8206404505658307`*^9}, {3.820640525708227*^9, 3.8206405563792224`*^9}, {
   3.820683687845157*^9, 3.8206836973221316`*^9}, {3.8206837549879293`*^9, 
   3.82068375542807*^9}, {3.8207849253768363`*^9, 3.820784936298422*^9}, {
   3.8209572599779663`*^9, 3.820957269055828*^9}, {3.8209573053985577`*^9, 
   3.82095730911718*^9}, {3.8209573555377216`*^9, 3.820957376505872*^9}, 
   3.820959331578873*^9, {3.8211383625770736`*^9, 3.821138434965591*^9}, {
   3.8211391968813686`*^9, 3.8211392657387943`*^9}, {3.8211393227801085`*^9, 
   3.8211393248269296`*^9}, {3.8231412829889646`*^9, 
   3.8231413534418135`*^9}, {3.823141502823724*^9, 3.823141590018277*^9}, {
   3.8236550912938766`*^9, 3.823655091765791*^9}, {3.823655203401829*^9, 
   3.823655207905835*^9}, 3.8236552809376774`*^9, {3.8236554318533964`*^9, 
   3.823655451762082*^9}, {3.8236555524262657`*^9, 3.8236555539227486`*^9}, 
   3.8236559408177524`*^9, {3.8236560073907485`*^9, 3.823656012705702*^9}, {
   3.823656049761657*^9, 3.823656075118746*^9}, {3.8236561252655396`*^9, 
   3.8236561297886395`*^9}, {3.8236561840697174`*^9, 3.823656356883749*^9}, {
   3.8236563931635723`*^9, 3.8236564049636545`*^9}, {3.8236564635160527`*^9, 
   3.8236565479856715`*^9}, {3.823656618451815*^9, 3.8236566465918303`*^9}, {
   3.823656727027627*^9, 3.823656931711747*^9}, {3.823657222775753*^9, 
   3.823657223811759*^9}, {3.8236572819197936`*^9, 3.823657298687948*^9}, {
   3.8236575651035223`*^9, 3.8236575652587833`*^9}, {3.823658825445919*^9, 
   3.8236588428556743`*^9}, {3.8236588835076056`*^9, 
   3.8236588917699304`*^9}, {3.823658941811777*^9, 3.823659065405012*^9}, 
   3.8236591191973047`*^9, {3.8236591545892467`*^9, 3.823659159429226*^9}, {
   3.8236592347429695`*^9, 3.8236592412367287`*^9}, {3.8236592904521437`*^9, 
   3.823659344315798*^9}, {3.8236596184162054`*^9, 3.823659637556746*^9}, {
   3.8236596691579185`*^9, 3.823659684080753*^9}, {3.8236597325893965`*^9, 
   3.8236597343847976`*^9}, {3.8236601931837378`*^9, 3.8236602194517236`*^9}, 
   3.823660296435614*^9, {3.8236604298554325`*^9, 3.823660455115836*^9}, {
   3.823660608374081*^9, 3.823660652983501*^9}, {3.823660700146762*^9, 
   3.8236607531821775`*^9}, 3.823661051697723*^9, {3.823661138770689*^9, 
   3.823661138920743*^9}, {3.8236613560267515`*^9, 3.8236613626528077`*^9}, {
   3.823705924277069*^9, 3.823705928881971*^9}, {3.8237059701539326`*^9, 
   3.823706072345337*^9}, {3.823706152409139*^9, 3.8237062134294844`*^9}, {
   3.8237062665279016`*^9, 3.8237062974604316`*^9}, {3.8237068479088516`*^9, 
   3.823706890818034*^9}, {3.8237069216601305`*^9, 3.82370692860581*^9}, 
   3.823707190748353*^9, {3.82370725094484*^9, 3.823707262591812*^9}, {
   3.823707340191991*^9, 3.823707356751421*^9}, {3.8237076381476016`*^9, 
   3.823707646086524*^9}, {3.823707746283389*^9, 3.8237077796832247`*^9}, {
   3.823708048187185*^9, 3.823708103419061*^9}, {3.823728382426073*^9, 
   3.823728399682021*^9}, {3.8237284598020363`*^9, 3.823728516326993*^9}, {
   3.8237285611391726`*^9, 3.8237285643821106`*^9}, {3.8237286081178455`*^9, 
   3.8237286379563403`*^9}, {3.8237286846662283`*^9, 
   3.8237286862857733`*^9}, {3.8237289626060767`*^9, 
   3.8237290048500767`*^9}, {3.823729116237099*^9, 3.823729191229148*^9}, {
   3.8237292308770666`*^9, 3.8237294147446876`*^9}, {3.8237294584626665`*^9, 
   3.8237295104445972`*^9}, {3.8237299129994955`*^9, 3.8237299581529636`*^9}, 
   3.8237300554370832`*^9, {3.823730285632378*^9, 3.823730363900202*^9}, {
   3.8237304091279984`*^9, 3.8237304392041626`*^9}, {3.8237304945595117`*^9, 
   3.8237305354160633`*^9}, {3.823730694278023*^9, 3.8237307226990404`*^9}, 
   3.8237308523750677`*^9, {3.8237309023386126`*^9, 3.8237309042346444`*^9}, {
   3.823731779067478*^9, 3.823731825586029*^9}, 3.8237324204650035`*^9, {
   3.82373245925289*^9, 3.8237325063963423`*^9}, {3.8237325966490307`*^9, 
   3.823732605524499*^9}, 3.823732692761057*^9, {3.823732769929077*^9, 
   3.8237328899984727`*^9}, 3.8237329288240776`*^9, 3.823732965168416*^9, {
   3.8237333039320307`*^9, 3.823733408592134*^9}, 3.823733600180997*^9, {
   3.823736663198963*^9, 3.823736702405344*^9}, {3.8237369666456614`*^9, 
   3.823737052398509*^9}, 3.8237370829936914`*^9, {3.823737157058519*^9, 
   3.8237371725509596`*^9}, {3.823737217601596*^9, 3.823737226818432*^9}, {
   3.8237373837812986`*^9, 3.823737389407007*^9}, {3.8237374207851253`*^9, 
   3.823737452405983*^9}, {3.8237380196997395`*^9, 3.8237380245366936`*^9}, {
   3.823738117246798*^9, 3.8237382259370117`*^9}, {3.823738320755745*^9, 
   3.8237383358970237`*^9}, {3.8237383685322657`*^9, 
   3.8237384019185057`*^9}, {3.823738469144698*^9, 3.8237384722511835`*^9}, {
   3.82373852346023*^9, 3.8237385298203306`*^9}, {3.823738565503487*^9, 
   3.8237386734922*^9}, {3.82373879248609*^9, 3.823738856689348*^9}, {
   3.8237389790900536`*^9, 3.8237389817730284`*^9}, {3.8237391022189736`*^9, 
   3.823739174282079*^9}, {3.8237392090371246`*^9, 3.8237392764709306`*^9}, {
   3.823739345903858*^9, 3.823739357080057*^9}, {3.823739387679063*^9, 
   3.8237394053347883`*^9}, {3.8237394948284035`*^9, 
   3.8237395186320996`*^9}, {3.823739565088069*^9, 3.8237396551919794`*^9}, {
   3.823740018991229*^9, 3.8237400961036205`*^9}, {3.8237401565379987`*^9, 
   3.8237401583227644`*^9}, {3.8237406700578303`*^9, 
   3.8237406873889093`*^9}, {3.823740729465277*^9, 3.8237407580952125`*^9}, {
   3.823743202639067*^9, 3.823743265482156*^9}, {3.823743309386753*^9, 
   3.823743338638073*^9}, {3.823743451001852*^9, 3.8237434801695995`*^9}, {
   3.8237435370078297`*^9, 3.823743554581031*^9}, 3.823743636833749*^9, {
   3.8237438303167863`*^9, 3.8237438758120584`*^9}, {3.823743919387436*^9, 
   3.823744012998006*^9}, {3.823744051708722*^9, 3.8237442543125477`*^9}, {
   3.8237445368510323`*^9, 3.8237445558440323`*^9}, {3.823744639735987*^9, 
   3.823744684511101*^9}, {3.82374475010604*^9, 3.823744936594909*^9}, {
   3.8237452088641305`*^9, 3.823745239430967*^9}, {3.8237460347111006`*^9, 
   3.82374617805915*^9}, {3.823746792911957*^9, 3.8237468516238985`*^9}, {
   3.8237468857440047`*^9, 3.823746958316041*^9}, {3.8237469978285875`*^9, 
   3.8237470042127037`*^9}, {3.823747070596759*^9, 3.823747074388387*^9}, {
   3.8237495748269873`*^9, 3.823749609174774*^9}, {3.82375073357521*^9, 
   3.823750764626575*^9}, {3.8237975210314207`*^9, 3.8237975383534193`*^9}, {
   3.8237977209756107`*^9, 3.8237977264053907`*^9}, {3.823806101634373*^9, 
   3.823806121822695*^9}, {3.8238192686382732`*^9, 3.823819279622287*^9}, {
   3.823819456391144*^9, 3.8238194752757015`*^9}, {3.8238197938119698`*^9, 
   3.823819842664462*^9}, {3.82381996737532*^9, 3.8238199801275992`*^9}, {
   3.8238200107883034`*^9, 3.8238200502193074`*^9}, {3.8238203314817343`*^9, 
   3.8238203449004345`*^9}, {3.823820398268285*^9, 3.823820417787322*^9}, {
   3.823820462590725*^9, 3.823820474539569*^9}, {3.8238205296225133`*^9, 
   3.8238205823231497`*^9}, {3.8238208428763075`*^9, 
   3.8238209144581904`*^9}, {3.82382094576075*^9, 3.823820954298182*^9}, {
   3.8238213092518225`*^9, 3.8238213662822804`*^9}, {3.823821437938188*^9, 
   3.823821478904256*^9}, {3.823821509554306*^9, 3.8238215237621946`*^9}, {
   3.8238217374562645`*^9, 3.823821775065325*^9}, {3.8238221227689457`*^9, 
   3.8238221468352494`*^9}, {3.823822181376028*^9, 3.8238222544972897`*^9}, {
   3.8238222972372246`*^9, 3.8238223378561316`*^9}, {3.8238223830483766`*^9, 
   3.8238224160132856`*^9}, {3.8238225866892824`*^9, 
   3.8238225999920163`*^9}, {3.823822642672739*^9, 3.823822658304906*^9}, {
   3.8238227192242556`*^9, 3.8238227688817725`*^9}, {3.823822810648243*^9, 
   3.823822852808134*^9}, {3.8238230424202857`*^9, 3.8238231296388717`*^9}, {
   3.8238232293512616`*^9, 3.823823251352811*^9}, {3.823824031102771*^9, 
   3.8238240502979484`*^9}, {3.8238245509533257`*^9, 
   3.8238246404222946`*^9}, {3.823824679840721*^9, 3.823824690557724*^9}, {
   3.8238247698572607`*^9, 3.8238247779256954`*^9}, {3.823824809886386*^9, 
   3.823824838381317*^9}, 3.8238249927152467`*^9, {3.8238250246933217`*^9, 
   3.8238250720392838`*^9}, {3.823825133777273*^9, 3.8238251785642242`*^9}, {
   3.8238252550770435`*^9, 3.8238253349729357`*^9}, {3.8239697236828747`*^9, 
   3.8239697251760592`*^9}, {3.823969782413111*^9, 3.823969824113186*^9}, {
   3.8239698688481555`*^9, 3.823969872125151*^9}, {3.823969945019972*^9, 
   3.823969967152932*^9}, 3.824007366286104*^9, {3.8241444651258554`*^9, 
   3.824144467142995*^9}, {3.8241445687269354`*^9, 3.8241445905858517`*^9}, {
   3.824144949093319*^9, 3.8241450011408052`*^9}, {3.824145120484915*^9, 
   3.824145149371142*^9}, {3.824176079878627*^9, 3.824176087228521*^9}, 
   3.8241761267707405`*^9, 3.82417616415281*^9, {3.8241762047395916`*^9, 
   3.82417622932755*^9}, {3.8241763713657064`*^9, 3.824176408102358*^9}, {
   3.8241766775568523`*^9, 3.8241766777147956`*^9}, 3.824692474279517*^9, {
   3.8248554940921984`*^9, 3.8248555393983564`*^9}, {3.824855790150652*^9, 
   3.8248557918062744`*^9}, {3.8248559944839196`*^9, 
   3.8248560681837373`*^9}, {3.8248581381878815`*^9, 
   3.8248582733915033`*^9}, {3.8248583098293166`*^9, 
   3.8248583634083753`*^9}, {3.8248589634108086`*^9, 3.824859022205922*^9}, {
   3.8248590957118087`*^9, 3.8248591812566757`*^9}, {3.82485922744764*^9, 
   3.8248594110889826`*^9}, {3.824859458837884*^9, 3.824859515438059*^9}, {
   3.824859549829937*^9, 3.8248596196937847`*^9}, {3.8248596535819206`*^9, 
   3.824859861657907*^9}, {3.824859897986916*^9, 3.8248598991059237`*^9}, {
   3.8248606068840094`*^9, 3.8248606486899695`*^9}, {3.8248607633499727`*^9, 
   3.8248608303329473`*^9}, {3.8248610121139803`*^9, 
   3.8248611153620644`*^9}, {3.82486116007648*^9, 3.8248612499544053`*^9}, {
   3.8248615874843783`*^9, 3.824861588698498*^9}, {3.824863498104088*^9, 
   3.8248635099992046`*^9}, {3.824863540811947*^9, 3.824863842692172*^9}, {
   3.8248641849726477`*^9, 3.824864241820711*^9}, {3.824864393684721*^9, 
   3.824864451135827*^9}, {3.824864527524806*^9, 3.824864643672598*^9}, {
   3.8248651872538767`*^9, 3.8248652295969086`*^9}, {3.8248653512179537`*^9, 
   3.8248653688538847`*^9}, {3.824865400436881*^9, 3.82486544599679*^9}, {
   3.824865556516977*^9, 3.8248655895979476`*^9}, {3.8248656624809184`*^9, 
   3.8248657301649356`*^9}, {3.824865775472945*^9, 3.8248658456930285`*^9}, {
   3.8248658997849164`*^9, 3.8248659699731464`*^9}, {3.824866045977904*^9, 
   3.8248661011259117`*^9}, {3.824866138870102*^9, 3.8248661602539935`*^9}, {
   3.824866381797201*^9, 3.8248663854131937`*^9}, {3.8248664830507493`*^9, 
   3.824866485312036*^9}, {3.8248665217342715`*^9, 3.824866706398279*^9}, {
   3.824866740962959*^9, 3.8248667829710083`*^9}, {3.824866822720973*^9, 
   3.824866881402107*^9}, {3.824866928326332*^9, 3.8248669405423574`*^9}, {
   3.8248670374785595`*^9, 3.824867052438156*^9}, 3.8248672305928755`*^9, {
   3.8248672681503887`*^9, 3.8248673164026723`*^9}, {3.8248673902943897`*^9, 
   3.8248674653471622`*^9}, {3.824867512481283*^9, 3.824867567107338*^9}, {
   3.824867597582734*^9, 3.824867597657949*^9}, {3.8248703785678463`*^9, 
   3.8248703849688787`*^9}, {3.8248704178606644`*^9, 
   3.8248704243188753`*^9}, {3.824870512414856*^9, 3.8248705134156895`*^9}, {
   3.8248705445478535`*^9, 3.8248705704709697`*^9}, 3.824870767074888*^9, {
   3.824870845810909*^9, 3.8248708491358414`*^9}, {3.8248708905038247`*^9, 
   3.824870918263834*^9}, {3.8248709504798117`*^9, 3.8248709511518693`*^9}, {
   3.82487098675991*^9, 3.824871008351866*^9}, {3.824871043495852*^9, 
   3.8248711884199567`*^9}, 3.824871219299938*^9, {3.824871269875946*^9, 
   3.8248712724559493`*^9}, 3.8248713077219086`*^9, {3.8248714178207035`*^9, 
   3.824871431207952*^9}, {3.8248715050759525`*^9, 3.8248715086679497`*^9}, 
   3.8248715914469337`*^9, 3.824871630113031*^9, 3.824918736116824*^9, {
   3.824918831876279*^9, 3.8249188592878246`*^9}, {3.8249188949241276`*^9, 
   3.824918916395336*^9}, {3.8249189589208436`*^9, 3.8249191089441996`*^9}, {
   3.8249191486023817`*^9, 3.824919161299123*^9}, {3.8249192264932456`*^9, 
   3.8249192843492675`*^9}, {3.8249195470833564`*^9, 
   3.8249195753685193`*^9}, {3.8249196824495945`*^9, 
   3.8249197059685616`*^9}, {3.8249198737606325`*^9, 3.824919894381673*^9}, {
   3.82491995693666*^9, 3.8249199983767214`*^9}, {3.8249200607305593`*^9, 
   3.824920080512822*^9}, {3.8249201152808523`*^9, 3.82492018045674*^9}, 
   3.8249260591478357`*^9, {3.824926102112735*^9, 3.8249261182916527`*^9}, {
   3.824926155227851*^9, 3.824926165227862*^9}, 3.824927264763813*^9, 
   3.8249284940372095`*^9, {3.8249286647931633`*^9, 3.8249286919328136`*^9}, {
   3.824930675494668*^9, 3.8249307904993544`*^9}, {3.824930825113406*^9, 
   3.824930826549461*^9}, 3.8249308724294558`*^9, {3.8249311749866467`*^9, 
   3.8249312134795732`*^9}, {3.824931266802411*^9, 3.824931329131488*^9}, {
   3.8249315629485345`*^9, 3.8249315646205845`*^9}, {3.8249317170010915`*^9, 
   3.824931734714775*^9}, {3.8249317715096874`*^9, 3.8249318008986015`*^9}, 
   3.824931958855652*^9, {3.824932070765748*^9, 3.824932092118788*^9}, {
   3.8249321667914214`*^9, 3.8249321768227706`*^9}, 3.8249322966454697`*^9, 
   3.8249323590480747`*^9, {3.824932476319854*^9, 3.8249324994627223`*^9}, {
   3.824932532575835*^9, 3.8249325408677945`*^9}, {3.824935135051778*^9, 
   3.824935195729768*^9}, {3.8249378066977844`*^9, 3.824937856937821*^9}, {
   3.8249378935857415`*^9, 3.8249379276087565`*^9}, {3.8249380201017585`*^9, 
   3.8249380344772897`*^9}, 3.824938225310755*^9, {3.824938429070714*^9, 
   3.8249384624460135`*^9}, {3.8249385544947643`*^9, 3.824938561276759*^9}, {
   3.824938612718734*^9, 3.8249386177907257`*^9}, {3.82493872285442*^9, 
   3.8249387991537867`*^9}, 3.824938957250723*^9, {3.824939087185829*^9, 
   3.824939091467716*^9}, {3.824939155783268*^9, 3.824939194602249*^9}, 
   3.8249393718344297`*^9, {3.824944854531822*^9, 3.8249448593663836`*^9}, {
   3.8249449072807407`*^9, 3.824944990081777*^9}, {3.8249451975316906`*^9, 
   3.8249452043515267`*^9}, {3.8249452413861904`*^9, 
   3.8249452424955993`*^9}, {3.824945306196274*^9, 3.8249453079197855`*^9}, 
   3.824945453525382*^9, {3.824947930933343*^9, 3.8249479428888316`*^9}, {
   3.8249479860455694`*^9, 3.824948010149576*^9}, 3.824948048784681*^9, {
   3.8249481486977634`*^9, 3.8249481825106754`*^9}, {3.824948240929731*^9, 
   3.824948268838681*^9}, {3.824948344021683*^9, 3.8249484079378004`*^9}, 
   3.8249484613737183`*^9, 3.8249485092866507`*^9, {3.8249488132516556`*^9, 
   3.8249488200727797`*^9}, 3.824949117622732*^9, {3.824949182597331*^9, 
   3.8249491866672087`*^9}, {3.8249492375433607`*^9, 
   3.8249492387426367`*^9}, {3.8249496260388103`*^9, 3.824949648890667*^9}, {
   3.824949697275775*^9, 3.8249497119435606`*^9}, {3.824949771574411*^9, 
   3.82494990415077*^9}, {3.824949935625725*^9, 3.824949944963252*^9}, {
   3.8249500214681807`*^9, 3.824950061742335*^9}, {3.824950106632338*^9, 
   3.8249501149517174`*^9}, 3.824950334224843*^9, {3.8249504922811413`*^9, 
   3.824950501754794*^9}, {3.824950535055521*^9, 3.8249505369168267`*^9}, {
   3.824950643155122*^9, 3.8249506518243294`*^9}, {3.8249508901108513`*^9, 
   3.824950896408331*^9}, {3.8249509611248026`*^9, 3.8249509779465027`*^9}, {
   3.824951131644086*^9, 3.824951145059025*^9}, {3.825029685214327*^9, 
   3.8250297111862707`*^9}, {3.8250304689683504`*^9, 3.825030535836391*^9}, {
   3.8250307888440385`*^9, 3.825030852232153*^9}, {3.825030990528429*^9, 
   3.825031055685049*^9}, {3.82503110460461*^9, 3.825031107929455*^9}, {
   3.8250311791713877`*^9, 3.8250313618611555`*^9}, {3.825032817357188*^9, 
   3.825032858876341*^9}, {3.825032899588101*^9, 3.8250329319964485`*^9}, {
   3.8250329900727024`*^9, 3.82503299336228*^9}, {3.825033113511448*^9, 
   3.8250331161483316`*^9}, {3.8250331877052994`*^9, 
   3.8250331933091574`*^9}, {3.8250334294520283`*^9, 
   3.8250334684190006`*^9}, {3.825033563317192*^9, 3.825033566863104*^9}, {
   3.825033916638444*^9, 3.825033931753398*^9}, {3.8250343527314386`*^9, 
   3.8250343653483415`*^9}, 3.82503450811926*^9, 3.8250350628093615`*^9, {
   3.825035101794323*^9, 3.825035106529402*^9}, {3.825035141410263*^9, 
   3.825035311579383*^9}, {3.825035353570861*^9, 3.825035375844096*^9}, {
   3.8250356321401105`*^9, 3.825035668483427*^9}, {3.8251074106564817`*^9, 
   3.8251074282853556`*^9}, 3.8251074622734427`*^9, {3.825107509436661*^9, 
   3.8251075099010024`*^9}, {3.8251075419690013`*^9, 3.825107559492883*^9}, {
   3.825107657700059*^9, 3.825107720572483*^9}, {3.8251077756872463`*^9, 
   3.8251077768520956`*^9}, {3.825112241393627*^9, 3.8251123130547857`*^9}, {
   3.82511237352559*^9, 3.8251124818865924`*^9}, {3.8251125219305964`*^9, 
   3.8251125524465885`*^9}, {3.825112609633627*^9, 3.8251126544900713`*^9}, {
   3.825112693829616*^9, 3.8251127267656126`*^9}, 3.825112898187585*^9, {
   3.8251130688775897`*^9, 3.8251131639828053`*^9}, {3.8251132115325966`*^9, 
   3.825113219963628*^9}, {3.825113254518587*^9, 3.8251133003107843`*^9}, {
   3.8251133362718973`*^9, 3.8251133391907682`*^9}, {3.825113738487503*^9, 
   3.8251137867986116`*^9}, {3.8251138248948717`*^9, 
   3.8251138878835287`*^9}, {3.8251139359329896`*^9, 3.825113990267004*^9}, {
   3.8251140303157167`*^9, 3.8251142110438023`*^9}, {3.8251142487426205`*^9, 
   3.8251143913676434`*^9}, {3.8251144454038825`*^9, 3.825114527495221*^9}, 
   3.825114686832468*^9, {3.825114720732188*^9, 3.825114748662099*^9}, {
   3.82511480953331*^9, 3.825114814789626*^9}, {3.8251149561849065`*^9, 
   3.82511501414065*^9}, 3.8251150621695185`*^9, {3.825115124414464*^9, 
   3.82511518521279*^9}, {3.82511521562442*^9, 3.8251152664716225`*^9}, {
   3.8251153412464733`*^9, 3.825115394159856*^9}, {3.825115711763401*^9, 
   3.825115739136504*^9}, 3.825115802335621*^9, {3.8251158641134586`*^9, 
   3.8251159642219706`*^9}, {3.8251161676341233`*^9, 3.825116170536463*^9}, {
   3.8251163019175444`*^9, 3.8251163262814693`*^9}, {3.825116416816228*^9, 
   3.8251164200015736`*^9}, {3.8251164606011877`*^9, 3.825116466463657*^9}, {
   3.825116621426254*^9, 3.8251166338331833`*^9}, {3.825116673601297*^9, 
   3.825116758647108*^9}, {3.825116893072377*^9, 3.825116977881137*^9}, {
   3.8251170088084126`*^9, 3.825117133799431*^9}, {3.8251172108434277`*^9, 
   3.825117259057486*^9}, {3.825117329735531*^9, 3.8251173298364267`*^9}, {
   3.8251174136285453`*^9, 3.825117419410365*^9}, {3.825117465021659*^9, 
   3.8251174991910524`*^9}, {3.8251175955855207`*^9, 
   3.8251175979144015`*^9}, {3.8251228928233395`*^9, 3.825122908818619*^9}, {
   3.825122964937612*^9, 3.8251229943785887`*^9}, {3.8251231786693897`*^9, 
   3.825123230807619*^9}, {3.825123273571483*^9, 3.8251232951225624`*^9}, {
   3.8251233815705056`*^9, 3.8251234408196197`*^9}, {3.825123492023644*^9, 
   3.825123499343487*^9}, {3.8251235832195997`*^9, 3.8251235858665876`*^9}, {
   3.8251236162096167`*^9, 3.8251236473245935`*^9}, {3.8251236999996166`*^9, 
   3.8251237320415916`*^9}, {3.8251237780188103`*^9, 3.825123887306597*^9}, {
   3.8251239541568336`*^9, 3.825123961270546*^9}, {3.8251239978396077`*^9, 
   3.8251241017285523`*^9}, {3.8251241469996176`*^9, 3.825124212762742*^9}, {
   3.8251242620015836`*^9, 3.8251242624915843`*^9}, {3.825124331980756*^9, 
   3.8251243364607453`*^9}, {3.8251244736191196`*^9, 3.8251244769488087`*^9}, 
   3.825124708139988*^9, 3.82512490138111*^9, {3.8251250734006433`*^9, 
   3.8251251073565845`*^9}, {3.825125444824342*^9, 3.8251254500020676`*^9}, {
   3.825125528515123*^9, 3.825125533835323*^9}, {3.825125589764288*^9, 
   3.825125595496958*^9}, {3.825125654061408*^9, 3.8251256678387194`*^9}, 
   3.825125787416888*^9, {3.825125934344818*^9, 3.8251259350493145`*^9}, {
   3.8251260319779787`*^9, 3.8251261589522505`*^9}, {3.8251262245214634`*^9, 
   3.8251262493232102`*^9}, 3.8251263284459877`*^9, {3.8251263948974404`*^9, 
   3.8251266061747875`*^9}, {3.8251267456090946`*^9, 
   3.8251267878365297`*^9}, {3.8252014212330217`*^9, 
   3.8252014278843565`*^9}, {3.8252015318608227`*^9, 3.825201534025397*^9}, {
   3.8252015932183094`*^9, 3.825201638519158*^9}, {3.825201745485388*^9, 
   3.8252017509363613`*^9}, {3.8252018263803806`*^9, 3.825201841765905*^9}, {
   3.825201872925373*^9, 3.825201911436224*^9}, {3.825201958482499*^9, 
   3.8252019616854696`*^9}, {3.8252022205776978`*^9, 
   3.8252022556680565`*^9}, {3.825202288733057*^9, 3.8252022956409087`*^9}, {
   3.825202341170432*^9, 3.8252023583550315`*^9}, {3.825202403838107*^9, 
   3.8252024339778805`*^9}, {3.8252026663779774`*^9, 
   3.8252026903126917`*^9}, {3.8252031529973845`*^9, 
   3.8252031603302813`*^9}, {3.8252032175586357`*^9, 
   3.8252033196873207`*^9}, {3.8252033874303513`*^9, 3.82520339687774*^9}, {
   3.8252034401422787`*^9, 3.8252034999682617`*^9}, {3.8252035307012806`*^9, 
   3.825203532434366*^9}, {3.8252035856383314`*^9, 3.825203598914426*^9}, 
   3.825203638382357*^9, {3.8252038649384394`*^9, 3.8252038667554264`*^9}, 
   3.8252039504042454`*^9, {3.8252040534373856`*^9, 3.825204076903442*^9}, {
   3.825204276092473*^9, 3.825204333944439*^9}, 3.825204379076498*^9, {
   3.825204450887293*^9, 3.8252044617594037`*^9}, {3.825204497533407*^9, 
   3.8252045092294235`*^9}, {3.8252046011413884`*^9, 
   3.8252046659265347`*^9}, {3.8252047226396627`*^9, 3.825204752544791*^9}, {
   3.8252048384574184`*^9, 3.825204881444479*^9}, {3.8252056454745965`*^9, 
   3.8252057495605917`*^9}, {3.8252058536710606`*^9, 
   3.8252059282911787`*^9}, {3.825206009940809*^9, 3.825206019784396*^9}, {
   3.825206054648757*^9, 3.8252061058152895`*^9}, {3.825206140337419*^9, 
   3.8252062058884563`*^9}, {3.8252062513528733`*^9, 3.825206297839419*^9}, {
   3.825206341288153*^9, 3.825206395296438*^9}, {3.825206509686785*^9, 
   3.825206516498825*^9}, {3.825206586726118*^9, 3.8252066242604475`*^9}, {
   3.8252066600959544`*^9, 3.8252066817439594`*^9}, {3.825206858674218*^9, 
   3.8252068675332985`*^9}, {3.8252084748454037`*^9, 3.825208489729294*^9}, {
   3.825208698448345*^9, 3.8252087441143928`*^9}, 3.825209012203766*^9, {
   3.825209055738775*^9, 3.825209082120344*^9}, {3.8252091179562607`*^9, 
   3.8252091201763067`*^9}, {3.825209193573662*^9, 3.825209211097583*^9}, {
   3.825269837904316*^9, 3.8252698477757287`*^9}, {3.825269889144647*^9, 
   3.825269927736794*^9}, 3.825269957999621*^9, 3.8252700182798376`*^9, {
   3.825270096932644*^9, 3.825270100000124*^9}, {3.8252701438680296`*^9, 
   3.825270143978655*^9}, {3.82527049298145*^9, 3.825270530487769*^9}, {
   3.825270598004809*^9, 3.8252707293515034`*^9}, {3.8252708110772915`*^9, 
   3.82527082024675*^9}, {3.825271057090623*^9, 3.825271089071453*^9}, 
   3.825271227921497*^9, {3.825271280457679*^9, 3.825271294777677*^9}, {
   3.825271408704564*^9, 3.825271431142701*^9}, {3.825274622036351*^9, 
   3.825274624216405*^9}, {3.825274668609521*^9, 3.825274719785666*^9}, 
   3.8252747776654224`*^9, {3.8252748250619373`*^9, 3.825274842858553*^9}, {
   3.825275099354559*^9, 3.8252751837335386`*^9}, {3.8252755556110506`*^9, 
   3.825275559810046*^9}, {3.8252827955455046`*^9, 3.8252829192166505`*^9}, {
   3.8252829633365183`*^9, 3.825282992781548*^9}, {3.8252830994145517`*^9, 
   3.8252831105825834`*^9}, {3.825283156238617*^9, 3.8252831829136906`*^9}, 
   3.8252850404151754`*^9, {3.825286773512032*^9, 3.8252868004068947`*^9}, {
   3.8252869041589646`*^9, 3.8252870208551617`*^9}, {3.8252873622357492`*^9, 
   3.825287427671309*^9}, 3.825287466164644*^9, {3.8252874969913425`*^9, 
   3.825287568939683*^9}, {3.825287689387618*^9, 3.825287764342353*^9}, {
   3.825287799511036*^9, 3.8252878456042857`*^9}, {3.8252878757434416`*^9, 
   3.8252878799684577`*^9}, {3.825287920121481*^9, 3.8252879505114746`*^9}, {
   3.8252880475956464`*^9, 3.8252881567673907`*^9}, {3.825288194699346*^9, 
   3.825288225983613*^9}, {3.8252884598715005`*^9, 3.825288488613561*^9}, {
   3.8252886610655613`*^9, 3.8252886677607336`*^9}, 3.8252887333778253`*^9, {
   3.8252890331985273`*^9, 3.8252890345164127`*^9}, {3.8252891262177644`*^9, 
   3.8252891317516923`*^9}, 3.8477446057094526`*^9, {3.847931982414719*^9, 
   3.8479319847264605`*^9}, {3.847932633591057*^9, 3.8479326594302764`*^9}, {
   3.8479326962304373`*^9, 3.847932770399935*^9}, {3.847932828826699*^9, 
   3.8479328583445177`*^9}, {3.8479328917727027`*^9, 
   3.8479329001381135`*^9}, {3.847933078338348*^9, 3.847933082715928*^9}, {
   3.847933175306342*^9, 3.847933177565844*^9}, 3.8479332813522415`*^9, {
   3.847933330700545*^9, 3.847933342463937*^9}, {3.8479333830177836`*^9, 
   3.84793340190598*^9}, {3.8479334364174695`*^9, 3.8479335151381907`*^9}, 
   3.847933545883972*^9, {3.8479335789304576`*^9, 3.8479335842977095`*^9}, 
   3.847933627944661*^9, {3.8479337242678623`*^9, 3.8479337299934454`*^9}, {
   3.8479338121603823`*^9, 3.8479338652464576`*^9}, 3.8479339275638103`*^9, 
   3.8479339632985964`*^9, {3.847933998166684*^9, 3.8479340246443806`*^9}, {
   3.847984930200548*^9, 3.8479850227858725`*^9}, {3.8479851956709943`*^9, 
   3.8479852004962254`*^9}, 3.847986930940091*^9, {3.847987559329653*^9, 
   3.8479875856112337`*^9}, {3.847987635228112*^9, 3.847987714377577*^9}, {
   3.8479877457029667`*^9, 3.8479878376583514`*^9}, 3.847992583304481*^9, {
   3.847992665525615*^9, 3.847992673896764*^9}, {3.847992708256222*^9, 
   3.847992751360216*^9}, {3.8479927829077954`*^9, 3.847992787503013*^9}, {
   3.847992854321946*^9, 3.8479929070074825`*^9}, {3.847993651910375*^9, 
   3.84799376169369*^9}, {3.847993809645507*^9, 3.8479938128671017`*^9}, {
   3.8479938476163073`*^9, 3.847993867832755*^9}, {3.847993902479431*^9, 
   3.8479939370419836`*^9}, {3.847993991195037*^9, 3.847994004518298*^9}, {
   3.8479940426396513`*^9, 3.8479940798138914`*^9}, {3.84799437175031*^9, 
   3.847994382987075*^9}, 3.8479944422863846`*^9, 3.8479945696548862`*^9, {
   3.847995486394289*^9, 3.847995509963298*^9}, {3.8479956601946554`*^9, 
   3.8479956723440323`*^9}, {3.8479960419999228`*^9, 3.8479960739826794`*^9}, 
   3.8479961089588137`*^9, {3.847996166664254*^9, 3.847996198506184*^9}, {
   3.847996232291165*^9, 3.8479962876160154`*^9}, {3.847996322786419*^9, 
   3.8479963441488132`*^9}, {3.8479964800999765`*^9, 
   3.8479964869301186`*^9}, {3.847996587434383*^9, 3.8479966859587135`*^9}, {
   3.84799681754235*^9, 3.84799682199829*^9}, 3.847996877874048*^9, {
   3.8479969219629164`*^9, 3.8479969492657127`*^9}, 3.847997152194538*^9, {
   3.847997224034694*^9, 3.8479973104963617`*^9}, 3.8479973771222277`*^9, {
   3.8479974349829245`*^9, 3.847997449269702*^9}, {3.8479974846729565`*^9, 
   3.847997499285398*^9}, 3.847997531246236*^9, {3.8479985319825764`*^9, 
   3.847998536693822*^9}, {3.8479986191458488`*^9, 3.847998644782928*^9}, 
   3.847998706065302*^9, {3.847998758270503*^9, 3.8479987762005157`*^9}, {
   3.847998856079177*^9, 3.847998892360922*^9}, {3.847998966574079*^9, 
   3.847998982583066*^9}, {3.847999200613038*^9, 3.8479993504288816`*^9}, 
   3.8479993872633224`*^9, {3.8479994190550003`*^9, 3.847999440585135*^9}, 
   3.847999482525767*^9, {3.8479995556255426`*^9, 3.8479995782038517`*^9}, {
   3.84800000515221*^9, 3.848000007324628*^9}, {3.848002294015657*^9, 
   3.8480022966391196`*^9}, {3.848020339796462*^9, 3.8480203977533007`*^9}, {
   3.8480819397782865`*^9, 3.848081968673379*^9}, 3.8480821044347887`*^9, {
   3.848082136782061*^9, 3.848082145599272*^9}, {3.848083258953453*^9, 
   3.8480832787947083`*^9}, 3.848083465563081*^9, 3.848083681777334*^9, {
   3.84808373307453*^9, 3.848083774257618*^9}, {3.8480839955987673`*^9, 
   3.8480840122515335`*^9}, {3.848086589588733*^9, 3.848086670589955*^9}, {
   3.848088238389031*^9, 3.8480882571101694`*^9}, {3.848092855035469*^9, 
   3.8480928761022606`*^9}, {3.848093028220156*^9, 3.8480930289179993`*^9}, {
   3.848093073274706*^9, 3.848093121889184*^9}, 3.8480932454618416`*^9, {
   3.848093311137794*^9, 3.8480933258444157`*^9}, {3.848093575074492*^9, 
   3.84809359304156*^9}, {3.848093672641148*^9, 3.84809368338381*^9}, 
   3.8482636559096394`*^9},
 CellLabel->"In[16]:=",ExpressionUUID->"181f1108-5125-456a-80b8-eb9cab241d19"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Outputs", " ", "EdgeDistances", " ", "of", " ", "Least", " ", "Bridges", 
    " ", "Graph", " ", "Clusters"}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Input", ":", " ", 
    RowBox[{"[", "edistances_", "]"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"edistances", " ", "=", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"v1", "\[UndirectedEdge]", "v2"}], ",", "8"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"v1", "\[DirectedEdge]", "v3"}], ",", 
         SqrtBox["2"]}], "}"}], ",", "..."}], "}"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"#1", " ", "=", " ", 
        RowBox[{"directed", " ", 
         RowBox[{"and", "/", "or"}], " ", "undirected", " ", "edges"}]}], ",",
        " ", 
       RowBox[{
        RowBox[{"no", " ", "rules"}], ";", " ", 
        RowBox[{"#2", " ", "=", " ", 
         RowBox[{"non", "-", 
          RowBox[{"complex", " ", "distance"}]}]}]}]}], ")"}]}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Output", ":", " ", "selectedEdgeDistances"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"LeastBridgesClusters", "[", "edistances_", "]"}], ":=", 
     RowBox[{"Block", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
        "fmaxdata", ",", "fvalsdata", ",", "testCount", ",", "\[Delta]opt"}], 
        "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"fmaxdata", ",", "fvalsdata", ",", "testCount"}], "}"}], 
         "=", 
         RowBox[{"ComponentMaximal", "[", "edistances", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Delta]opt", "=", 
         RowBox[{"fmaxdata", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"LeastBridgesEdgeDistances", "[", 
         RowBox[{"edistances", ",", "\[Delta]opt", ",", "False"}], "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.802192433608954*^9, 3.802192433608954*^9}, {
   3.8248608627209926`*^9, 3.8248609251279907`*^9}, {3.8479230012648163`*^9, 
   3.84792300781653*^9}, {3.848192776914865*^9, 3.8481928035074625`*^9}, {
   3.848192858748963*^9, 3.8481928663468385`*^9}, {3.8482618726360407`*^9, 
   3.84826188137094*^9}, {3.8482619142360487`*^9, 3.8482619202188225`*^9}, {
   3.8482619589686484`*^9, 3.8482621067777004`*^9}, 3.8487078022776737`*^9, 
   3.848707850078265*^9, {3.8487079518487444`*^9, 3.84870801565462*^9}, {
   3.8487080564348803`*^9, 3.848708224140271*^9}},
 CellLabel->"In[17]:=",ExpressionUUID->"d9886223-131c-4c4a-ac26-fbe49cf5b762"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Outputs", " ", "classified", " ", "edge", " ", "distances", " ", "of", 
     " ", "Least", " ", "Bridges", " ", "Graph"}], ",", " ", 
    RowBox[{"possibly", " ", "distance", " ", "limited"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Input", ":", " ", 
    RowBox[{"[", 
     RowBox[{"edistances_", ",", "distancelimit_", ",", "verbose_"}], "]"}]}],
    " ", "*)"}], 
  RowBox[{"(*", " ", 
   RowBox[{"edistances", " ", "=", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"v1", "\[UndirectedEdge]", "v2"}], ",", "8"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"v1", "\[DirectedEdge]", "v3"}], ",", 
         SqrtBox["2"]}], "}"}], ",", "..."}], "}"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"#1", " ", "=", " ", 
        RowBox[{"directed", " ", 
         RowBox[{"and", "/", "or"}], " ", "undirected", " ", "edges"}]}], ",",
        " ", 
       RowBox[{
        RowBox[{"no", " ", "rules"}], ";", " ", 
        RowBox[{"#2", " ", "=", " ", 
         RowBox[{"non", "-", 
          RowBox[{"complex", " ", "distance"}]}]}]}]}], ")"}]}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"distancelimit", " ", "=", " ", 
    RowBox[{"L", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"L", " ", "\[LessEqual]", " ", "0"}], " ", "\[RightArrow]", 
        " ", 
        RowBox[{"no", " ", "graph", " ", "computed"}]}], ",", " ", 
       RowBox[{
        RowBox[{"L", " ", "<", " ", "\[Infinity]"}], " ", "\[RightArrow]", 
        " ", 
        RowBox[{
        "LBG", " ", "computation", " ", "halts", " ", "at", " ", "L", " ", 
         "if", " ", "reached"}]}], ",", " ", 
       RowBox[{"\[Infinity]", " ", "\[RightArrow]", " ", 
        RowBox[{"no", " ", "distance", " ", "limit"}]}], ",", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"NumberQ", "[", "L", "]"}], "\[Equal]", "False"}], " ", 
        "\[RightArrow]", " ", "ignored"}]}], ")"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{" ", 
    RowBox[{"verbose", " ", "=", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"True", " ", "|", " ", "False"}], ")"}], " ", "progress", " ", 
      RowBox[{"messages", ".", " ", "default"}], " ", "is", " ", "False"}]}], 
    ")"}], " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Output", ":", " ", 
    RowBox[{"{", 
     RowBox[{"componentCoreEdges", ",", "nnBridges", ",", "leastBridges"}], 
     "}"}]}], " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"LeastBridgesClassifiedEdges", "[", 
      RowBox[{"edistances_", ",", "distancelimit_", ",", "verbose_"}], "]"}], 
     ":=", 
     RowBox[{"Block", "[", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"local", " ", "variables"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
        "edgeCount", ",", "\[IndentingNewLine]", "absoluteMinMax", ",", 
         "\[IndentingNewLine]", "distancePairsGathered", ",", 
         "\[IndentingNewLine]", "uniqueEdgeDistances", ",", 
         "uniqueEdgeDistancesCount", ",", "\[IndentingNewLine]", 
         "nnUniqueEdgeDistances", ",", "nnEdges", ",", "nnUniqueEdges", ",", 
         "nnUniqueDirectedEdgeCount", ",", "nnUniqueUndirectedEdgeCount", ",",
          "nnEdgeQ", ",", "\[IndentingNewLine]", "pairToEdgeHash", ",", 
         "pairToDistanceHash", ",", "\[IndentingNewLine]", "vertices", ",", 
         "verticesCount", ",", "\[IndentingNewLine]", "distancelimitNaN", ",",
          "distancelimitStr", ",", "requestedlimit", ",", "assignedlimit", 
         ",", "t", ",", "triallimit", ",", "\[IndentingNewLine]", 
         "showprogress", ",", "\[IndentingNewLine]", "trial", ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "componentCoreEdges", 
         ",", "nnBridges", ",", "leastBridges", ",", "\[IndentingNewLine]", 
         "componentCoreEdgesCount", ",", "nnBridgesCount", ",", 
         "leastBridgesCount", ",", "\[IndentingNewLine]", 
         "acceptedEdgeDistances", ",", "\[IndentingNewLine]", "newComponentQ",
          ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         "acceptedEdgesCount", ",", "priorAcceptedEdgesCount", ",", 
         "\[IndentingNewLine]", "graphEdgesVertices", ",", 
         "graphEdgesVerticesCount", ",", "\[IndentingNewLine]", 
         "graphComponents", ",", "graphComponentsCount", ",", 
         "graphComponentsVertices", ",", "\[IndentingNewLine]", 
         "vertexComponentHash", ",", "threadedComponents", ",", 
         "\[IndentingNewLine]", "graphPairsDegenerateSet", ",", 
         "\[IndentingNewLine]", "trialSelections", ",", "trialPairs", ",", 
         "trialPairsCount", ",", "trialPairsDistance", ",", 
         "\[IndentingNewLine]", "thisPair", ",", "notDegenerate", ",", 
         "v1component", ",", "v2component", ",", "notSelfLoop", ",", 
         "\[IndentingNewLine]", "thisEdge", ",", "thisEdgeHeadStr", ",", 
         "undirectedEdgeStr", ",", "directedEdgeStr", ",", 
         "\[IndentingNewLine]", "trialEdgesCount", ",", "verticesComplements",
          ",", "verticesComplementsCount", ",", "\[IndentingNewLine]", 
         "pseudoComponents", ",", "pseudoComponentsCount"}], 
        "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"process", " ", "input"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"edgeCount", "=", 
         RowBox[{"Length", "[", "edistances", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"absoluteMinMax", "=", 
         RowBox[{"MinMax", "[", 
          RowBox[{"edistances", "[", 
           RowBox[{"[", 
            RowBox[{";;", ",", "2"}], "]"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"distancePairsGathered", "=", 
         RowBox[{"(", 
          RowBox[{"GatherBy", "[", 
           RowBox[{
            RowBox[{"Sort", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"#", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
                   RowBox[{"#", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "2"}], "]"}], "]"}]}], "}"}]}], "}"}], 
               "&"}], "/@", "edistances"}], "]"}], ",", "First"}], "]"}], 
          ")"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"uniqueEdgeDistances", "=", 
         RowBox[{"distancePairsGathered", "[", 
          RowBox[{"[", 
           RowBox[{";;", ",", "1", ",", "1"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"uniqueEdgeDistancesCount", "=", 
         RowBox[{"Length", "[", "distancePairsGathered", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"pairToEdgeHash", "=", 
         RowBox[{"CreateDataStructure", "[", "\"\<HashTable\>\"", "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"pairToEdgeHash", "[", 
           RowBox[{"\"\<Insert\>\"", ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"#", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"#", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "2"}], "]"}], "]"}]}], "}"}], "\[Rule]", 
             RowBox[{"#", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}]}], "]"}], "&"}], "/@", 
         "edistances"}], ";", "\[IndentingNewLine]", 
        RowBox[{"pairToDistanceHash", "=", 
         RowBox[{"CreateDataStructure", "[", "\"\<HashTable\>\"", "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"pairToDistanceHash", "[", 
           RowBox[{"\"\<Insert\>\"", ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"#", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"#", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "2"}], "]"}], "]"}]}], "}"}], "\[Rule]", 
             RowBox[{"#", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], "&"}], "/@", 
         "edistances"}], ";", "\[IndentingNewLine]", 
        RowBox[{"vertices", "=", 
         RowBox[{"Sort", "[", 
          RowBox[{"DeleteDuplicates", "[", 
           RowBox[{"Flatten", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"List", "@@", "#"}], ")"}], "&"}], "/@", 
             RowBox[{"edistances", "[", 
              RowBox[{"[", 
               RowBox[{";;", ",", "1"}], "]"}], "]"}]}], "]"}], "]"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"verticesCount", "=", 
         RowBox[{"Length", "[", "vertices", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"distancelimitNaN", "=", 
         RowBox[{"!", 
          RowBox[{"NumberQ", "[", "distancelimit", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", "distancelimitNaN", ")"}], "&&", 
            RowBox[{"(", 
             RowBox[{"distancelimit", "\[NotEqual]", "\[Infinity]"}], ")"}]}],
            ")"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Do", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"distancelimitStr", "=", 
              RowBox[{"ToString", "[", "distancelimit", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"assignedlimit", ",", "requestedlimit"}], "}"}], "=", 
              RowBox[{"{", 
               RowBox[{"0", ",", "distancelimitStr"}], "}"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "1"}], "]"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"Which", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"distancelimit", "\[Equal]", "\[Infinity]"}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"assignedlimit", ",", "requestedlimit"}], "}"}], "=", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"absoluteMinMax", "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", "distancelimit"}], 
              "}"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"distancelimit", "<", "0"}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"assignedlimit", ",", "requestedlimit"}], "}"}], "=", 
             RowBox[{"{", 
              RowBox[{"0", ",", "distancelimit"}], "}"}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"distancelimit", ">", 
             RowBox[{"absoluteMinMax", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"assignedlimit", ",", "requestedlimit"}], "}"}], "=", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"absoluteMinMax", "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", "distancelimit"}], 
              "}"}]}], ",", "\[IndentingNewLine]", "True", ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"assignedlimit", ",", "requestedlimit"}], "}"}], "=", 
             RowBox[{"{", 
              RowBox[{"distancelimit", ",", "distancelimit"}], "}"}]}]}], 
           "]"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"t", "=", "1"}], ";", "\[IndentingNewLine]", 
        RowBox[{"While", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"assignedlimit", "\[GreaterEqual]", 
              RowBox[{"uniqueEdgeDistances", "[", 
               RowBox[{"[", "t", "]"}], "]"}]}], ")"}], "&&", 
            RowBox[{"(", 
             RowBox[{"t", "<", "uniqueEdgeDistancesCount"}], ")"}]}], ")"}], 
          ",", 
          RowBox[{"t", "++"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"assignedlimit", "\[Equal]", 
           RowBox[{"uniqueEdgeDistances", "[", 
            RowBox[{"[", "t", "]"}], "]"}]}], ",", 
          RowBox[{"triallimit", "=", "t"}], ",", 
          RowBox[{"triallimit", "=", 
           RowBox[{"t", "-", "1"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"showprogress", "=", "False"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"BooleanQ", "[", "verbose", "]"}], ",", 
          RowBox[{"showprogress", "=", "verbose"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"more", " ", "initialization"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"undirectedEdgeStr", "=", 
         RowBox[{"ToString", "[", 
          RowBox[{"Head", "[", 
           RowBox[{"0", "\[UndirectedEdge]", "0"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"directedEdgeStr", "=", 
         RowBox[{"ToString", "[", 
          RowBox[{"Head", "[", 
           RowBox[{"0", "\[DirectedEdge]", "0"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"nnUniqueEdgeDistances", "=", 
         RowBox[{"NearestUniqueEdgeDistances", "[", "edistances", "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"nnUniqueEdges", "=", 
         RowBox[{"nnUniqueEdgeDistances", "[", 
          RowBox[{"[", 
           RowBox[{";;", ",", "1"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"nnUniqueDirectedEdgeCount", "=", 
         RowBox[{"Total", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"ToString", "[", 
                RowBox[{"Head", "[", "#", "]"}], "]"}], "\[Equal]", 
               "directedEdgeStr"}], ",", "1", ",", "0"}], "]"}], "&"}], "/@", 
           "nnUniqueEdges"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"nnUniqueUndirectedEdgeCount", "=", 
         RowBox[{"Total", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"ToString", "[", 
                RowBox[{"Head", "[", "#", "]"}], "]"}], "\[Equal]", 
               "undirectedEdgeStr"}], ",", "1", ",", "0"}], "]"}], "&"}], "/@",
            "nnUniqueEdges"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"nnEdges", "=", 
         RowBox[{"DeleteDuplicates", "[", 
          RowBox[{"Join", "[", 
           RowBox[{"nnUniqueEdges", ",", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"ToString", "[", 
                   RowBox[{"Head", "[", "#", "]"}], "]"}], "\[Equal]", 
                  "undirectedEdgeStr"}], ",", 
                 RowBox[{
                  RowBox[{"#", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "\[UndirectedEdge]", 
                  RowBox[{"#", "[", 
                   RowBox[{"[", "1", "]"}], "]"}]}], ",", "Nothing"}], "]"}], 
               "&"}], "/@", "nnUniqueEdges"}], ")"}]}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"progress", " ", "report"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Print", "[", "\"\<LeastBridgesEdgeDistances:\>\"", "]"}], 
           ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{"\"\<\\t\>\"", ",", "\"\<INITIALIZATION\>\""}], "]"}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<Dimensions[edistances] = \>\"", ",", 
             RowBox[{"Dimensions", "[", "edistances", "]"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<edgeCount = \>\"", ",", "edgeCount"}],
             "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<absoluteMinMax = \>\"", ",", 
             "absoluteMinMax"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<uniqueEdgeDistancesCount = \>\"", ",",
              "uniqueEdgeDistancesCount"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<verticesCount = \>\"", ",", 
             "verticesCount"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<nnUniqueDirectedEdgeCount = \>\"", 
             ",", "nnUniqueDirectedEdgeCount"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<nnUniqueUndirectedEdgeCount = \>\"", 
             ",", "nnUniqueUndirectedEdgeCount"}], "]"}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<distancelimit = \>\"", ",", 
             "distancelimit"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<distancelimitNaN = \>\"", ",", 
             "distancelimitNaN"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<requestedlimit = \>\"", ",", 
             "requestedlimit"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<assignedlimit = \>\"", ",", 
             "assignedlimit"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<triallimit = \>\"", ",", "triallimit",
              ",", "\"\< of \>\"", ",", "uniqueEdgeDistancesCount", ",", 
             "\"\< possible\>\""}], "]"}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<verbose = \>\"", ",", "verbose"}], "]"}],
            ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<showprogress = \>\"", ",", 
             "showprogress"}], "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], 
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"least", " ", "bridges", " ", "graph", " ", "edges"}], " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Print", "[", 
            RowBox[{"\"\<\\t\>\"", ",", "\"\<COMPUTATION\>\""}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", 
             "\"\<computing least bridge graph edges\>\""}], "]"}]}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"trial", "=", "0"}], ";", "\[IndentingNewLine]", 
        RowBox[{"acceptedEdgeDistances", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"componentCoreEdges", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"nnBridges", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"leastBridges", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"componentCoreEdgesCount", "=", 
         RowBox[{"Length", "[", "componentCoreEdges", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"nnBridgesCount", "=", 
         RowBox[{"Length", "[", "nnBridges", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"leastBridgesCount", "=", 
         RowBox[{"Length", "[", "leastBridges", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"acceptedEdgesCount", "=", "0"}], ";", "\[IndentingNewLine]", 
        RowBox[{"graphEdgesVertices", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"graphEdgesVerticesCount", "=", "0"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"graphComponents", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"graphComponentsCount", "=", 
         RowBox[{"Length", "[", "graphComponents", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"graphComponentsVertices", "=", 
         RowBox[{"Sort", "[", 
          RowBox[{"Flatten", "[", "graphComponents", "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "vertexComponentHash", " ", "maps", " ", "vertex", " ", "to", " ", 
          "component", " ", 
          RowBox[{"index", ".", " ", "reset"}], " ", "every", " ", 
          RowBox[{"trial", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"pseudoComponents", "=", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"{", "#", "}"}], "&"}], "/@", "vertices"}], ")"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"pseudoComponentsCount", "=", 
         RowBox[{"Length", "[", "pseudoComponents", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"vertexComponentHash", "=", 
         RowBox[{"CreateDataStructure", "[", "\"\<HashTable\>\"", "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"threadedComponents", "=", 
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"pseudoComponents", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", ",", "j"}], "]"}], "]"}], ",", "i"}], "}"}], 
               ",", 
               RowBox[{"{", 
                RowBox[{"j", ",", "1", ",", 
                 RowBox[{"Length", "[", 
                  RowBox[{"pseudoComponents", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", "pseudoComponentsCount"}], "}"}]}], 
            "]"}], ",", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"vertexComponentHash", "[", 
           RowBox[{"\"\<Insert\>\"", ",", 
            RowBox[{
             RowBox[{"#", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "\[Rule]", 
             RowBox[{"#", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], "&"}], "/@", 
         "threadedComponents"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
          "a", " ", "set", " ", "of", " ", "every", " ", "edge", " ", "in", 
           " ", "the", " ", "graph"}], ",", " ", 
          RowBox[{
          "including", " ", "vertex", " ", "pairs", " ", "of", " ", 
           "directed", " ", "edges", " ", "and", " ", "both", " ", "vertex", 
           " ", "pairs", " ", 
           RowBox[{"(", 
            RowBox[{"forward", " ", "and", " ", "reverse"}], ")"}], " ", "of",
            " ", "undirected", " ", "edges"}]}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"graphPairsDegenerateSet", "=", 
         RowBox[{"CreateDataStructure", "[", "\"\<HashSet\>\"", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<\[Bullet] trial: \>\"", ",", 
             "trial"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\\t\>\"", ",", "\"\<pseudoComponentsCount = \>\"", ",",
              "pseudoComponentsCount"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\\t\>\"", ",", "\"\<graphComponentsCount = \>\"", ",", 
             "graphComponentsCount"}], "]"}], ";"}]}], "\[IndentingNewLine]", 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"While", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"graphComponentsCount", ">", "1"}], ")"}], "||", 
             RowBox[{"(", 
              RowBox[{"graphEdgesVerticesCount", "<", "verticesCount"}], 
              ")"}]}], ")"}], "&&", 
           RowBox[{"(", 
            RowBox[{"trial", "<", "triallimit"}], ")"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Do", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"trial", "++"}], ";", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{"showprogress", ",", 
               RowBox[{"Print", "[", 
                RowBox[{
                "\"\<\\t\\t\>\"", ",", "\"\<\[Bullet] trial: \>\"", ",", 
                 "trial"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"priorAcceptedEdgesCount", "=", "acceptedEdgesCount"}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"trialSelections", "=", 
              RowBox[{"distancePairsGathered", "[", 
               RowBox[{"[", "trial", "]"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"trialPairs", "=", 
              RowBox[{"trialSelections", "[", 
               RowBox[{"[", 
                RowBox[{";;", ",", "2"}], "]"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"trialPairsCount", "=", 
              RowBox[{"Length", "[", "trialPairs", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"trialPairsDistance", "=", 
              RowBox[{"pairToDistanceHash", "[", 
               RowBox[{"\"\<Lookup\>\"", ",", 
                RowBox[{"trialPairs", "[", 
                 RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{"showprogress", ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"Print", "[", 
                 RowBox[{
                 "\"\<\\t\\t\\t\>\"", ",", "\"\<trialPairsCount = \>\"", ",", 
                  "trialPairsCount"}], "]"}], ";", "\[IndentingNewLine]", 
                RowBox[{"Print", "[", 
                 RowBox[{
                 "\"\<\\t\\t\\t\>\"", ",", "\"\<trialPairsDistance = \>\"", 
                  ",", "trialPairsDistance"}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"Print", "[", 
                 RowBox[{
                 "\"\<\\t\\t\\t\>\"", ",", "\"\<trialPairs = \>\"", ",", 
                  "trialPairs"}], "]"}], ";"}]}], "\[IndentingNewLine]", 
              "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"Do", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"thisPair", "=", 
                 RowBox[{"trialPairs", "[", 
                  RowBox[{"[", "p", "]"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"notDegenerate", "=", 
                 RowBox[{"!", 
                  RowBox[{"graphPairsDegenerateSet", "[", 
                   RowBox[{"\"\<MemberQ\>\"", ",", "thisPair"}], "]"}]}]}], 
                ";", "\[IndentingNewLine]", 
                RowBox[{"v1component", "=", 
                 RowBox[{"vertexComponentHash", "[", 
                  RowBox[{"\"\<Lookup\>\"", ",", 
                   RowBox[{"thisPair", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"v2component", "=", 
                 RowBox[{"vertexComponentHash", "[", 
                  RowBox[{"\"\<Lookup\>\"", ",", 
                   RowBox[{"thisPair", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"notSelfLoop", "=", 
                 RowBox[{"v1component", "\[NotEqual]", "v2component"}]}], ";",
                 "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{"showprogress", ",", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"Print", "[", 
                    RowBox[{
                    "\"\<\\t\\t\\t\\t\>\"", ",", "\"\<thisPair = \>\"", ",", 
                    "thisPair"}], "]"}], ";", "\[IndentingNewLine]", 
                   RowBox[{"Print", "[", 
                    RowBox[{
                    "\"\<\\t\\t\\t\\t\\t\>\"", ",", 
                    "\"\<notDegenerate = \>\"", ",", "notDegenerate"}], "]"}],
                    ";", "\[IndentingNewLine]", 
                   RowBox[{"Print", "[", 
                    RowBox[{
                    "\"\<\\t\\t\\t\\t\\t\>\"", ",", "\"\<notSelfLoop = \>\"", 
                    ",", "notSelfLoop"}], "]"}], ";"}]}], 
                 "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", "notDegenerate", ")"}], "&&", 
                   RowBox[{"(", "notSelfLoop", ")"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"Do", "[", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"thisEdge", "=", 
                    RowBox[{"pairToEdgeHash", "[", 
                    RowBox[{"\"\<Lookup\>\"", ",", "thisPair"}], "]"}]}], ";",
                     "\[IndentingNewLine]", 
                    RowBox[{"nnEdgeQ", "=", 
                    RowBox[{"MemberQ", "[", 
                    RowBox[{"nnEdges", ",", "thisEdge"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"newComponentQ", "=", 
                    RowBox[{"!", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{"graphComponentsVertices", ",", 
                    RowBox[{"thisPair", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "\[Or]", 
                    RowBox[{"MemberQ", "[", 
                    RowBox[{"graphComponentsVertices", ",", 
                    RowBox[{"thisPair", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], ")"}]}]}], ";",
                     "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{"showprogress", ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Print", "[", 
                    RowBox[{
                    "\"\<\\t\\t\\t\\t\\t\>\"", ",", "\"\<nnEdgeQ = \>\"", ",",
                     "nnEdgeQ"}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"Print", "[", 
                    RowBox[{
                    "\"\<\\t\\t\\t\\t\\t\>\"", ",", 
                    "\"\<newComponentQ = \>\"", ",", "newComponentQ"}], "]"}],
                     ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{"newComponentQ", ",", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"componentCoreEdges", ",", 
                    RowBox[{"{", 
                    RowBox[{"thisEdge", ",", "trialPairsDistance"}], "}"}]}], 
                    "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"nnEdgeQ", "\[And]", 
                    RowBox[{"(", 
                    RowBox[{"!", "newComponentQ"}], ")"}]}], ",", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"nnBridges", ",", 
                    RowBox[{"{", 
                    RowBox[{"thisEdge", ",", "trialPairsDistance"}], "}"}]}], 
                    "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"!", 
                    RowBox[{"(", 
                    RowBox[{"nnEdgeQ", "\[Or]", "newComponentQ"}], ")"}]}], 
                    ",", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"leastBridges", ",", 
                    RowBox[{"{", 
                    RowBox[{"thisEdge", ",", "trialPairsDistance"}], "}"}]}], 
                    "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
                    "\[IndentingNewLine]", 
                    RowBox[{"thisEdgeHeadStr", "=", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"Head", "[", "thisEdge", "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    "thisEdgeHeadStr", "\[Equal]", "undirectedEdgeStr"}], ",",
                     "\[IndentingNewLine]", 
                    RowBox[{"Do", "[", " ", 
                    RowBox[{"(*", " ", 
                    RowBox[{"unordered", " ", "edge"}], " ", "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"acceptedEdgeDistances", ",", 
                    RowBox[{"{", 
                    RowBox[{"thisEdge", ",", "trialPairsDistance"}], "}"}]}], 
                    "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"graphPairsDegenerateSet", "[", 
                    RowBox[{"\"\<Insert\>\"", ",", "thisPair"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"graphPairsDegenerateSet", "[", 
                    RowBox[{"\"\<Insert\>\"", ",", 
                    RowBox[{"Reverse", "[", "thisPair", "]"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "1"}], 
                    "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    "thisEdgeHeadStr", "\[Equal]", "directedEdgeStr"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Do", "[", " ", 
                    RowBox[{"(*", " ", 
                    RowBox[{"directed", " ", "edge"}], " ", "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"acceptedEdgeDistances", ",", 
                    RowBox[{"{", 
                    RowBox[{"thisEdge", ",", "trialPairsDistance"}], "}"}]}], 
                    "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"graphPairsDegenerateSet", "[", 
                    RowBox[{"\"\<Insert\>\"", ",", "thisPair"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "1"}], 
                    "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "1"}], 
                   "]"}]}], " ", 
                 RowBox[{"(*", " ", 
                  RowBox[{
                  "end", " ", "add", " ", "thisPair", " ", "to", " ", 
                   "graph"}], " ", "*)"}], "\[IndentingNewLine]", "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"p", ",", "1", ",", "trialPairsCount"}], "}"}]}], 
              "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"componentCoreEdgesCount", "=", 
              RowBox[{"Length", "[", "componentCoreEdges", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"nnBridgesCount", "=", 
              RowBox[{"Length", "[", "nnBridges", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"leastBridgesCount", "=", 
              RowBox[{"Length", "[", "leastBridges", "]"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"graphComponents", "=", 
              RowBox[{"ConnectedComponents", "[", 
               RowBox[{"UndirectedGraph", "[", 
                RowBox[{"acceptedEdgeDistances", "[", 
                 RowBox[{"[", 
                  RowBox[{";;", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], ";",
              "\[IndentingNewLine]", 
             RowBox[{"graphComponentsCount", "=", 
              RowBox[{"Length", "[", "graphComponents", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"graphComponentsVertices", "=", 
              RowBox[{"Sort", "[", 
               RowBox[{"Flatten", "[", "graphComponents", "]"}], "]"}]}], ";",
              "\[IndentingNewLine]", 
             RowBox[{"acceptedEdgesCount", "=", 
              RowBox[{"Length", "[", "acceptedEdgeDistances", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"trialEdgesCount", "=", 
              RowBox[{
              "acceptedEdgesCount", "-", "priorAcceptedEdgesCount"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{"showprogress", ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"Print", "[", 
                 RowBox[{
                 "\"\<\\t\\t\\t\>\"", ",", 
                  "\"\<componentCoreEdgesCount = \>\"", ",", 
                  "componentCoreEdgesCount"}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"Print", "[", 
                 RowBox[{
                 "\"\<\\t\\t\\t\>\"", ",", "\"\<nnBridgesCount = \>\"", ",", 
                  "nnBridgesCount"}], "]"}], ";", "\[IndentingNewLine]", 
                RowBox[{"Print", "[", 
                 RowBox[{
                 "\"\<\\t\\t\\t\>\"", ",", "\"\<leastBridgesCount = \>\"", 
                  ",", "leastBridgesCount"}], "]"}], ";"}]}], 
              "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"graphEdgesVertices", "=", 
              RowBox[{"Sort", "[", 
               RowBox[{"DeleteDuplicates", "[", 
                RowBox[{"Flatten", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"List", "@@", "#"}], ")"}], "&"}], "/@", 
                  RowBox[{"acceptedEdgeDistances", "[", 
                   RowBox[{"[", 
                    RowBox[{";;", ",", "1"}], "]"}], "]"}]}], "]"}], "]"}], 
               "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"graphEdgesVerticesCount", "=", 
              RowBox[{"Length", "[", "graphEdgesVertices", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"verticesComplements", "=", 
              RowBox[{"Complement", "[", 
               RowBox[{"vertices", ",", "graphEdgesVertices"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"verticesComplementsCount", "=", 
              RowBox[{"Length", "[", "verticesComplements", "]"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"pseudoComponents", "=", 
              RowBox[{"Join", "[", 
               RowBox[{"graphComponents", ",", 
                RowBox[{
                 RowBox[{
                  RowBox[{"{", "#", "}"}], "&"}], "/@", 
                 "verticesComplements"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"pseudoComponentsCount", "=", 
              RowBox[{"Length", "[", "pseudoComponents", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"vertexComponentHash", "=", 
              RowBox[{
              "CreateDataStructure", "[", "\"\<HashTable\>\"", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"threadedComponents", "=", 
              RowBox[{"Flatten", "[", 
               RowBox[{
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"Table", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"pseudoComponents", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j"}], "]"}], "]"}], ",", "i"}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{"j", ",", "1", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"pseudoComponents", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
                  ",", 
                  RowBox[{"{", 
                   RowBox[{"i", ",", "1", ",", "pseudoComponentsCount"}], 
                   "}"}]}], "]"}], ",", "1"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"vertexComponentHash", "[", 
                RowBox[{"\"\<Insert\>\"", ",", 
                 RowBox[{
                  RowBox[{"#", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "\[Rule]", 
                  RowBox[{"#", "[", 
                   RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], "&"}], "/@", 
              "threadedComponents"}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "1"}], "]"}]}],
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<\\t\\t\>\"", ",", "\"\<completed \>\"", ",", "trial", ",", 
            "\"\< trials.\>\""}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<\\t\\t\>\"", ",", "\"\<acceptedEdgesCount = \>\"", ",", 
            "acceptedEdgesCount"}], "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<\\t\\t\>\"", ",", "\"\<graphEdgesVerticesCount = \>\"", ",", 
            "graphEdgesVerticesCount"}], "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
         "componentCoreEdges", ",", "nnBridges", ",", "leastBridges"}], 
         "}"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.8048894328314266`*^9, 3.8048894997893095`*^9}, 
   3.8048932504914227`*^9, 3.8048932855556264`*^9, 3.8048933200387383`*^9, {
   3.8049787200358596`*^9, 3.804978723801437*^9}, {3.804978767722407*^9, 
   3.8049788118152714`*^9}, {3.8053053803429146`*^9, 
   3.8053053877333555`*^9}, {3.8053054803528347`*^9, 
   3.8053055428980227`*^9}, {3.8053093369091387`*^9, 
   3.8053093403934264`*^9}, {3.8100699591179037`*^9, 
   3.8100700165378733`*^9}, {3.810240248551813*^9, 3.8102402662699814`*^9}, {
   3.810240362712524*^9, 3.8102403698530006`*^9}, 3.8102404642945232`*^9, 
   3.8198464252718763`*^9, {3.819846496426095*^9, 3.8198465080664034`*^9}, {
   3.819846647143484*^9, 3.8198466548463907`*^9}, 3.819848553304391*^9, {
   3.819848594121112*^9, 3.8198486448221283`*^9}, {3.819848853713481*^9, 
   3.8198488575436077`*^9}, {3.819849305886876*^9, 3.8198493126366835`*^9}, {
   3.819849783805763*^9, 3.819849795289811*^9}, {3.8198498751370897`*^9, 
   3.8198498796753483`*^9}, 3.819852410975874*^9, {3.819852720438212*^9, 
   3.819852726688031*^9}, {3.81985871609789*^9, 3.819858723004779*^9}, {
   3.8198588690489035`*^9, 3.8198588808657217`*^9}, {3.819859020980142*^9, 
   3.819859077063222*^9}, {3.8198592298239613`*^9, 3.8198592314959803`*^9}, {
   3.8198598378046885`*^9, 3.819859848586525*^9}, {3.819859966904131*^9, 
   3.819859978467265*^9}, {3.8198601024428253`*^9, 3.819860147710929*^9}, {
   3.81986041497547*^9, 3.8198604260385838`*^9}, {3.8198605213875723`*^9, 
   3.819860528950492*^9}, 3.819860656019965*^9, {3.8198622090297728`*^9, 
   3.8198622151392*^9}, 3.819863567856737*^9, 3.8198636082164145`*^9, {
   3.819934109527196*^9, 3.819934115702182*^9}, 3.819939980798693*^9, {
   3.81994004790958*^9, 3.819940055487485*^9}, 3.8199465340708485`*^9, 
   3.819947052234573*^9, {3.819947237064841*^9, 3.819947248002035*^9}, {
   3.8199482827172318`*^9, 3.819948291930473*^9}, {3.819989034310416*^9, 
   3.8199890499118176`*^9}, 3.819995532946477*^9, {3.8199956762079926`*^9, 
   3.8199956892388983`*^9}, {3.8200889339886756`*^9, 3.820088944941464*^9}, {
   3.82008912313525*^9, 3.820089124775836*^9}, 3.8200907862550397`*^9, {
   3.8200912810865135`*^9, 3.820091286789473*^9}, {3.820115148129422*^9, 
   3.82011515286366*^9}, {3.8201152861410875`*^9, 3.8201153572484207`*^9}, {
   3.820206233484451*^9, 3.820206255112809*^9}, {3.8202071518792677`*^9, 
   3.820207169675432*^9}, 3.8202073478112817`*^9, 3.8202079047303452`*^9, {
   3.820460400220234*^9, 3.8204604028023806`*^9}, 3.820460462612266*^9, 
   3.8204606147399035`*^9, 3.82054410414405*^9, {3.820640395379943*^9, 
   3.8206404505658307`*^9}, {3.820640525708227*^9, 3.8206405563792224`*^9}, {
   3.820683687845157*^9, 3.8206836973221316`*^9}, {3.8206837549879293`*^9, 
   3.82068375542807*^9}, {3.8207849253768363`*^9, 3.820784936298422*^9}, {
   3.8209572599779663`*^9, 3.820957269055828*^9}, {3.8209573053985577`*^9, 
   3.82095730911718*^9}, {3.8209573555377216`*^9, 3.820957376505872*^9}, 
   3.820959331578873*^9, {3.8211383625770736`*^9, 3.821138434965591*^9}, {
   3.8211391968813686`*^9, 3.8211392657387943`*^9}, {3.8211393227801085`*^9, 
   3.8211393248269296`*^9}, {3.8231412829889646`*^9, 
   3.8231413534418135`*^9}, {3.823141502823724*^9, 3.823141590018277*^9}, {
   3.8236550912938766`*^9, 3.823655091765791*^9}, {3.823655203401829*^9, 
   3.823655207905835*^9}, 3.8236552809376774`*^9, {3.8236554318533964`*^9, 
   3.823655451762082*^9}, {3.8236555524262657`*^9, 3.8236555539227486`*^9}, 
   3.8236559408177524`*^9, {3.8236560073907485`*^9, 3.823656012705702*^9}, {
   3.823656049761657*^9, 3.823656075118746*^9}, {3.8236561252655396`*^9, 
   3.8236561297886395`*^9}, {3.8236561840697174`*^9, 3.823656356883749*^9}, {
   3.8236563931635723`*^9, 3.8236564049636545`*^9}, {3.8236564635160527`*^9, 
   3.8236565479856715`*^9}, {3.823656618451815*^9, 3.8236566465918303`*^9}, {
   3.823656727027627*^9, 3.823656931711747*^9}, {3.823657222775753*^9, 
   3.823657223811759*^9}, {3.8236572819197936`*^9, 3.823657298687948*^9}, {
   3.8236575651035223`*^9, 3.8236575652587833`*^9}, {3.823658825445919*^9, 
   3.8236588428556743`*^9}, {3.8236588835076056`*^9, 
   3.8236588917699304`*^9}, {3.823658941811777*^9, 3.823659065405012*^9}, 
   3.8236591191973047`*^9, {3.8236591545892467`*^9, 3.823659159429226*^9}, {
   3.8236592347429695`*^9, 3.8236592412367287`*^9}, {3.8236592904521437`*^9, 
   3.823659344315798*^9}, {3.8236596184162054`*^9, 3.823659637556746*^9}, {
   3.8236596691579185`*^9, 3.823659684080753*^9}, {3.8236597325893965`*^9, 
   3.8236597343847976`*^9}, {3.8236601931837378`*^9, 3.8236602194517236`*^9}, 
   3.823660296435614*^9, {3.8236604298554325`*^9, 3.823660455115836*^9}, {
   3.823660608374081*^9, 3.823660652983501*^9}, {3.823660700146762*^9, 
   3.8236607531821775`*^9}, 3.823661051697723*^9, {3.823661138770689*^9, 
   3.823661138920743*^9}, {3.8236613560267515`*^9, 3.8236613626528077`*^9}, {
   3.823705924277069*^9, 3.823705928881971*^9}, {3.8237059701539326`*^9, 
   3.823706072345337*^9}, {3.823706152409139*^9, 3.8237062134294844`*^9}, {
   3.8237062665279016`*^9, 3.8237062974604316`*^9}, {3.8237068479088516`*^9, 
   3.823706890818034*^9}, {3.8237069216601305`*^9, 3.82370692860581*^9}, 
   3.823707190748353*^9, {3.82370725094484*^9, 3.823707262591812*^9}, {
   3.823707340191991*^9, 3.823707356751421*^9}, {3.8237076381476016`*^9, 
   3.823707646086524*^9}, {3.823707746283389*^9, 3.8237077796832247`*^9}, {
   3.823708048187185*^9, 3.823708103419061*^9}, {3.823728382426073*^9, 
   3.823728399682021*^9}, {3.8237284598020363`*^9, 3.823728516326993*^9}, {
   3.8237285611391726`*^9, 3.8237285643821106`*^9}, {3.8237286081178455`*^9, 
   3.8237286379563403`*^9}, {3.8237286846662283`*^9, 
   3.8237286862857733`*^9}, {3.8237289626060767`*^9, 
   3.8237290048500767`*^9}, {3.823729116237099*^9, 3.823729191229148*^9}, {
   3.8237292308770666`*^9, 3.8237294147446876`*^9}, {3.8237294584626665`*^9, 
   3.8237295104445972`*^9}, {3.8237299129994955`*^9, 3.8237299581529636`*^9}, 
   3.8237300554370832`*^9, {3.823730285632378*^9, 3.823730363900202*^9}, {
   3.8237304091279984`*^9, 3.8237304392041626`*^9}, {3.8237304945595117`*^9, 
   3.8237305354160633`*^9}, {3.823730694278023*^9, 3.8237307226990404`*^9}, 
   3.8237308523750677`*^9, {3.8237309023386126`*^9, 3.8237309042346444`*^9}, {
   3.823731779067478*^9, 3.823731825586029*^9}, 3.8237324204650035`*^9, {
   3.82373245925289*^9, 3.8237325063963423`*^9}, {3.8237325966490307`*^9, 
   3.823732605524499*^9}, 3.823732692761057*^9, {3.823732769929077*^9, 
   3.8237328899984727`*^9}, 3.8237329288240776`*^9, 3.823732965168416*^9, {
   3.8237333039320307`*^9, 3.823733408592134*^9}, 3.823733600180997*^9, {
   3.823736663198963*^9, 3.823736702405344*^9}, {3.8237369666456614`*^9, 
   3.823737052398509*^9}, 3.8237370829936914`*^9, {3.823737157058519*^9, 
   3.8237371725509596`*^9}, {3.823737217601596*^9, 3.823737226818432*^9}, {
   3.8237373837812986`*^9, 3.823737389407007*^9}, {3.8237374207851253`*^9, 
   3.823737452405983*^9}, {3.8237380196997395`*^9, 3.8237380245366936`*^9}, {
   3.823738117246798*^9, 3.8237382259370117`*^9}, {3.823738320755745*^9, 
   3.8237383358970237`*^9}, {3.8237383685322657`*^9, 
   3.8237384019185057`*^9}, {3.823738469144698*^9, 3.8237384722511835`*^9}, {
   3.82373852346023*^9, 3.8237385298203306`*^9}, {3.823738565503487*^9, 
   3.8237386734922*^9}, {3.82373879248609*^9, 3.823738856689348*^9}, {
   3.8237389790900536`*^9, 3.8237389817730284`*^9}, {3.8237391022189736`*^9, 
   3.823739174282079*^9}, {3.8237392090371246`*^9, 3.8237392764709306`*^9}, {
   3.823739345903858*^9, 3.823739357080057*^9}, {3.823739387679063*^9, 
   3.8237394053347883`*^9}, {3.8237394948284035`*^9, 
   3.8237395186320996`*^9}, {3.823739565088069*^9, 3.8237396551919794`*^9}, {
   3.823740018991229*^9, 3.8237400961036205`*^9}, {3.8237401565379987`*^9, 
   3.8237401583227644`*^9}, {3.8237406700578303`*^9, 
   3.8237406873889093`*^9}, {3.823740729465277*^9, 3.8237407580952125`*^9}, {
   3.823743202639067*^9, 3.823743265482156*^9}, {3.823743309386753*^9, 
   3.823743338638073*^9}, {3.823743451001852*^9, 3.8237434801695995`*^9}, {
   3.8237435370078297`*^9, 3.823743554581031*^9}, 3.823743636833749*^9, {
   3.8237438303167863`*^9, 3.8237438758120584`*^9}, {3.823743919387436*^9, 
   3.823744012998006*^9}, {3.823744051708722*^9, 3.8237442543125477`*^9}, {
   3.8237445368510323`*^9, 3.8237445558440323`*^9}, {3.823744639735987*^9, 
   3.823744684511101*^9}, {3.82374475010604*^9, 3.823744936594909*^9}, {
   3.8237452088641305`*^9, 3.823745239430967*^9}, {3.8237460347111006`*^9, 
   3.82374617805915*^9}, {3.823746792911957*^9, 3.8237468516238985`*^9}, {
   3.8237468857440047`*^9, 3.823746958316041*^9}, {3.8237469978285875`*^9, 
   3.8237470042127037`*^9}, {3.823747070596759*^9, 3.823747074388387*^9}, {
   3.8237495748269873`*^9, 3.823749609174774*^9}, {3.82375073357521*^9, 
   3.823750764626575*^9}, {3.8237975210314207`*^9, 3.8237975383534193`*^9}, {
   3.8237977209756107`*^9, 3.8237977264053907`*^9}, {3.823806101634373*^9, 
   3.823806121822695*^9}, {3.8238192686382732`*^9, 3.823819279622287*^9}, {
   3.823819456391144*^9, 3.8238194752757015`*^9}, {3.8238197938119698`*^9, 
   3.823819842664462*^9}, {3.82381996737532*^9, 3.8238199801275992`*^9}, {
   3.8238200107883034`*^9, 3.8238200502193074`*^9}, {3.8238203314817343`*^9, 
   3.8238203449004345`*^9}, {3.823820398268285*^9, 3.823820417787322*^9}, {
   3.823820462590725*^9, 3.823820474539569*^9}, {3.8238205296225133`*^9, 
   3.8238205823231497`*^9}, {3.8238208428763075`*^9, 
   3.8238209144581904`*^9}, {3.82382094576075*^9, 3.823820954298182*^9}, {
   3.8238213092518225`*^9, 3.8238213662822804`*^9}, {3.823821437938188*^9, 
   3.823821478904256*^9}, {3.823821509554306*^9, 3.8238215237621946`*^9}, {
   3.8238217374562645`*^9, 3.823821775065325*^9}, {3.8238221227689457`*^9, 
   3.8238221468352494`*^9}, {3.823822181376028*^9, 3.8238222544972897`*^9}, {
   3.8238222972372246`*^9, 3.8238223378561316`*^9}, {3.8238223830483766`*^9, 
   3.8238224160132856`*^9}, {3.8238225866892824`*^9, 
   3.8238225999920163`*^9}, {3.823822642672739*^9, 3.823822658304906*^9}, {
   3.8238227192242556`*^9, 3.8238227688817725`*^9}, {3.823822810648243*^9, 
   3.823822852808134*^9}, {3.8238230424202857`*^9, 3.8238231296388717`*^9}, {
   3.8238232293512616`*^9, 3.823823251352811*^9}, {3.823824031102771*^9, 
   3.8238240502979484`*^9}, {3.8238245509533257`*^9, 
   3.8238246404222946`*^9}, {3.823824679840721*^9, 3.823824690557724*^9}, {
   3.8238247698572607`*^9, 3.8238247779256954`*^9}, {3.823824809886386*^9, 
   3.823824838381317*^9}, 3.8238249927152467`*^9, {3.8238250246933217`*^9, 
   3.8238250720392838`*^9}, {3.823825133777273*^9, 3.8238251785642242`*^9}, {
   3.8238252550770435`*^9, 3.8238253349729357`*^9}, {3.8239697236828747`*^9, 
   3.8239697251760592`*^9}, {3.823969782413111*^9, 3.823969824113186*^9}, {
   3.8239698688481555`*^9, 3.823969872125151*^9}, {3.823969945019972*^9, 
   3.823969967152932*^9}, 3.824007366286104*^9, {3.8241444651258554`*^9, 
   3.824144467142995*^9}, {3.8241445687269354`*^9, 3.8241445905858517`*^9}, {
   3.824144949093319*^9, 3.8241450011408052`*^9}, {3.824145120484915*^9, 
   3.824145149371142*^9}, {3.824176079878627*^9, 3.824176087228521*^9}, 
   3.8241761267707405`*^9, 3.82417616415281*^9, {3.8241762047395916`*^9, 
   3.82417622932755*^9}, {3.8241763713657064`*^9, 3.824176408102358*^9}, {
   3.8241766775568523`*^9, 3.8241766777147956`*^9}, 3.824692474279517*^9, {
   3.8248554940921984`*^9, 3.8248555393983564`*^9}, {3.824855790150652*^9, 
   3.8248557918062744`*^9}, {3.8248559944839196`*^9, 
   3.8248560681837373`*^9}, {3.8248581381878815`*^9, 
   3.8248582733915033`*^9}, {3.8248583098293166`*^9, 
   3.8248583634083753`*^9}, {3.8248589634108086`*^9, 3.824859022205922*^9}, {
   3.8248590957118087`*^9, 3.8248591812566757`*^9}, {3.82485922744764*^9, 
   3.8248594110889826`*^9}, {3.824859458837884*^9, 3.824859515438059*^9}, {
   3.824859549829937*^9, 3.8248596196937847`*^9}, {3.8248596535819206`*^9, 
   3.824859861657907*^9}, {3.824859897986916*^9, 3.8248598991059237`*^9}, {
   3.8248606068840094`*^9, 3.8248606486899695`*^9}, {3.8248607633499727`*^9, 
   3.8248608303329473`*^9}, {3.8248610121139803`*^9, 
   3.8248611153620644`*^9}, {3.82486116007648*^9, 3.8248612499544053`*^9}, {
   3.8248615874843783`*^9, 3.824861588698498*^9}, {3.824863498104088*^9, 
   3.8248635099992046`*^9}, {3.824863540811947*^9, 3.824863842692172*^9}, {
   3.8248641849726477`*^9, 3.824864241820711*^9}, {3.824864393684721*^9, 
   3.824864451135827*^9}, {3.824864527524806*^9, 3.824864643672598*^9}, {
   3.8248651872538767`*^9, 3.8248652295969086`*^9}, {3.8248653512179537`*^9, 
   3.8248653688538847`*^9}, {3.824865400436881*^9, 3.82486544599679*^9}, {
   3.824865556516977*^9, 3.8248655895979476`*^9}, {3.8248656624809184`*^9, 
   3.8248657301649356`*^9}, {3.824865775472945*^9, 3.8248658456930285`*^9}, {
   3.8248658997849164`*^9, 3.8248659699731464`*^9}, {3.824866045977904*^9, 
   3.8248661011259117`*^9}, {3.824866138870102*^9, 3.8248661602539935`*^9}, {
   3.824866381797201*^9, 3.8248663854131937`*^9}, {3.8248664830507493`*^9, 
   3.824866485312036*^9}, {3.8248665217342715`*^9, 3.824866706398279*^9}, {
   3.824866740962959*^9, 3.8248667829710083`*^9}, {3.824866822720973*^9, 
   3.824866881402107*^9}, {3.824866928326332*^9, 3.8248669405423574`*^9}, {
   3.8248670374785595`*^9, 3.824867052438156*^9}, 3.8248672305928755`*^9, {
   3.8248672681503887`*^9, 3.8248673164026723`*^9}, {3.8248673902943897`*^9, 
   3.8248674653471622`*^9}, {3.824867512481283*^9, 3.824867567107338*^9}, {
   3.824867597582734*^9, 3.824867597657949*^9}, {3.8248703785678463`*^9, 
   3.8248703849688787`*^9}, {3.8248704178606644`*^9, 
   3.8248704243188753`*^9}, {3.824870512414856*^9, 3.8248705134156895`*^9}, {
   3.8248705445478535`*^9, 3.8248705704709697`*^9}, 3.824870767074888*^9, {
   3.824870845810909*^9, 3.8248708491358414`*^9}, {3.8248708905038247`*^9, 
   3.824870918263834*^9}, {3.8248709504798117`*^9, 3.8248709511518693`*^9}, {
   3.82487098675991*^9, 3.824871008351866*^9}, {3.824871043495852*^9, 
   3.8248711884199567`*^9}, 3.824871219299938*^9, {3.824871269875946*^9, 
   3.8248712724559493`*^9}, 3.8248713077219086`*^9, {3.8248714178207035`*^9, 
   3.824871431207952*^9}, {3.8248715050759525`*^9, 3.8248715086679497`*^9}, 
   3.8248715914469337`*^9, 3.824871630113031*^9, 3.824918736116824*^9, {
   3.824918831876279*^9, 3.8249188592878246`*^9}, {3.8249188949241276`*^9, 
   3.824918916395336*^9}, {3.8249189589208436`*^9, 3.8249191089441996`*^9}, {
   3.8249191486023817`*^9, 3.824919161299123*^9}, {3.8249192264932456`*^9, 
   3.8249192843492675`*^9}, {3.8249195470833564`*^9, 
   3.8249195753685193`*^9}, {3.8249196824495945`*^9, 
   3.8249197059685616`*^9}, {3.8249198737606325`*^9, 3.824919894381673*^9}, {
   3.82491995693666*^9, 3.8249199983767214`*^9}, {3.8249200607305593`*^9, 
   3.824920080512822*^9}, {3.8249201152808523`*^9, 3.82492018045674*^9}, 
   3.8249260591478357`*^9, {3.824926102112735*^9, 3.8249261182916527`*^9}, {
   3.824926155227851*^9, 3.824926165227862*^9}, 3.824927264763813*^9, 
   3.8249284940372095`*^9, {3.8249286647931633`*^9, 3.8249286919328136`*^9}, {
   3.824930675494668*^9, 3.8249307904993544`*^9}, {3.824930825113406*^9, 
   3.824930826549461*^9}, 3.8249308724294558`*^9, {3.8249311749866467`*^9, 
   3.8249312134795732`*^9}, {3.824931266802411*^9, 3.824931329131488*^9}, {
   3.8249315629485345`*^9, 3.8249315646205845`*^9}, {3.8249317170010915`*^9, 
   3.824931734714775*^9}, {3.8249317715096874`*^9, 3.8249318008986015`*^9}, 
   3.824931958855652*^9, {3.824932070765748*^9, 3.824932092118788*^9}, {
   3.8249321667914214`*^9, 3.8249321768227706`*^9}, 3.8249322966454697`*^9, 
   3.8249323590480747`*^9, {3.824932476319854*^9, 3.8249324994627223`*^9}, {
   3.824932532575835*^9, 3.8249325408677945`*^9}, {3.824935135051778*^9, 
   3.824935195729768*^9}, {3.8249378066977844`*^9, 3.824937856937821*^9}, {
   3.8249378935857415`*^9, 3.8249379276087565`*^9}, {3.8249380201017585`*^9, 
   3.8249380344772897`*^9}, 3.824938225310755*^9, {3.824938429070714*^9, 
   3.8249384624460135`*^9}, {3.8249385544947643`*^9, 3.824938561276759*^9}, {
   3.824938612718734*^9, 3.8249386177907257`*^9}, {3.82493872285442*^9, 
   3.8249387991537867`*^9}, 3.824938957250723*^9, {3.824939087185829*^9, 
   3.824939091467716*^9}, {3.824939155783268*^9, 3.824939194602249*^9}, 
   3.8249393718344297`*^9, {3.824944854531822*^9, 3.8249448593663836`*^9}, {
   3.8249449072807407`*^9, 3.824944990081777*^9}, {3.8249451975316906`*^9, 
   3.8249452043515267`*^9}, {3.8249452413861904`*^9, 
   3.8249452424955993`*^9}, {3.824945306196274*^9, 3.8249453079197855`*^9}, 
   3.824945453525382*^9, {3.824947930933343*^9, 3.8249479428888316`*^9}, {
   3.8249479860455694`*^9, 3.824948010149576*^9}, 3.824948048784681*^9, {
   3.8249481486977634`*^9, 3.8249481825106754`*^9}, {3.824948240929731*^9, 
   3.824948268838681*^9}, {3.824948344021683*^9, 3.8249484079378004`*^9}, 
   3.8249484613737183`*^9, 3.8249485092866507`*^9, {3.8249488132516556`*^9, 
   3.8249488200727797`*^9}, 3.824949117622732*^9, {3.824949182597331*^9, 
   3.8249491866672087`*^9}, {3.8249492375433607`*^9, 
   3.8249492387426367`*^9}, {3.8249496260388103`*^9, 3.824949648890667*^9}, {
   3.824949697275775*^9, 3.8249497119435606`*^9}, {3.824949771574411*^9, 
   3.82494990415077*^9}, {3.824949935625725*^9, 3.824949944963252*^9}, {
   3.8249500214681807`*^9, 3.824950061742335*^9}, {3.824950106632338*^9, 
   3.8249501149517174`*^9}, 3.824950334224843*^9, {3.8249504922811413`*^9, 
   3.824950501754794*^9}, {3.824950535055521*^9, 3.8249505369168267`*^9}, {
   3.824950643155122*^9, 3.8249506518243294`*^9}, {3.8249508901108513`*^9, 
   3.824950896408331*^9}, {3.8249509611248026`*^9, 3.8249509779465027`*^9}, {
   3.824951131644086*^9, 3.824951145059025*^9}, {3.825029685214327*^9, 
   3.8250297111862707`*^9}, {3.8250304689683504`*^9, 3.825030535836391*^9}, {
   3.8250307888440385`*^9, 3.825030852232153*^9}, {3.825030990528429*^9, 
   3.825031055685049*^9}, {3.82503110460461*^9, 3.825031107929455*^9}, {
   3.8250311791713877`*^9, 3.8250313618611555`*^9}, {3.825032817357188*^9, 
   3.825032858876341*^9}, {3.825032899588101*^9, 3.8250329319964485`*^9}, {
   3.8250329900727024`*^9, 3.82503299336228*^9}, {3.825033113511448*^9, 
   3.8250331161483316`*^9}, {3.8250331877052994`*^9, 
   3.8250331933091574`*^9}, {3.8250334294520283`*^9, 
   3.8250334684190006`*^9}, {3.825033563317192*^9, 3.825033566863104*^9}, {
   3.825033916638444*^9, 3.825033931753398*^9}, {3.8250343527314386`*^9, 
   3.8250343653483415`*^9}, 3.82503450811926*^9, 3.8250350628093615`*^9, {
   3.825035101794323*^9, 3.825035106529402*^9}, {3.825035141410263*^9, 
   3.825035311579383*^9}, {3.825035353570861*^9, 3.825035375844096*^9}, {
   3.8250356321401105`*^9, 3.825035668483427*^9}, {3.8251074106564817`*^9, 
   3.8251074282853556`*^9}, 3.8251074622734427`*^9, {3.825107509436661*^9, 
   3.8251075099010024`*^9}, {3.8251075419690013`*^9, 3.825107559492883*^9}, {
   3.825107657700059*^9, 3.825107720572483*^9}, {3.8251077756872463`*^9, 
   3.8251077768520956`*^9}, {3.825112241393627*^9, 3.8251123130547857`*^9}, {
   3.82511237352559*^9, 3.8251124818865924`*^9}, {3.8251125219305964`*^9, 
   3.8251125524465885`*^9}, {3.825112609633627*^9, 3.8251126544900713`*^9}, {
   3.825112693829616*^9, 3.8251127267656126`*^9}, 3.825112898187585*^9, {
   3.8251130688775897`*^9, 3.8251131639828053`*^9}, {3.8251132115325966`*^9, 
   3.825113219963628*^9}, {3.825113254518587*^9, 3.8251133003107843`*^9}, {
   3.8251133362718973`*^9, 3.8251133391907682`*^9}, {3.825113738487503*^9, 
   3.8251137867986116`*^9}, {3.8251138248948717`*^9, 
   3.8251138878835287`*^9}, {3.8251139359329896`*^9, 3.825113990267004*^9}, {
   3.8251140303157167`*^9, 3.8251142110438023`*^9}, {3.8251142487426205`*^9, 
   3.8251143913676434`*^9}, {3.8251144454038825`*^9, 3.825114527495221*^9}, 
   3.825114686832468*^9, {3.825114720732188*^9, 3.825114748662099*^9}, {
   3.82511480953331*^9, 3.825114814789626*^9}, {3.8251149561849065`*^9, 
   3.82511501414065*^9}, 3.8251150621695185`*^9, {3.825115124414464*^9, 
   3.82511518521279*^9}, {3.82511521562442*^9, 3.8251152664716225`*^9}, {
   3.8251153412464733`*^9, 3.825115394159856*^9}, {3.825115711763401*^9, 
   3.825115739136504*^9}, 3.825115802335621*^9, {3.8251158641134586`*^9, 
   3.8251159642219706`*^9}, {3.8251161676341233`*^9, 3.825116170536463*^9}, {
   3.8251163019175444`*^9, 3.8251163262814693`*^9}, {3.825116416816228*^9, 
   3.8251164200015736`*^9}, {3.8251164606011877`*^9, 3.825116466463657*^9}, {
   3.825116621426254*^9, 3.8251166338331833`*^9}, {3.825116673601297*^9, 
   3.825116758647108*^9}, {3.825116893072377*^9, 3.825116977881137*^9}, {
   3.8251170088084126`*^9, 3.825117133799431*^9}, {3.8251172108434277`*^9, 
   3.825117259057486*^9}, {3.825117329735531*^9, 3.8251173298364267`*^9}, {
   3.8251174136285453`*^9, 3.825117419410365*^9}, {3.825117465021659*^9, 
   3.8251174991910524`*^9}, {3.8251175955855207`*^9, 
   3.8251175979144015`*^9}, {3.8251228928233395`*^9, 3.825122908818619*^9}, {
   3.825122964937612*^9, 3.8251229943785887`*^9}, {3.8251231786693897`*^9, 
   3.825123230807619*^9}, {3.825123273571483*^9, 3.8251232951225624`*^9}, {
   3.8251233815705056`*^9, 3.8251234408196197`*^9}, {3.825123492023644*^9, 
   3.825123499343487*^9}, {3.8251235832195997`*^9, 3.8251235858665876`*^9}, {
   3.8251236162096167`*^9, 3.8251236473245935`*^9}, {3.8251236999996166`*^9, 
   3.8251237320415916`*^9}, {3.8251237780188103`*^9, 3.825123887306597*^9}, {
   3.8251239541568336`*^9, 3.825123961270546*^9}, {3.8251239978396077`*^9, 
   3.8251241017285523`*^9}, {3.8251241469996176`*^9, 3.825124212762742*^9}, {
   3.8251242620015836`*^9, 3.8251242624915843`*^9}, {3.825124331980756*^9, 
   3.8251243364607453`*^9}, {3.8251244736191196`*^9, 3.8251244769488087`*^9}, 
   3.825124708139988*^9, 3.82512490138111*^9, {3.8251250734006433`*^9, 
   3.8251251073565845`*^9}, {3.825125444824342*^9, 3.8251254500020676`*^9}, {
   3.825125528515123*^9, 3.825125533835323*^9}, {3.825125589764288*^9, 
   3.825125595496958*^9}, {3.825125654061408*^9, 3.8251256678387194`*^9}, 
   3.825125787416888*^9, {3.825125934344818*^9, 3.8251259350493145`*^9}, {
   3.8251260319779787`*^9, 3.8251261589522505`*^9}, {3.8251262245214634`*^9, 
   3.8251262493232102`*^9}, 3.8251263284459877`*^9, {3.8251263948974404`*^9, 
   3.8251266061747875`*^9}, {3.8251267456090946`*^9, 
   3.8251267878365297`*^9}, {3.8252014212330217`*^9, 
   3.8252014278843565`*^9}, {3.8252015318608227`*^9, 3.825201534025397*^9}, {
   3.8252015932183094`*^9, 3.825201638519158*^9}, {3.825201745485388*^9, 
   3.8252017509363613`*^9}, {3.8252018263803806`*^9, 3.825201841765905*^9}, {
   3.825201872925373*^9, 3.825201911436224*^9}, {3.825201958482499*^9, 
   3.8252019616854696`*^9}, {3.8252022205776978`*^9, 
   3.8252022556680565`*^9}, {3.825202288733057*^9, 3.8252022956409087`*^9}, {
   3.825202341170432*^9, 3.8252023583550315`*^9}, {3.825202403838107*^9, 
   3.8252024339778805`*^9}, {3.8252026663779774`*^9, 
   3.8252026903126917`*^9}, {3.8252031529973845`*^9, 
   3.8252031603302813`*^9}, {3.8252032175586357`*^9, 
   3.8252033196873207`*^9}, {3.8252033874303513`*^9, 3.82520339687774*^9}, {
   3.8252034401422787`*^9, 3.8252034999682617`*^9}, {3.8252035307012806`*^9, 
   3.825203532434366*^9}, {3.8252035856383314`*^9, 3.825203598914426*^9}, 
   3.825203638382357*^9, {3.8252038649384394`*^9, 3.8252038667554264`*^9}, 
   3.8252039504042454`*^9, {3.8252040534373856`*^9, 3.825204076903442*^9}, {
   3.825204276092473*^9, 3.825204333944439*^9}, 3.825204379076498*^9, {
   3.825204450887293*^9, 3.8252044617594037`*^9}, {3.825204497533407*^9, 
   3.8252045092294235`*^9}, {3.8252046011413884`*^9, 
   3.8252046659265347`*^9}, {3.8252047226396627`*^9, 3.825204752544791*^9}, {
   3.8252048384574184`*^9, 3.825204881444479*^9}, {3.8252056454745965`*^9, 
   3.8252057495605917`*^9}, {3.8252058536710606`*^9, 
   3.8252059282911787`*^9}, {3.825206009940809*^9, 3.825206019784396*^9}, {
   3.825206054648757*^9, 3.8252061058152895`*^9}, {3.825206140337419*^9, 
   3.8252062058884563`*^9}, {3.8252062513528733`*^9, 3.825206297839419*^9}, {
   3.825206341288153*^9, 3.825206395296438*^9}, {3.825206509686785*^9, 
   3.825206516498825*^9}, {3.825206586726118*^9, 3.8252066242604475`*^9}, {
   3.8252066600959544`*^9, 3.8252066817439594`*^9}, {3.825206858674218*^9, 
   3.8252068675332985`*^9}, {3.8252084748454037`*^9, 3.825208489729294*^9}, {
   3.825208698448345*^9, 3.8252087441143928`*^9}, 3.825209012203766*^9, {
   3.825209055738775*^9, 3.825209082120344*^9}, {3.8252091179562607`*^9, 
   3.8252091201763067`*^9}, {3.825209193573662*^9, 3.825209211097583*^9}, {
   3.825269837904316*^9, 3.8252698477757287`*^9}, {3.825269889144647*^9, 
   3.825269927736794*^9}, 3.825269957999621*^9, 3.8252700182798376`*^9, {
   3.825270096932644*^9, 3.825270100000124*^9}, {3.8252701438680296`*^9, 
   3.825270143978655*^9}, {3.82527049298145*^9, 3.825270530487769*^9}, {
   3.825270598004809*^9, 3.8252707293515034`*^9}, {3.8252708110772915`*^9, 
   3.82527082024675*^9}, {3.825271057090623*^9, 3.825271089071453*^9}, 
   3.825271227921497*^9, {3.825271280457679*^9, 3.825271294777677*^9}, {
   3.825271408704564*^9, 3.825271431142701*^9}, {3.825274622036351*^9, 
   3.825274624216405*^9}, {3.825274668609521*^9, 3.825274719785666*^9}, 
   3.8252747776654224`*^9, {3.8252748250619373`*^9, 3.825274842858553*^9}, {
   3.825275099354559*^9, 3.8252751837335386`*^9}, {3.8252755556110506`*^9, 
   3.825275559810046*^9}, {3.8252827955455046`*^9, 3.8252829192166505`*^9}, {
   3.8252829633365183`*^9, 3.825282992781548*^9}, {3.8252830994145517`*^9, 
   3.8252831105825834`*^9}, {3.825283156238617*^9, 3.8252831829136906`*^9}, 
   3.8252850404151754`*^9, {3.825286773512032*^9, 3.8252868004068947`*^9}, {
   3.8252869041589646`*^9, 3.8252870208551617`*^9}, {3.8252873622357492`*^9, 
   3.825287427671309*^9}, 3.825287466164644*^9, {3.8252874969913425`*^9, 
   3.825287568939683*^9}, {3.825287689387618*^9, 3.825287764342353*^9}, {
   3.825287799511036*^9, 3.8252878456042857`*^9}, {3.8252878757434416`*^9, 
   3.8252878799684577`*^9}, {3.825287920121481*^9, 3.8252879505114746`*^9}, {
   3.8252880475956464`*^9, 3.8252881567673907`*^9}, {3.825288194699346*^9, 
   3.825288225983613*^9}, {3.8252884598715005`*^9, 3.825288488613561*^9}, {
   3.8252886610655613`*^9, 3.8252886677607336`*^9}, 3.8252887333778253`*^9, {
   3.8252890331985273`*^9, 3.8252890345164127`*^9}, {3.8252891262177644`*^9, 
   3.8252891317516923`*^9}, 3.8477446057094526`*^9, {3.847931982414719*^9, 
   3.8479319847264605`*^9}, {3.847932633591057*^9, 3.8479326594302764`*^9}, {
   3.8479326962304373`*^9, 3.847932770399935*^9}, {3.847932828826699*^9, 
   3.8479328583445177`*^9}, {3.8479328917727027`*^9, 
   3.8479329001381135`*^9}, {3.847933078338348*^9, 3.847933082715928*^9}, {
   3.847933175306342*^9, 3.847933177565844*^9}, 3.8479332813522415`*^9, {
   3.847933330700545*^9, 3.847933342463937*^9}, {3.8479333830177836`*^9, 
   3.84793340190598*^9}, {3.8479334364174695`*^9, 3.8479335151381907`*^9}, 
   3.847933545883972*^9, {3.8479335789304576`*^9, 3.8479335842977095`*^9}, 
   3.847933627944661*^9, {3.8479337242678623`*^9, 3.8479337299934454`*^9}, {
   3.8479338121603823`*^9, 3.8479338652464576`*^9}, 3.8479339275638103`*^9, 
   3.8479339632985964`*^9, {3.847933998166684*^9, 3.8479340246443806`*^9}, {
   3.847984930200548*^9, 3.8479850227858725`*^9}, {3.8479851956709943`*^9, 
   3.8479852004962254`*^9}, 3.847986930940091*^9, {3.847987559329653*^9, 
   3.8479875856112337`*^9}, {3.847987635228112*^9, 3.847987714377577*^9}, {
   3.8479877457029667`*^9, 3.8479878376583514`*^9}, 3.847992583304481*^9, {
   3.847992665525615*^9, 3.847992673896764*^9}, {3.847992708256222*^9, 
   3.847992751360216*^9}, {3.8479927829077954`*^9, 3.847992787503013*^9}, {
   3.847992854321946*^9, 3.8479929070074825`*^9}, {3.847993651910375*^9, 
   3.84799376169369*^9}, {3.847993809645507*^9, 3.8479938128671017`*^9}, {
   3.8479938476163073`*^9, 3.847993867832755*^9}, {3.847993902479431*^9, 
   3.8479939370419836`*^9}, {3.847993991195037*^9, 3.847994004518298*^9}, {
   3.8479940426396513`*^9, 3.8479940798138914`*^9}, {3.84799437175031*^9, 
   3.847994382987075*^9}, 3.8479944422863846`*^9, 3.8479945696548862`*^9, {
   3.847995486394289*^9, 3.847995509963298*^9}, {3.8479956601946554`*^9, 
   3.8479956723440323`*^9}, {3.8479960419999228`*^9, 3.8479960739826794`*^9}, 
   3.8479961089588137`*^9, {3.847996166664254*^9, 3.847996198506184*^9}, {
   3.847996232291165*^9, 3.8479962876160154`*^9}, {3.847996322786419*^9, 
   3.8479963441488132`*^9}, {3.8479964800999765`*^9, 
   3.8479964869301186`*^9}, {3.847996587434383*^9, 3.8479966859587135`*^9}, {
   3.84799681754235*^9, 3.84799682199829*^9}, 3.847996877874048*^9, {
   3.8479969219629164`*^9, 3.8479969492657127`*^9}, 3.847997152194538*^9, {
   3.847997224034694*^9, 3.8479973104963617`*^9}, 3.8479973771222277`*^9, {
   3.8479974349829245`*^9, 3.847997449269702*^9}, {3.8479974846729565`*^9, 
   3.847997499285398*^9}, 3.847997531246236*^9, {3.8479985319825764`*^9, 
   3.847998536693822*^9}, {3.8479986191458488`*^9, 3.847998644782928*^9}, 
   3.847998706065302*^9, {3.847998758270503*^9, 3.8479987762005157`*^9}, {
   3.847998856079177*^9, 3.847998892360922*^9}, {3.847998966574079*^9, 
   3.847998982583066*^9}, {3.847999200613038*^9, 3.8479993504288816`*^9}, 
   3.8479993872633224`*^9, {3.8479994190550003`*^9, 3.847999440585135*^9}, 
   3.847999482525767*^9, {3.8479995556255426`*^9, 3.8479995782038517`*^9}, {
   3.84800000515221*^9, 3.848000007324628*^9}, {3.848002294015657*^9, 
   3.8480022966391196`*^9}, 3.848019869684489*^9, {3.84801998293229*^9, 
   3.848019997802806*^9}, {3.848020424260491*^9, 3.84802046921712*^9}, {
   3.848020504517079*^9, 3.8480205431254373`*^9}, 3.8480207924818087`*^9, {
   3.8480208303899183`*^9, 3.848020870501447*^9}, {3.8480209061866093`*^9, 
   3.848020955487481*^9}, {3.8480805733833*^9, 3.8480805761669827`*^9}, {
   3.84808062978627*^9, 3.8480806711333437`*^9}, {3.8480810590182967`*^9, 
   3.8480810864494514`*^9}, {3.848081155003725*^9, 3.848081193498169*^9}, {
   3.848081496309805*^9, 3.8480815454101844`*^9}, {3.8480817617984514`*^9, 
   3.848081811169591*^9}, {3.8480826400427575`*^9, 3.848082757989847*^9}, {
   3.8480827951946077`*^9, 3.8480827968857813`*^9}, {3.848083133617014*^9, 
   3.8480831550569067`*^9}, {3.8480831902128396`*^9, 
   3.8480832333421373`*^9}, {3.8480834314035244`*^9, 
   3.8480834449297895`*^9}, {3.8480835622738724`*^9, 3.8480836350361843`*^9}, 
   3.848084162024353*^9, {3.8480846792895927`*^9, 3.8480847259577885`*^9}, 
   3.8480847851457744`*^9, {3.8480851387656574`*^9, 3.8480852088135433`*^9}, 
   3.8480852481225643`*^9, {3.848085298337333*^9, 3.8480853026138735`*^9}, {
   3.8480853943626366`*^9, 3.848085430493684*^9}, 3.848085484162488*^9, {
   3.8480855158603754`*^9, 3.8480856748535633`*^9}, {3.848085752009205*^9, 
   3.848085754193741*^9}, {3.8480857935631695`*^9, 3.8480858533173733`*^9}, {
   3.848085919055191*^9, 3.8480859232483406`*^9}, {3.8480859538310146`*^9, 
   3.848085957902436*^9}, {3.848086048067357*^9, 3.8480860624121017`*^9}, 
   3.8480861072471275`*^9, {3.8480864806737037`*^9, 3.848086499820129*^9}, {
   3.8480867197783227`*^9, 3.848086726314973*^9}, {3.84808680227567*^9, 
   3.848086890438217*^9}, {3.848086959161666*^9, 3.8480870097821665`*^9}, 
   3.848088063261906*^9, {3.8480882643751802`*^9, 3.8480882768208895`*^9}, {
   3.8480930025440536`*^9, 3.8480930128967485`*^9}, 3.848093396381839*^9, {
   3.8480936026157427`*^9, 3.8480936173618584`*^9}, {3.8480936908193684`*^9, 
   3.8480937036446733`*^9}, {3.8480941403068414`*^9, 3.848094206057458*^9}, 
   3.8480942436530914`*^9, {3.848094346904891*^9, 3.8480944052926598`*^9}, {
   3.848094435499094*^9, 3.84809450598545*^9}, {3.8480945386575117`*^9, 
   3.8480945684825034`*^9}, 3.8480947710147905`*^9, {3.848094803112998*^9, 
   3.848094825264998*^9}, {3.8480948910457973`*^9, 3.8480949459198704`*^9}, {
   3.8480950081873865`*^9, 3.8480950333193693`*^9}, {3.8480951737701745`*^9, 
   3.848095199709664*^9}, {3.8480952809397955`*^9, 3.84809540627249*^9}, {
   3.8480954859387646`*^9, 3.848095506261831*^9}, {3.8480955748749638`*^9, 
   3.8480956108811703`*^9}, {3.848095653948654*^9, 3.848095688595973*^9}, {
   3.848096185028742*^9, 3.848096188308367*^9}, 3.8481035425558586`*^9, 
   3.848103728909137*^9, {3.8481037988249717`*^9, 3.848103802249567*^9}, {
   3.848103842822173*^9, 3.8481038480462704`*^9}, {3.848103926116166*^9, 
   3.8481039585924306`*^9}, {3.8481040004204082`*^9, 
   3.8481040827482543`*^9}, {3.848104128185786*^9, 3.848104172462432*^9}, {
   3.8481090219559317`*^9, 3.8481090307767415`*^9}, {3.84810971039793*^9, 
   3.8481097342837777`*^9}, {3.848540666404989*^9, 3.8485406828755383`*^9}, 
   3.902857648733553*^9},
 CellLabel->"In[18]:=",ExpressionUUID->"d616b612-60ec-4f0c-8e82-3845f455ee1a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Creates", " ", "Distance", " ", "Annotated", " ", "Least", " ", "Bridges",
     " ", "Graph", " ", "Edges"}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Input", ":", " ", 
    RowBox[{"[", 
     RowBox[{
     "edistances_", ",", "estyle_", ",", "labeled_", ",", "distancelimit_", 
      ",", "verbose_"}], "]"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"edistances", " ", "=", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"v1", "\[UndirectedEdge]", "v2"}], ",", "8"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"v1", "\[DirectedEdge]", "v3"}], ",", 
         SqrtBox["2"]}], "}"}], ",", "..."}], "}"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"#1", " ", "=", " ", 
        RowBox[{"directed", " ", 
         RowBox[{"and", "/", "or"}], " ", "undirected", " ", "edges"}]}], ",",
        " ", 
       RowBox[{
        RowBox[{"no", " ", "rules"}], ";", " ", 
        RowBox[{"#2", " ", "=", " ", 
         RowBox[{"non", "-", 
          RowBox[{"complex", " ", "distance"}]}]}]}]}], ")"}]}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"estyle", " ", "=", " ", 
    RowBox[{"\"\<plain edges\>\"", " ", "|", " ", "\"\<hued edges\>\""}]}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"labeled", " ", "=", " ", 
    RowBox[{"False", " ", "|", " ", "True", " ", "|", " ", 
     RowBox[{"fpp", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"False", " ", "\[RightArrow]", " ", 
         RowBox[{"no", " ", "label"}]}], ",", " ", 
        RowBox[{"True", " ", "\[RightArrow]", " ", 
         RowBox[{"labeled", " ", "with", " ", "default", " ", "fpp"}]}], ",", 
        " ", 
        RowBox[{"fpp", " ", "\[RightArrow]", " ", 
         RowBox[{
          RowBox[{"use", " ", "precision", " ", "fpp"}], " ", 
          "\[GreaterEqual]", " ", "1"}]}]}], ")"}]}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"distancelimit", " ", "=", " ", 
    RowBox[{"L", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"L", " ", "\[LessEqual]", " ", "0"}], " ", "\[RightArrow]", 
        " ", 
        RowBox[{"no", " ", "graph", " ", "computed"}]}], ",", " ", 
       RowBox[{
        RowBox[{"L", " ", "<", " ", "\[Infinity]"}], " ", "\[RightArrow]", 
        " ", 
        RowBox[{
        "LBG", " ", "computation", " ", "halts", " ", "at", " ", "L", " ", 
         "if", " ", "reached"}]}], ",", " ", 
       RowBox[{"\[Infinity]", " ", "\[RightArrow]", " ", 
        RowBox[{"max", " ", "distance"}]}], ",", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"NumberQ", "[", "L", "]"}], "\[Equal]", "False"}], " ", 
        "\[RightArrow]", " ", "ignored"}]}], ")"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"verbose", " ", "=", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"True", " ", "|", " ", "False"}], ")"}], " ", "|", " ", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"True", "|", "False"}], ",", " ", 
        RowBox[{"True", "|", "False"}], ",", " ", 
        RowBox[{"True", "|", "False"}]}], "}"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"#1", " ", "=", " ", 
         RowBox[{"class", " ", "messages"}]}], ",", " ", 
        RowBox[{"#2", " ", "=", " ", 
         RowBox[{"LBG", " ", "messages"}]}], ",", " ", 
        RowBox[{"#3", " ", "=", " ", "progress"}]}], ")"}]}]}]}], " ", "*)"}],
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Output", ":", " ", 
    RowBox[{"{", 
     RowBox[{"hues", ",", "partitions", ",", "annotatedEdges"}], "}"}]}], " ",
    "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"LeastBridgesPartitionedEdges", "[", 
      RowBox[{
      "edistances_", ",", "estyle_", ",", "labeled_", ",", "distancelimit_", 
       ",", "verbose_"}], "]"}], ":=", 
     RowBox[{"Block", "[", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"local", " ", "variables"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
        "edgeCount", ",", "\[IndentingNewLine]", "absoluteMinMax", ",", 
         "distancePairsGathered", ",", "distancePairsGatheredCount", ",", 
         "uniqueEdgeDistances", ",", "uniqueEdgeDistancesCount", ",", 
         "\[IndentingNewLine]", "pairToEdgeHash", ",", "pairToDistanceHash", 
         ",", "pairToClassIndexHash", ",", "distanceToClassIndexHash", ",", 
         "\[IndentingNewLine]", "vertices", ",", "verticesCount", ",", 
         "binCount", ",", "\[IndentingNewLine]", 
         RowBox[{"plainEdges", "=", "\"\<plain edges\>\""}], ",", 
         "plainEdgesQ", ",", " ", 
         RowBox[{"huedEdges", "=", "\"\<hued edges\>\""}], ",", "huedEdgesQ", 
         ",", "edgeStyle", ",", "\[IndentingNewLine]", "labelQ", ",", 
         RowBox[{"defaultFpp", "=", "3"}], ",", "fppQ", ",", "fpp", ",", 
         "\[IndentingNewLine]", "distancelimitNaN", ",", "distancelimitStr", 
         ",", "requestedlimit", ",", "assignedlimit", ",", "t", ",", 
         "triallimit", ",", "\[IndentingNewLine]", "showclasses", ",", 
         "showLBG", ",", "showprogress", ",", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"partitions", "=", 
          RowBox[{"{", "}"}]}], ",", "partitionsCount", ",", "np", ",", 
         "\[IndentingNewLine]", "b", ",", "c", ",", "\[IndentingNewLine]", 
         "overallMin", ",", "overallMax", ",", "binWidth", ",", 
         "\[IndentingNewLine]", "processedVertices", ",", 
         "processedVerticesCount", ",", "remainingVerticesCount", ",", 
         "\[IndentingNewLine]", "remainingEdgeData", ",", 
         "remainingEdgeDataCount", ",", "\[IndentingNewLine]", 
         "theseDistances", ",", "theseDistancesCount", ",", 
         "theseDistancesMinMax", ",", "theseDistancesMean", ",", 
         "\[IndentingNewLine]", "distanceClass", ",", "distanceClassCount", 
         ",", 
         RowBox[{"distanceClasses", "=", 
          RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "classVertices", 
         ",", "classVerticesCount", ",", 
         RowBox[{"distanceClassVertices", "=", 
          RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
         "binPartitionsCount", ",", "binPartitions", ",", "binsCenters", ",", 
         "binsCentersCount", ",", "binTallies", ",", "binTalliesCount", ",", 
         "binsXY", ",", "binTallyMax", ",", "binsYupperB", ",", 
         "\[IndentingNewLine]", "distancesHash", ",", "distancesHashCount", 
         ",", "\[IndentingNewLine]", "vertexOrderedDistances", ",", 
         "distancesGatheredByVertices", ",", 
         "firstOrderNeighborDistancesData", ",", "\[IndentingNewLine]", 
         "walking", ",", "priorTrend", ",", "beenDown", ",", "beenUp", ",", 
         "bFinal", ",", "upperBound", ",", "trend", ",", "plotdistances", ",",
          "\[IndentingNewLine]", 
         RowBox[{"hmin", "=", 
          RowBox[{"1", "/", "7"}]}], ",", 
         RowBox[{"hmax", "=", 
          RowBox[{"5", "/", "6"}]}], ",", 
         RowBox[{"hsup", "=", "1"}], ",", "hinc", ",", "hValues", ",", 
         RowBox[{"hues", "=", 
          RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "trial", ",", "\[IndentingNewLine]", 
         "maxEdgeClass", ",", "annotatedEdges", ",", "graphEdgesCount", ",", 
         "priorGraphEdgesCount", ",", "\[IndentingNewLine]", 
         "graphEdgesVertices", ",", "graphEdgesVerticesCount", ",", 
         "\[IndentingNewLine]", "graphComponents", ",", 
         "graphComponentsCount", ",", "vertexComponentHash", ",", 
         "threadedComponents", ",", "\[IndentingNewLine]", 
         "graphPairsDegenerateSet", ",", "\[IndentingNewLine]", 
         "trialSelections", ",", "trialPairs", ",", "trialPairsCount", ",", 
         "trialPairsDistance", ",", "\[IndentingNewLine]", "thisPair", ",", 
         "notDegenerate", ",", "v1component", ",", "v2component", ",", 
         "\[IndentingNewLine]", "thisEdge", ",", "thisDistance", ",", 
         "thisClassIndex", ",", "\[IndentingNewLine]", "trialEdgesCount", ",",
          "verticesComplements", ",", "verticesComplementsCount", ",", 
         "\[IndentingNewLine]", "pseudoComponents", ",", 
         "pseudoComponentsCount"}], "\[IndentingNewLine]", "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"process", " ", "input"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"edgeCount", "=", 
         RowBox[{"Length", "[", "edistances", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"absoluteMinMax", "=", 
         RowBox[{"MinMax", "[", 
          RowBox[{"edistances", "[", 
           RowBox[{"[", 
            RowBox[{";;", ",", "2"}], "]"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"distancePairsGathered", "=", 
         RowBox[{"(", 
          RowBox[{"GatherBy", "[", 
           RowBox[{
            RowBox[{"Sort", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"#", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
                   RowBox[{"#", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "2"}], "]"}], "]"}]}], "}"}]}], "}"}], 
               "&"}], "/@", "edistances"}], "]"}], ",", "First"}], "]"}], 
          ")"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"distancePairsGatheredCount", "=", 
         RowBox[{"Length", "[", "distancePairsGathered", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"uniqueEdgeDistances", "=", 
         RowBox[{"distancePairsGathered", "[", 
          RowBox[{"[", 
           RowBox[{";;", ",", "1", ",", "1"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
        "uniqueEdgeDistancesCount", "=", "distancePairsGatheredCount"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"pairToEdgeHash", "=", 
         RowBox[{"CreateDataStructure", "[", "\"\<HashTable\>\"", "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"pairToEdgeHash", "[", 
           RowBox[{"\"\<Insert\>\"", ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"#", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"#", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "2"}], "]"}], "]"}]}], "}"}], "\[Rule]", 
             RowBox[{"#", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}]}], "]"}], "&"}], "/@", 
         "edistances"}], ";", "\[IndentingNewLine]", 
        RowBox[{"pairToDistanceHash", "=", 
         RowBox[{"CreateDataStructure", "[", "\"\<HashTable\>\"", "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"pairToDistanceHash", "[", 
           RowBox[{"\"\<Insert\>\"", ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"#", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"#", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "2"}], "]"}], "]"}]}], "}"}], "\[Rule]", 
             RowBox[{"#", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], "&"}], "/@", 
         "edistances"}], ";", "\[IndentingNewLine]", 
        RowBox[{"pairToClassIndexHash", "=", 
         RowBox[{"CreateDataStructure", "[", "\"\<HashTable\>\"", "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"distanceToClassIndexHash", "=", 
         RowBox[{"CreateDataStructure", "[", "\"\<HashTable\>\"", "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"vertices", "=", 
         RowBox[{"Sort", "[", 
          RowBox[{"DeleteDuplicates", "[", 
           RowBox[{"Flatten", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"List", "@@", "#"}], ")"}], "&"}], "/@", 
             RowBox[{"edistances", "[", 
              RowBox[{"[", 
               RowBox[{";;", ",", "1"}], "]"}], "]"}]}], "]"}], "]"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"verticesCount", "=", 
         RowBox[{"Length", "[", "vertices", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"binCount", "=", 
         RowBox[{"Max", "[", 
          RowBox[{"1", ",", 
           RowBox[{"Round", "[", 
            RowBox[{"verticesCount", "/", "3"}], "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"plainEdgesQ", "=", 
         RowBox[{"(", 
          RowBox[{"estyle", "\[Equal]", "plainEdges"}], ")"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"huedEdgesQ", "=", 
         RowBox[{"(", 
          RowBox[{"estyle", "\[Equal]", "huedEdges"}], ")"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"edgeStyle", "=", 
         RowBox[{
         "\"\<unknown, defaulting to \\\"\>\"", "<>", "plainEdges", "<>", 
          "\"\<\\\"\>\""}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"plainEdgesQ", "||", "huedEdgesQ"}], ",", 
          RowBox[{"edgeStyle", "=", "estyle"}], ",", 
          RowBox[{"plainEdgesQ", "=", "True"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"fppQ", "=", 
         RowBox[{"NumberQ", "[", "labeled", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"fpp", "=", 
         RowBox[{"If", "[", 
          RowBox[{"fppQ", ",", 
           RowBox[{"Round", "[", "labeled", "]"}], ",", "0"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"fpp", ">", "0"}], ",", "\[IndentingNewLine]", 
          RowBox[{"labelQ", "=", "True"}], ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"TrueQ", "[", "labeled", "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Do", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"labelQ", "=", "True"}], ";", "\[IndentingNewLine]", 
               RowBox[{"fpp", "=", "defaultFpp"}], ";", "\[IndentingNewLine]", 
               RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "1"}], "]"}],
             ",", "\[IndentingNewLine]", 
            RowBox[{"labelQ", "=", "False"}]}], "\[IndentingNewLine]", 
           "]"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"distancelimitNaN", "=", 
         RowBox[{"!", 
          RowBox[{"NumberQ", "[", "distancelimit", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"!", 
              RowBox[{"NumberQ", "[", "distancelimit", "]"}]}], ")"}], "&&", 
            RowBox[{"(", 
             RowBox[{"distancelimit", "\[NotEqual]", "\[Infinity]"}], ")"}]}],
            ")"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Do", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"distancelimitStr", "=", 
              RowBox[{"ToString", "[", "distancelimit", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"assignedlimit", ",", "requestedlimit"}], "}"}], "=", 
              RowBox[{"{", 
               RowBox[{"0", ",", "distancelimitStr"}], "}"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "1"}], "]"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"Which", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"distancelimit", "\[Equal]", "\[Infinity]"}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"assignedlimit", ",", "requestedlimit"}], "}"}], "=", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"absoluteMinMax", "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", "distancelimit"}], 
              "}"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"distancelimit", "<", "0"}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"assignedlimit", ",", "requestedlimit"}], "}"}], "=", 
             RowBox[{"{", 
              RowBox[{"0", ",", "distancelimit"}], "}"}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"distancelimit", ">", 
             RowBox[{"absoluteMinMax", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"assignedlimit", ",", "requestedlimit"}], "}"}], "=", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"absoluteMinMax", "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", "distancelimit"}], 
              "}"}]}], ",", "\[IndentingNewLine]", "True", ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"assignedlimit", ",", "requestedlimit"}], "}"}], "=", 
             RowBox[{"{", 
              RowBox[{"distancelimit", ",", "distancelimit"}], "}"}]}]}], 
           "]"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"t", "=", "1"}], ";", "\[IndentingNewLine]", 
        RowBox[{"While", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"assignedlimit", "\[GreaterEqual]", 
              RowBox[{"uniqueEdgeDistances", "[", 
               RowBox[{"[", "t", "]"}], "]"}]}], ")"}], "&&", 
            RowBox[{"(", 
             RowBox[{"t", "<", "uniqueEdgeDistancesCount"}], ")"}]}], ")"}], 
          ",", 
          RowBox[{"t", "++"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"assignedlimit", "\[Equal]", 
           RowBox[{"uniqueEdgeDistances", "[", 
            RowBox[{"[", "t", "]"}], "]"}]}], ",", 
          RowBox[{"triallimit", "=", "t"}], ",", 
          RowBox[{"triallimit", "=", 
           RowBox[{"t", "-", "1"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Which", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "verbose", "]"}], "\[Equal]", "0"}], ",", 
          RowBox[{"Which", "[", 
           RowBox[{
            RowBox[{"!", 
             RowBox[{"BooleanQ", "[", "verbose", "]"}]}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"showclasses", ",", "showLBG", ",", "showprogress"}], 
              "}"}], "=", 
             RowBox[{"{", 
              RowBox[{"False", ",", "False", ",", "True"}], "}"}]}], ",", 
            "\[IndentingNewLine]", "verbose", ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"showclasses", ",", "showLBG", ",", "showprogress"}], 
              "}"}], "=", 
             RowBox[{"{", 
              RowBox[{"True", ",", "True", ",", "True"}], "}"}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"!", "verbose"}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"showclasses", ",", "showLBG", ",", "showprogress"}], 
              "}"}], "=", 
             RowBox[{"{", 
              RowBox[{"False", ",", "False", ",", "False"}], "}"}]}]}], "]"}],
           ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Length", "[", "verbose", "]"}], "\[Equal]", "3"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"showclasses", ",", "showLBG", ",", "showprogress"}], 
            "}"}], "=", "verbose"}], ",", "\[IndentingNewLine]", "True", ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"showclasses", ",", "showLBG", ",", "showprogress"}], 
            "}"}], "=", 
           RowBox[{"{", 
            RowBox[{"False", ",", "False", ",", "True"}], "}"}]}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
           "Print", "[", "\"\<LeastBridgesPartitionedEdges:\>\"", "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<verbose = \>\"", ",", "verbose"}], "]"}],
            ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<showclasses = \>\"", ",", 
             "showclasses"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<showLBG = \>\"", ",", "showLBG"}], 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<showprogress = \>\"", ",", 
             "showprogress"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<edge count = \>\"", ",", "edgeCount"}], 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<edge distances min/max = \>\"", ",", 
             "absoluteMinMax"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<unique distances = \>\"", ",", 
             "distancePairsGatheredCount"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<vertex count = \>\"", ",", 
             "verticesCount"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<computed bin count = \>\"", ",", 
             "binCount"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<edge style = \>\"", ",", "edgeStyle"}], 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<label edges = \>\"", ",", "labeled"}], 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<label requested = \>\"", ",", 
             "labelQ"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<fpp supplied = \>\"", ",", "fppQ"}], 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<fpp value = \>\"", ",", "fpp"}], 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\>\"", ",", "\"\<distance limit = \>\"", ",", 
             "assignedlimit"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"assignedlimit", "\[NotEqual]", "requestedlimit"}], ",", 
             RowBox[{"Print", "[", 
              RowBox[{
              "\"\<\\t\\t\>\"", ",", "\"\<requested distance limit (\>\"", 
               ",", "requestedlimit", ",", "\"\<) modified\>\""}], "]"}]}], 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<\\t\\t\>\"", ",", "\"\<trial limit = \>\"", ",", 
             "triallimit", ",", "\"\< of \>\"", ",", 
             "uniqueEdgeDistancesCount", ",", "\"\< possible\>\""}], "]"}], 
           ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"distance", " ", "classes"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<\\t\>\"", ",", "\"\<processing distance classes\>\""}], 
           "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"absoluteMinMax", "=", 
         RowBox[{"MinMax", "[", 
          RowBox[{"edistances", "[", 
           RowBox[{"[", 
            RowBox[{";;", ",", "2"}], "]"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"plainEdgesQ", ",", "\[IndentingNewLine]", 
          RowBox[{"Do", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"hues", "=", 
              RowBox[{"{", "Black", "}"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"partitions", "=", "absoluteMinMax"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"pairToClassIndexHash", "[", 
                RowBox[{"\"\<Insert\>\"", ",", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "2"}], "]"}], "]"}]}], "}"}], "\[Rule]",
                   "1"}]}], "]"}], "&"}], "/@", "edistances"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "1"}], "]"}], 
          ",", "\[IndentingNewLine]", "    ", 
          RowBox[{"(*", " ", "else", " ", "*)"}], "\[IndentingNewLine]", 
          RowBox[{"Do", "[", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", "initialization", " ", "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"partitions", "=", 
              RowBox[{"{", 
               RowBox[{"absoluteMinMax", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "}"}]}], ";", "  ", 
             RowBox[{"(*", " ", "initialization", " ", "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"processedVertices", "=", 
              RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"processedVerticesCount", "=", "0"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"remainingEdgeData", "=", "edistances"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"remainingEdgeDataCount", "=", 
              RowBox[{"Length", "[", "remainingEdgeData", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"theseDistances", "=", 
              RowBox[{"remainingEdgeData", "[", 
               RowBox[{"[", 
                RowBox[{";;", ",", "2"}], "]"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"theseDistancesCount", "=", 
              RowBox[{"Length", "[", "theseDistances", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"theseDistancesMinMax", "=", "absoluteMinMax"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"overallMin", "=", 
              RowBox[{"absoluteMinMax", "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"overallMax", "=", 
              RowBox[{"absoluteMinMax", "[", 
               RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"theseDistancesMean", "=", 
              RowBox[{"Mean", "[", "theseDistances", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"binWidth", "=", 
              RowBox[{"N", "[", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"overallMax", "-", "overallMin"}], ")"}], "/", 
                "binCount"}], "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"binPartitionsCount", "=", 
              RowBox[{
               RowBox[{"Round", "[", 
                RowBox[{
                 RowBox[{"IntegerPart", "[", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"overallMax", "-", "overallMin"}], ")"}], "/", 
                   "binWidth"}], "]"}], "+", "1"}], "]"}], "+", "1"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"binPartitions", "=", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"overallMin", "+", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"b", "-", "1"}], ")"}], "*", "binWidth"}], 
                  ")"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"b", ",", "1", ",", "binPartitionsCount"}], "}"}]}], 
               "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"binsCenters", "=", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"Mean", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"binPartitions", "[", 
                    RowBox[{"[", 
                    RowBox[{"b", "-", "1"}], "]"}], "]"}], ",", 
                   RowBox[{"binPartitions", "[", 
                    RowBox[{"[", "b", "]"}], "]"}]}], "}"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"b", ",", "2", ",", "binPartitionsCount"}], "}"}]}], 
               "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"binsCentersCount", "=", 
              RowBox[{"Length", "[", "binsCenters", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"binTallies", "=", 
              RowBox[{"BinCounts", "[", 
               RowBox[{"theseDistances", ",", 
                RowBox[{"{", "binPartitions", "}"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"binTalliesCount", "=", 
              RowBox[{"Length", "[", "binTallies", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"binsXY", "=", 
              RowBox[{"Thread", "[", 
               RowBox[{"List", "[", 
                RowBox[{"binsCenters", ",", "binTallies"}], "]"}], "]"}]}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{"showclasses", ",", "\[IndentingNewLine]", 
               RowBox[{"Print", "[", "\[IndentingNewLine]", 
                RowBox[{
                "\"\<\\t\\t\>\"", ",", "\"\<\[Bullet] initialization\\n\>\"", 
                 ",", "\[IndentingNewLine]", "\"\<\\t\\t\\t\>\"", ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"ListPlot", "[", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], ",", 
                    "Nothing", ",", "#"}], "]"}], "&"}], "/@", "binsXY"}], 
                    ")"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "overallMax"}], "}"}], ",", "All"}], 
                    "}"}]}], ",", "\[IndentingNewLine]", 
                   RowBox[{"PlotStyle", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Black", ",", 
                    RowBox[{"PointSize", "[", "0.025", "]"}]}], "}"}]}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"AxesStyle", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Black", ",", "11"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Black", ",", "11"}], "}"}]}], "}"}]}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Ticks", "\[Rule]", "Automatic"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"AxesLabel", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<bin \[Mu]\>\"", ",", 
                    RowBox[{"{", 
                    RowBox[{"Black", ",", "11"}], "}"}]}], "]"}], ",", 
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<count\>\"", ",", 
                    RowBox[{"{", 
                    RowBox[{"Black", ",", "11"}], "}"}]}], "]"}]}], "}"}]}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"PlotLabel", "\[Rule]", 
                    RowBox[{"Column", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<Distance distribution of complete graph\>\"", ",", 
                    RowBox[{"{", 
                    RowBox[{"Black", ",", "12"}], "}"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Style", "[", 
                    RowBox[{
                    RowBox[{"\"\<binWidth \[TildeTilde] \>\"", "<>", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"SetPrecision", "[", 
                    RowBox[{"binWidth", ",", "3"}], "]"}], "]"}], "<>", 
                    "\"\<,  mean \[TildeTilde] \>\"", "<>", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"SetPrecision", "[", 
                    RowBox[{"theseDistancesMean", ",", "3"}], "]"}], "]"}]}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{"Black", ",", "11"}], "}"}]}], "]"}]}], 
                    "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
                    "Center", ",", "0.5"}], "]"}]}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"256", ",", "Automatic"}], "}"}]}]}], 
                  "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
                "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"r", "=", "4"}], ";", "\[IndentingNewLine]", 
             RowBox[{"c", "=", "0"}], ";", "  ", 
             RowBox[{"(*", " ", 
              RowBox[{"class", " ", "iteration", " ", "count"}], " ", "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"While", "[", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"processedVerticesCount", "<", "verticesCount"}], 
                  ")"}], "&&", 
                 RowBox[{"(", 
                  RowBox[{"remainingEdgeDataCount", ">", "0"}], ")"}]}], 
                ")"}], ",", "\[IndentingNewLine]", 
               RowBox[{"Do", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{
                  RowBox[{"c", "++"}], ";", "\[IndentingNewLine]", 
                  RowBox[{"If", "[", 
                   RowBox[{"showclasses", ",", 
                    RowBox[{"Print", "[", 
                    RowBox[{
                    "\"\<\\t\\t\>\"", ",", 
                    "\"\<\[Bullet] class iteration: \>\"", ",", "c"}], 
                    "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
                  RowBox[{"(*", " ", 
                   RowBox[{
                   "1.", " ", "Get", " ", "the", " ", "nearest", " ", 
                    "neighbors"}], " ", "*)"}], "\[IndentingNewLine]", 
                  RowBox[{"remainingVerticesCount", "=", 
                   RowBox[{"verticesCount", "-", "processedVerticesCount"}]}],
                   ";", "\[IndentingNewLine]", 
                  RowBox[{"distancesHash", "=", 
                   RowBox[{
                   "CreateDataStructure", "[", "\"\<HashTable\>\"", "]"}]}], 
                  ";", " ", 
                  RowBox[{"(*", " ", 
                   RowBox[{
                   "unique", " ", "edges", " ", "are", " ", "retained", " ", 
                    "in", " ", "remainingEdgeData"}], " ", "*)"}], 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"distancesHash", "[", 
                    RowBox[{"\"\<Insert\>\"", ",", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "\[Rule]", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], "&"}], "/@", 
                   "remainingEdgeData"}], ";", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"distancesHash", "[", 
                    RowBox[{"\"\<KeyExistsQ\>\"", ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}], ",", "Nothing", 
                    ",", 
                    RowBox[{"distancesHash", "[", 
                    RowBox[{"\"\<Insert\>\"", ",", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "\[Rule]", 
                    RowBox[{"distancesHash", "[", 
                    RowBox[{"\"\<Lookup\>\"", ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}]}], "]"}]}], 
                    "]"}], "&"}], "/@", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"DirectedGraphQ", "[", 
                    RowBox[{"Graph", "[", "#", "]"}], "]"}], ",", "Nothing", 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Head", "[", "#", "]"}], "@@", 
                    RowBox[{"Reverse", "[", 
                    RowBox[{"List", "@@", "#"}], "]"}]}], ",", "#"}], "}"}]}],
                     "]"}], "&"}], "/@", 
                    RowBox[{"distancesHash", "[", "\"\<Keys\>\"", "]"}]}], 
                    ")"}]}], ";", "\[IndentingNewLine]", 
                  RowBox[{"distancesHashCount", "=", 
                   RowBox[{"distancesHash", "[", "\"\<Length\>\"", "]"}]}], 
                  ";", "\[IndentingNewLine]", 
                  RowBox[{"vertexOrderedDistances", "=", 
                   RowBox[{"Sort", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{"distancesHash", "[", 
                    RowBox[{"\"\<Lookup\>\"", ",", "#"}], "]"}]}], "}"}], 
                    "&"}], "/@", 
                    RowBox[{"distancesHash", "[", "\"\<Keys\>\"", "]"}]}], 
                    "]"}]}], ";", "\[IndentingNewLine]", 
                  RowBox[{"distancesGatheredByVertices", "=", 
                   RowBox[{"GatherBy", "[", 
                    RowBox[{"vertexOrderedDistances", ",", "First"}], "]"}]}],
                   ";", "\[IndentingNewLine]", 
                  RowBox[{"firstOrderNeighborDistancesData", "=", 
                   RowBox[{"Sort", "[", 
                    RowBox[{
                    RowBox[{"Flatten", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"First", "[", 
                    RowBox[{"GatherBy", "[", 
                    RowBox[{
                    RowBox[{"Sort", "[", 
                    RowBox[{"#", ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#1", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "<", 
                    RowBox[{"#2", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ")"}], "&"}]}], "]"}], 
                    ",", "Last"}], "]"}], "]"}], "&"}], "/@", 
                    "distancesGatheredByVertices"}], ",", "1"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#1", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "<", 
                    RowBox[{"#2", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ")"}], "&"}]}], "]"}]}],
                   ";", "\[IndentingNewLine]", 
                  RowBox[{"(*", " ", 
                   RowBox[{
                   "2.", " ", "Compute", " ", "the", " ", "bin", " ", 
                    "data"}], " ", "*)"}], "\[IndentingNewLine]", 
                  RowBox[{"theseDistances", "=", 
                   RowBox[{"firstOrderNeighborDistancesData", "[", 
                    RowBox[{"[", 
                    RowBox[{";;", ",", "3"}], "]"}], "]"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"theseDistancesCount", "=", 
                   RowBox[{"Length", "[", "theseDistances", "]"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"theseDistancesMinMax", "=", 
                   RowBox[{"MinMax", "[", "theseDistances", "]"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"theseDistancesMean", "=", 
                   RowBox[{"Mean", "[", "theseDistances", "]"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"binPartitionsCount", "=", 
                   RowBox[{
                    RowBox[{"Round", "[", 
                    RowBox[{
                    RowBox[{"IntegerPart", "[", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"theseDistancesMinMax", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", 
                    RowBox[{"theseDistances", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
                    "binWidth"}], "]"}], "+", "1"}], "]"}], "+", "1"}]}], ";",
                   "\[IndentingNewLine]", 
                  RowBox[{"binPartitions", "=", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"theseDistances", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "+", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"b", "-", "1"}], ")"}], "*", "binWidth"}], 
                    ")"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"b", ",", "1", ",", "binPartitionsCount"}], 
                    "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
                  RowBox[{"binsCenters", "=", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"Mean", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"binPartitions", "[", 
                    RowBox[{"[", 
                    RowBox[{"b", "-", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"binPartitions", "[", 
                    RowBox[{"[", "b", "]"}], "]"}]}], "}"}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"b", ",", "2", ",", "binPartitionsCount"}], 
                    "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
                  RowBox[{"binsCentersCount", "=", 
                   RowBox[{"Length", "[", "binsCenters", "]"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"binTallies", "=", 
                   RowBox[{"BinCounts", "[", 
                    RowBox[{"theseDistances", ",", 
                    RowBox[{"{", "binPartitions", "}"}]}], "]"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"binTalliesCount", "=", 
                   RowBox[{"Length", "[", "binTallies", "]"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"binsXY", "=", 
                   RowBox[{"Thread", "[", 
                    RowBox[{"List", "[", 
                    RowBox[{"binsCenters", ",", "binTallies"}], "]"}], 
                    "]"}]}], ";", "\[IndentingNewLine]", 
                  RowBox[{"binTallyMax", "=", 
                   RowBox[{"Max", "[", "binTallies", "]"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"binsYupperB", "=", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Mod", "[", 
                    RowBox[{"binTallyMax", ",", "5"}], "]"}], "\[Equal]", 
                    "0"}], ",", 
                    RowBox[{"binTallyMax", "+", "2"}], ",", 
                    RowBox[{
                    RowBox[{"Round", "[", 
                    RowBox[{
                    RowBox[{"binTallyMax", "+", "2.5"}], ",", "5"}], "]"}], 
                    "+", "2"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
                  RowBox[{"If", "[", 
                   RowBox[{"showclasses", ",", "\[IndentingNewLine]", 
                    RowBox[{"Print", "[", "\[IndentingNewLine]", 
                    RowBox[{"\"\<\\t\\t\\t\>\"", ",", "\[IndentingNewLine]", 
                    RowBox[{"ListPlot", "[", "\[IndentingNewLine]", 
                    RowBox[{"binsXY", ",", "\[IndentingNewLine]", 
                    RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "overallMax"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "binsYupperB"}], "}"}]}], "}"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"PlotStyle", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Black", ",", 
                    RowBox[{"PointSize", "[", "0.025", "]"}]}], "}"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AxesStyle", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Black", ",", "11"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Black", ",", "11"}], "}"}]}], "}"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Ticks", "\[Rule]", "Automatic"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AxesLabel", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<bin \[Mu]\>\"", ",", 
                    RowBox[{"{", 
                    RowBox[{"Black", ",", "11"}], "}"}]}], "]"}], ",", 
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<count\>\"", ",", 
                    RowBox[{"{", 
                    RowBox[{"Black", ",", "11"}], "}"}]}], "]"}]}], "}"}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"PlotLabel", "\[Rule]", 
                    RowBox[{"Column", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<1st order nearest neighbor distances\>\"", ",", 
                    RowBox[{"{", 
                    RowBox[{"Black", ",", "12"}], "}"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Style", "[", 
                    RowBox[{
                    RowBox[{"\"\<of \>\"", "<>", 
                    RowBox[{"Which", "[", 
                    RowBox[{
                    RowBox[{"c", "\[Equal]", "1"}], ",", "\"\<all \>\"", ",", 
                    "True", ",", "\"\<remaining \>\""}], "]"}], "<>", 
                    RowBox[{"ToString", "[", "remainingVerticesCount", "]"}], 
                    "<>", "\"\< vertices\>\""}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Black", ",", "12"}], "}"}]}], "]"}]}], 
                    "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
                    "Center", ",", "0.5"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"256", ",", "Automatic"}], "}"}]}]}], 
                    "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
                    "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"(*", " ", 
                   RowBox[{
                   "capture", " ", "leading", " ", "subdistribution"}], " ", 
                   "*)"}], "\[IndentingNewLine]", 
                  RowBox[{"b", "=", "1"}], ";", "\[IndentingNewLine]", 
                  RowBox[{"trend", "=", "0"}], ";", "\[IndentingNewLine]", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"binTalliesCount", ">", "1"}], ",", "  ", 
                    RowBox[{"(*", " ", 
                    RowBox[{
                    "We", " ", "are", " ", "walking", " ", "through", " ", 
                    RowBox[{"binTallies", "."}]}], " ", "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"Do", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"walking", "=", "True"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"priorTrend", "=", "0"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"beenDown", "=", "False"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"beenUp", "=", "False"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"While", "[", 
                    RowBox[{
                    RowBox[{"walking", " ", "&&", " ", 
                    RowBox[{"(", 
                    RowBox[{"b", "<", "binTalliesCount"}], ")"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Do", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"b", "++"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"trend", "=", 
                    RowBox[{"Which", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"binTallies", "[", 
                    RowBox[{"[", "b", "]"}], "]"}], ">", 
                    RowBox[{"binTallies", "[", 
                    RowBox[{"[", 
                    RowBox[{"b", "-", "1"}], "]"}], "]"}]}], ",", "1", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"binTallies", "[", 
                    RowBox[{"[", "b", "]"}], "]"}], "\[Equal]", 
                    RowBox[{"binTallies", "[", 
                    RowBox[{"[", 
                    RowBox[{"b", "-", "1"}], "]"}], "]"}]}], ",", "0", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"binTallies", "[", 
                    RowBox[{"[", "b", "]"}], "]"}], "<", 
                    RowBox[{"binTallies", "[", 
                    RowBox[{"[", 
                    RowBox[{"b", "-", "1"}], "]"}], "]"}]}], ",", 
                    RowBox[{"-", "1"}]}], "\[IndentingNewLine]", "]"}]}], ";",
                     "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"trend", "\[Equal]", "1"}], ")"}], "&&", 
                    RowBox[{"(", 
                    RowBox[{"trend", ">", "priorTrend"}], ")"}], "&&", 
                    RowBox[{"(", 
                    RowBox[{"beenUp", "||", "beenDown"}], ")"}]}], ",", 
                    RowBox[{"walking", "=", "False"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"trend", "\[Equal]", 
                    RowBox[{"-", "1"}]}], ")"}], "&&", 
                    RowBox[{"(", 
                    RowBox[{"!", "beenDown"}], ")"}]}], ",", 
                    RowBox[{"beenDown", "=", "True"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"trend", "\[Equal]", "1"}], ")"}], "&&", 
                    RowBox[{"(", 
                    RowBox[{"!", "beenUp"}], ")"}]}], ",", 
                    RowBox[{"beenUp", "=", "True"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"priorTrend", "=", "trend"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "1"}], 
                    "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "1"}], 
                    "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"bFinal", "=", 
                   RowBox[{"Max", "[", 
                    RowBox[{"1", ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"b", "\[Equal]", "binTalliesCount"}], ")"}], "&&", 
                    RowBox[{"(", 
                    RowBox[{"trend", "\[Equal]", 
                    RowBox[{"-", "1"}]}], ")"}]}], ")"}], ",", "b", ",", 
                    RowBox[{"b", "-", "1"}]}], "]"}]}], "]"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"upperBound", "=", 
                   RowBox[{"binPartitions", "[", 
                    RowBox[{"[", 
                    RowBox[{"bFinal", "+", "1"}], "]"}], "]"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"AppendTo", "[", 
                   RowBox[{"partitions", ",", "upperBound"}], "]"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"(*", " ", 
                   RowBox[{
                    RowBox[{
                    "find", " ", "the", " ", "vertices", " ", "with", " ", 
                    "an", " ", "edge", " ", "length"}], " ", "<", " ", 
                    "upperBound"}], " ", "*)"}], "\[IndentingNewLine]", 
                  RowBox[{"distanceClass", "=", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "<", "upperBound"}], 
                    ")"}], "&&", 
                    RowBox[{"(", 
                    RowBox[{"!", 
                    RowBox[{"MemberQ", "[", 
                    RowBox[{"processedVertices", ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], ")"}]}], ")"}],
                     ",", "#", ",", "Nothing"}], "]"}], "&"}], "/@", 
                    "firstOrderNeighborDistancesData"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"distanceClassCount", "=", 
                   RowBox[{"Length", "[", "distanceClass", "]"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"classVertices", "=", 
                   RowBox[{"Sort", "[", 
                    RowBox[{"DeleteDuplicates", "[", 
                    RowBox[{"distanceClass", "[", 
                    RowBox[{"[", 
                    RowBox[{";;", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
                  ";", "\[IndentingNewLine]", 
                  RowBox[{"classVerticesCount", "=", 
                   RowBox[{"Length", "[", "classVertices", "]"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"AppendTo", "[", 
                   RowBox[{"distanceClassVertices", ",", "classVertices"}], 
                   "]"}], ";", "\[IndentingNewLine]", 
                  RowBox[{"plotdistances", "=", 
                   RowBox[{"distanceClass", "[", 
                    RowBox[{"[", 
                    RowBox[{";;", ",", "3"}], "]"}], "]"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"binTallies", "=", 
                   RowBox[{"BinCounts", "[", 
                    RowBox[{"plotdistances", ",", 
                    RowBox[{"{", "binPartitions", "}"}]}], "]"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"binsXY", "=", 
                   RowBox[{"Thread", "[", 
                    RowBox[{"List", "[", 
                    RowBox[{"binsCenters", ",", "binTallies"}], "]"}], 
                    "]"}]}], ";", "\[IndentingNewLine]", 
                  RowBox[{"If", "[", 
                   RowBox[{"showclasses", ",", "\[IndentingNewLine]", 
                    RowBox[{"Print", "[", "\[IndentingNewLine]", 
                    RowBox[{"\"\<\\t\\t\\t\>\"", ",", "\[IndentingNewLine]", 
                    RowBox[{"ListPlot", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], ",", 
                    "Nothing", ",", "#"}], "]"}], "&"}], "/@", "binsXY"}], 
                    ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "overallMax"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "binsYupperB"}], "}"}]}], "}"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"PlotStyle", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Black", ",", 
                    RowBox[{"PointSize", "[", "0.025", "]"}]}], "}"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AxesStyle", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Black", ",", "11"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Black", ",", "11"}], "}"}]}], "}"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Ticks", "\[Rule]", "Automatic"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AxesLabel", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<bin \[Mu]\>\"", ",", 
                    RowBox[{"{", 
                    RowBox[{"Black", ",", "11"}], "}"}]}], "]"}], ",", 
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<count\>\"", ",", 
                    RowBox[{"{", 
                    RowBox[{"Black", ",", "11"}], "}"}]}], "]"}]}], "}"}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"PlotLabel", "\[Rule]", 
                    RowBox[{"Column", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    RowBox[{"\"\<Leading \>\"", "<>", 
                    RowBox[{"ToString", "[", "bFinal", "]"}], "<>", 
                    "\"\< bins, upper bound \[TildeTilde] \>\"", "<>", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"SetPrecision", "[", 
                    RowBox[{"upperBound", ",", "3"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Black", ",", "12"}], "}"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Style", "[", 
                    RowBox[{
                    RowBox[{"\"\<with \>\"", "<>", 
                    RowBox[{"ToString", "[", "classVerticesCount", "]"}], 
                    "<>", "\"\< vertices and \>\"", "<>", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"Length", "[", 
                    RowBox[{"DeleteDuplicates", "[", "plotdistances", "]"}], 
                    "]"}], "]"}], "<>", "\"\< unique distances\>\""}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Black", ",", "12"}], "}"}]}], "]"}]}], 
                    "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
                    "Center", ",", "0.5"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"256", ",", "Automatic"}], "}"}]}]}], 
                    "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
                    "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"(*", " ", 
                   RowBox[{
                   "update", " ", "the", " ", "recursive", " ", "files"}], 
                   " ", "*)"}], "\[IndentingNewLine]", 
                  RowBox[{"processedVertices", "=", 
                   RowBox[{"Sort", "[", 
                    RowBox[{"Join", "[", 
                    RowBox[{"processedVertices", ",", "classVertices"}], 
                    "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
                  RowBox[{"remainingEdgeData", "=", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{"classVertices", ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "]"}], "||", 
                    RowBox[{"MemberQ", "[", 
                    RowBox[{"classVertices", ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "2"}], "]"}], "]"}]}], "]"}]}], ",", 
                    "Nothing", ",", "#"}], "]"}], "&"}], "/@", 
                    "remainingEdgeData"}]}], ";", "\[IndentingNewLine]", 
                  RowBox[{"distanceClasses", "=", 
                   RowBox[{"AppendTo", "[", 
                    RowBox[{"distanceClasses", ",", "distanceClass"}], 
                    "]"}]}], ";", "\[IndentingNewLine]", 
                  RowBox[{"processedVerticesCount", "=", 
                   RowBox[{"Length", "[", "processedVertices", "]"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"remainingEdgeDataCount", "=", 
                   RowBox[{"Length", "[", "remainingEdgeData", "]"}]}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "1"}], 
                "]"}]}], "\[IndentingNewLine]", "]"}], ";", " ", 
             RowBox[{"(*", " ", 
              RowBox[{"end", " ", "While"}], " ", "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"c", "\[Equal]", "1"}], ",", 
               RowBox[{"partitions", "=", "binPartitions"}]}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Last", "[", "partitions", "]"}], "\[NotEqual]", 
                "overallMax"}], ",", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"partitions", ",", "overallMax"}], "]"}]}], "]"}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"partitionsCount", "=", 
              RowBox[{"Length", "[", "partitions", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{"assign", " ", "the", " ", "class", " ", "indices"}], 
              " ", "*)"}], "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{"showclasses", ",", 
               RowBox[{"Print", "[", 
                RowBox[{
                "\"\<\\t\\t\>\"", ",", 
                 "\"\<\[Bullet] assigning class indices\>\""}], "]"}]}], 
              "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"Do", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"thisDistance", "=", 
                 RowBox[{"pairToDistanceHash", "[", 
                  RowBox[{"\"\<Lookup\>\"", ",", "pair"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"c", "=", "1"}], ";", "\[IndentingNewLine]", 
                RowBox[{"While", "[", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"c", "<", "partitionsCount"}], ")"}], "&&", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"partitions", "[", 
                    RowBox[{"[", 
                    RowBox[{"c", "+", "1"}], "]"}], "]"}], "\[LessEqual]", 
                    "thisDistance"}], ")"}]}], ")"}], ",", 
                  RowBox[{"c", "++"}]}], "]"}], ";", "\[IndentingNewLine]", 
                RowBox[{"pairToClassIndexHash", "[", 
                 RowBox[{"\"\<Insert\>\"", ",", 
                  RowBox[{"pair", "\[Rule]", "c"}]}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"distanceToClassIndexHash", "[", 
                 RowBox[{"\"\<Insert\>\"", ",", 
                  RowBox[{"thisDistance", "\[Rule]", "c"}]}], "]"}], ";", " ", 
                RowBox[{"(*", " ", 
                 RowBox[{"cross", "-", 
                  RowBox[{"check", " ", "of", " ", "assignment"}]}], " ", 
                 "*)"}], "\[IndentingNewLine]", 
                RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"pair", ",", 
                 RowBox[{"pairToDistanceHash", "[", "\"\<Keys\>\"", "]"}]}], 
                "}"}]}], "\[IndentingNewLine]", "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{
               RowBox[{"Print", "[", 
                RowBox[{
                "\"\<\\t\\t\>\"", ",", "\"\<distanceToClassIndexHash = \>\"", 
                 ",", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"#", ",", 
                    RowBox[{"distanceToClassIndexHash", "[", 
                    RowBox[{"\"\<Lookup\>\"", ",", "#"}], "]"}]}], "}"}], 
                   "&"}], "/@", 
                  RowBox[{"Sort", "[", 
                   RowBox[{
                   "distanceToClassIndexHash", "[", "\"\<Keys\>\"", "]"}], 
                   "]"}]}]}], "]"}], ";"}], " ", "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{"assign", " ", "the", " ", "hues"}], " ", "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"np", "=", 
              RowBox[{"Max", "[", 
               RowBox[{"1", ",", 
                RowBox[{"partitionsCount", "-", "3"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"hinc", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"hmax", "-", "hmin"}], ")"}], "/", "np"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"hValues", "=", 
              RowBox[{"Table", "[", 
               RowBox[{"h", ",", 
                RowBox[{"{", 
                 RowBox[{"h", ",", "hmin", ",", "hmax", ",", "hinc"}], 
                 "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{
               RowBox[{"AppendTo", "[", 
                RowBox[{"hValues", ",", "hsup"}], "]"}], ";"}], " ", "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"hues", "=", 
              RowBox[{
               RowBox[{
                RowBox[{"Hue", "[", "#", "]"}], "&"}], "/@", "hValues"}]}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{"showprogress", ",", 
               RowBox[{"Print", "[", 
                RowBox[{
                "\"\<\\t\\t\>\"", ",", "\"\<hue values = \>\"", ",", 
                 "hValues"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "1"}], "]"}]}],
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", 
          RowBox[{"Print", "[", 
           RowBox[{"\"\<\\t\\t\>\"", ",", "\"\<hues = \>\"", ",", "hues"}], 
           "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<\\t\\t\>\"", ",", "\"\<partitions = \>\"", ",", 
            "partitions"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"least", " ", "bridge", " ", "graph", " ", "edges"}], " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<\\t\>\"", ",", "\"\<computing least bridge graph edges\>\""}],
            "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"trial", "=", "0"}], ";", "\[IndentingNewLine]", 
        RowBox[{"maxEdgeClass", "=", "0"}], ";", "\[IndentingNewLine]", 
        RowBox[{"annotatedEdges", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"graphEdgesCount", "=", "0"}], ";", "\[IndentingNewLine]", 
        RowBox[{"graphEdgesVertices", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"graphEdgesVerticesCount", "=", "0"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"graphComponents", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"{", "#", "}"}], "&"}], "/@", "vertices"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"graphComponentsCount", "=", 
         RowBox[{"Length", "[", "graphComponents", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"maps", " ", "vertex", " ", "to", " ", "component", " ", 
          RowBox[{"index", ".", " ", "reset"}], " ", "every", " ", 
          RowBox[{"trial", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"vertexComponentHash", "=", 
         RowBox[{"CreateDataStructure", "[", "\"\<HashTable\>\"", "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"threadedComponents", "=", 
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"graphComponents", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", ",", "j"}], "]"}], "]"}], ",", "i"}], "}"}], 
               ",", 
               RowBox[{"{", 
                RowBox[{"j", ",", "1", ",", 
                 RowBox[{"Length", "[", 
                  RowBox[{"graphComponents", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", "graphComponentsCount"}], "}"}]}], 
            "]"}], ",", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"vertexComponentHash", "[", 
           RowBox[{"\"\<Insert\>\"", ",", 
            RowBox[{
             RowBox[{"#", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "\[Rule]", 
             RowBox[{"#", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], "&"}], "/@", 
         "threadedComponents"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
          "a", " ", "set", " ", "of", " ", "every", " ", "edge", " ", "in", 
           " ", "the", " ", "graph"}], ",", " ", 
          RowBox[{
          "including", " ", "vertex", " ", "pairs", " ", "of", " ", 
           "directed", " ", "edges", " ", "and", " ", "both", " ", "vertex", 
           " ", "pairs", " ", 
           RowBox[{"(", 
            RowBox[{"forward", " ", "and", " ", "reverse"}], ")"}], " ", "of",
            " ", "undirected", " ", "edges"}]}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"graphPairsDegenerateSet", "=", 
         RowBox[{"CreateDataStructure", "[", "\"\<HashSet\>\"", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showLBG", ",", 
          RowBox[{"Print", "[", "\[IndentingNewLine]", 
           RowBox[{
           "\"\<\\t\\t\>\"", ",", "\"\<\[Bullet] trial iteration: \>\"", ",", 
            "trial", ",", "\"\<\\n\>\"", ",", "\[IndentingNewLine]", 
            "\"\<\\t\\t\\t\>\"", ",", "\"\<components = \>\"", ",", 
            "graphComponentsCount", ",", "\"\<\\n\>\"", ",", 
            "\[IndentingNewLine]", "\"\<\\t\\t\\t\>\"", ",", 
            "\"\<distance pair sets = \>\"", ",", 
            "distancePairsGatheredCount"}], "\[IndentingNewLine]", "]"}]}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"While", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"graphComponentsCount", ">", "1"}], ")"}], "||", 
             RowBox[{"(", 
              RowBox[{"graphEdgesVerticesCount", "<", "verticesCount"}], 
              ")"}]}], ")"}], "&&", 
           RowBox[{"(", 
            RowBox[{"trial", "<", "triallimit"}], ")"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Do", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"trial", "++"}], ";", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{"showLBG", ",", 
               RowBox[{"Print", "[", 
                RowBox[{
                "\"\<\\t\\t\>\"", ",", "\"\<\[Bullet] trial iteration: \>\"", 
                 ",", "trial"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"priorGraphEdgesCount", "=", "graphEdgesCount"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"trialSelections", "=", 
              RowBox[{"distancePairsGathered", "[", 
               RowBox[{"[", "trial", "]"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"trialPairs", "=", 
              RowBox[{"trialSelections", "[", 
               RowBox[{"[", 
                RowBox[{";;", ",", "2"}], "]"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"trialPairsCount", "=", 
              RowBox[{"Length", "[", "trialPairs", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"trialPairsDistance", "=", 
              RowBox[{"pairToDistanceHash", "[", 
               RowBox[{"\"\<Lookup\>\"", ",", 
                RowBox[{"trialPairs", "[", 
                 RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{"showprogress", ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"Print", "[", 
                 RowBox[{
                 "\"\<\\t\\t\\t\>\"", ",", "\"\<trial pairs count = \>\"", 
                  ",", "trialPairsCount"}], "]"}], ";", "\[IndentingNewLine]", 
                RowBox[{"Print", "[", 
                 RowBox[{
                 "\"\<\\t\\t\\t\>\"", ",", "\"\<trial pairs distance = \>\"", 
                  ",", "trialPairsDistance"}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"Print", "[", 
                 RowBox[{
                 "\"\<\\t\\t\\t\>\"", ",", "\"\<trialPairs = \>\"", ",", 
                  "trialPairs"}], "]"}], ";"}]}], "\[IndentingNewLine]", 
              "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"Do", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"thisPair", "=", 
                 RowBox[{"trialPairs", "[", 
                  RowBox[{"[", "p", "]"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"notDegenerate", "=", 
                 RowBox[{"!", 
                  RowBox[{"graphPairsDegenerateSet", "[", 
                   RowBox[{"\"\<MemberQ\>\"", ",", "thisPair"}], "]"}]}]}], 
                ";", "\[IndentingNewLine]", 
                RowBox[{"v1component", "=", 
                 RowBox[{"vertexComponentHash", "[", 
                  RowBox[{"\"\<Lookup\>\"", ",", 
                   RowBox[{"thisPair", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"v2component", "=", 
                 RowBox[{"vertexComponentHash", "[", 
                  RowBox[{"\"\<Lookup\>\"", ",", 
                   RowBox[{"thisPair", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], ";", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", "notDegenerate", ")"}], "&&", 
                   RowBox[{"(", 
                    RowBox[{"v1component", "\[NotEqual]", "v2component"}], 
                    ")"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"Do", "[", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"thisEdge", "=", 
                    RowBox[{"pairToEdgeHash", "[", 
                    RowBox[{"\"\<Lookup\>\"", ",", "thisPair"}], "]"}]}], ";",
                     "\[IndentingNewLine]", 
                    RowBox[{"thisClassIndex", "=", 
                    RowBox[{"pairToClassIndexHash", "[", 
                    RowBox[{"\"\<Lookup\>\"", ",", "thisPair"}], "]"}]}], ";",
                     "\[IndentingNewLine]", 
                    RowBox[{"maxEdgeClass", "=", 
                    RowBox[{"Max", "[", 
                    RowBox[{"maxEdgeClass", ",", "thisClassIndex"}], "]"}]}], 
                    ";", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Head", "[", "thisEdge", "]"}], "\[Equal]", 
                    RowBox[{"Head", "[", 
                    RowBox[{"0", "\[UndirectedEdge]", "0"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Do", "[", " ", 
                    RowBox[{"(*", " ", 
                    RowBox[{"unordered", " ", "edge"}], " ", "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{"labelQ", ",", "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"annotatedEdges", ",", 
                    RowBox[{"Annotation", "[", 
                    RowBox[{"thisEdge", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"EdgeLabels", "\[Rule]", 
                    RowBox[{"Placed", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    RowBox[{"SetPrecision", "[", 
                    RowBox[{"trialPairsDistance", ",", "fpp"}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Black", ",", "11"}], "}"}]}], "]"}], ",", 
                    "Automatic"}], "]"}]}], ",", 
                    RowBox[{"EdgeStyle", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Thickness", "[", "Medium", "]"}], ",", 
                    RowBox[{"Dashing", "[", 
                    RowBox[{"{", "}"}], "]"}], ",", 
                    RowBox[{"hues", "[", 
                    RowBox[{"[", "thisClassIndex", "]"}], "]"}]}], "}"}]}]}], 
                    "}"}]}], "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"annotatedEdges", ",", 
                    RowBox[{"Annotation", "[", 
                    RowBox[{"thisEdge", ",", 
                    RowBox[{"{", 
                    RowBox[{"EdgeStyle", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Thickness", "[", "Medium", "]"}], ",", 
                    RowBox[{"Dashing", "[", 
                    RowBox[{"{", "}"}], "]"}], ",", 
                    RowBox[{"hues", "[", 
                    RowBox[{"[", "thisClassIndex", "]"}], "]"}]}], "}"}]}], 
                    "}"}]}], "]"}]}], "]"}]}], "\[IndentingNewLine]", "]"}], 
                    ";", "\[IndentingNewLine]", 
                    RowBox[{"graphPairsDegenerateSet", "[", 
                    RowBox[{"\"\<Insert\>\"", ",", "thisPair"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"graphPairsDegenerateSet", "[", 
                    RowBox[{"\"\<Insert\>\"", ",", 
                    RowBox[{"Reverse", "[", "thisPair", "]"}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "1"}], 
                    "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Head", "[", "thisEdge", "]"}], "\[Equal]", 
                    RowBox[{"Head", "[", 
                    RowBox[{"0", "\[DirectedEdge]", "0"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Do", "[", " ", 
                    RowBox[{"(*", " ", 
                    RowBox[{"directed", " ", "edge"}], " ", "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{"labelQ", ",", "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"annotatedEdges", ",", 
                    RowBox[{"Annotation", "[", 
                    RowBox[{"thisEdge", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"EdgeLabels", "\[Rule]", 
                    RowBox[{"Placed", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    RowBox[{"SetPrecision", "[", 
                    RowBox[{"trialPairsDistance", ",", "fpp"}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Black", ",", "11"}], "}"}]}], "]"}], ",", 
                    "Automatic"}], "]"}]}], ",", 
                    RowBox[{"EdgeStyle", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Thickness", "[", "Medium", "]"}], ",", 
                    RowBox[{"Dashing", "[", 
                    RowBox[{"{", "}"}], "]"}], ",", 
                    RowBox[{"hues", "[", 
                    RowBox[{"[", "thisClassIndex", "]"}], "]"}]}], "}"}]}]}], 
                    "}"}]}], "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"annotatedEdges", ",", 
                    RowBox[{"Annotation", "[", 
                    RowBox[{"thisEdge", ",", 
                    RowBox[{"{", 
                    RowBox[{"EdgeStyle", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Thickness", "[", "Medium", "]"}], ",", 
                    RowBox[{"Dashing", "[", 
                    RowBox[{"{", "}"}], "]"}], ",", 
                    RowBox[{"hues", "[", 
                    RowBox[{"[", "thisClassIndex", "]"}], "]"}]}], "}"}]}], 
                    "}"}]}], "]"}]}], "]"}]}], "\[IndentingNewLine]", "]"}], 
                    ";", "\[IndentingNewLine]", 
                    RowBox[{"graphPairsDegenerateSet", "[", 
                    RowBox[{"\"\<Insert\>\"", ",", "thisPair"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "1"}], 
                    "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "1"}], 
                   "]"}]}], " ", 
                 RowBox[{"(*", " ", 
                  RowBox[{
                  "end", " ", "add", " ", "thisPair", " ", "to", " ", 
                   "graph"}], " ", "*)"}], "\[IndentingNewLine]", "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"p", ",", "1", ",", "trialPairsCount"}], "}"}]}], 
              "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"graphComponents", "=", 
              RowBox[{"ConnectedComponents", "[", 
               RowBox[{"UndirectedGraph", "[", "annotatedEdges", "]"}], 
               "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"graphComponentsCount", "=", 
              RowBox[{"Length", "[", "graphComponents", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"graphEdgesCount", "=", 
              RowBox[{"Length", "[", "annotatedEdges", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"trialEdgesCount", "=", 
              RowBox[{"graphEdgesCount", "-", "priorGraphEdgesCount"}]}], ";",
              "\[IndentingNewLine]", 
             RowBox[{"graphEdgesVertices", "=", 
              RowBox[{"Sort", "[", 
               RowBox[{"DeleteDuplicates", "[", 
                RowBox[{"Flatten", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"List", "@@", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "&"}], "/@", 
                  "annotatedEdges"}], "]"}], "]"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"graphEdgesVerticesCount", "=", 
              RowBox[{"Length", "[", "graphEdgesVertices", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"verticesComplements", "=", 
              RowBox[{"Complement", "[", 
               RowBox[{"vertices", ",", "graphEdgesVertices"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"verticesComplementsCount", "=", 
              RowBox[{"Length", "[", "verticesComplements", "]"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"pseudoComponents", "=", 
              RowBox[{"Join", "[", 
               RowBox[{"graphComponents", ",", 
                RowBox[{
                 RowBox[{
                  RowBox[{"{", "#", "}"}], "&"}], "/@", 
                 "verticesComplements"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"pseudoComponentsCount", "=", 
              RowBox[{"Length", "[", "pseudoComponents", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"vertexComponentHash", "=", 
              RowBox[{
              "CreateDataStructure", "[", "\"\<HashTable\>\"", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"threadedComponents", "=", 
              RowBox[{"Flatten", "[", 
               RowBox[{
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"Table", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"pseudoComponents", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j"}], "]"}], "]"}], ",", "i"}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{"j", ",", "1", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"pseudoComponents", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
                  ",", 
                  RowBox[{"{", 
                   RowBox[{"i", ",", "1", ",", "pseudoComponentsCount"}], 
                   "}"}]}], "]"}], ",", "1"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"vertexComponentHash", "[", 
                RowBox[{"\"\<Insert\>\"", ",", 
                 RowBox[{
                  RowBox[{"#", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "\[Rule]", 
                  RowBox[{"#", "[", 
                   RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], "&"}], "/@", 
              "threadedComponents"}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "1"}], "]"}]}],
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<\\t\\t\>\"", ",", "\"\<completed \>\"", ",", "trial", ",", 
            "\"\< trials.\>\""}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<\\t\\t\>\"", ",", "\"\<graph edges count = \>\"", ",", 
            "graphEdgesCount"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<\\t\\t\>\"", ",", "\"\<graph vertices count = \>\"", ",", 
            "graphEdgesVerticesCount"}], "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"showprogress", ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<\\t\\t\>\"", ",", "\"\<maxEdgeClass = \>\"", ",", 
            "maxEdgeClass"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"hues", ",", "partitions", ",", 
          RowBox[{"Sort", "[", "annotatedEdges", "]"}]}], "}"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.8048894328314266`*^9, 3.8048894997893095`*^9}, 
   3.8048932504914227`*^9, 3.8048932855556264`*^9, 3.8048933200387383`*^9, {
   3.8049787200358596`*^9, 3.804978723801437*^9}, {3.804978767722407*^9, 
   3.8049788118152714`*^9}, {3.8053053803429146`*^9, 
   3.8053053877333555`*^9}, {3.8053054803528347`*^9, 
   3.8053055428980227`*^9}, {3.8053093369091387`*^9, 
   3.8053093403934264`*^9}, {3.8100699591179037`*^9, 
   3.8100700165378733`*^9}, {3.810240248551813*^9, 3.8102402662699814`*^9}, {
   3.810240362712524*^9, 3.8102403698530006`*^9}, 3.8102404642945232`*^9, 
   3.8198464252718763`*^9, {3.819846496426095*^9, 3.8198465080664034`*^9}, {
   3.819846647143484*^9, 3.8198466548463907`*^9}, 3.819848553304391*^9, {
   3.819848594121112*^9, 3.8198486448221283`*^9}, {3.819848853713481*^9, 
   3.8198488575436077`*^9}, {3.819849305886876*^9, 3.8198493126366835`*^9}, {
   3.819849783805763*^9, 3.819849795289811*^9}, {3.8198498751370897`*^9, 
   3.8198498796753483`*^9}, 3.819852410975874*^9, {3.819852720438212*^9, 
   3.819852726688031*^9}, {3.81985871609789*^9, 3.819858723004779*^9}, {
   3.8198588690489035`*^9, 3.8198588808657217`*^9}, {3.819859020980142*^9, 
   3.819859077063222*^9}, {3.8198592298239613`*^9, 3.8198592314959803`*^9}, {
   3.8198598378046885`*^9, 3.819859848586525*^9}, {3.819859966904131*^9, 
   3.819859978467265*^9}, {3.8198601024428253`*^9, 3.819860147710929*^9}, {
   3.81986041497547*^9, 3.8198604260385838`*^9}, {3.8198605213875723`*^9, 
   3.819860528950492*^9}, 3.819860656019965*^9, {3.8198622090297728`*^9, 
   3.8198622151392*^9}, 3.819863567856737*^9, 3.8198636082164145`*^9, {
   3.819934109527196*^9, 3.819934115702182*^9}, 3.819939980798693*^9, {
   3.81994004790958*^9, 3.819940055487485*^9}, 3.8199465340708485`*^9, 
   3.819947052234573*^9, {3.819947237064841*^9, 3.819947248002035*^9}, {
   3.8199482827172318`*^9, 3.819948291930473*^9}, {3.819989034310416*^9, 
   3.8199890499118176`*^9}, 3.819995532946477*^9, {3.8199956762079926`*^9, 
   3.8199956892388983`*^9}, {3.8200889339886756`*^9, 3.820088944941464*^9}, {
   3.82008912313525*^9, 3.820089124775836*^9}, 3.8200907862550397`*^9, {
   3.8200912810865135`*^9, 3.820091286789473*^9}, {3.820115148129422*^9, 
   3.82011515286366*^9}, {3.8201152861410875`*^9, 3.8201153572484207`*^9}, {
   3.820206233484451*^9, 3.820206255112809*^9}, {3.8202071518792677`*^9, 
   3.820207169675432*^9}, 3.8202073478112817`*^9, 3.8202079047303452`*^9, {
   3.820460400220234*^9, 3.8204604028023806`*^9}, 3.820460462612266*^9, 
   3.8204606147399035`*^9, 3.82054410414405*^9, {3.820640395379943*^9, 
   3.8206404505658307`*^9}, {3.820640525708227*^9, 3.8206405563792224`*^9}, {
   3.820683687845157*^9, 3.8206836973221316`*^9}, {3.8206837549879293`*^9, 
   3.82068375542807*^9}, {3.8207849253768363`*^9, 3.820784936298422*^9}, {
   3.8209572599779663`*^9, 3.820957269055828*^9}, {3.8209573053985577`*^9, 
   3.82095730911718*^9}, {3.8209573555377216`*^9, 3.820957376505872*^9}, 
   3.820959331578873*^9, {3.8211383625770736`*^9, 3.821138434965591*^9}, {
   3.8211391968813686`*^9, 3.8211392657387943`*^9}, {3.8211393227801085`*^9, 
   3.8211393248269296`*^9}, {3.8231412829889646`*^9, 
   3.8231413534418135`*^9}, {3.823141502823724*^9, 3.823141590018277*^9}, {
   3.8236550912938766`*^9, 3.823655091765791*^9}, {3.823655203401829*^9, 
   3.823655207905835*^9}, 3.8236552809376774`*^9, {3.8236554318533964`*^9, 
   3.823655451762082*^9}, {3.8236555524262657`*^9, 3.8236555539227486`*^9}, 
   3.8236559408177524`*^9, {3.8236560073907485`*^9, 3.823656012705702*^9}, {
   3.823656049761657*^9, 3.823656075118746*^9}, {3.8236561252655396`*^9, 
   3.8236561297886395`*^9}, {3.8236561840697174`*^9, 3.823656356883749*^9}, {
   3.8236563931635723`*^9, 3.8236564049636545`*^9}, {3.8236564635160527`*^9, 
   3.8236565479856715`*^9}, {3.823656618451815*^9, 3.8236566465918303`*^9}, {
   3.823656727027627*^9, 3.823656931711747*^9}, {3.823657222775753*^9, 
   3.823657223811759*^9}, {3.8236572819197936`*^9, 3.823657298687948*^9}, {
   3.8236575651035223`*^9, 3.8236575652587833`*^9}, {3.823658825445919*^9, 
   3.8236588428556743`*^9}, {3.8236588835076056`*^9, 
   3.8236588917699304`*^9}, {3.823658941811777*^9, 3.823659065405012*^9}, 
   3.8236591191973047`*^9, {3.8236591545892467`*^9, 3.823659159429226*^9}, {
   3.8236592347429695`*^9, 3.8236592412367287`*^9}, {3.8236592904521437`*^9, 
   3.823659344315798*^9}, {3.8236596184162054`*^9, 3.823659637556746*^9}, {
   3.8236596691579185`*^9, 3.823659684080753*^9}, {3.8236597325893965`*^9, 
   3.8236597343847976`*^9}, {3.8236601931837378`*^9, 3.8236602194517236`*^9}, 
   3.823660296435614*^9, {3.8236604298554325`*^9, 3.823660455115836*^9}, {
   3.823660608374081*^9, 3.823660652983501*^9}, {3.823660700146762*^9, 
   3.8236607531821775`*^9}, 3.823661051697723*^9, {3.823661138770689*^9, 
   3.823661138920743*^9}, {3.8236613560267515`*^9, 3.8236613626528077`*^9}, {
   3.823705924277069*^9, 3.823705928881971*^9}, {3.8237059701539326`*^9, 
   3.823706072345337*^9}, {3.823706152409139*^9, 3.8237062134294844`*^9}, {
   3.8237062665279016`*^9, 3.8237062974604316`*^9}, {3.8237068479088516`*^9, 
   3.823706890818034*^9}, {3.8237069216601305`*^9, 3.82370692860581*^9}, 
   3.823707190748353*^9, {3.82370725094484*^9, 3.823707262591812*^9}, {
   3.823707340191991*^9, 3.823707356751421*^9}, {3.8237076381476016`*^9, 
   3.823707646086524*^9}, {3.823707746283389*^9, 3.8237077796832247`*^9}, {
   3.823708048187185*^9, 3.823708103419061*^9}, {3.823728382426073*^9, 
   3.823728399682021*^9}, {3.8237284598020363`*^9, 3.823728516326993*^9}, {
   3.8237285611391726`*^9, 3.8237285643821106`*^9}, {3.8237286081178455`*^9, 
   3.8237286379563403`*^9}, {3.8237286846662283`*^9, 
   3.8237286862857733`*^9}, {3.8237289626060767`*^9, 
   3.8237290048500767`*^9}, {3.823729116237099*^9, 3.823729191229148*^9}, {
   3.8237292308770666`*^9, 3.8237294147446876`*^9}, {3.8237294584626665`*^9, 
   3.8237295104445972`*^9}, {3.8237299129994955`*^9, 3.8237299581529636`*^9}, 
   3.8237300554370832`*^9, {3.823730285632378*^9, 3.823730363900202*^9}, {
   3.8237304091279984`*^9, 3.8237304392041626`*^9}, {3.8237304945595117`*^9, 
   3.8237305354160633`*^9}, {3.823730694278023*^9, 3.8237307226990404`*^9}, 
   3.8237308523750677`*^9, {3.8237309023386126`*^9, 3.8237309042346444`*^9}, {
   3.823731779067478*^9, 3.823731825586029*^9}, 3.8237324204650035`*^9, {
   3.82373245925289*^9, 3.8237325063963423`*^9}, {3.8237325966490307`*^9, 
   3.823732605524499*^9}, 3.823732692761057*^9, {3.823732769929077*^9, 
   3.8237328899984727`*^9}, 3.8237329288240776`*^9, 3.823732965168416*^9, {
   3.8237333039320307`*^9, 3.823733408592134*^9}, 3.823733600180997*^9, {
   3.823736663198963*^9, 3.823736702405344*^9}, {3.8237369666456614`*^9, 
   3.823737052398509*^9}, 3.8237370829936914`*^9, {3.823737157058519*^9, 
   3.8237371725509596`*^9}, {3.823737217601596*^9, 3.823737226818432*^9}, {
   3.8237373837812986`*^9, 3.823737389407007*^9}, {3.8237374207851253`*^9, 
   3.823737452405983*^9}, {3.8237380196997395`*^9, 3.8237380245366936`*^9}, {
   3.823738117246798*^9, 3.8237382259370117`*^9}, {3.823738320755745*^9, 
   3.8237383358970237`*^9}, {3.8237383685322657`*^9, 
   3.8237384019185057`*^9}, {3.823738469144698*^9, 3.8237384722511835`*^9}, {
   3.82373852346023*^9, 3.8237385298203306`*^9}, {3.823738565503487*^9, 
   3.8237386734922*^9}, {3.82373879248609*^9, 3.823738856689348*^9}, {
   3.8237389790900536`*^9, 3.8237389817730284`*^9}, {3.8237391022189736`*^9, 
   3.823739174282079*^9}, {3.8237392090371246`*^9, 3.8237392764709306`*^9}, {
   3.823739345903858*^9, 3.823739357080057*^9}, {3.823739387679063*^9, 
   3.8237394053347883`*^9}, {3.8237394948284035`*^9, 
   3.8237395186320996`*^9}, {3.823739565088069*^9, 3.8237396551919794`*^9}, {
   3.823740018991229*^9, 3.8237400961036205`*^9}, {3.8237401565379987`*^9, 
   3.8237401583227644`*^9}, {3.8237406700578303`*^9, 
   3.8237406873889093`*^9}, {3.823740729465277*^9, 3.8237407580952125`*^9}, {
   3.823743202639067*^9, 3.823743265482156*^9}, {3.823743309386753*^9, 
   3.823743338638073*^9}, {3.823743451001852*^9, 3.8237434801695995`*^9}, {
   3.8237435370078297`*^9, 3.823743554581031*^9}, 3.823743636833749*^9, {
   3.8237438303167863`*^9, 3.8237438758120584`*^9}, {3.823743919387436*^9, 
   3.823744012998006*^9}, {3.823744051708722*^9, 3.8237442543125477`*^9}, {
   3.8237445368510323`*^9, 3.8237445558440323`*^9}, {3.823744639735987*^9, 
   3.823744684511101*^9}, {3.82374475010604*^9, 3.823744936594909*^9}, {
   3.8237452088641305`*^9, 3.823745239430967*^9}, {3.8237460347111006`*^9, 
   3.82374617805915*^9}, {3.823746792911957*^9, 3.8237468516238985`*^9}, {
   3.8237468857440047`*^9, 3.823746958316041*^9}, {3.8237469978285875`*^9, 
   3.8237470042127037`*^9}, {3.823747070596759*^9, 3.823747074388387*^9}, {
   3.8237495748269873`*^9, 3.823749609174774*^9}, {3.82375073357521*^9, 
   3.823750764626575*^9}, {3.8237975210314207`*^9, 3.8237975383534193`*^9}, {
   3.8237977209756107`*^9, 3.8237977264053907`*^9}, {3.823806101634373*^9, 
   3.823806121822695*^9}, {3.8238192686382732`*^9, 3.823819279622287*^9}, {
   3.823819456391144*^9, 3.8238194752757015`*^9}, {3.8238197938119698`*^9, 
   3.823819842664462*^9}, {3.82381996737532*^9, 3.8238199801275992`*^9}, {
   3.8238200107883034`*^9, 3.8238200502193074`*^9}, {3.8238203314817343`*^9, 
   3.8238203449004345`*^9}, {3.823820398268285*^9, 3.823820417787322*^9}, {
   3.823820462590725*^9, 3.823820474539569*^9}, {3.8238205296225133`*^9, 
   3.8238205823231497`*^9}, {3.8238208428763075`*^9, 
   3.8238209144581904`*^9}, {3.82382094576075*^9, 3.823820954298182*^9}, {
   3.8238213092518225`*^9, 3.8238213662822804`*^9}, {3.823821437938188*^9, 
   3.823821478904256*^9}, {3.823821509554306*^9, 3.8238215237621946`*^9}, {
   3.8238217374562645`*^9, 3.823821775065325*^9}, {3.8238221227689457`*^9, 
   3.8238221468352494`*^9}, {3.823822181376028*^9, 3.8238222544972897`*^9}, {
   3.8238222972372246`*^9, 3.8238223378561316`*^9}, {3.8238223830483766`*^9, 
   3.8238224160132856`*^9}, {3.8238225866892824`*^9, 
   3.8238225999920163`*^9}, {3.823822642672739*^9, 3.823822658304906*^9}, {
   3.8238227192242556`*^9, 3.8238227688817725`*^9}, {3.823822810648243*^9, 
   3.823822852808134*^9}, {3.8238230424202857`*^9, 3.8238231296388717`*^9}, {
   3.8238232293512616`*^9, 3.823823251352811*^9}, {3.823824031102771*^9, 
   3.8238240502979484`*^9}, {3.8238245509533257`*^9, 
   3.8238246404222946`*^9}, {3.823824679840721*^9, 3.823824690557724*^9}, {
   3.8238247698572607`*^9, 3.8238247779256954`*^9}, {3.823824809886386*^9, 
   3.823824838381317*^9}, 3.8238249927152467`*^9, {3.8238250246933217`*^9, 
   3.8238250720392838`*^9}, {3.823825133777273*^9, 3.8238251785642242`*^9}, {
   3.8238252550770435`*^9, 3.8238253349729357`*^9}, {3.8239697236828747`*^9, 
   3.8239697251760592`*^9}, {3.823969782413111*^9, 3.823969824113186*^9}, {
   3.8239698688481555`*^9, 3.823969872125151*^9}, {3.823969945019972*^9, 
   3.823969967152932*^9}, 3.824007366286104*^9, {3.8241444651258554`*^9, 
   3.824144467142995*^9}, {3.8241445687269354`*^9, 3.8241445905858517`*^9}, {
   3.824144949093319*^9, 3.8241450011408052`*^9}, {3.824145120484915*^9, 
   3.824145149371142*^9}, {3.824176079878627*^9, 3.824176087228521*^9}, 
   3.8241761267707405`*^9, 3.82417616415281*^9, {3.8241762047395916`*^9, 
   3.82417622932755*^9}, {3.8241763713657064`*^9, 3.824176408102358*^9}, {
   3.8241766775568523`*^9, 3.8241766777147956`*^9}, 3.824692474279517*^9, {
   3.8248554940921984`*^9, 3.8248555393983564`*^9}, {3.824855790150652*^9, 
   3.8248557918062744`*^9}, {3.8248559944839196`*^9, 
   3.8248560681837373`*^9}, {3.8248581381878815`*^9, 
   3.8248582733915033`*^9}, {3.8248583098293166`*^9, 
   3.8248583634083753`*^9}, {3.8248589634108086`*^9, 3.824859022205922*^9}, {
   3.8248590957118087`*^9, 3.8248591812566757`*^9}, {3.82485922744764*^9, 
   3.8248594110889826`*^9}, {3.824859458837884*^9, 3.824859515438059*^9}, {
   3.824859549829937*^9, 3.8248596196937847`*^9}, {3.8248596535819206`*^9, 
   3.824859861657907*^9}, {3.824859897986916*^9, 3.8248598991059237`*^9}, {
   3.8248606068840094`*^9, 3.8248606486899695`*^9}, {3.8248607633499727`*^9, 
   3.8248608303329473`*^9}, {3.8248610121139803`*^9, 
   3.8248611153620644`*^9}, {3.82486116007648*^9, 3.8248612499544053`*^9}, {
   3.8248615874843783`*^9, 3.824861588698498*^9}, {3.824863498104088*^9, 
   3.8248635099992046`*^9}, {3.824863540811947*^9, 3.824863842692172*^9}, {
   3.8248641849726477`*^9, 3.824864241820711*^9}, {3.824864393684721*^9, 
   3.824864451135827*^9}, {3.824864527524806*^9, 3.824864643672598*^9}, {
   3.8248651872538767`*^9, 3.8248652295969086`*^9}, {3.8248653512179537`*^9, 
   3.8248653688538847`*^9}, {3.824865400436881*^9, 3.82486544599679*^9}, {
   3.824865556516977*^9, 3.8248655895979476`*^9}, {3.8248656624809184`*^9, 
   3.8248657301649356`*^9}, {3.824865775472945*^9, 3.8248658456930285`*^9}, {
   3.8248658997849164`*^9, 3.8248659699731464`*^9}, {3.824866045977904*^9, 
   3.8248661011259117`*^9}, {3.824866138870102*^9, 3.8248661602539935`*^9}, {
   3.824866381797201*^9, 3.8248663854131937`*^9}, {3.8248664830507493`*^9, 
   3.824866485312036*^9}, {3.8248665217342715`*^9, 3.824866706398279*^9}, {
   3.824866740962959*^9, 3.8248667829710083`*^9}, {3.824866822720973*^9, 
   3.824866881402107*^9}, {3.824866928326332*^9, 3.8248669405423574`*^9}, {
   3.8248670374785595`*^9, 3.824867052438156*^9}, 3.8248672305928755`*^9, {
   3.8248672681503887`*^9, 3.8248673164026723`*^9}, {3.8248673902943897`*^9, 
   3.8248674653471622`*^9}, {3.824867512481283*^9, 3.824867567107338*^9}, {
   3.824867597582734*^9, 3.824867597657949*^9}, {3.8248703785678463`*^9, 
   3.8248703849688787`*^9}, {3.8248704178606644`*^9, 
   3.8248704243188753`*^9}, {3.824870512414856*^9, 3.8248705134156895`*^9}, {
   3.8248705445478535`*^9, 3.8248705704709697`*^9}, 3.824870767074888*^9, {
   3.824870845810909*^9, 3.8248708491358414`*^9}, {3.8248708905038247`*^9, 
   3.824870918263834*^9}, {3.8248709504798117`*^9, 3.8248709511518693`*^9}, {
   3.82487098675991*^9, 3.824871008351866*^9}, {3.824871043495852*^9, 
   3.8248711884199567`*^9}, 3.824871219299938*^9, {3.824871269875946*^9, 
   3.8248712724559493`*^9}, 3.8248713077219086`*^9, {3.8248714178207035`*^9, 
   3.824871431207952*^9}, {3.8248715050759525`*^9, 3.8248715086679497`*^9}, 
   3.8248715914469337`*^9, 3.824871630113031*^9, 3.824918736116824*^9, {
   3.824918831876279*^9, 3.8249188592878246`*^9}, {3.8249188949241276`*^9, 
   3.824918916395336*^9}, {3.8249189589208436`*^9, 3.8249191089441996`*^9}, {
   3.8249191486023817`*^9, 3.824919161299123*^9}, {3.8249192264932456`*^9, 
   3.8249192843492675`*^9}, {3.8249195470833564`*^9, 
   3.8249195753685193`*^9}, {3.8249196824495945`*^9, 
   3.8249197059685616`*^9}, {3.8249198737606325`*^9, 3.824919894381673*^9}, {
   3.82491995693666*^9, 3.8249199983767214`*^9}, {3.8249200607305593`*^9, 
   3.824920080512822*^9}, {3.8249201152808523`*^9, 3.82492018045674*^9}, 
   3.8249260591478357`*^9, {3.824926102112735*^9, 3.8249261182916527`*^9}, {
   3.824926155227851*^9, 3.824926165227862*^9}, 3.824927264763813*^9, 
   3.8249284940372095`*^9, {3.8249286647931633`*^9, 3.8249286919328136`*^9}, {
   3.824930675494668*^9, 3.8249307904993544`*^9}, {3.824930825113406*^9, 
   3.824930826549461*^9}, 3.8249308724294558`*^9, {3.8249311749866467`*^9, 
   3.8249312134795732`*^9}, {3.824931266802411*^9, 3.824931329131488*^9}, {
   3.8249315629485345`*^9, 3.8249315646205845`*^9}, {3.8249317170010915`*^9, 
   3.824931734714775*^9}, {3.8249317715096874`*^9, 3.8249318008986015`*^9}, 
   3.824931958855652*^9, {3.824932070765748*^9, 3.824932092118788*^9}, {
   3.8249321667914214`*^9, 3.8249321768227706`*^9}, 3.8249322966454697`*^9, 
   3.8249323590480747`*^9, {3.824932476319854*^9, 3.8249324994627223`*^9}, {
   3.824932532575835*^9, 3.8249325408677945`*^9}, {3.824935135051778*^9, 
   3.824935195729768*^9}, {3.8249378066977844`*^9, 3.824937856937821*^9}, {
   3.8249378935857415`*^9, 3.8249379276087565`*^9}, {3.8249380201017585`*^9, 
   3.8249380344772897`*^9}, 3.824938225310755*^9, {3.824938429070714*^9, 
   3.8249384624460135`*^9}, {3.8249385544947643`*^9, 3.824938561276759*^9}, {
   3.824938612718734*^9, 3.8249386177907257`*^9}, {3.82493872285442*^9, 
   3.8249387991537867`*^9}, 3.824938957250723*^9, {3.824939087185829*^9, 
   3.824939091467716*^9}, {3.824939155783268*^9, 3.824939194602249*^9}, 
   3.8249393718344297`*^9, {3.824944854531822*^9, 3.8249448593663836`*^9}, {
   3.8249449072807407`*^9, 3.824944990081777*^9}, {3.8249451975316906`*^9, 
   3.8249452043515267`*^9}, {3.8249452413861904`*^9, 
   3.8249452424955993`*^9}, {3.824945306196274*^9, 3.8249453079197855`*^9}, 
   3.824945453525382*^9, {3.824947930933343*^9, 3.8249479428888316`*^9}, {
   3.8249479860455694`*^9, 3.824948010149576*^9}, 3.824948048784681*^9, {
   3.8249481486977634`*^9, 3.8249481825106754`*^9}, {3.824948240929731*^9, 
   3.824948268838681*^9}, {3.824948344021683*^9, 3.8249484079378004`*^9}, 
   3.8249484613737183`*^9, 3.8249485092866507`*^9, {3.8249488132516556`*^9, 
   3.8249488200727797`*^9}, 3.824949117622732*^9, {3.824949182597331*^9, 
   3.8249491866672087`*^9}, {3.8249492375433607`*^9, 
   3.8249492387426367`*^9}, {3.8249496260388103`*^9, 3.824949648890667*^9}, {
   3.824949697275775*^9, 3.8249497119435606`*^9}, {3.824949771574411*^9, 
   3.82494990415077*^9}, {3.824949935625725*^9, 3.824949944963252*^9}, {
   3.8249500214681807`*^9, 3.824950061742335*^9}, {3.824950106632338*^9, 
   3.8249501149517174`*^9}, 3.824950334224843*^9, {3.8249504922811413`*^9, 
   3.824950501754794*^9}, {3.824950535055521*^9, 3.8249505369168267`*^9}, {
   3.824950643155122*^9, 3.8249506518243294`*^9}, {3.8249508901108513`*^9, 
   3.824950896408331*^9}, {3.8249509611248026`*^9, 3.8249509779465027`*^9}, {
   3.824951131644086*^9, 3.824951145059025*^9}, {3.825029685214327*^9, 
   3.8250297111862707`*^9}, {3.8250304689683504`*^9, 3.825030535836391*^9}, {
   3.8250307888440385`*^9, 3.825030852232153*^9}, {3.825030990528429*^9, 
   3.825031055685049*^9}, {3.82503110460461*^9, 3.825031107929455*^9}, {
   3.8250311791713877`*^9, 3.8250313618611555`*^9}, {3.825032817357188*^9, 
   3.825032858876341*^9}, {3.825032899588101*^9, 3.8250329319964485`*^9}, {
   3.8250329900727024`*^9, 3.82503299336228*^9}, {3.825033113511448*^9, 
   3.8250331161483316`*^9}, {3.8250331877052994`*^9, 
   3.8250331933091574`*^9}, {3.8250334294520283`*^9, 
   3.8250334684190006`*^9}, {3.825033563317192*^9, 3.825033566863104*^9}, {
   3.825033916638444*^9, 3.825033931753398*^9}, {3.8250343527314386`*^9, 
   3.8250343653483415`*^9}, 3.82503450811926*^9, 3.8250350628093615`*^9, {
   3.825035101794323*^9, 3.825035106529402*^9}, {3.825035141410263*^9, 
   3.825035311579383*^9}, {3.825035353570861*^9, 3.825035375844096*^9}, {
   3.8250356321401105`*^9, 3.825035668483427*^9}, {3.8251074106564817`*^9, 
   3.8251074282853556`*^9}, 3.8251074622734427`*^9, {3.825107509436661*^9, 
   3.8251075099010024`*^9}, {3.8251075419690013`*^9, 3.825107559492883*^9}, {
   3.825107657700059*^9, 3.825107720572483*^9}, {3.8251077756872463`*^9, 
   3.8251077768520956`*^9}, {3.825112241393627*^9, 3.8251123130547857`*^9}, {
   3.82511237352559*^9, 3.8251124818865924`*^9}, {3.8251125219305964`*^9, 
   3.8251125524465885`*^9}, {3.825112609633627*^9, 3.8251126544900713`*^9}, {
   3.825112693829616*^9, 3.8251127267656126`*^9}, 3.825112898187585*^9, {
   3.8251130688775897`*^9, 3.8251131639828053`*^9}, {3.8251132115325966`*^9, 
   3.825113219963628*^9}, {3.825113254518587*^9, 3.8251133003107843`*^9}, {
   3.8251133362718973`*^9, 3.8251133391907682`*^9}, {3.825113738487503*^9, 
   3.8251137867986116`*^9}, {3.8251138248948717`*^9, 
   3.8251138878835287`*^9}, {3.8251139359329896`*^9, 3.825113990267004*^9}, {
   3.8251140303157167`*^9, 3.8251142110438023`*^9}, {3.8251142487426205`*^9, 
   3.8251143913676434`*^9}, {3.8251144454038825`*^9, 3.825114527495221*^9}, 
   3.825114686832468*^9, {3.825114720732188*^9, 3.825114748662099*^9}, {
   3.82511480953331*^9, 3.825114814789626*^9}, {3.8251149561849065`*^9, 
   3.82511501414065*^9}, 3.8251150621695185`*^9, {3.825115124414464*^9, 
   3.82511518521279*^9}, {3.82511521562442*^9, 3.8251152664716225`*^9}, {
   3.8251153412464733`*^9, 3.825115394159856*^9}, {3.825115711763401*^9, 
   3.825115739136504*^9}, 3.825115802335621*^9, {3.8251158641134586`*^9, 
   3.8251159642219706`*^9}, {3.8251161676341233`*^9, 3.825116170536463*^9}, {
   3.8251163019175444`*^9, 3.8251163262814693`*^9}, {3.825116416816228*^9, 
   3.8251164200015736`*^9}, {3.8251164606011877`*^9, 3.825116466463657*^9}, {
   3.825116621426254*^9, 3.8251166338331833`*^9}, {3.825116673601297*^9, 
   3.825116758647108*^9}, {3.825116893072377*^9, 3.825116977881137*^9}, {
   3.8251170088084126`*^9, 3.825117133799431*^9}, {3.8251172108434277`*^9, 
   3.825117259057486*^9}, {3.825117329735531*^9, 3.8251173298364267`*^9}, {
   3.8251174136285453`*^9, 3.825117419410365*^9}, {3.825117465021659*^9, 
   3.8251174991910524`*^9}, {3.8251175955855207`*^9, 
   3.8251175979144015`*^9}, {3.8251228928233395`*^9, 3.825122908818619*^9}, {
   3.825122964937612*^9, 3.8251229943785887`*^9}, {3.8251231786693897`*^9, 
   3.825123230807619*^9}, {3.825123273571483*^9, 3.8251232951225624`*^9}, {
   3.8251233815705056`*^9, 3.8251234408196197`*^9}, {3.825123492023644*^9, 
   3.825123499343487*^9}, {3.8251235832195997`*^9, 3.8251235858665876`*^9}, {
   3.8251236162096167`*^9, 3.8251236473245935`*^9}, {3.8251236999996166`*^9, 
   3.8251237320415916`*^9}, {3.8251237780188103`*^9, 3.825123887306597*^9}, {
   3.8251239541568336`*^9, 3.825123961270546*^9}, {3.8251239978396077`*^9, 
   3.8251241017285523`*^9}, {3.8251241469996176`*^9, 3.825124212762742*^9}, {
   3.8251242620015836`*^9, 3.8251242624915843`*^9}, {3.825124331980756*^9, 
   3.8251243364607453`*^9}, {3.8251244736191196`*^9, 3.8251244769488087`*^9}, 
   3.825124708139988*^9, 3.82512490138111*^9, {3.8251250734006433`*^9, 
   3.8251251073565845`*^9}, {3.825125444824342*^9, 3.8251254500020676`*^9}, {
   3.825125528515123*^9, 3.825125533835323*^9}, {3.825125589764288*^9, 
   3.825125595496958*^9}, {3.825125654061408*^9, 3.8251256678387194`*^9}, 
   3.825125787416888*^9, {3.825125934344818*^9, 3.8251259350493145`*^9}, {
   3.8251260319779787`*^9, 3.8251261589522505`*^9}, {3.8251262245214634`*^9, 
   3.8251262493232102`*^9}, 3.8251263284459877`*^9, {3.8251263948974404`*^9, 
   3.8251266061747875`*^9}, {3.8251267456090946`*^9, 
   3.8251267878365297`*^9}, {3.8252014212330217`*^9, 
   3.8252014278843565`*^9}, {3.8252015318608227`*^9, 3.825201534025397*^9}, {
   3.8252015932183094`*^9, 3.825201638519158*^9}, {3.825201745485388*^9, 
   3.8252017509363613`*^9}, {3.8252018263803806`*^9, 3.825201841765905*^9}, {
   3.825201872925373*^9, 3.825201911436224*^9}, {3.825201958482499*^9, 
   3.8252019616854696`*^9}, {3.8252022205776978`*^9, 
   3.8252022556680565`*^9}, {3.825202288733057*^9, 3.8252022956409087`*^9}, {
   3.825202341170432*^9, 3.8252023583550315`*^9}, {3.825202403838107*^9, 
   3.8252024339778805`*^9}, {3.8252026663779774`*^9, 
   3.8252026903126917`*^9}, {3.8252031529973845`*^9, 
   3.8252031603302813`*^9}, {3.8252032175586357`*^9, 
   3.8252033196873207`*^9}, {3.8252033874303513`*^9, 3.82520339687774*^9}, {
   3.8252034401422787`*^9, 3.8252034999682617`*^9}, {3.8252035307012806`*^9, 
   3.825203532434366*^9}, {3.8252035856383314`*^9, 3.825203598914426*^9}, 
   3.825203638382357*^9, {3.8252038649384394`*^9, 3.8252038667554264`*^9}, 
   3.8252039504042454`*^9, {3.8252040534373856`*^9, 3.825204076903442*^9}, {
   3.825204276092473*^9, 3.825204333944439*^9}, 3.825204379076498*^9, {
   3.825204450887293*^9, 3.8252044617594037`*^9}, {3.825204497533407*^9, 
   3.8252045092294235`*^9}, {3.8252046011413884`*^9, 
   3.8252046659265347`*^9}, {3.8252047226396627`*^9, 3.825204752544791*^9}, {
   3.8252048384574184`*^9, 3.825204881444479*^9}, {3.8252056454745965`*^9, 
   3.8252057495605917`*^9}, {3.8252058536710606`*^9, 
   3.8252059282911787`*^9}, {3.825206009940809*^9, 3.825206019784396*^9}, {
   3.825206054648757*^9, 3.8252061058152895`*^9}, {3.825206140337419*^9, 
   3.8252062058884563`*^9}, {3.8252062513528733`*^9, 3.825206297839419*^9}, {
   3.825206341288153*^9, 3.825206395296438*^9}, {3.825206509686785*^9, 
   3.825206516498825*^9}, {3.825206586726118*^9, 3.8252066242604475`*^9}, {
   3.8252066600959544`*^9, 3.8252066817439594`*^9}, {3.825206858674218*^9, 
   3.8252068675332985`*^9}, {3.8252084748454037`*^9, 3.825208489729294*^9}, {
   3.825208698448345*^9, 3.8252087441143928`*^9}, 3.825209012203766*^9, {
   3.825209055738775*^9, 3.825209082120344*^9}, {3.8252091179562607`*^9, 
   3.8252091201763067`*^9}, {3.825209193573662*^9, 3.825209211097583*^9}, {
   3.825269837904316*^9, 3.8252698477757287`*^9}, {3.825269889144647*^9, 
   3.825269927736794*^9}, 3.825269957999621*^9, 3.8252700182798376`*^9, {
   3.825270096932644*^9, 3.825270100000124*^9}, {3.8252701438680296`*^9, 
   3.825270143978655*^9}, {3.82527049298145*^9, 3.825270530487769*^9}, {
   3.825270598004809*^9, 3.8252707293515034`*^9}, {3.8252708110772915`*^9, 
   3.82527082024675*^9}, {3.825271057090623*^9, 3.825271089071453*^9}, 
   3.825271227921497*^9, {3.825271280457679*^9, 3.825271294777677*^9}, {
   3.825271408704564*^9, 3.825271431142701*^9}, {3.825274622036351*^9, 
   3.825274624216405*^9}, {3.825274668609521*^9, 3.825274719785666*^9}, 
   3.8252747776654224`*^9, {3.8252748250619373`*^9, 3.825274842858553*^9}, {
   3.825275099354559*^9, 3.8252751837335386`*^9}, {3.8252755556110506`*^9, 
   3.825275559810046*^9}, {3.8252827955455046`*^9, 3.8252829192166505`*^9}, {
   3.8252829633365183`*^9, 3.825282992781548*^9}, {3.8252830994145517`*^9, 
   3.8252831105825834`*^9}, {3.825283156238617*^9, 3.8252831829136906`*^9}, 
   3.8252850404151754`*^9, {3.825286773512032*^9, 3.8252868004068947`*^9}, {
   3.8252869041589646`*^9, 3.8252870208551617`*^9}, {3.8252873622357492`*^9, 
   3.825287427671309*^9}, 3.825287466164644*^9, {3.8252874969913425`*^9, 
   3.825287568939683*^9}, {3.825287689387618*^9, 3.825287764342353*^9}, {
   3.825287799511036*^9, 3.8252878456042857`*^9}, {3.8252878757434416`*^9, 
   3.8252878799684577`*^9}, {3.825287920121481*^9, 3.8252879505114746`*^9}, {
   3.8252880475956464`*^9, 3.8252881567673907`*^9}, {3.825288194699346*^9, 
   3.825288225983613*^9}, {3.8252884598715005`*^9, 3.825288488613561*^9}, {
   3.8252886610655613`*^9, 3.8252886677607336`*^9}, 3.8252887333778253`*^9, {
   3.8252890331985273`*^9, 3.8252890345164127`*^9}, {3.8252891262177644`*^9, 
   3.8252891317516923`*^9}, 3.8477446057094526`*^9, {3.847931982414719*^9, 
   3.8479319847264605`*^9}, {3.8479851581696253`*^9, 3.847985162438923*^9}, {
   3.8479852449645615`*^9, 3.8479852508526382`*^9}, {3.847986815624115*^9, 
   3.8479868499510508`*^9}, {3.847992495148491*^9, 3.847992530185153*^9}, 
   3.8479926004159036`*^9, {3.848008811495241*^9, 3.848008822460959*^9}, {
   3.8480101956511197`*^9, 3.848010216638848*^9}, {3.8480102705999546`*^9, 
   3.8480103017555656`*^9}, {3.8480103846863747`*^9, 
   3.8480104160763226`*^9}, {3.8480112188991013`*^9, 3.848011219863351*^9}, {
   3.8480112536164975`*^9, 3.8480112781522074`*^9}, 3.8480135968402376`*^9, {
   3.848013785003805*^9, 3.848013789018938*^9}, {3.8480167750631127`*^9, 
   3.8480167844764853`*^9}, {3.848016844655369*^9, 3.848016851628237*^9}, {
   3.848017014526941*^9, 3.8480170213416657`*^9}, {3.8480820147099676`*^9, 
   3.848082040291561*^9}, 3.8480821752597446`*^9, {3.8480822561550407`*^9, 
   3.8480822786442404`*^9}},
 CellLabel->"In[19]:=",ExpressionUUID->"07f63e71-2b29-4fa5-ab3d-5504b8176b3d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HuePartitionLegend", "[", 
     RowBox[{"hues_", ",", "partitions_", ",", "fpp_"}], "]"}], ":=", 
    RowBox[{"Row", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Column", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{"#", ",", 
              RowBox[{"{", 
               RowBox[{"Black", ",", "12"}], "}"}]}], "]"}], "&"}], "/@", 
           RowBox[{"{", 
            RowBox[{"\"\<Distance\>\"", ",", "\"\<Legend:\>\""}], "}"}]}], 
          ",", "Left", ",", "0.5"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Grid", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{"hues", ",", "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{
                RowBox[{"ToString", "[", 
                 RowBox[{"Row", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{"SetPrecision", "[", 
                    RowBox[{"#", ",", "fpp"}], "]"}], "&"}], "/@", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"partitions", "[", 
                    RowBox[{"[", "p", "]"}], "]"}], ",", 
                    RowBox[{"partitions", "[", 
                    RowBox[{"[", 
                    RowBox[{"p", "+", "1"}], "]"}], "]"}]}], "}"}]}], ",", 
                   "\"\<, \>\""}], "]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"Black", ",", "12"}], "}"}]}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"p", ",", "1", ",", 
                RowBox[{"Length", "[", "hues", "]"}]}], "}"}]}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Alignment", "\[Rule]", "Center"}], ",", 
          RowBox[{"Spacings", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"1", ",", " ", "1"}], "}"}]}], ",", 
          RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}]}], 
       "\[IndentingNewLine]", "}"}], ",", 
      RowBox[{"Spacer", "[", "16", "]"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.802192433608954*^9, 3.802192433608954*^9}, {
   3.8248608627209926`*^9, 3.8248609251279907`*^9}, {3.825293796606659*^9, 
   3.825293847502709*^9}, 3.825294226892686*^9, {3.8252943122376013`*^9, 
   3.8252943286717453`*^9}, {3.8252950348930593`*^9, 
   3.8252950614037495`*^9}, {3.8252964948333874`*^9, 3.8252965546067095`*^9}, 
   3.825296604521697*^9, {3.825297462078339*^9, 3.82529754105752*^9}, {
   3.8252977242692976`*^9, 3.825297724911049*^9}, {3.8252977596363482`*^9, 
   3.825297900717387*^9}, {3.825298503163257*^9, 3.8252985294163256`*^9}, 
   3.82529863496666*^9, 3.825298668081324*^9, {3.8252987052483845`*^9, 
   3.825298736509637*^9}, {3.8252993736755676`*^9, 3.825299387189641*^9}, {
   3.8480159854948206`*^9, 3.8480159856410236`*^9}, {3.848017087310547*^9, 
   3.8480170875625234`*^9}},
 CellLabel->"In[20]:=",ExpressionUUID->"02ae7579-7bec-4c92-b02d-85873b5e8ed8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"Outputs", " ", "unique", " ", "nearest"}], "-", 
     RowBox[{"neighbor", " ", "EdgeDistances"}]}], ",", " ", 
    RowBox[{
     RowBox[{"where", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Edge", "[", 
         RowBox[{"a", ",", "b"}], "]"}], ",", " ", "c"}], "}"}], " ", "means",
       " ", "b", " ", "is", " ", "a", " ", "nearest"}], "-", 
     RowBox[{
     "neighbor", " ", "of", " ", "a", " ", "at", " ", "distance", " ", 
      "c"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Input", ":", " ", 
    RowBox[{"[", "edistances_", "]"}]}], " ", "*)"}], 
  RowBox[{"(*", " ", 
   RowBox[{"edistances", " ", "=", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"v1", "\[UndirectedEdge]", "v2"}], ",", "8"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"v1", "\[DirectedEdge]", "v3"}], ",", 
         SqrtBox["2"]}], "}"}], ",", "..."}], "}"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"#1", " ", "=", " ", 
        RowBox[{"directed", " ", 
         RowBox[{"and", "/", "or"}], " ", "undirected", " ", "edges"}]}], ",",
        " ", 
       RowBox[{
        RowBox[{"no", " ", "rules"}], ";", " ", 
        RowBox[{"#2", " ", "=", " ", 
         RowBox[{"non", "-", 
          RowBox[{"complex", " ", "distance"}]}]}]}]}], ")"}]}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"NearestUniqueEdgeDistances", "[", "edistances_", "]"}], ":=", 
     RowBox[{"Block", "[", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"local", " ", "variables"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
        "undirectedEdgeStr", ",", "directedEdgeStr", ",", 
         "\[IndentingNewLine]", "vertexEdges", ",", "\[IndentingNewLine]", 
         "nnEdgeDistances"}], "\[IndentingNewLine]", "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"undirectedEdgeStr", "=", 
         RowBox[{"ToString", "[", 
          RowBox[{"Head", "[", 
           RowBox[{"0", "\[UndirectedEdge]", "0"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"directedEdgeStr", "=", 
         RowBox[{"ToString", "[", 
          RowBox[{"Head", "[", 
           RowBox[{"0", "\[DirectedEdge]", "0"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"vertexEdges", "=", 
         RowBox[{"DeleteDuplicates", "[", 
          RowBox[{"Join", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", 
                   RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
                 RowBox[{"#", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{"#", "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "&"}], "/@", 
              "edistances"}], ")"}], ",", "\[IndentingNewLine]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"ToString", "[", 
                   RowBox[{"Head", "[", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "]"}], "\[Equal]", 
                  "directedEdgeStr"}], ",", "Nothing", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"#", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "2"}], "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "2"}], "]"}], "]"}], 
                    "\[UndirectedEdge]", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ",", 
                   RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], "]"}], "&"}], "/@",
               "edistances"}], ")"}]}], "\[IndentingNewLine]", "]"}], "]"}]}],
         ";", "\[IndentingNewLine]", 
        RowBox[{"nnEdgeDistances", "=", 
         RowBox[{"DeleteDuplicates", "[", "\[IndentingNewLine]", 
          RowBox[{"(", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"ToString", "[", 
                   RowBox[{"Head", "[", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "]"}], "\[Equal]", 
                  "undirectedEdgeStr"}], ",", 
                 RowBox[{"Sort", "[", 
                  RowBox[{"#", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                 RowBox[{"#", "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", 
               RowBox[{"#", "[", 
                RowBox[{"[", "3", "]"}], "]"}]}], "}"}], "&"}], "/@", 
            RowBox[{"Flatten", "[", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"GatherBy", "[", 
                   RowBox[{"#", ",", "Last"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "&"}], "/@", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"SortBy", "[", 
                    RowBox[{"#", ",", "Last"}], "]"}], "&"}], "/@", 
                  RowBox[{"GatherBy", "[", 
                   RowBox[{"vertexEdges", ",", "First"}], "]"}]}], ")"}]}], 
               ")"}], ",", "1"}], "]"}]}], "\[IndentingNewLine]", ")"}], 
          "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "nnEdgeDistances"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.802192433608954*^9, 3.802192433608954*^9}, {
   3.8248608627209926`*^9, 3.8248609251279907`*^9}, {3.8479230012648163`*^9, 
   3.84792300781653*^9}, {3.8480219556722765`*^9, 3.848021968372931*^9}, 
   3.848022006363068*^9, {3.848022111893202*^9, 3.8480221137342863`*^9}, {
   3.8480221473044224`*^9, 3.8480222382586346`*^9}, {3.8480222718620987`*^9, 
   3.8480222915900335`*^9}, 3.84802232185475*^9, {3.8480224497467823`*^9, 
   3.848022524569333*^9}, {3.848022656216408*^9, 3.848022695274737*^9}, {
   3.848022740582446*^9, 3.848022776907707*^9}, {3.848022814398562*^9, 
   3.8480229342338033`*^9}, {3.8480230389664497`*^9, 3.848023054291798*^9}, {
   3.848023184675329*^9, 3.8480232241633167`*^9}, {3.848023258862903*^9, 
   3.8480232731477942`*^9}, {3.8480233553657136`*^9, 3.848023360439845*^9}, {
   3.848023391410174*^9, 3.8480234421418304`*^9}, {3.8480235152538586`*^9, 
   3.8480235443265123`*^9}, {3.848023638017321*^9, 3.8480236610505953`*^9}, {
   3.8480237155038533`*^9, 3.848023914409787*^9}, 3.8480243809940567`*^9, {
   3.848024589215248*^9, 3.8480246055896006`*^9}, {3.8480246393350043`*^9, 
   3.8480246836380014`*^9}, {3.8480247160369663`*^9, 
   3.8480247600989823`*^9}, {3.8480247923743553`*^9, 
   3.8480248096788087`*^9}, {3.8480248451911077`*^9, 
   3.8480248925143347`*^9}, {3.8480249416983*^9, 3.8480250188466816`*^9}, {
   3.8480250971467905`*^9, 3.84802515195151*^9}, {3.8480253022247944`*^9, 
   3.848025375148168*^9}, {3.8480255763231373`*^9, 3.848025607578881*^9}, 
   3.848025784222965*^9, {3.8480259799148297`*^9, 3.8480261130215096`*^9}, 
   3.8480264222228374`*^9, {3.8480264680727777`*^9, 3.848026544597378*^9}, 
   3.8480266810400295`*^9, {3.848026716189931*^9, 3.8480268099848814`*^9}, {
   3.8480268944456606`*^9, 3.8480269485174046`*^9}, {3.848026987193945*^9, 
   3.8480270159183273`*^9}, {3.8480271136123*^9, 3.8480271381292334`*^9}, {
   3.8480272583534274`*^9, 3.848027269018358*^9}, {3.848027314533514*^9, 
   3.848027434272748*^9}, {3.848027668671334*^9, 3.848027691296731*^9}, {
   3.8480845210537744`*^9, 3.848084528051923*^9}, {3.8487679274682403`*^9, 
   3.848767948712389*^9}, {3.8487680397819104`*^9, 3.8487680579446993`*^9}, {
   3.848768161806506*^9, 3.848768189018999*^9}, {3.8487682267844224`*^9, 
   3.8487685321706715`*^9}, {3.848768597615246*^9, 3.848768619661158*^9}, {
   3.8487686788041887`*^9, 3.84876872427619*^9}, {3.8487687592318*^9, 
   3.8487687722638273`*^9}, {3.848768811424337*^9, 3.848768817323126*^9}, {
   3.8487688920012097`*^9, 3.848768907997195*^9}, 3.8487689931890182`*^9, {
   3.848769030989319*^9, 3.8487690394763603`*^9}, {3.848769109670047*^9, 
   3.848769139295062*^9}, {3.8487692246180005`*^9, 3.848769227005835*^9}, {
   3.8487693398603373`*^9, 3.8487693789109755`*^9}, {3.8487695913743205`*^9, 
   3.8487697434396687`*^9}, {3.8487697990414696`*^9, 3.848769849523274*^9}, 
   3.8487699957584343`*^9, 3.902857648749175*^9, {3.9028576851782737`*^9, 
   3.902857686324956*^9}},
 CellLabel->"In[21]:=",ExpressionUUID->"18efeb18-d268-4e20-a656-e5aae92153c4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Outputs", " ", 
    RowBox[{"{", 
     RowBox[{"fmaxdata", ",", "fvalsdata", ",", "testCount"}], "}"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Input", ":", " ", "edistances_"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"edistances", " ", "=", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"v1", "\[UndirectedEdge]", "v2"}], ",", "8"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"v1", "\[DirectedEdge]", "v3"}], ",", 
         SqrtBox["2"]}], "}"}], ",", "..."}], "}"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"#1", " ", "=", " ", 
        RowBox[{"directed", " ", 
         RowBox[{"and", "/", "or"}], " ", "undirected", " ", "edges"}]}], ",",
        " ", 
       RowBox[{
        RowBox[{"no", " ", "rules"}], ";", " ", 
        RowBox[{"#2", " ", "=", " ", 
         RowBox[{"non", "-", 
          RowBox[{"complex", " ", "distance"}]}]}]}]}], ")"}]}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Output", ":", " ", 
    RowBox[{"{", 
     RowBox[{"fmaxdata", ",", "fvalsdata", ",", "testCount"}], "}"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"fmaxdata", " ", "=", " ", 
    RowBox[{"{", 
     RowBox[{
      SubscriptBox["\[Delta]", "opt"], ",", "c", ",", "v", ",", 
      RowBox[{"f", "[", 
       SubscriptBox["\[Delta]", "opt"], "]"}]}], "}"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"fvalsdata", " ", "=", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         SubscriptBox["\[Delta]", "1"], ",", "c", ",", "v", ",", 
         RowBox[{"f", "[", 
          SubscriptBox["\[Delta]", "1"], "]"}]}], "}"}], ",", "...", ",", 
       RowBox[{"{", 
        RowBox[{
         SubscriptBox["\[Delta]", "n"], ",", "c", ",", "v", ",", 
         RowBox[{"f", "[", 
          SubscriptBox["\[Delta]", "n"], "]"}]}], "}"}]}], "}"}], " ", 
     "where", " ", "n", " ", "is", " ", "determined", " ", "by", " ", "a", 
     " ", "telescoping", " ", "algorithm"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"testCount", " ", "=", " ", 
    RowBox[{
    "#", " ", "of", " ", "telescoping", " ", "trials", " ", "to", " ", 
     "determine", " ", 
     SubscriptBox["\[Delta]", "opt"]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ComponentMaximal", "[", "edistances_", "]"}], ":=", 
     RowBox[{"Block", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
        "uniqueEdgeDistances", ",", "uniqueEdgeDistancesCount", ",", 
         "uniqueEdgeDistancesIndexHash", ",", "\[IndentingNewLine]", 
         "verticesHalfCount", ",", "\[IndentingNewLine]", "imin", ",", "imax",
          ",", "iinc", ",", "iopt", ",", "iradius", ",", 
         "\[IndentingNewLine]", "new\[Delta]vals", ",", 
         "new\[Delta]valscount", ",", "\[Delta]vals", ",", "\[Delta]opt", ",",
          "\[IndentingNewLine]", "myf", ",", "fscale", ",", "newfvals", ",", 
         "fmax", ",", "fmaxdata", ",", "fvalsdata", ",", 
         "\[IndentingNewLine]", "testCount"}], "\[IndentingNewLine]", "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "initialize", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"uniqueEdgeDistances", "=", 
         RowBox[{"Sort", "[", 
          RowBox[{"DeleteDuplicates", "[", 
           RowBox[{"edistances", "[", 
            RowBox[{"[", 
             RowBox[{";;", ",", "2"}], "]"}], "]"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"uniqueEdgeDistancesCount", "=", 
         RowBox[{"Length", "[", "uniqueEdgeDistances", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"uniqueEdgeDistancesIndexHash", "=", 
         RowBox[{"CreateDataStructure", "[", "\"\<HashTable\>\"", "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"uniqueEdgeDistancesIndexHash", "[", 
           RowBox[{"\"\<Insert\>\"", ",", 
            RowBox[{
             RowBox[{"uniqueEdgeDistances", "[", 
              RowBox[{"[", "#", "]"}], "]"}], "\[Rule]", "#"}]}], "]"}], 
          "&"}], "/@", 
         RowBox[{"Range", "[", "uniqueEdgeDistancesCount", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"verticesQuarterCount", "=", 
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{"DeleteDuplicates", "[", 
            RowBox[{"Flatten", "[", 
             RowBox[{"List", "@@@", 
              RowBox[{"edistances", "[", 
               RowBox[{"[", 
                RowBox[{";;", ",", "1"}], "]"}], "]"}]}], "]"}], "]"}], "]"}],
           "/", "4"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"fscale", "=", "1"}], ";", "\[IndentingNewLine]", 
        RowBox[{"While", "[", 
         RowBox[{
          RowBox[{"fscale", "<", "verticesQuarterCount"}], ",", 
          RowBox[{"fscale", "*=", "2"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"myf", "[", "x_", "]"}], ":=", 
         RowBox[{"Block", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "edists", ",", "edgeG", ",", "compcount", ",", "vertcount", ",", 
             "f"}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"edists", "=", 
             RowBox[{"LeastBridgesEdgeDistances", "[", 
              RowBox[{"edistances", ",", "x", ",", "False"}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"edgeG", "=", 
             RowBox[{"Graph", "[", 
              RowBox[{"edists", "[", 
               RowBox[{"[", 
                RowBox[{";;", ",", "1"}], "]"}], "]"}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"compcount", "=", 
             RowBox[{"Length", "[", 
              RowBox[{"ConnectedComponents", "[", "edgeG", "]"}], "]"}]}], 
            ";", "\[IndentingNewLine]", 
            RowBox[{"vertcount", "=", 
             RowBox[{"Length", "[", 
              RowBox[{"VertexList", "[", "edgeG", "]"}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"f", "=", 
             RowBox[{"compcount", "*", 
              RowBox[{"vertcount", "/", "fscale"}]}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"x", ",", "compcount", ",", "vertcount", ",", "f"}], 
             "}"}]}]}], "\[IndentingNewLine]", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", "compute", " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"\[Delta]vals", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"fvalsdata", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"imin", "=", "1"}], ";", "\[IndentingNewLine]", 
        RowBox[{"imax", "=", "uniqueEdgeDistancesCount"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"new\[Delta]valscount", "=", "uniqueEdgeDistancesCount"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"testCount", "=", "0"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"While", "[", 
         RowBox[{
          RowBox[{"new\[Delta]valscount", ">", "0"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"testCount", "++"}], ";", "\[IndentingNewLine]", 
           RowBox[{"iinc", "=", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"imax", "-", "imin"}], ")"}], "/", "8"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"new\[Delta]vals", "=", 
            RowBox[{
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"MemberQ", "[", 
                 RowBox[{"\[Delta]vals", ",", "#"}], "]"}], ",", "Nothing", 
                ",", "#"}], "]"}], "&"}], "/@", 
             RowBox[{"DeleteDuplicates", "[", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"uniqueEdgeDistances", "[", 
                 RowBox[{"[", 
                  RowBox[{"Round", "[", "i", "]"}], "]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", "imin", ",", "imax", ",", "iinc"}], 
                 "}"}]}], "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"newfvals", "=", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"myf", "[", "#", "]"}], "&"}], "/@", 
              "new\[Delta]vals"}], ")"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"fvalsdata", "=", 
            RowBox[{"Join", "[", 
             RowBox[{"fvalsdata", ",", "newfvals"}], "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"fmax", "=", 
            RowBox[{"Max", "[", 
             RowBox[{"fvalsdata", "[", 
              RowBox[{"[", 
               RowBox[{";;", ",", "4"}], "]"}], "]"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"fmaxdata", "=", 
            RowBox[{"Last", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"#", "[", 
                   RowBox[{"[", "4", "]"}], "]"}], "\[Equal]", "fmax"}], ",", 
                 "#", ",", "Nothing"}], "]"}], "&"}], "/@", "fvalsdata"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"\[Delta]opt", "=", 
            RowBox[{"fmaxdata", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"iopt", "=", 
            RowBox[{"uniqueEdgeDistancesIndexHash", "[", 
             RowBox[{"\"\<Lookup\>\"", ",", "\[Delta]opt"}], "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"iradius", "=", 
            RowBox[{"Round", "[", 
             RowBox[{"3", "*", "iinc"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"imin", "=", 
            RowBox[{"Max", "[", 
             RowBox[{
              RowBox[{"iopt", "-", "iradius"}], ",", "1"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"imax", "=", 
            RowBox[{"Min", "[", 
             RowBox[{
              RowBox[{"iopt", "+", "iradius"}], ",", 
              "uniqueEdgeDistancesCount"}], "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"\[Delta]vals", "=", 
            RowBox[{"Join", "[", 
             RowBox[{"\[Delta]vals", ",", "new\[Delta]vals"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"new\[Delta]valscount", "=", 
            RowBox[{"Length", "[", "new\[Delta]vals", "]"}]}], ";"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"fmaxdata", ",", "fvalsdata", ",", "testCount"}], "}"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.802192433608954*^9, 3.802192433608954*^9}, {
   3.8248608627209926`*^9, 3.8248609251279907`*^9}, {3.8479230012648163`*^9, 
   3.84792300781653*^9}, {3.848192776914865*^9, 3.8481928035074625`*^9}, {
   3.848192858748963*^9, 3.8481928663468385`*^9}, {3.8482618726360407`*^9, 
   3.84826188137094*^9}, {3.8482619142360487`*^9, 3.8482619202188225`*^9}, {
   3.8482619589686484`*^9, 3.8482621067777004`*^9}, {3.848533196432002*^9, 
   3.848533243522766*^9}, {3.848533364409202*^9, 3.84853336491726*^9}, {
   3.848534579985882*^9, 3.8485345984484606`*^9}, {3.848534646805723*^9, 
   3.8485346498087945`*^9}, {3.8485347038051987`*^9, 3.848534746173213*^9}, {
   3.8485348596249433`*^9, 3.8485349122453613`*^9}, {3.8485355199121284`*^9, 
   3.848535519991329*^9}, {3.8485355668399725`*^9, 3.8485355733762493`*^9}, {
   3.8485357367805176`*^9, 3.8485357422835956`*^9}, {3.8485358367758226`*^9, 
   3.8485358571831207`*^9}, {3.848535891688016*^9, 3.848535952631882*^9}, {
   3.848536063256945*^9, 3.8485360703426056`*^9}, {3.8485361544859776`*^9, 
   3.8485361571566567`*^9}, {3.8485363099760714`*^9, 
   3.8485363122512465`*^9}, {3.8485366843637505`*^9, 
   3.8485366873346467`*^9}, {3.8485367257110524`*^9, 3.848536757347684*^9}, {
   3.8485367912887635`*^9, 3.8485367946435633`*^9}, {3.8485368450629053`*^9, 
   3.848536845688708*^9}, 3.8485369906199226`*^9, {3.848537421324711*^9, 
   3.8485374709094577`*^9}, {3.8485375765230846`*^9, 3.8485375788296676`*^9}, 
   3.8485377399616795`*^9, {3.8485385058925962`*^9, 3.848538516871804*^9}, {
   3.848543267468754*^9, 3.84854327465219*^9}, {3.848706392815345*^9, 
   3.8487064187499866`*^9}, {3.848706673008318*^9, 3.848706680341791*^9}, {
   3.8487068944796715`*^9, 3.8487069069197235`*^9}, {3.848706943570423*^9, 
   3.8487070196512856`*^9}, {3.848707059100363*^9, 3.8487071049597983`*^9}},
 CellLabel->"In[22]:=",ExpressionUUID->"1bc9aee2-71c9-4ec9-9497-e01706f012c3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Outputs", " ", "List", " ", "of", " ", "Laplacian", " ", "matrix", " ", 
    "eigenvalues", " ", "or", " ", "List", " ", "of", " ", "error", " ", 
    "code", 
    RowBox[{"(", "s", ")"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Input", ":", " ", 
    RowBox[{"[", "edgelist_", "]"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"edgelist", " ", "=", " ", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"v1", "\[UndirectedEdge]", "v2"}], ",", 
        RowBox[{"{", 
         RowBox[{"v1", "\[DirectedEdge]", "v3"}], "}"}], ",", "..."}], "}"}], 
      " ", "directed", " ", 
      RowBox[{"and", "/", "or"}], " ", "undirected", " ", "edges"}]}], ",", 
    " ", 
    RowBox[{"no", " ", "rules", " ", "or", " ", "other", " ", "Head"}]}], " ",
    "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Output", ":", " ", "laplacianMatrixEigenvalues"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"LaplacianMatrixEigenvalues", "[", "edgelist_", "]"}], ":=", 
     RowBox[{"Block", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
        "directedEdgeStr", ",", "undirectedEdgeStr", ",", 
         "acceptedEdgeHeadStrs", ",", "\[IndentingNewLine]", "vertexPairs", 
         ",", "\[IndentingNewLine]", "vertices", ",", "verticesCount", ",", 
         "vertexCoordHash", ",", "\[IndentingNewLine]", "vertexDegrees", ",", 
         "\[IndentingNewLine]", "labeledLaplacianMatrix", ",", "j", ",", 
         "\[IndentingNewLine]", "laplacianMatrixEigenvalues"}], 
        "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"directedEdgeStr", "=", 
         RowBox[{"ToString", "[", 
          RowBox[{"Head", "[", 
           RowBox[{"0", "\[DirectedEdge]", "0"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"undirectedEdgeStr", "=", 
         RowBox[{"ToString", "[", 
          RowBox[{"Head", "[", 
           RowBox[{"0", "\[UndirectedEdge]", "0"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"acceptedEdgeHeadStrs", "=", 
         RowBox[{"{", 
          RowBox[{"directedEdgeStr", ",", "undirectedEdgeStr"}], "}"}]}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"laplacianMatrixEigenvalues", "=", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"{", "Indeterminate", "}"}], ",", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"MemberQ", "[", 
                 RowBox[{"acceptedEdgeHeadStrs", ",", "#"}], "]"}], ",", 
                "Nothing", ",", "#"}], "]"}], "&"}], "/@", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"ToString", "[", 
                 RowBox[{"Head", "[", "#", "]"}], "]"}], "&"}], "/@", 
               "edgelist"}], ")"}]}], ")"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "laplacianMatrixEigenvalues", "]"}], 
           "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"vertexPairs", "=", 
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"List", "@@@", "edgelist"}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"ToString", "[", 
                    RowBox[{"Head", "[", "#", "]"}], "]"}], "\[Equal]", 
                   "undirectedEdgeStr"}], ",", 
                  RowBox[{"Reverse", "[", 
                   RowBox[{"List", "@@", "#"}], "]"}], ",", "Nothing"}], 
                 "]"}], "&"}], "/@", "edgelist"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"Print", "[", "vertexPairs", "]"}], ";"}], " ", "*)"}], 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"vertices", "=", 
            RowBox[{"Sort", "[", 
             RowBox[{"DeleteDuplicates", "[", 
              RowBox[{"Flatten", "[", "vertexPairs", "]"}], "]"}], "]"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"verticesCount", "=", 
            RowBox[{"Length", "[", "vertices", "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"vertexCoordHash", "=", 
            RowBox[{"CreateDataStructure", "[", "\"\<HashTable\>\"", "]"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"vertexCoordHash", "[", 
              RowBox[{"\"\<Insert\>\"", ",", 
               RowBox[{
                RowBox[{"vertices", "[", 
                 RowBox[{"[", "#", "]"}], "]"}], "\[Rule]", 
                RowBox[{"(", 
                 RowBox[{"#", "+", "1"}], ")"}]}]}], "]"}], "&"}], "/@", 
            RowBox[{"Range", "[", "verticesCount", "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"Print", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"#", ",", 
                  RowBox[{"vertexCoordHash", "[", 
                   RowBox[{"\"\<Lookup\>\"", ",", "#"}], "]"}]}], "}"}], 
                "&"}], "/@", "vertices"}], "]"}], ";"}], " ", "*)"}], 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"vertexDegrees", "=", 
            RowBox[{"Table", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"v", ",", 
                RowBox[{"Total", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "v"}], ",", 
                    "1", ",", "0"}], "]"}], "&"}], "/@", "vertexPairs"}], 
                 "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"v", ",", "vertices"}], "}"}]}], "\[IndentingNewLine]",
              "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"Print", "[", "vertexDegrees", "]"}], ";"}], " ", "*)"}],
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"labeledLaplacianMatrix", "=", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{"0", ",", 
                RowBox[{"verticesCount", "+", "1"}]}], "]"}], ",", 
              RowBox[{"verticesCount", "+", "1"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"labeledLaplacianMatrix", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"2", ";;"}], ",", "1"}], "]"}], "]"}], "=", 
            "vertices"}], ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"labeledLaplacianMatrix", "[", 
             RowBox[{"[", 
              RowBox[{"1", ",", 
               RowBox[{"2", ";;"}]}], "]"}], "]"}], "=", "vertices"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Do", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"labeledLaplacianMatrix", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"vertexCoordHash", "[", 
                  RowBox[{"\"\<Lookup\>\"", ",", 
                   RowBox[{"edata", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}], ",", 
                 RowBox[{"vertexCoordHash", "[", 
                  RowBox[{"\"\<Lookup\>\"", ",", 
                   RowBox[{"edata", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], "]"}], "]"}], 
              "=", 
              RowBox[{"-", "1"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"edata", ",", "vertexPairs"}], "}"}]}], 
            "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"j", "=", "1"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Do", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"j", "++"}], ";", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"labeledLaplacianMatrix", "[", 
                RowBox[{"[", 
                 RowBox[{"j", ",", "j"}], "]"}], "]"}], "+=", 
               RowBox[{"vertexDegrees", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "2"}], "]"}], "]"}]}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"i", ",", "verticesCount"}], "}"}]}], 
            "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"Print", "[", 
              RowBox[{"\"\<labeledLaplacianMatrix:\\n\>\"", ",", 
               RowBox[{"Grid", "[", 
                RowBox[{"labeledLaplacianMatrix", ",", 
                 RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}]}], "]"}], ";"}],
             " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"laplacianMatrixEigenvalues", "=", 
            RowBox[{"N", "[", 
             RowBox[{"Eigenvalues", "[", 
              RowBox[{"labeledLaplacianMatrix", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"2", ";;"}], ",", 
                 RowBox[{"2", ";;"}]}], "]"}], "]"}], "]"}], "]"}]}], ";"}]}],
          "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{"Print", "[", "laplacianMatrixEigenvalues", "]"}], ";"}], 
          " ", "*)"}], "\[IndentingNewLine]", "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "laplacianMatrixEigenvalues"}]}], "\[IndentingNewLine]", "]"}]}], 
    ";"}], "\[IndentingNewLine]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.802192433608954*^9, 3.802192433608954*^9}, {
   3.8248608627209926`*^9, 3.8248609251279907`*^9}, {3.8479230012648163`*^9, 
   3.84792300781653*^9}, {3.848192776914865*^9, 3.8481928035074625`*^9}, {
   3.848192858748963*^9, 3.8481928663468385`*^9}, {3.8482618726360407`*^9, 
   3.84826188137094*^9}, {3.8482619142360487`*^9, 3.8482619202188225`*^9}, {
   3.8482619589686484`*^9, 3.8482621067777004`*^9}, {3.8484122239814696`*^9, 
   3.848412431403941*^9}, {3.8484126212052183`*^9, 3.848412641974083*^9}, 
   3.8484126847833633`*^9, 3.848412893424708*^9, {3.8484129668127346`*^9, 
   3.848413073529786*^9}, {3.8484139934534693`*^9, 3.8484140536293583`*^9}, {
   3.8484144375062256`*^9, 3.8484144451973314`*^9}, 3.848414559864258*^9, {
   3.8484146513575583`*^9, 3.8484148071930633`*^9}, {3.848414899421559*^9, 
   3.848414936229832*^9}, {3.8484150961284337`*^9, 3.848415112670023*^9}, {
   3.8484151592490625`*^9, 3.8484153394325175`*^9}, {3.8484153850496426`*^9, 
   3.8484153946467915`*^9}, {3.8484154521544313`*^9, 
   3.8484155190378957`*^9}, {3.848415627101592*^9, 3.848415629029183*^9}, {
   3.848415669977871*^9, 3.848415746648657*^9}, 3.848415823965466*^9, {
   3.8484158915012608`*^9, 3.848415965345403*^9}, {3.8484160047256756`*^9, 
   3.848416046629339*^9}, 3.8484166050421867`*^9, {3.8484168726772795`*^9, 
   3.8484168754328485`*^9}, {3.848416957786363*^9, 3.848416968981411*^9}, {
   3.8484170010712*^9, 3.848417003418024*^9}, {3.848417107830129*^9, 
   3.8484171218379655`*^9}, {3.848417179554074*^9, 3.848417203045656*^9}, {
   3.8484172436786795`*^9, 3.848417264666362*^9}, {3.8484173077103925`*^9, 
   3.8484173726554856`*^9}, {3.8484174409182053`*^9, 3.848417447797374*^9}, {
   3.848417827942122*^9, 3.848418001813562*^9}, {3.848418052686564*^9, 
   3.8484181583658257`*^9}, {3.8484303308615932`*^9, 
   3.8484303671179843`*^9}, {3.8484304010412483`*^9, 
   3.8484304723733068`*^9}, {3.8484305876404715`*^9, 3.848430651017041*^9}, {
   3.848430831661123*^9, 3.8484309796255145`*^9}, {3.8484310113148055`*^9, 
   3.84843109200404*^9}, 3.848431151046339*^9, {3.8484311994090233`*^9, 
   3.8484312386418095`*^9}, {3.8484313050468245`*^9, 3.848431350997254*^9}, {
   3.84843158883286*^9, 3.8484316073290052`*^9}, {3.8484316876648855`*^9, 
   3.8484316884573936`*^9}, {3.8484317765691957`*^9, 3.848431778800906*^9}, {
   3.848431821954669*^9, 3.848431899176857*^9}, {3.8484319308855762`*^9, 
   3.8484319334889765`*^9}, {3.848432294489472*^9, 3.848432296895342*^9}, {
   3.84843243104313*^9, 3.848432472889349*^9}},
 CellLabel->"In[23]:=",ExpressionUUID->"57d64e64-1f76-454d-8000-e278e95872d4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LeastBridgesGraphsKey", ":=", "3306206825"}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.802192433608954*^9, 3.802192433608954*^9}, {
   3.8248608627209926`*^9, 3.8248609251279907`*^9}, {3.825293796606659*^9, 
   3.825293847502709*^9}, 3.825294226892686*^9, {3.8252943122376013`*^9, 
   3.8252943286717453`*^9}, {3.8252950348930593`*^9, 
   3.8252950614037495`*^9}, {3.825296842826265*^9, 3.825296862440692*^9}, {
   3.8253012867026415`*^9, 3.8253012896976795`*^9}, 3.8253491249097123`*^9, {
   3.8479233164551277`*^9, 3.847923335102805*^9}, 3.8479235416561136`*^9},
 CellLabel->"In[24]:=",ExpressionUUID->"fb7fda1a-07b3-4f79-b87c-10da79bbc7f2"]
},
AutoGeneratedPackage->Automatic,
Evaluator->"Local",
WindowSize->{1264.5, 729.75},
WindowMargins->{{3, Automatic}, {Automatic, 0}},
DockedCells->{},
FrontEndVersion->"13.3 for Microsoft Windows (64-bit) (July 24, 2023)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"a5e044b4-84f0-4044-a6ca-64da80062f93"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 351, 7, 44, "Input",ExpressionUUID->"8c5d4967-02f1-4da1-84c8-76a8548377d4",
 InitializationCell->True],
Cell[912, 29, 1389, 27, 178, "Input",ExpressionUUID->"9480d78b-feb2-41d0-b29e-a0a9a01ad1da",
 InitializationCell->True],
Cell[2304, 58, 116112, 2205, 8851, "Input",ExpressionUUID->"e1f05980-5fef-4dfc-9dc5-a9e2bfbed61a",
 InitializationCell->True],
Cell[118419, 2265, 65978, 1188, 3663, "Input",ExpressionUUID->"181f1108-5125-456a-80b8-eb9cab241d19",
 InitializationCell->True],
Cell[184400, 3455, 3015, 70, 333, "Input",ExpressionUUID->"d9886223-131c-4c4a-ac26-fbe49cf5b762",
 InitializationCell->True],
Cell[187418, 3527, 77433, 1406, 4577, "Input",ExpressionUUID->"d616b612-60ec-4f0c-8e82-3845f455ee1a",
 InitializationCell->True],
Cell[264854, 4935, 120598, 2343, 8232, "Input",ExpressionUUID->"07f63e71-2b29-4fa5-ab3d-5504b8176b3d",
 InitializationCell->True],
Cell[385455, 7280, 3299, 71, 235, "Input",ExpressionUUID->"02ae7579-7bec-4c92-b02d-85873b5e8ed8",
 InitializationCell->True],
Cell[388757, 7353, 9369, 199, 523, "Input",ExpressionUUID->"18efeb18-d268-4e20-a656-e5aae92153c4",
 InitializationCell->True],
Cell[398129, 7554, 13318, 291, 1324, "Input",ExpressionUUID->"1bc9aee2-71c9-4ec9-9497-e01706f012c3",
 InitializationCell->True],
Cell[411450, 7847, 13026, 274, 1206, "Input",ExpressionUUID->"57d64e64-1f76-454d-8000-e278e95872d4",
 InitializationCell->True],
Cell[424479, 8123, 743, 13, 66, "Input",ExpressionUUID->"fb7fda1a-07b3-4f79-b87c-10da79bbc7f2",
 InitializationCell->True]
}
]
*)

